<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.20 $
*/
include_once('includes/global.php');
include_once('includes/lookups.php');
include_once('classes/period.php');
include_once('classes/tools/Processor.php');
loadStrings(BOOT.'asterisk_queues/strings.txt');

$doc->title .= ' :: '.getResource('asterisk.queues.title');

required_access('asterisk_queues');

switch($_GET['lookup']){
	case 'query':	lookup('query');
}

class ExecForm extends PForm {
	
	var $buf;
	
	function open(){}
	
	function close(){}
	
	function read(){
		if(isset($this->records[$this->i])){
			return implode(",", $this->records[$this->i++])."\n";
		}else{
			return -1;
		}
	}
	
	function write($buf){
		$this->buf .= $buf;
	}
	
	function Process(){
		global $asterisk_queues;
		switch($this->submiter){
			case 'exec':
				$this->processQueue($asterisk_queues->active_record['id']);
				break;
			case 'exec_all':
				foreach(loadRecords("SELECT id FROM asterisk_queues WHERE actual=1 ORDER BY id") as $arr){
					$this->processQueue($arr['id']);
				}
				break;
			case 'stop':
				$this->stopQueue($asterisk_queues->active_record['id']);
				break;
			case 'stop_all':
				foreach(loadRecords("SELECT id FROM asterisk_queues WHERE actual=1 ORDER BY id") as $arr){
					$this->stopQueue($arr['id']);
				}
				break;
		}
	}
	
	function stopQueue($id){
		global $db, $doc, $oper;
		//$db->debug = 1;
		$q = loadRecord("SELECT * FROM asterisk_queues WHERE id='".$id."'");
		if(strlen($q['stop_cmd']) > 0){
			exec($q['stop_cmd'], $out, $exit);
			PrintStrings($q['name'], $out);
			if($exit !=0){
				return sprintf(getResource('asterisk.queues.stop.fail'), $exit);
			}else{
				//$db->Execute("UPDATE asterisk_queues SET last_sent=NOW(), last_sender='".$oper->id."' WHERE id='".$id."'");
			}
		}
	}
	
	function processQueue($id){
		global $db, $doc, $oper;
		//$db->debug = 1;
		$q = loadRecord("SELECT * FROM asterisk_queues WHERE id='".$id."'");
		if($q['actual'] && $q['query'] && (strlen($q['target_cmd']) > 0)){
			$arr = loadRecord("SELECT body FROM queries WHERE id='".$q['query']."'");
			$db->Execute("CREATE TEMPORARY TABLE _qlients (id INT UNSIGNED NOT NULL, num INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, KEY(id)) ENGINE=Memory ".prepare_multiquery($arr['body']));
			$this->records = loadRecords("SELECT q.id, c.phone FROM _qlients q LEFT JOIN clients c ON c.id=q.id WHERE LENGTH(c.phone) > 0 ORDER BY q.num");
			$db->Execute("DROP TABLE _qlients");
			$this->i = 0;
			$this->buf = '';
			$processor = new Processor();
			$exit = $processor->process($q['target_cmd'], $this, $this, $this);
			PrintStrings($q['name'], trim($this->buf));
			if($exit !=0){
				return sprintf(getResource('asterisk.queues.exec.fail'), $exit);
			}else{
				$db->Execute("UPDATE asterisk_queues SET last_sent=NOW(), last_sender='".$oper->id."' WHERE id='".$id."'");
			}
		}
	}
}

$db->Execute("CREATE TEMPORARY TABLE asterisk_queues_active (code VARCHAR(64) PRIMARY KEY) ENGINE=Memory");

if($cmd = getTrimOption('ASTERISK_LIST_DISPATCHERS')){
	exec($cmd, $out, $err);
	if(!$err){
		foreach($out as $line){
			$db->Execute("INSERT INTO asterisk_queues_active (code) VALUES ('".addslashes(trim($line))."')");
		}
	}
}

$asterisk_queues = new PTable($db,BOOT.'asterisk_queues/table.php');
addCityPolicy($asterisk_queues, 's.city');

$doc->page->contents['asterisk_queues'] = new PMyAccess($asterisk_queues, array(
	'title'=>getResource('asterisk.queues.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/calls.gif',
	'grid_boot'=>BOOT.'asterisk_queues/grid.php',
	'form_boot'=>$oper->system_access['asterisk_queues'] ? BOOT.'asterisk_queues/form.php' : '',
));

$doc->page->contents['rebuild'] = new ExecForm($nil, BOOT.'asterisk_queues/exec_form.php');
if(!$asterisk_queues->isOn()){
	unset($doc->page->contents['rebuild']->submits['exec']);
	unset($doc->page->contents['rebuild']->submits['stop']);
}
echo $doc->Paint();
?>