<?
$obj = array(
	'name'=>'account_resource_types',
	'nick'=>'acrtps',
	'masters'=>array(
			'account_types'=>array(
				'table'=>$GLOBALS['account_types'],
				'on'=>'id',
				'by'=>'account_type',
			),
		),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'BeforeDelete'=>'before_street_delete',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source' => 'account_resource_types art
		LEFT JOIN account_types at ON at.id = art.account_type
		LEFT JOIN resource_types rt ON rt.id = art.resource_type
		LEFT JOIN stamps st ON st.id=art.stamp
		LEFT JOIN operators cr ON cr.id = st.created_by
		LEFT JOIN staff crs ON crs.id=cr.person
		LEFT JOIN operators md ON md.id = st.modified_by
		LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'art.id',
			'desc'=>1,
		),
		'account_type'=>array(
			'selector'=>'art.account_type',
			'desc'=>1,
			'log_by'=>'account_type_name',
		),
		'account_type_name'=>array(
			'selector'=>'at.name',
		),
		'resource_type'=>array(
			'selector'=>'art.resource_type',
			'log_by'=>'resource_type_name',
			'key'=>1,
		),
		'resource_type_name'=>array(
			'selector'=>'rt.name',
		),
		'stamp'=>array(
			'selector'=>'art.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>