<?
$obj = array(
	'name'=>'trouble_answers',
	'nick'=>'tans',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'BeforeDelete'=>'before_answer_delete',
	'AfterInsert'=>'after_logged_insert,after_answer_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_answer_delete,after_stamped_delete, after_logged_delete',
	'source'=>'trouble_answers t
	LEFT JOIN troubles x ON x.id=t.trouble
	LEFT JOIN clients c ON c.id=x.client
	LEFT JOIN cities ci ON ci.id=c.city
	LEFT JOIN stamps st ON st.id=t.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'t.id',
		),
		'city'=>array(
			'selector'=>'c.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'trouble'=>array(
			'selector'=>'t.trouble',
			'log_by'=>'trouble_name',
			'desc'=>1,
		),
		'trouble_code'=>array(
			'selector'=>'(x.code+0)',
		),
		'trouble_title'=>array(
			'selector'=>'x.title',
		),
		'trouble_name'=>array(
			'selector'=>'CONCAT(IFNULL(x.code, x.id), "/" ,c.login, ": ", x.title)',
		),
		'client'=>array(
			'selector'=>'x.client',
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'body'=>array(
			'selector'=>'t.body',
		),
		'role'=>array(
			'selector'=>'t.role',
			'log_by'=>'role_name',
		),
		'role_name'=>array(
			'selector'=>'case
				when t.role=1 then "'.getResource('trouble.answers.role.1').'"
				when t.role=2 then "'.getResource('trouble.answers.role.2').'"
				when t.role=3 then "'.getResource('trouble.answers.role.3').'"
				else "" end',
		),
		'stamp'=>array(
			'selector'=>'t.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>