<?
$obj = array(
	'name'=>'asterisk_address_book',
	'nick'=>'sts',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'BeforeDelete'=>'before_street_delete',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'asterisk_address_book s
	LEFT JOIN cities ci ON ci.id=s.city
	LEFT JOIN hosts h ON h.id=s.host
	LEFT JOIN clients c ON c.id=h.client
	LEFT JOIN staff p ON p.id=s.person
	LEFT JOIN stamps st ON st.id=s.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'s.id',
		),
		'city'=>array(
			'selector'=>'s.city',
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'name'=>array(
			'bin'=>1,
			'desc'=>1,
			'selector'=>'s.name',
		),
		'number'=>array(
			'bin'=>1,
			'desc'=>1,
			'selector'=>'s.number',
		),
		'type'=>array(
			'selector'=>'s.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE s.type
				WHEN 1 THEN "'.getResource('asterisk.address.book.type.1').'"
				WHEN 2 THEN "'.getResource('asterisk.address.book.type.2').'"
				ELSE "" END',
		),
		'host'=>array(
			'selector'=>'s.host',
			'log_by'=>'host_name',
			'nullable'=>1,
		),
		'host_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,") - ", h.ip)',
		),
		'person'=>array(
			'selector'=>'s.person',
			'log_by'=>'person_name',
			'nullable'=>1,
		),
		'person_name'=>array(
			'selector'=>'p.name',
		),
		'notes'=>array(
			'selector'=>'s.notes',
		),
		'stamp'=>array(
			'selector'=>'s.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>