<?
$obj = array(
	'name'=>'asterisk_schedule',
	'nick'=>'as',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert,apply_schedule_plan',
	'AfterPost'=>'after_logged_post,apply_schedule_plan',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'asterisk_schedule a
	LEFT JOIN cities ci ON ci.id=a.city
	LEFT JOIN asterisk_schedule_plans asp ON asp.id=a.schedule_plan
	LEFT JOIN asterisk_schedule_labels asl ON asl.id=a.label
	LEFT JOIN stamps st ON st.id=a.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'a.id',
			'desc'=>1,
		),
		'city'=>array(
			'selector'=>'a.city',
			'nullable'=>1,
			'log_by'=>'city_name',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'day'=>array(
			'selector'=>'a.day',
			'key'=>1,
		),
		'schedule_plan'=>array(
			'selector'=>'a.schedule_plan',
			'nullable'=>1,
			'log_by'=>'schedule_plan_name',
		),
		'schedule_plan_name' => array(
			'selector' => 'asp.name',
		),
		'label'=>array(
			'selector'=>'a.label',
			'nullable'=>1,
			'log_by'=>'label_name',
		),
		'label_name'=>array(
			'selector'=>'asl.name',
		),
		'day_type'=>array(
			'selector'=>'a.day_type',
			'log_by'=>'day_type_name',
		),
		'day_type_name' => array(
			'selector'=>'case a.day_type
				when 1 then "'.getResource('asterisk_schedule.day_type.1').'"
				when 2 then "'.getResource('asterisk_schedule.day_type.2').'"
				else "" end',
		),
		'notes'=>array(
			'selector'=>'a.notes',
		),
		'stamp'=>array(
			'selector'=>'a.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>