<?
$configurer = 'cadaver.configurer';
$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'/.+/'=>'accounting/$0.php',
			),
		),
	),

	'cadaver.configurer'=>array(
		'class'=>'RemoteConfigurer',
		'properties'=>array(
			'patterns'=>array(
				'|cadaver\.ipset\..+|',
				'|cadaver\.ipt\..+|',
			),
			'host'=>'194.50.85.251',
			'user'=>'root',
		),
	),
	
	'cadaver.rule.driver.world-host'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.world-host',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.world-host',
			'allowBuilder:ref'=>'cadaver.ipset.ulog.world-host',
		),
	),
	'cadaver.rule.driver.world-host.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.world-host',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.world-host',
		),
	),
	'cadaver.ipt.accounter.world-host'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*world-host.*|',
			'clientIsSource'=>false,
		),
	),
	'cadaver.ipset.blocker.world-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-world-host',
		),
	),
	'cadaver.ipset.ulog.world-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-world-host',
		),
	),

	'cadaver.rule.driver.host-world'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.host-world',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.host-world',
			'allowBuilder:ref'=>'cadaver.ipset.ulog.host-world',
		),
	),
	'cadaver.rule.driver.host-world.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.host-world',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.host-world',
		),
	),
	'cadaver.ipt.accounter.host-world'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-world.*|',
			'clientIsSource'=>true,
		),
	),
	'cadaver.ipset.blocker.host-world'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-world',
		),
	),
	'cadaver.ipset.ulog.host-world'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-world',
		),
	),

	'cadaver.rule.driver.ua-host'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.ua-host',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.ua-host',
			'allowBuilder:ref'=>'cadaver.ipset.ulog.ua-host',
		),
	),
	'cadaver.rule.driver.ua-host.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.ua-host',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.ua-host',
		),
	),
	'cadaver.ipt.accounter.ua-host'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*ua-host.*|',
			'clientIsSource'=>false,
		),
	),
	'cadaver.ipset.blocker.ua-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-ua-host',
		),
	),
	'cadaver.ipset.ulog.ua-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-ua-host',
		),
	),

	'cadaver.rule.driver.host-ua'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.host-ua',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.host-ua',
			'allowBuilder:ref'=>'cadaver.ipset.ulog.host-ua',
		),
	),
	'cadaver.rule.driver.host-ua.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'cadaver.ipt.accounter.host-ua',
			'blockBuilder:ref'=>'cadaver.ipset.blocker.host-ua',
		),
	),
	'cadaver.ipt.accounter.host-ua'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-ua.*|',
			'clientIsSource'=>true,
		),
	),
	'cadaver.ipset.blocker.host-ua'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-ua',
		),
	),
	'cadaver.ipset.ulog.host-ua'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-ua',
		),
	),
);
?>