<?
$configurer = 'sizif.configurer';
$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'/.+/'=>'accounting/$0.php',
			),
		),
	),

	'sizif.configurer'=>array(
		'class'=>'RemoteConfigurer',
		'properties'=>array(
			'patterns'=>array(
				'|sizif\.ipset\..+|',
				'|sizif\.ipt\..+|',
			),
			'host'=>'sizif.la.net.ua',
			'user'=>'root',
		),
	),

	'sizif.rule.driver.world-host'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.world-host',
			'blockBuilder:ref'=>'sizif.ipset.blocker.world-host',
			'allowBuilder:ref'=>'sizif.ipset.ulog.world-host',
		),
	),
	'sizif.rule.driver.world-host.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.world-host',
			'blockBuilder:ref'=>'sizif.ipset.blocker.world-host',
		),
	),
	'sizif.ipt.accounter.world-host'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*world-host.*|',
			'clientIsSource'=>false,
		),
	),
	'sizif.ipset.blocker.world-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-world-host',
		),
	),
	'sizif.ipset.ulog.world-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-world-host',
		),
	),

	'sizif.rule.driver.host-world'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.host-world',
			'blockBuilder:ref'=>'sizif.ipset.blocker.host-world',
			'allowBuilder:ref'=>'sizif.ipset.ulog.host-world',
		),
	),
	'sizif.rule.driver.host-world.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.host-world',
			'blockBuilder:ref'=>'sizif.ipset.blocker.host-world',
		),
	),
	'sizif.ipt.accounter.host-world'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-world.*|',
			'clientIsSource'=>true,
		),
	),
	'sizif.ipset.blocker.host-world'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-world',
		),
	),
	'sizif.ipset.ulog.host-world'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-world',
		),
	),

	'sizif.rule.driver.pop3-host'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.pop3-host',
			'blockBuilder:ref'=>'sizif.ipset.blocker.pop3-host',
			'allowBuilder:ref'=>'sizif.ipset.ulog.pop3-host',
		),
	),
	'sizif.rule.driver.pop3-host.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.pop3-host',
			'blockBuilder:ref'=>'sizif.ipset.blocker.pop3-host',
		),
	),
	'sizif.ipt.accounter.pop3-host'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*pop3-host.*|',
			'clientIsSource'=>false,
		),
	),
	'sizif.ipset.blocker.pop3-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-pop3-host',
		),
	),
	'sizif.ipset.ulog.pop3-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-pop3-host',
		),
	),

	'sizif.rule.driver.host-smtp'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.host-smtp',
			'blockBuilder:ref'=>'sizif.ipset.blocker.host-smtp',
			'allowBuilder:ref'=>'sizif.ipset.ulog.host-smtp',
		),
	),
	'sizif.rule.driver.host-smtp.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.host-smtp',
			'blockBuilder:ref'=>'sizif.ipset.blocker.host-smtp',
		),
	),
	'sizif.ipt.accounter.host-smtp'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-smtp.*|',
			'clientIsSource'=>true,
		),
	),
	'sizif.ipset.blocker.host-smtp'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-smtp',
		),
	),
	'sizif.ipset.ulog.host-smtp'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-smtp',
		),
	),

	'sizif.rule.driver.ua-host'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.ua-host',
			'blockBuilder:ref'=>'sizif.ipset.blocker.ua-host',
			'allowBuilder:ref'=>'sizif.ipset.ulog.ua-host',
		),
	),
	'sizif.rule.driver.ua-host.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.ua-host',
			'blockBuilder:ref'=>'sizif.ipset.blocker.ua-host',
		),
	),
	'sizif.ipt.accounter.ua-host'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*ua-host.*|',
			'clientIsSource'=>false,
		),
	),
	'sizif.ipset.blocker.ua-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-ua-host',
		),
	),
	'sizif.ipset.ulog.ua-host'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-ua-host',
		),
	),

	'sizif.rule.driver.host-ua'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.host-ua',
			'blockBuilder:ref'=>'sizif.ipset.blocker.host-ua',
			'allowBuilder:ref'=>'sizif.ipset.ulog.host-ua',
		),
	),
	'sizif.rule.driver.host-ua.no-ulog'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'sizif.ipt.accounter.host-ua',
			'blockBuilder:ref'=>'sizif.ipset.blocker.host-ua',
		),
	),
	'sizif.ipt.accounter.host-ua'=>array(
		'class'=>'RemoteIptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-ua.*|',
			'clientIsSource'=>true,
		),
	),
	'sizif.ipset.blocker.host-ua'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-ua',
		),
	),
	'sizif.ipset.ulog.host-ua'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-ua',
		),
	),

	'sizif.rule.driver.host-smtp'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'blockBuilder:ref'=>'sizif.ipset.blocker.host-smtp',
		),
	),
	'sizif.ipset.blocker.host-smtp'=>array(
		'class'=>'RemoteIpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-smtp',
		),
	),
);
?>