<?

include dirname(__FILE__).'/scope.php';

$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'/.+/'=>'accounting/$0.php',
			),
		),
	),
	
	'iptNames'=>array(
	    'class'=>'IptNames',
	),
	'ipSetBuildHelper'=>array(
		'class'=>'IpSetBuildHelper',
	),
	
	'none.accounting.driver'=>array(
		'class'=>'NoneAccountingDriver',
	),

	'rule.driver.world-host'=>array(
		'class'=>'SplitAccountingDriverAlt',
		'properties'=>array(
			//'iptAccounter:ref'=>'ipt.accounter.world-host',
			//'blockBuilder:ref'=>'ipset.blocker.world-host',
			//'allowBuilder:ref'=>'ipset.ulog.world-host',
			'drivers'=>array(
				array(
					'driver:ref'=>'local.rule.driver.world-host',
					'scope'=>$scope['local'],
				),
				array(
					'driver:ref'=>'nas01.rule.driver.world-host',
					'scope'=>$scope['nas01'],
				),
				array(
					'driver:ref'=>'nas02.rule.driver.world-host',
					'scope'=>$scope['nas02'],
				),
			),
		),
	),
	'ipt.accounter.world-host'=>array(
		'class'=>'IptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*world-host.*|',
			'clientIsSource'=>false,
		),
	),
	'ipset.blocker.world-host'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-world-host',
			//'netHashName'=>'block-x-world-host',
		),
	),
	'ipset.ulog.world-host'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-world-host',
		),
	),

	'rule.driver.host-world'=>array(
		'class'=>'SplitAccountingDriverAlt',
		'properties'=>array(
			//'iptAccounter:ref'=>'ipt.accounter.host-world',
			//'blockBuilder:ref'=>'ipset.blocker.host-world',
			//'allowBuilder:ref'=>'ipset.ulog.host-world',
			'drivers'=>array(
				array(
					'driver:ref'=>'nas01.rule.driver.host-world',
					'scope'=>$scope['nas01'],
				),
				array(
					'driver:ref'=>'nas02.rule.driver.host-world',
					'scope'=>$scope['nas02'],
				),
			),
		),
	),
	'ipt.accounter.host-world'=>array(
		'class'=>'IptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-world.*|',
			'clientIsSource'=>true,
		),
	),
	'ipset.blocker.host-world'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-world',
			//'netHashName'=>'block-x-host-world',
		),
	),
	'ipset.ulog.host-world'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-world',
		),
	),
	
	/*
	'rule.driver.pop3-host'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'ipt.accounter.pop3-host',
			'blockBuilder:ref'=>'ipset.blocker.pop3-host',
			//'allowBuilder:ref'=>'ipset.ulog.pop3-host',
		),
	),
	'ipt.accounter.pop3-host'=>array(
		'class'=>'IptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*pop3-host.*|',
			'clientIsSource'=>false,
		),
	),
	'ipset.blocker.pop3-host'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-pop3-host',
			//'netHashName'=>'block-x-pop3-host',
		),
	),
	'ipset.ulog.pop3-host'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-pop3-host',
		),
	),

	'rule.driver.host-smtp'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'ipt.accounter.host-smtp',
			'blockBuilder:ref'=>'ipset.blocker.host-smtp',
			//'allowBuilder:ref'=>'ipset.ulog.host-smtp',
		),
	),
	'ipt.accounter.host-smtp'=>array(
		'class'=>'IptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-smtp.*|',
			'clientIsSource'=>true,
		),
	),
	'ipset.blocker.host-smtp'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-smtp',
			//'netHashName'=>'block-x-host-smtp',
		),
	),
	'ipset.ulog.host-smtp'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-smtp',
		),
	),*/

	'rule.driver.ua-host'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'ipt.accounter.ua-host',
			'blockBuilder:ref'=>'ipset.blocker.ua-host',
			//'allowBuilder:ref'=>'ipset.ulog.ua-host',
		),
	),
	'ipt.accounter.ua-host'=>array(
		'class'=>'IptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*ua-host.*|',
			'clientIsSource'=>false,
		),
	),
	'ipset.blocker.ua-host'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-ua-host',
			//'netHashName'=>'block-x-ua-host',
		),
	),
	'ipset.ulog.ua-host'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-ua-host',
		),
	),
	
	'rule.driver.host-ua'=>array(
		'class'=>'IptAccountingDriver',
		'properties'=>array(
			'iptAccounter:ref'=>'ipt.accounter.host-ua',
			'blockBuilder:ref'=>'ipset.blocker.host-ua',
			//'allowBuilder:ref'=>'ipset.ulog.host-ua',
		),
	),
	'ipt.accounter.host-ua'=>array(
		'class'=>'IptAccounter',
		'properties'=>array(
			'tablesPattern'=>'|.*host-ua.*|',
			'clientIsSource'=>false,
		),
	),
	'ipset.blocker.host-ua'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'block-1-host-ua',
			//'netHashName'=>'block-x-host-ua',
		),
	),
	'ipset.ulog.host-ua'=>array(
		'class'=>'IpSetBuilder',
		'properties'=>array(
			'ipHashName'=>'ulog-host-ua',
		),
	),
	
	'rule.driver.pop3-host'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.host-smtp'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.dns-host'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.host-dns'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.host-proxy'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.proxy-host'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.host-local'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.local-host'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.host-klocal'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.klocal-host'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.host-kvant'=>array(
		'class'=>'NoneAccountingDriver',
	),
	'rule.driver.kvant-host'=>array(
		'class'=>'NoneAccountingDriver',
	),
);
?>