<?
$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'/.+/'=>'log/$0.php',
			),
		),
	),
	'appender.file'=>array(
		'class'=>'FileAppender',
		'properties'=>array(
			'fileName'=>'/var/log/caban',
		),
	),
	'appender.debug'=>array(
		'class'=>'FileAppender',
		'properties'=>array(
			'fileName'=>'/var/log/caban-debug',
		),
	),
	'appender.file.switch'=>array(
		'class'=>'FileAppender',
		'properties'=>array(
			'fileName'=>'/var/log/switch',
		),
	),
	'appender.stdout'=>array(
		'class'=>'StdoutAppender',
	),
	'logger.debug-to-stdout'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.stdout',
			'level'=>'DEBUG',
		),
	),
	'logger.info-to-stdout'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.stdout',
			'level'=>'INFO',
		),
	),
	'logger.warning-to-stdout'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.stdout',
			'level'=>'WARNING',
		),
	),
	'logger.error-to-stdout'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.stdout',
			'level'=>'ERROR',
		),
	),
	'logger.debug-to-file'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.file',
			'level'=>'DEBUG',
		),
	),
	'logger.info-to-file'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.file',
			'level'=>'INFO',
		),
	),
	'logger.switch'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.file.switch',
			'level'=>'INFO',
		),
	),
	'logger.quite'=>array(
		'class'=>'ChainLoggerFactory',
		'properties'=>array(
			'chain'=>array(
				'0:ref'=>'logger.error-to-stdout',
				'1:ref'=>'logger.info-to-file',
			),
		),
	),
	'logger.verbose'=>array(
		'class'=>'ChainLoggerFactory',
		'properties'=>array(
			'chain'=>array(
				'0:ref'=>'logger.info-to-stdout',
				'1:ref'=>'logger.debug-to-file',
			),
		),
	),
	'logger.debug'=>array(
		'class'=>'ChainLoggerFactory',
		'properties'=>array(
			'chain'=>array(
				'0:ref'=>'logger.debug-to-stdout',
				'1:ref'=>'logger.debug-to-file',
			),
		),
	),
	'logger.debug2'=>array(
		'class'=>'DefaultLoggerFactory',
		'properties'=>array(
			'appender:ref'=>'appender.debug',
			'level'=>'DEBUG',
		),
	),
	'logger.file-debug'=>array(
		'class'=>'ChainLoggerFactory',
		'properties'=>array(
			'chain'=>array(
				'0:ref'=>'logger.warning-to-stdout',
				'1:ref'=>'logger.debug-to-file',
			),
		),
	),
	'logger.file-debug2'=>array(
		'class'=>'ChainLoggerFactory',
		'properties'=>array(
			'chain'=>array(
				'0:ref'=>'logger.error-to-stdout',
				'1:ref'=>'logger.info-to-file',
				'2:ref'=>'logger.debug2',
			),
		),
	),
	'loggerFactory'=>array(
		'class'=>'LoggerRegistryFactory',
		'properties'=>array(
			'registry'=>array(
				'default:ref'=>'logger.quite',//'logger.file-debug2',
				'|switch.+|:ref'=>'logger.switch',
				'|.*drweb.*|:ref'=>'logger.file-debug',
				'|.*mail.*|:ref'=>'logger.file-debug',
//				'|.*profiler.*|:ref'=>'logger.file-debug',
//				'|.*helper.*|:ref'=>'logger.file-debug',
//				'|.*ipt\.names*|:ref'=>'logger.file-debug',
//				'personal.periods.service:ref'=>'logger.debug2',
//				'state.update.service:ref'=>'logger.debug2',
//				'pay.manager:ref'=>'logger.debug2',
//				'jobs.service:ref'=>'logger.debug2',
//				'jobs.extras.service:ref'=>'logger.debug2',
//				'|.*extras.*|:ref'=>'logger.debug',
//				'|.*offline.*|:ref'=>'logger.file-debug',
//				'default:ref'=>'logger.verbose',
//				'mysql:ref'=>'logger.verbose',
//				'ipt.accounting.driver:ref'=>'logger.verbose',
			),
		),
	),
	'logFactory'=>array(
		'alias'=>'loggerFactory',
	),
	'logfactory'=>array(
		'alias'=>'loggerFactory',
	),
	'loggerfactory'=>array(
		'alias'=>'loggerFactory',
	),
);
?>