<?
$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'/.+/'=>'service/$0.php',
			),
		),
	),
	'configurer'=>array(
		'class'=>'Environment',
		'properties'=>array(
			'workdir'=>TMP_DIR.'/caban',
		),
	),
	'accessTrackerService'=>array(
		'class'=>'AccessTrackerService',
		'properties'=>array(
			'accessTrackerDAO:ref'=>'accessTrackerDAO',
			'connectionPolicy:ref'=>'connectionPolicy',
			'clientsManager:ref'=>'clientsManager',
			'hostsManager:ref'=>'hostsManager',
		),
	),
	'accountTypesManager'=>array(
		'class'=>'AccountTypesManager',
	),
	'accountingRulesManager'=>array(
		'class'=>'AccountingRulesManager',
		'properties'=>array(
			'workDirOption:ref'=>'workDirOption',
		),
	),
	'connectionPolicy'=>array(
		'class'=>'ConnectionPolicy',
		'properties'=>array(
			'members'=>array(
				'blocks:ref'=>'blocksManager',
				'personalPeriods:ref'=>'personalPeriodsPolicy',
			),
		),
	),
	'blockPolicy'=>array(
		'class'=>'BlockPolicy',
		'properties'=>array(
			'members'=>array(
				'blocks:ref'=>'blocksManager',
				'deposit:ref'=>'depositBlocker',
				'personalPeriods:ref'=>'personalPeriodsPolicy',
				'self:ref'=>'selfLimitationsManager',
			),
		),
	),
	'accountsManager'=>array(
		'class'=>'AccountsManager',
		'properties'=>array(
			'accountsDAO:ref'=>'accountsDAO',
			'accountStatesDAO:ref'=>'accountStatesDAO',
			'movementsDAO:ref'=>'movementsDAO',
			'calendarPeriodsManager:ref'=>'calendarPeriodsManager',
		),
	),
	'blocksManager'=>array(
		'class'=>'BlocksManager',
		'properties'=>array(
			'blocksDAO:ref'=>'blocksDAO',
		),
	),
	'bonusesManager'=>array(
		'class'=>'BonusesManager',
		'properties'=>array(
			'bonusesDAO:ref'=>'bonusesDAO',
			'accountsManager:ref'=>'accountsManager',
		),
	),
	'calendarPeriodsService'=>array(
		'class'=>'CalendarPeriodsService',
		'properties'=>array(
			'calendarPeriodsDAO:ref'=>'calendarPeriodsDAO',
			'accountStatesDAO:ref'=>'accountStatesDAO',
			'resourceUsesManager:ref'=>'resourceUsesManager',
			'calendarPeriodsManager:ref'=>'calendarPeriodsManager',
		),
	),
	'calendarPeriodsManager'=>array(
		'class'=>'CalendarPeriodsManager',
		'properties'=>array(
			'calendarPeriodsDAO:ref'=>'calendarPeriodsDAO',
			'accountStatesDAO:ref'=>'accountStatesDAO',
		),
	),
	'chargeTypesManager'=>array(
		'class'=>'ChargeTypesManager',
		'properties'=>array(
			'chargeTypesDAO:ref'=>'chargeTypesDAO',
		),
	),
	'clientsManager'=>array(
		'class'=>'ClientsManager',
		'properties'=>array(
			'clientsDAO:ref'=>'clientsDAO',
		),
	),
	'clientShaperPatchesManager'=>array(
		'class'=>'ClientShaperPatchesManager',
		'properties'=>array(
			'clientShaperPatchesDAO:ref'=>'clientShaperPatchesDAO',
		),
	),
	'connectionTypesManager'=>array(
		'class'=>'ConnectionTypesManager',
		'properties'=>array(
			'connectionTypesDAO:ref'=>'connectionTypesDAO',
		),
	),
	'depositBlocker'=>array(
		'class'=>'DepositBlocker',
		'properties'=>array(
			'accountsManager:ref'=>'accountsManager',
			'clientsManager:ref'=>'clientsManager',
			'creditsDAO:ref'=>'creditsDAO',
		),
	),
	'hostsManager'=>array(
		'class'=>'HostsManager',
		'properties'=>array(
			'hostsDAO:ref'=>'hostsDAO',
		),
	),
	'hostsIpList'=>array(
		'class'=>'HostsIpList',
		'properties'=>array(
			'commandLineInterface:ref'=>'hostsIpListCLI',
			'criteriaOption:ref'=>'criteriaOption',
			'hostsDAO:ref'=>'hostsDAO',
			'connectionPolicy:ref'=>'connectionPolicy',
		),
	),
	'ipUseLogManager'=>array(
		'class'=>'IpUseLogManager',
		'properties'=>array(
			'ipUseLogDAO:ref'=>'ipUseLogDAO',
		),
	),
	'ipUseLogPacker'=>array(
		'class'=>'IpUseLogPacker',
		'properties'=>array(
			'ipUseLogPackerDAO:ref'=>'ipUseLogPackerDAO',
			'optionsManager:ref'=>'optionsManager',
		),
	),
	'ipUsesManager'=>array(
		'class'=>'IpUsesManager',
		'properties'=>array(
			'ipUsesDAO:ref'=>'ipUsesDAO',
			'calendarPeriodsManager:ref'=>'calendarPeriodsManager',
		),
	),
	'jobsService'=>array(
		'class'=>'JobsService',
	),
	'jobsExtrasService'=>array(
		'class'=>'JobsExtrasService',
	),
	'optionsManager'=>array(
		'class'=>'OptionsManager',
		'properties'=>array(
			'optionsDAO:ref'=>'optionsDAO',
		),
	),
	'payManager'=>array(
		'class'=>'PayManager',
	),
	'personalFirewallManager'=>array(
		'class'=>'PersonalFirewallManager',
		'properties'=>array(
			'personalFirewallDAO:ref'=>'personalFirewallDAO',
		),
	),
	'personalPeriodPlansManager'=>array(
		'class'=>'PersonalPeriodPlansManager',
		'properties'=>array(
			'personalPeriodPlansDAO:ref'=>'personalPeriodPlansDAO',
		),
	),
	'personalPeriodsManager'=>array(
		'class'=>'PersonalPeriodsManager',
		'properties'=>array(
			'personalPeriodsDAO:ref'=>'personalPeriodsDAO',
		),
	),
	'personalPeriodResourceUsesManager'=>array(
		'class'=>'PersonalPeriodResourceUsesManager',
		'properties'=>array(
			'personalPeriodResourceUsesDAO:ref'=>'personalPeriodResourceUsesDAO',
			'calendarPeriodsManager:ref'=>'calendarPeriodsManager',
		),
	),
	'personalPeriodsService'=>array(
		'class'=>'PersonalPeriodsService',
		'properties'=>array(
			'personalPeriodsDAO:ref'=>'personalPeriodsDAO',
			'personalPeriodsManager:ref'=>'personalPeriodsManager',
			'personalPeriodPlansManager:ref'=>'personalPeriodPlansManager',
			'blocksManager:ref'=>'blocksManager',
			'accountsManager:ref'=>'accountsManager',
			'bonusesManager:ref'=>'bonusesManager',
			'chargeTypesManager:ref'=>'chargeTypesManager',
			'clientsManager:ref'=>'clientsManager',
			'connectionTypesManager:ref'=>'connectionTypesManager',
			'depositBlocker:ref'=>'depositBlocker',
			'subscriptionsManager:ref'=>'subscriptionsManager',
			'resourceUsesManager:ref'=>'resourceUsesManager',
			'personalPeriodResourceUsesManager:ref'=>'personalPeriodResourceUsesManager',
		),
	),
	'personalPeriodsNotifier'=>array(
		'class'=>'PersonalPeriodsNotifier',
		'properties'=>array(
			'notifiedPersonalPeriodsDAO:ref'=>'notifiedPersonalPeriodsDAO',
			'personalPeriodsManager:ref'=>'personalPeriodsManager',
			'personalPeriodPlansManager:ref'=>'personalPeriodPlansManager',
			'chargeTypesManager:ref'=>'chargeTypesManager',
			'connectionTypesManager:ref'=>'connectionTypesManager',
			'subscriptionsManager:ref'=>'subscriptionsManager',
			'resourceTypesManager:ref'=>'resourceTypesManager',
		),
	),
	'personalPeriodsPolicy'=>array(
		'class'=>'PersonalPeriodsPolicy',
		'properties'=>array(
			'personalPeriodsManager:ref'=>'personalPeriodsManager',
			'personalPeriodPlansManager:ref'=>'personalPeriodPlansManager',
		),
	),
	'resourceTypesManager'=>array(
		'class'=>'ResourceTypesManager',
		'properties'=>array(
			'resourceTypesDAO:ref'=>'resourceTypesDAO',
		),
	),
	'resourceUsesManager'=>array(
		'class'=>'ResourceUsesManager',
		'properties'=>array(
			'resourceUsesDAO:ref'=>'resourceUsesDAO',
			'accountsManager:ref'=>'accountsManager',
			'calendarPeriodsManager:ref'=>'calendarPeriodsManager',
		),
	),
	'rulesBuilder'=>array(
		'class'=>'RulesBuilder',
	),
	'rulesManager'=>array(
		'class'=>'RulesManager',
		'properties'=>array(
			'rulesDAO:ref'=>'rulesDAO',
		),
	),
	'selfLimitationsManager'=>array(
		'class'=>'SelfLimitationsManager',
		'properties'=>array(
			'selfLimitationsDAO:ref'=>'selfLimitationsDAO',
			'personalPeriodsManager:ref'=>'personalPeriodsManager',
			'personalPeriodPlansManager:ref'=>'personalPeriodPlansManager',
			'resourceTypesManager:ref'=>'resourceTypesManager',
		),
	),
	'subscriptionsManager'=>array(
		'class'=>'SubscriptionsManager',
		'properties'=>array(
			'subscriptionsDAO:ref'=>'subscriptionsDAO',
		),
	),
	'tariffsManager'=>array(
		'class'=>'TariffsManager',
		'properties'=>array(
			'tariffsDAO:ref'=>'tariffsDAO',
		),
	),
	'timeService'=>array(
		'class'=>'TimeService',
	),
	'timeservice'=>array(
		'alias'=>'timeService',
	),
	'fetcherMaster'=>array(
		'class'=>'FetcherMaster',
	),
	'fetcher'=>array(
		'class'=>'Fetcher',
		'properties'=>array(
			'bonusesManager:ref'=>'bonusesManager',
			'calendarPeriodsService:ref'=>'calendarPeriodsService',
			'personalPeriodsService:ref'=>'personalPeriodsService',
			'personalPeriodPlansManager:ref'=>'personalPeriodPlansManager',
			'shapersManager:ref'=>'shapersManager',
			'trafficAccounter:ref'=>'trafficAccounter',
			'notificator:ref'=>'notificator',
		),
	),
	'trafficAccounter'=>array(
		'class'=>'TrafficAccounter',
		'properties'=>array(
			'accountsManager:ref'=>'accountsManager',
			'connectionPolicy:ref'=>'connectionPolicy',
			'bonusesManager:ref'=>'bonusesManager',
			'clientsManager:ref'=>'clientsManager',
			'clientShaperPatchesManager:ref'=>'clientShaperPatchesManager',
			'connectionTypesManager:ref'=>'connectionTypesManager',
			'hostsManager:ref'=>'hostsManager',
			'ipUseIntervalsDAO:ref'=>'ipUseIntervalsDAO',
			'ipUseLogManager:ref'=>'ipUseLogManager',
			'ipUsesManager:ref'=>'ipUsesManager',
			'personalFirewallManager:ref'=>'personalFirewallManager',
			'personalPeriodsManager:ref'=>'personalPeriodsManager',
			'personalPeriodResourceUsesManager:ref'=>'personalPeriodResourceUsesManager',
			'personalPeriodPlansManager:ref'=>'personalPeriodPlansManager',
			'resourceUsesManager:ref'=>'resourceUsesManager',
			'rulesManager:ref'=>'rulesManager',
			'tariffsManager:ref'=>'tariffsManager',
			'workDirOption:ref'=>'workDirOption',
			'fetchPeriod'=>FETCH_PERIOD,
			'clientsPerTransaction'=>10,
		),
	),
	'launcher'=>array(
		'class'=>'Launcher',
		'properties'=>array(
			'commandLineInterface:ref'=>'cabanCLI',
			'actionOption:ref'=>'actionOption',
		),
	),
	'chainer'=>array(
		'class'=>'Chainer',
		'properties'=>array(
			'commandLineInterface:ref'=>'chainerCLI',
			'tableOption:ref'=>'tableOption',
			'chainOption:ref'=>'chainOption',
			'locationOption:ref'=>'locationOption',
			'targetOption:ref'=>'targetOption',
			'keepFirstOption:ref'=>'keepFirstOption',
			'keepLastOption:ref'=>'keepLastOption',
			'workDirOption:ref'=>'workDirOption',
			'ipSource:ref'=>'stdinIterable',
		),
	),
	'connectedHostsIpSource'=>array(
		'class'=>'HostsIpSource',
		'properties'=>array(
			'hostsDAO:ref'=>'hostsDAO',
			'connectionPolicy:ref'=>'connectionPolicy',
			'criteria'=>'connected',
		),
	),
	'disconnectedHostsIpSource'=>array(
		'class'=>'HostsIpSource',
		'properties'=>array(
			'hostsDAO:ref'=>'hostsDAO',
			'connectionPolicy:ref'=>'connectionPolicy',
			'criteria'=>'disconnected',
		),
	),
	'modemsIpSource'=>array(
		'class'=>'ModemsIpSource',
		'properties'=>array(
			'modemsDAO:ref'=>'modemsDAO',
		),
	),
	'notificator'=>array(
		'class'=>'Notificator',
		'properties'=>array(
			'clientsManager:ref'=>'clientsManager',
			'optionsManager:ref'=>'optionsManager',
			'sendProcessor'=>'sendmail -t',
			//'sendProcessor'=>'cat',
			'members'=>array(
				'periods:ref'=>'personalPeriodsNotifier',
				'block:ref'=>'depositBlocker',
				'accounts:ref'=>'accountsNotificator',
				'selfLimitations:ref'=>'selfLimitationsManager',
			),
		),
	),
	'accountsNotificator'=>array(
		'class'=>'AccountsNotificator',
		'properties'=>array(
			'accountsManager:ref'=>'accountsManager',
			'bonusesManager:ref'=>'bonusesManager',
			'resourceTypesManager:ref'=>'resourceTypesManager',
		),
	),
	'shapersManager'=>array(
		'class'=>'ShapersManager',
		'properties'=>array(
			'shapersDAO:ref'=>'shapersDAO',
			'clientShaperPatchesManager:ref'=>'clientShaperPatchesManager',
			'connectionTypesManager:ref'=>'connectionTypesManager',
			'hostsManager:ref'=>'hostsManager',
			'optionsManager:ref'=>'optionsManager',
			'personalPeriodsManager:ref'=>'personalPeriodsManager',
			'personalPeriodPlansManager:ref'=>'personalPeriodPlansManager',
		),
	),
	'charge.driver.drweb'=>array(
		'class'=>'ChargeDriverDrWeb',
		'properties'=>array(
			'optionsManager:ref'=>'optionsManager',
		),
	),
	'charge.driver.drweb.2'=>array(
		'class'=>'ChargeDriverDrWeb2',
		'properties'=>array(
			'optionsManager:ref'=>'optionsManager',
		),
	),
	'modemsTreeView'=>array(
		'class'=>'ModemsTreeView',
		'properties'=>array(
			'hostsDAO:ref'=>'hostsDAO',
			'modemsDAO:ref'=>'modemsDAO',
			'location'=>TMP_DIR.'/tree-view',
			'model'=>'ES4612',
		),
	),
	'offlineManager'=>array(
		'class'=>'OfflineManager',
		'properties'=>array(
			'threshold'=>60*60*24*93, //93 days
			'offlineDepartment'=>36,
			'offlineAccount'=>8996,
			'operator'=>BILLING_OPERATOR,
		),
	),
	'snapshotTemplate'=>array(
		'class'=>'PhpTemplate',
		'location'=>'classes/tools/PhpTemplate.php',
		'properties'=>array(
			'fileName'=>'boot/snapshots/template.php',
		),
	),
	'snapshotMaker'=>array(
		'class'=>'SnapshotMaker',
		'properties'=>array(
			'pathTemplate:ref'=>'snapshotTemplate',
			'pathInfo'=>array(
				'1'=>array(
					'network'=>2,
					'author'=>' ',
					'send'=>'curl -T - -u lanet:asd -s ftp://romsat.ua//pub/report/lanet/%s_lanet.xml',
				),
			),
		),
	),
	'stampManager'=>array(
		'class'=>'StampManager',
		'properties'=>array(
			'operator'=>BILLING_OPERATOR,
		),
	),
	'taskMover'=>array(
		'class'=>'TaskMover',
	),
	'ipUseLogCleaner'=>array(
		'class'=>'IpUseLogCleaner',
	),
	'delayedTasksManager'=>array(
		'class'=>'DelayedTasksManager',
	),
	'paysImportManager'=>array(
		'class'=>'PaysImportManager',
	),
	'moveManager'=>array(
		'class'=>'MoveManager',
	),
	'tvTypesManager'=>array(
		'class'=>'TvTypesManager',
	),
	'stateUpdateService'=>array(
		'class'=>'StateUpdateService',
	),
	'splitter'=>array(
		'class'=>'Splitter',
	),
	'callReport'=>array(
		'class'=>'CallReport',
	),
);
?>