<?
$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'/.+/'=>'tools/$0.php',
			),
		),
	),
	'calculator'=>array(
		'class'=>'GmpCalculator',
	),
	'currencyFormat'=>array(
		'class'=>'CurrencyFormat',
	),
	'currencyformat'=>array(
		'alias'=>'currencyFormat',
	),
	'stdinIterable'=>array(
		'class'=>'StdinIterable',
	),
	'importShapers'=>array(
		'class'=>'ImportShapers',
		'properties'=>array(
			'location'=>'/var/www/html/stat/tools/shapers/',
		),
	),
	'processor'=>array(
		'class'=>'Processor',
	),
	'processorLogged'=>array(
		'class'=>'ProcessorLogged',
	),
	'profiler'=>array(
		'class'=>'Profiler',
	),
	'spawner'=>array(
		'class'=>'Spawner',
	),
	'accReport'=>array(
		'class'=>'AccReport',
	),
	'dbImport'=>array(
		'class'=>'DBImport',
		'properties'=>array(
			'databases'=>array( // dst -> src
				'billing'=>'if_billing',
				'billing_storage'=>'if_billing_storage',
			),
			'afterImport'=>array( // dst -> array(method, args)
				'billing.clients'=>array('afterClient', array(13, 14, date("Y-m-d 12:00:00"))),
			),
			'tables'=>array( // dst table names
				"billing.operators",
				"billing.staff",
				"billing.admin_districts",
				"billing.districts",
				"billing.dispatching",
				"billing.streets",
				"billing.koops",
				"billing.koop_pays",
				"billing.koops_files",
				"billing.kpreos",
				"billing.houses",
				"billing.houses_foto",
				"billing.houses_notes",
				"billing.entrances",
				"billing.entrance_notes",
				"billing.domains",
				"billing.resource_types",
				"billing.charge_types",
				"billing.mailbox_types",
				"|billing\.job_types.+|",
				"billing.modems",
				"billing.clients",
				"billing.self_limitations",
				"billing.credits",
				"billing.blocks",
				"billing.charge_subscriptions",
				"billing.client_mailboxes",
				"billing.client_notes",
				"billing.hosts",
				"billing.hosts_firewall",
				"|billing\.trouble.+|"
			),
			'inherit'=>array(
				'billing.shapers'=>array(
					'112'=>'112','113'=>'113','206'=>'282','207'=>'277','228'=>'227',
					'230'=>'218','232'=>'247','235'=>'254','243'=>'271','244'=>'272',
					'247'=>'128','248'=>'124','249'=>'125','250'=>'278','251'=>'192',
					'253'=>'129','254'=>'273','255'=>'190','257'=>'114','258'=>'111',
					'282'=>'210','283'=>'251','284'=>'200','285'=>'202','286'=>'245',
					'287'=>'244','288'=>'248','292'=>'276','293'=>'281','294'=>'280',
					'295'=>'275','296'=>'274','297'=>'279','298'=>'249','299'=>'250',
				),
				'billing.expense_material_types' => array(
					'1'=>'1', 
					'2'=>'2',
					'3'=>'3',
					'4'=>'14',
					'5'=>'5',
					'6'=>'6',
					'7'=>'7',
					'8'=>'8',
					'9'=>'9',
					'10'=>'10',
					'11'=>'6',
				),
				'billing.system_entities' => array(
					'*'=>'*',
				),
				'billing.cities' => array(
					'1' => '4',
				),
				'billing.ranks' => array(
					'3'=>'13',
					'2'=>'51',
					'1'=>'24',
					'6'=>'34',
					'4'=>'1',
					'5'=>'52',
				),
				'billing.queries' => array(
					'1'=>'1',
				),
				'billing.operators' => array(
					'29'=>'14', '7'=>'10', '38'=>'3',
				),
				'billing.staff' => array(
					'31'=>'4', '24'=>'2', '23'=>'5',
				),
				'billing.groups' => array(
					'1'=>'6',
				),
				'billing.resource_types' => array(
					'5'=>'5', '3'=>'3', '4'=>'4', '7'=>'14', '2'=>'2', '8'=>'15', '1'=>'1',
				),
				'billing.accounts' => array(
					'7'=>'8', '3036'=>'31233', '11'=>'5396', '3'=>'9', '926'=>'11003', '9'=>'12', '6'=>'16', '5'=>'7', '10'=>'1014',
					'1'=>'1', '694'=>'15829', '3035'=>'30746', '2752'=>'21913', '3513'=>'6631', '12'=>'6476', '500'=>'11783',
					'720'=>'16244',  '2'=>'2', '3034'=>'29351', '3033'=>'28486', '4'=>'6', '8'=>'11',
				),
				'billing.rules' => array(
					'12'=>'12', '13'=>'13', '34'=>'34', '35'=>'35',
				)
			),
			'stick' => array(
				'billing.connection_types' => array(
					'billing.connection_type_bonuses'=>'connection_type',
					'billing.connection_type_boost'=>'connection_type',
					'billing.connection_type_resources'=>'connection_type',
					'billing.connection_type_shapers'=>'connection_type',
					'billing.connection_type_bonuses'=>'connection_type',
				),
				'billing.connection_type_resources' => array(
					'billing.connection_type_rules'=>'connection_type_resource',
				),
				'billing.personal_periods' => array(
					'billing.personal_period_plans'=>'personal_period',
				),
				'billing.operators' => array(
					'billing.operators_cities'=>'operator',
					'billing.operators_logins'=>'operator',
					'billing.operators_access'=>'operator',
				),
				'billing_storage.files' => array(
					'billing_storage.file_chunks'=>'file_id',
				),
			),
			'implicitForeignKeys'=>array(
				'billing.stamps'=>array(
					'fk_stamps_created_by' =>  array('billing.operators', 'created_by', 'id'),
					'fk_stamps_modified_by' => array('billing.operators', 'modified_by', 'id'),
				),
				'billing.partners'=>array(
					'fk_partners_photo_file' => array('billing_storage.files', 'photo_file', 'id'),
				),
				'billing.modems_foto'=>array(
					'fk_modems_foto_foto' => array('billing_storage.files', 'foto', 'id'),
				),
				'billing.staff_foto'=>array(
					'fk_staff_foto_foto' => array('billing_storage.files', 'foto', 'id'),
				),
				'billing.staff'=>array(
					'fk_staff_photo_file' => array('billing_storage.files', 'photo_file', 'id'),
				),
				'billing.mail_attachments'=>array(
					'fk_mail_attachments_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.documents'=>array(
					'fk_documents_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.exp_materials'=>array(
					'fk_exp_materials_photo_file' => array('billing_storage.files', 'photo_file', 'id'),
				),
				'billing.exp_complaints_files'=>array(
					'fk_exp_complaints_files_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.clients_documents'=>array(
					'fk_clients_documents_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.exp_tools'=>array(
					'fk_exp_tools_photo_file' => array('billing_storage.files', 'photo_file', 'id'),
				),
				'billing.trouble_files'=>array(
					'fk_trouble_files_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.trouble_answer_files'=>array(
					'fk_trouble_answer_files_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.faxes'=>array(
					'fk_faxes_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.exp_points'=>array(
					'fk_exp_tools_photo_file1' => array('billing_storage.files', 'photo_file1', 'id'),
					'fk_exp_tools_photo_file2' => array('billing_storage.files', 'photo_file2', 'id'),
					'fk_exp_tools_photo_file3' => array('billing_storage.files', 'photo_file3', 'id'),
					'fk_exp_tools_photo_file4' => array('billing_storage.files', 'photo_file4', 'id'),
				),
				'billing.koops'=>array(
					'fk_koops_contract_file' => array('billing_storage.files', 'contract_file', 'id'),
				),
				'billing.entrance_notes'=>array(
					'fk_entrance_notes_file' => array('billing_storage.files', 'file', 'id'),
				),
				'billing.exp_tasks'=>array(
					'fk_exp_tasks_file' => array('billing_storage.files', 'file', 'id'),
				),
			),
		),
	),
);
?>