<?
$obj = array(
	'name'=>'personal_period_resource_uses',
	'nick'=>'pprs',
	'masters'=>array(
		'resource_uses'=>array(
			'table'=>$GLOBALS['resource_uses'],
			'on'=>'id',
			'by'=>'resource_use',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert, after_personal_period_resource_use_insert',
	'AfterPost'=>'after_logged_post, after_personal_period_resource_use_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, after_personal_period_resource_use_delete',
	'source'=>'personal_period_resource_uses ppru
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN personal_periods pp ON pp.id=ppru.personal_period
	LEFT JOIN connection_types ct ON ct.id=pp.connection_type
	LEFT JOIN stamps st ON st.id=ppru.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'ppru.id',
		),
		'resource_use'=>array(
			'selector'=>'ppru.resource_use',
			'desc'=>1,
		),
		'personal_period'=>array(
			'selector'=>'ppru.personal_period',
			'desc'=>1,
		),
		'personal_period_begin'=>array(
			'selector'=>'pp.period_begin',
			'desc'=>1,
		),
		'personal_period_end'=>array(
			'selector'=>'pp.period_end',
			'desc'=>1,
		),
		'connection_type'=>array(
			'selector'=>'pp.connection_type',
		),
		'connection_type_name'=>array(
			'selector'=>'ct.name',
		),
		'amount'=>array(
			'selector'=>'ppru.amount',
			'aggregate'=>'sum',
		),
		'cost'=>array(
			'selector'=>'ppru.amount * ru.price / ru.unit_size / 100',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'ppru.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>