<?
$obj = array(
	'name'=>'bonus_accounts',
	'nick'=>'bns',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'BeforeInsert'=>'before_bonus_account_insert, before_stamped_insert',
	'BeforePost'=>'before_bonus_account_post, before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_sub_account_delete, after_stamped_delete, after_logged_delete',
	'source'=>'bonus_accounts ba
	LEFT JOIN account_types at ON at.id=ba.account_type
	LEFT JOIN calendar_account_states cas ON cas.account=ba.account AND cas.calendar_period="'.getCurrentCalendarPeriod().'"
	LEFT JOIN clients c ON ba.client = c.id
	LEFT JOIN system_accounts sa ON sa.account=ba.lost_dst
	LEFT JOIN stamps st ON st.id=ba.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'account'=>array(
			'key'=>1,
			'selector'=>'ba.account',
		),
		'account_type'=>array(
			'selector'=>'ba.account_type',
			'desc'=>1,
			'log_by'=>'account_type_name',
		),
		'account_type_name'=>array(
			'selector'=>'at.name',
		),
		'account_state'=>array(
			'selector'=>'ifnull(cas.state_end,0)/100',
			'aggregate'=>'sum',
		),
		'client'=>array(
			'selector'=>'ba.client',
			'desc'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login, ")")',
		),
		'priority'=>array(
			'selector'=>'at.priority',
		),
		'actual_from'=>array(
			'selector'=>'ba.actual_from',
			'nullable'=>1,
		),
		'actual_to'=>array(
			'selector'=>'ba.actual_to',
			'nullable'=>1,
		),
		'lost_dst'=>array(
			'selector'=>'ba.lost_dst',
			'nullable'=>1,
			'log_by'=>'lost_dst_name',
		),
		'lost_dst_name'=>array(
			'selector'=>'CONCAT(sa.name, " (", sa.code, ")")',
		),
		'stamp'=>array(
			'selector'=>'ba.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>