<?
$obj = array(
	'name'=>'client_calls',
	'nick'=>'ccls',
	'BeforeInsert'=>'before_stamped_insert,set_client_lang',
	'BeforePost'=>'before_stamped_post,set_client_lang',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'source'=>'client_calls cc
	LEFT JOIN clients c ON cc.client = c.id
	LEFT JOIN concurrents cnc ON cnc.id=cc.concurrent
	LEFT JOIN stamps st ON st.id=cc.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'cc.id',
			'key'=>1,
		),
		'client'=>array(
			'selector'=>'cc.client',
			'log_by'=>'client_name',
			'desc'=>1,
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login, ")")',
		),
		'client_lang'=>array(
			'selector'=>'c.lang',
		),
		'type'=>array(
			'selector'=>'cc.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'case cc.type
				when 1 then "'.getResource('client.calls.type.1').'"
				when 2 then "'.getResource('client.calls.type.2').'"
				when 3 then "'.getResource('client.calls.type.3').'"
				when 4 then "'.getResource('client.calls.type.4').'"
				when 5 then "'.getResource('client.calls.type.5').'"
				when 6 then "'.getResource('client.calls.type.6').'"
				when 7 then "'.getResource('client.calls.type.7').'"
				when 8 then "'.getResource('client.calls.type.8').'"
				when 9 then "'.getResource('client.calls.type.9').'"
				when 10 then "'.getResource('client.calls.type.10').'"
				else "" end',
		),
		'status'=>array(
			'selector'=>'cc.status',
			'log_by'=>'status_name',
		),
		'status_name'=>array(
			'selector'=>'case cc.status
				when 1 then "'.getResource('client.calls.status.1').'"
				when 2 then "'.getResource('client.calls.status.2').'"
				when 3 then CONCAT("'.getResource('client.calls.status.3').'", " ", IFNULL(DATE_FORMAT(cc.recall_date, "%Y-%m-%d %H:%i"), ""))
				when 4 then "'.getResource('client.calls.status.4').'"
				when 5 then "'.getResource('client.calls.status.5').'"
				else "" end',
		),
		'complaint'=>array(
			'selector'=>'cc.complaint',
			'log_by'=>'complaint_name',
		),
		'complaint_name'=>array(
			'selector'=>'case cc.complaint
				when 1 then "'.getResource('client.calls.complaint.1').'"
				when 2 then "'.getResource('client.calls.complaint.2').'"
				when 3 then "'.getResource('client.calls.complaint.3').'"
				when 4 then "'.getResource('client.calls.complaint.4').'"
				when 5 then "'.getResource('client.calls.complaint.5').'"
				else "" end',
		),
		'recall_date'=>array(
			'selector'=>'cc.recall_date',
			'nullable'=>1,
		),
		'start_ticket'=>array(
			'selector'=>'cc.start_ticket',
			'log_by'=>'start_ticket_name',
		),
		'start_ticket_name'=>array(
			'selector'=>'case cc.start_ticket
				when 1 then "'.getResource('client.calls.ticket.1').'"
				when 2 then "'.getResource('client.calls.ticket.2').'"
				else "" end',
		),
		'start_iptv'=>array(
			'selector'=>'cc.start_iptv',
			'log_by'=>'start_iptv_name',
		),
		'start_iptv_name'=>array(
			'selector'=>'case cc.start_iptv
				when 1 then "'.getResource('client.calls.iptv.1').'"
				when 2 then "'.getResource('client.calls.iptv.2').'"
				when 3 then "'.getResource('client.calls.iptv.3').'"
				else "" end',
		),
		'start_rating'=>array(
			'selector'=>'cc.start_rating',
		),
		'off_rating'=>array(
			'selector'=>'cc.off_rating',
			'log_by'=>'off_rating_name',
		),
		'off_rating_name'=>array(
			'selector'=>'case cc.off_rating
				when 1 then "'.getResource('client.calls.off.rating.1').'"
				when 2 then "'.getResource('client.calls.off.rating.2').'"
				when 3 then "'.getResource('client.calls.off.rating.3').'"
				when 4 then "'.getResource('client.calls.off.rating.4').'"
				else "" end',
		),
		'off_reason'=>array(
			'selector'=>'cc.off_reason',
			'log_by'=>'off_reason_name',
		),
		'off_reason_name'=>array(
			'selector'=>'case cc.off_reason
				when 1 then "'.getResource('client.calls.off.reason.1').'"
				when 2 then "'.getResource('client.calls.off.reason.2').'"
				when 3 then "'.getResource('client.calls.off.reason.3').'"
				else "" end',
		),
		'off_return'=>array(
			'selector'=>'cc.off_return',
			'log_by'=>'off_return_char',
		),
		'off_return_char'=>array(
			'selector'=>'if(cc.off_return, "+", "-")',
		),
		'note'=>array(
			'bin'=>1,
			'selector'=>'cc.note',
			'nullable'=>1,
		),
		'start_uniform'=>array(
			'selector'=>'cc.start_uniform',
			'log_by'=>'start_uniform_name',
		),
		'start_uniform_name'=>array(
			'selector'=>'case cc.start_uniform
				when 1 then "'.getResource('client.calls.start.uniform.1').'"
				when 2 then "'.getResource('client.calls.start.uniform.2').'"
				when 3 then "'.getResource('client.calls.start.uniform.3').'"
				when 4 then "'.getResource('client.calls.start.uniform.4').'"
				else "" end',
		),
		'concurrent'=>array(
			'selector'=>'cc.concurrent',
			'log_by'=>'concurrent_name',
			'nullable'=>1,
		),
		'concurrent_name'=>array(
			'selector'=>'cnc.name',
		),
		'debts_reason'=>array(
			'selector'=>'cc.debts_reason',
			'log_by'=>'debts_reason_name',
		),
		'debts_reason_name'=>array(
			'selector'=>'case cc.debts_reason
				when 1 then "'.getResource('client.calls.debts.reason.1').'"
				when 2 then "'.getResource('client.calls.debts.reason.2').'"
				when 3 then "'.getResource('client.calls.debts.reason.3').'"
				when 4 then "'.getResource('client.calls.debts.reason.4').'"
				when 5 then "'.getResource('client.calls.debts.reason.5').'"
				else "" end',
		),
		'debts_promise'=>array(
			'selector'=>'cc.debts_promise',
			'nullable'=>1,
		),
		'refuse_reason'=>array(
			'selector'=>'cc.refuse_reason',
			'log_by'=>'refuse_reason_name',
		),
		'refuse_reason_name'=>array(
			'selector'=>'case cc.refuse_reason
				when 1 then "'.getResource('client.calls.refuse.reason.1').'"
				when 2 then "'.getResource('client.calls.refuse.reason.2').'"
				when 3 then "'.getResource('client.calls.refuse.reason.3').'"
				when 4 then "'.getResource('client.calls.refuse.reason.4').'"
				when 5 then "'.getResource('client.calls.refuse.reason.5').'"
				else "" end',
		),
		'rating_tv_rating'=>array(
			'selector'=>'cc.rating_tv_rating',
		),
		'rating_tv_bad'=>array(
			'selector'=>'cc.rating_tv_bad',
			'log_by'=>'rating_tv_bad_name',
		),
		'rating_tv_bad_name'=>array(
			'selector'=>'case cc.rating_tv_bad
				when 1 then "'.getResource('client.calls.rating.tv.bad.1').'"
				when 2 then "'.getResource('client.calls.rating.tv.bad.2').'"
				when 3 then "'.getResource('client.calls.rating.tv.bad.3').'"
				when 4 then "'.getResource('client.calls.rating.tv.bad.4').'"
				else "" end',
		),
		'repair_done'=>array(
			'selector'=>'cc.repair_done',
			'log_by'=>'repair_done_sign',
		),
		'repair_done_sign'=>array(
			'selector'=>'IF(cc.repair_done, "+", "-")',
		),
		'repair_rating'=>array(
			'selector'=>'cc.repair_rating',
		),
		'repair_reason'=>array(
			'selector'=>'cc.repair_reason',
			'log_by'=>'repair_reason_name',
		),
		'repair_reason_name'=>array(
			'selector'=>'case cc.repair_reason
				when 1 then "'.getResource('client.calls.repair.reason.1').'"
				when 2 then "'.getResource('client.calls.repair.reason.2').'"
				when 3 then "'.getResource('client.calls.repair.reason.3').'"
				when 4 then "'.getResource('client.calls.repair.reason.4').'"
				else "" end',
		),
		'cabinet'=>array(
			'selector'=>'cc.cabinet',
			'log_by'=>'cabinet_name',
		),
		'cabinet_name'=>array(
			'selector'=>'case cc.cabinet
				when 1 then "'.getResource('client.calls.cabinet.1').'"
				when 2 then "'.getResource('client.calls.cabinet.2').'"
				when 3 then "'.getResource('client.calls.cabinet.3').'"
				else "" end',
		),
		'consult'=>array(
			'selector'=>'cc.consult',
			'log_by'=>'consult_sign',
		),
		'consult_sign'=>array(
			'selector'=>'IF(cc.consult, "+", "-")',
		),
		'office'=>array(
			'selector'=>'cc.office',
			'log_by'=>'office_name',
		),
		'office_name'=>array(
			'selector'=>'case cc.office
				when 1 then "'.getResource('client.calls.office.1').'"
				when 2 then "'.getResource('client.calls.office.2').'"
				when 3 then "'.getResource('client.calls.office.3').'"
				when 4 then "'.getResource('client.calls.office.4').'"
				else "" end',
		),
		'office_reason'=>array(
			'selector'=>'cc.office_reason',
			'log_by'=>'office_reason_name',
		),
		'office_reason_name'=>array(
			'selector'=>'case cc.office_reason
				when 1 then "'.getResource('client.calls.office.reason.1').'"
				when 2 then "'.getResource('client.calls.office.reason.2').'"
				when 3 then "'.getResource('client.calls.office.reason.3').'"
				when 4 then "'.getResource('client.calls.office.reason.4').'"
				when 5 then "'.getResource('client.calls.office.reason.5').'"
				when 6 then "'.getResource('client.calls.office.reason.6').'"
				when 7 then "'.getResource('client.calls.office.reason.7').'"
				when 8 then "'.getResource('client.calls.office.reason.8').'"
				else "" end',
		),
		'office_rating'=>array(
			'selector'=>'cc.office_rating',
		),
		'commercial'=>array(
			'selector'=>'cc.commercial',
			'log_by'=>'commercial_sign',
		),
		'commercial_sign'=>array(
			'selector'=>'IF(cc.consult, "+", "-")',
		),
		'service_rating'=>array(
			'selector'=>'cc.service_rating',
		),
		'stamp'=>array(
			'selector'=>'cc.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>