<?
$obj = array(
	'fields'=>array(
		'last_name'=>array(
			'title'=>getResource('clients.last_name'),
			'required'=>1,
		),
		'first_name'=>array(
			'title'=>getResource('clients.first_name'),
		),
		'patronymic'=>array(
			'title'=>getResource('clients.patronymic'),
		),
		'connection_type'=>array(
			'title'=>getResource('clients.connection.type'),
			'control'=>'select',
			'required'=>1,
			'list'=>'getConnectionTypes',
			'link'=>'connection_types.php?id=[connection_type]',
		),
		'tv_type'=>array(
			'title'=>getResource('clients.tv.type'),
			'control'=>'select',
			'list'=>'getTvTypes',
			'link'=>'connection_types.php?ctmenu_selected=tv&id=[tv_type]',
		),
		'department'=>array(
			'title'=>getResource('clients.department'),
			'control'=>'select',
			'required'=>1,
			'list'=>'getDepartments',
			'link'=>'departments.php?id=[department]',
		),
		'city'=>array(
			'title'=>getResource('clients.city'),
			'link'=>'cities.php?id=[city]',
			'required'=>1,
			'control'=>'select',
			'list'=>'getCities',
			'skip_finder'=>1,
		),
		'house_id'=>array(
			'title'=>getResource('clients.house'),
			'required'=>1,
			'link'=>'houses.php?id=[house_id]',
			'control'=>'lookup',
			'label'=>'[street_name] [house]',
			'source'=>'?lookup=house',
			'id'=>'lookup_house',
		),
		'entrance'=>array(
			'title'=>getResource('clients.entrance'),
			'positive'=>1,
			'control'=>'short',
			'default'=>'1',
		),
		'floor'=>array(
			'title'=>getResource('clients.floor'),
			'positive'=>1,
			'control'=>'short',
		),
		'apartment'=>array(
			'title'=>getResource('clients.apartment'),
			'control'=>'short',
		),
		'surveyor'=>array(
			'title'=>getResource('clients.surveyor'),
			'control'=>'short',
		),
		'phone'=>array(
			'title'=>getResource('clients.phone'),
			'comment'=>getResource('clients.phone.comment'),
		),
/*		'mobile'=>array(
			'title'=>getResource('clients.mobile'),
		),*/
		'passport'=>array(
			'title'=>getResource('clients.passport'),
		),
		'passport_info'=>array(
			'title'=>getResource('clients.passport.info'),
			'control'=>'textarea',
			'height'=>3,
		),
		'bank_account'=>array(
			'title'=>getResource('clients.bank.account'),
		),
		'contract'=>array(
			'title'=>getResource('clients.contract'),
			'required'=>1,
		),
		'referal'=>array(
			'title'=>getResource('clients.referal'),
		),
		'login'=>array(
			'title'=>getResource('clients.login'),
			'required'=>1,
		),
		'pass'=>array(
			'title'=>getResource('clients.password'),
			'control'=>'password',
			'with_confirm'=>1,
		),
		'email'=>array(
			'title'=>getResource('clients.email'),
			'comment'=>getResource('clients.form.email.comment'),
			'email'=>1,
		),
		'notes'=>array(
			'title'=>getResource('clients.notes'),
			'control'=>'textarea',
			'height'=>6,
		),
		'notice'=>array(
			'title'=>getResource('clients.notice'),
			'control'=>'short',
			'positive'=>1,
			'default'=>3,
			'comment'=>getResource('clients.form.notice.comment'),
		),
		'alarm'=>array(
			'title'=>getResource('clients.alarm'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'default'=>'300',
			'comment'=>getResource('clients.form.alarm.comment'),
		),
		'block'=>array(
			'title'=>getResource('clients.block'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'default'=>0,
			'comment'=>getResource('clients.form.block.comment'),
		),
		'reduction'=>array(
			'title'=>getResource('clients.reduction'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'default'=>0,
			'comment'=>getResource('clients.reduction.comment'),
		),
		'blockable'=>array(
			'title'=>getResource('clients.blockable'),
			'control'=>'checkbox',
			'default'=>1,
			'comment'=>getResource('clients.form.blockable.comment'),
		),
		'allow_ip_login'=>array(
			'title'=>getResource('clients.allow.ip.login'),
			'control'=>'checkbox',
			'default'=>1,
			'comment'=>getResource('clients.allow.ip.login.comment'),
		),
		'lang'=>array(
			'title'=>getResource('clients.lang'),
			'comment'=>getResource('clients.lang.comment'),
			'control'=>'select',
			'list'=>'getLangs',
		),
		'deposit1'=>array(
			'title'=>getResource('clients.deposit'),
			'readonly'=>1,
		),
		'traffic_rest'=>array(
			'title'=>getResource('clients.traffic.rest'),
			'readonly'=>1,
		),
		'created'=>array(
			'readonly'=>1,
			'title'=>getResource('clients.created'),
		),
		'created_name'=>array(
			'title'=>getResource('clients.created.by'),
			'readonly'=>1,
		),
		'modified'=>array(
			'readonly'=>1,
			'title'=>getResource('clients.modified'),
		),
		'modified_name'=>array(
			'title'=>getResource('clients.modified.by'),
			'readonly'=>1,
		),
	),
);
if($GLOBALS['oper']->department){
	unset($obj['fields']['department']);
}

?>