<?
$obj = array(
	'name'=>'clients',
	'nick'=>'cls',
	'BeforePost'=>'pre_client_post, before_stamped_post, check_client_contract_duplicate',
	'BeforeInsert'=>'pre_client_insert, before_stamped_insert, check_client_contract_duplicate',
	'BeforeDelete'=>'pre_client_delete',
	'AfterInsert'=>'client_insert, after_logged_insert',
	'AfterPost'=>'client_post, after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'clients c
	LEFT JOIN cities z ON z.id=c.city
	LEFT JOIN cl_filter f ON f.id=c.id
	LEFT JOIN clients_states cs ON cs.client=c.id
	LEFT JOIN calendar_account_states cas ON cas.account=c.account AND cas.calendar_period="'.getCurrentCalendarPeriod().'"
	LEFT JOIN personal_periods pp ON pp.id=c.personal_period
	LEFT JOIN houses h ON h.id=c.house_id
	LEFT JOIN streets s ON h.street = s.id
	LEFT JOIN departments d ON c.department = d.id
	LEFT JOIN connection_types ct ON c.connection_type = ct.id
	LEFT JOIN tv_types tt ON c.tv_type = tt.id
	LEFT JOIN connection_type_tv ctv ON ctv.connection_type=c.connection_type AND ctv.tv_type=c.tv_type
	LEFT JOIN ct_info ci ON ci.connection_type = c.connection_type
	LEFT JOIN browsers b ON b.id=c.last_browser
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'c.id',
		),
		'lang'=>array(
			'selector'=>'c.lang',
			'log_by'=>'lang_name',
		),
		'lang_name'=>array(
			'selector'=>'CASE c.lang
				WHEN 1 THEN "'.getResource('clients.lang.1').'"
				WHEN 2 THEN "'.getResource('clients.lang.2').'"
				ELSE "" END',
		),
		'city'=>array(
			'selector'=>'c.city',
			'log_by'=>'city_name',
			'desc'=>1,
		),
		'city_name'=>array(
			'selector'=>'z.name',
		),
		'account'=>array(
			'selector'=>'c.account',
		),
		'access_admin'=>array(
			'selector'=>'if(cs.block=0 ,"+", "-")',
		),
		'access_period'=>array(
			'selector'=>'if(ifnull(pp.state,0)=1,"+", "-")',
		),
		'access_modem'=>array(
			'selector'=>'if(cs.modem_state is null, "", if(cs.modem_state=1,"+", "-"))',
		),
		'access_deposit'=>array(
			'selector'=>'if(((ifnull(cas.state_end,0) + cs.credit) >= c.block) || not blockable, "+", "-")',
		),
		'access_firewall'=>array(
			'selector'=>'if(cs.firewall=0,"+", "-")',
		),
		'access_limitations'=>array(
			'selector'=>'if(cs.limits=0, "+", "-")',
		),
		'last_name'=>array(
			'selector'=>'c.last_name',
			'desc'=>1,
		),
		'first_name'=>array(
			'selector'=>'c.first_name',
			'desc'=>1,
		),
		'patronymic'=>array(
			'selector'=>'c.patronymic',
		),
		'name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login ,")")',
		),
		'department'=>array(
			'selector'=>'c.department',
			'log_by'=>'department_name',
		),
		'department_name'=>array(
			'selector'=>'d.name',
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
			'log_by'=>'connection_type_name',
		),
		'connection_type_name'=>array(
			'selector'=>'ct.name',
		),
		'tv_type'=>array(
			'selector'=>'c.tv_type',
			'log_by'=>'tv_type_name',
			'nullable'=>1,
		),
		'tv_type_name'=>array(
			'selector'=>'tt.name',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house_id'=>array(
			'selector'=>'c.house_id',
			'log_by'=>'house_name',
		),
		'house'=>array(
			'selector'=>'h.house',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'building'=>array(
			'selector'=>'c.building',
		),
		'entrance'=>array(
			'selector'=>'c.entrance',
		),
		'floor'=>array(
			'selector'=>'c.floor',
		),
		'apartment'=>array(
			'selector'=>'c.apartment',
		),
		'surveyor'=>array(
			'selector'=>'c.surveyor',
		),
		'phone'=>array(
			'selector'=>'c.phone',
		),
		'mobile'=>array(
			'selector'=>'c.mobile',
		),
		'passport'=>array(
			'selector'=>'c.passport',
		),
		'passport_info'=>array(
			'selector'=>'c.passport_info',
		),
		'login'=>array(
			'selector'=>'c.login',
			'desc'=>1,
		),
		'pass'=>array(
			'selector'=>'c.pass',
		),
		'email'=>array(
			'selector'=>'c.email',
		),
		'bank_account'=>array(
			'selector'=>'c.bank_account',
		),
		'contract'=>array(
			'nullable'=>1,
			'selector'=>'c.contract',
		),
		'referal'=>array(
			'selector'=>'c.referal',
			'nullable'=>1,
		),
		'notice'=>array(
			'selector'=>'c.notice',
		),
		'alarm'=>array(
			'selector'=>'c.alarm',
			'log_by'=>'alarm_cur',
		),
		'alarm_cur'=>array(
			'selector'=>'c.alarm/100',
		),
		'block'=>array(
			'selector'=>'c.block',
			'log_by'=>'block_cur',
		),
		'block_cur'=>array(
			'selector'=>'c.block/100',
		),
		'reduction'=>array(
			'selector'=>'c.reduction',
			'log_by'=>'reduction_cur',
		),
		'reduction_cur'=>array(
			'selector'=>'c.reduction/100',
			//'aggregate'=>'sum',
		),
		'blockable'=>array(
			'selector'=>'c.blockable',
		),
		'state'=>array(
			'selector'=>'c.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'case
				when c.state=0 then "'.getResource('clients.state.0.short').'"
				when c.state=1 then "'.getResource('clients.state.1.short').'"
				when c.state=2 then "'.getResource('clients.state.2.short').'"
				when c.state=3 then "'.getResource('clients.state.3.short').'"
				else "" end',
		),
		'deposit'=>array(
			'selector'=>'ifnull(cas.state_end,0)/100',
			//'aggregate'=>'sum',
		),
		'deposit1'=>array(
			'selector'=>'(ifnull(cas.state_end,0) - cs.incomplete)/100',
			'aggregate'=>'sum',
		),
		'traffic_rest'=>array(
			'selector'=>'cs.incomplete/100',
			//'aggregate'=>'sum',
		),
		'abon'=>array(
			'selector'=>'(ct.abon_amount + IFNULL(ctv.cost,0))/100',
			//'aggregate'=>'sum',
		),
		'subscription'=>array(
			'selector'=>'cs.subscriptions/100',
			//'aggregate'=>'sum',
		),
		'ct_plan'=>array(
			'selector'=>'ci.plan/100',
			//'aggregate'=>'sum',
		),
		'use_plan'=>array(
			'selector'=>'cs.use_plan/100',
			//'aggregate'=>'sum',
		),
		'use_actual'=>array(
			'selector'=>'cs.use_actual/100',
			//'aggregate'=>'sum',
		),
		'threshold'=>array(
			'selector'=>'(cs.threshold + cs.incomplete + ifnull(ci.plan,0) + c.block - cs.credit)/100',
			//'aggregate'=>'sum',
		),
		'miss'=>array(
			'selector'=>'if((cs.threshold + cs.incomplete + ifnull(ci.plan,0) + c.block - cs.credit) > ifnull(cas.state_end,0), cs.threshold + cs.incomplete + ifnull(ci.plan,0) + c.block - cs.credit - ifnull(cas.state_end, 0),0)/100',
			//'aggregate'=>'sum',
		),
		'credit_cur'=>array(
			'selector'=>'cs.credit/100',
			//'aggregate'=>'sum',
		),
		'notes'=>array(
			'selector'=>'c.notes',
		),
		'user_agent'=>array(
			'selector'=>'b.user_agent',
		),
		'allow_ip_login'=>array(
			'selector'=>'c.allow_ip_login',
			'log_by'=>'allow_ip_login_sign',
		),
		'allow_ip_login_sign'=>array(
			'selector'=>'IF(c.allow_ip_login, "+", "-")',
		),
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array (
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array (
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['fields']['department']['auto_insert'] = $d;
	$obj['filters']['department'] = "c.department='$d'";
}
?>