<?
$obj = array(
	'name'=>'coil_uses_details',
	'nick'=>'cuds',
	'masters'=>array(
		'uses'=>array(
			'table'=>$GLOBALS['coil_uses'],
			'on'=>'id',
			'by'=>'coil_use',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_config_post, before_stamped_post',
	'AfterInsert'=>'after_logged_insert, recalc_coil_use_detail',
	'AfterPost'=>'after_config_post, after_logged_post, recalc_coil_use_detail',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, recalc_coil_use_detail',
	'source'=>'coil_uses_details c
	
    LEFT JOIN coil_uses cu ON cu.id=c.coil_use
    LEFT JOIN coil_items ci ON ci.id=cu.item
    LEFT JOIN coil_supplies cs ON cs.id=ci.supply
	LEFT JOIN client_expenses ce ON ce.id=c.expense
	LEFT JOIN jobs j ON j.id=ce.job
	LEFT JOIN job_types jt ON jt.id = j.type
	LEFT JOIN houses h ON h.id=j.house_id 
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'c.id',
		),
		'coil_use'=>array(
			'selector'=>'c.coil_use',
			'desc'=>1,
			'log_by'=>'coil_use_name',
		),
		'coil_use_name' => array(
			'selector' => 'ci.code',
		),
		'expense'=>array(
			'selector'=>'c.expense',
			'desc'=>1,
			'log_by'=>'job_name',
		),
		'cable'=>array(
			'selector'=>'c.cable',
			'aggregate'=>'sum',
		),
		'cable_in'=>array(
			'selector'=>'c.cable_in',
			'aggregate'=>'sum',
		),
		'cable_out'=>array(
			'selector'=>'c.cable - c.cable_in',
			'aggregate'=>'sum',
		),
		'job'=>array(
			'selector'=>'ce.job',
		),
		'job_name'=>array(
			'selector'=>'CONCAT(j.id, " - ", IFNULL(s.name,""), " ", IFNULL(h.house,""), ", ", IFNULL(j.apartment, ""))'
		),
		/*'job_type_name'=>array(
			'selector'=>'case j.type '.
				'when 1 then "'.getResource('jobs.type.1').'" '.
				'when 2 then "'.getResource('jobs.type.2').'" '.
				'when 3 then "'.getResource('jobs.type.3').'" '.
				'when 4 then "'.getResource('jobs.type.4').'" '.
				'when 5 then "'.getResource('jobs.type.5').'" '.
				'end',
		),*/
		'job_type_name'=>array(
			'selector'=>'jt.name',
		),
		
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

?>