<?
$obj = array(
	'name'=>'coil_uses',
	'nick'=>'cs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_config_post, before_stamped_post, fix_item',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_config_post, after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'coil_uses c
	LEFT JOIN staff p ON p.id=c.person
	LEFT JOIN coil_items ci ON ci.id=c.item
	LEFT JOIN cities ct ON ct.id=ci.city
	LEFT JOIN coil_supplies cs ON cs.id = ci.supply
	LEFT JOIN coil_uses_info cui ON cui.coil_use=c.id
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'c.id',
		),
		'city'=>array(
			'selector'=>'ci.city',
		),
		'city_name'=>array(
			'selector'=>'ct.name',
		),
		'item_'=>array(
			'selector'=>'c.item',
			'desc'=>1,
			'log_by'=>'item_n',
		),
		'item_n'=>array(
			'bin'=>1,
			'selector'=>"ci.code",
		),
		'person'=>array(
			'selector'=>'c.person',
			'log_by'=>'person_n',
		),
		'person_n'=>array(
			'selector'=>'p.name',
		),
		'begin_date'=>array(
			'selector'=>'c.begin_date',
		),
		'begin_length'=>array(
			'selector'=>'c.begin_length',
		),
		'end_date'=>array(
			'selector' => 'c.end_date',
			'nullable'=>1,
		),
		'end_length' => array(
			'selector'=>'c.end_length',
		),
		'cable_type_name'=>array(
			'selector'=>'ci.cable_type',
			'log_by'=>'cable_type_name_f',
		),
		'cable_type_name_f'=>array(
			'selector'=>'case ci.cable_type
				when 1 then "'.getResource('cs.cable_type.1').'"
				when 2 then "'.getResource('cs.cable_type.2').'"
				when 4 then "'.getResource('cs.cable_type.4').'"
				else "" end',
		),
		'use_amount'=>array(
			'selector'=>'c.begin_length - c.end_length',
			'aggregate'=>'sum',
		),
		'cui_amount'=>array(
			'selector'=>'IFNULL(cui.amount, 0)',
			'aggregate'=>'sum',
		),
		'cui_delta'=>array(
			'selector'=>'c.begin_length - c.end_length - IFNULL(cui.amount, 0)',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

if(isset($GLOBALS['oper']->system_access['worker_features'])){
 $obj['filters']['by_worker'] = "c.person='".$GLOBALS['oper']->person."'"; //  alias  coil_uses - u
 $obj['fields']['person']['auto_insert'] = $GLOBALS['oper']->person;
}

?>