<?
$obj = array(
	'name'=>'connection_type_rules',
	'nick'=>'hprs',
	'masters'=>array(
		'connection_type_resources'=>array(
			'table'=>$GLOBALS['connection_type_resources'],
			'on'=>'id',
			'by'=>'connection_type_resource',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'connection_type_rules ctr
	LEFT JOIN connection_type_resources ctrs ON ctrs.id=ctr.connection_type_resource
	LEFT JOIN resource_types rt ON rt.id = ctrs.resource_type
	LEFT JOIN connection_types ct ON ct.id=ctrs.connection_type
	LEFT JOIN rules r ON r.id=ctr.rule
	LEFT JOIN tariffs t ON t.id=ctr.tariff
	LEFT JOIN tariffs tov ON tov.id=ctr.tariff_over
	LEFT JOIN stamps st ON st.id=ctr.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'ctr.id',
			'key'=>1,
		),
		'connection_type_resource'=>array(
			'selector'=>'ctr.connection_type_resource',
			'desc'=>1,
		),
		'rule'=>array(
			'selector'=>'ctr.rule',
			'desc'=>1,
			'log_by'=>'rule_name',
		),
		'rule_name'=>array(
			'selector'=>'r.name',
		),
		'tariff'=>array(
			'log_by'=>'tariff_name',
		),
		'tariff_name'=>array(
			'bin'=>1,
			'selector'=>'t.name',
		),
		'tariff_over'=>array(
			'log_by'=>'tariff_over_name',
		),
		'tariff_over_name'=>array(
			'bin'=>1,
			'selector'=>'tov.name',
		),
		'blockable'=>array(
			'selector'=>'ctr.blockable',
		),
		'stamp'=>array(
			'selector'=>'ctr.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>