<?
$obj = array(
	'fields'=>array(
		'name'=>array(
			'title'=>getResource('connection.types.name'),
			'required'=>1,
		),
		'city'=>array(
			'title'=>getResource('connection.types.city'),
			'control'=>'select',
			'list'=>'getCities',
		),
		'service_type'=>array(
			'title'=>getResource('connection.types.service.type'),
			'control' => 'bitset',
			'list'=>array(
				'1'=>getResource('connection.types.service.type.1'),
				'2'=>getResource('connection.types.service.type.2'),
			),
		),
		'period_months'=>array(
			'title'=>getResource('connection.types.period.months'),
			'comment'=>getResource('connection.types.period.months.comment'),
			'control'=>'short',
			'positive'=>1,
			'default'=>1,
		),
		'period_days'=>array(
			'title'=>getResource('connection.types.period.days'),
			'comment'=>getResource('connection.types.period.days.comment'),
			'control'=>'short',
			'positive'=>1,
			'default'=>0,
		),
		'abon_resource_type'=>array(
			'title'=>getResource('connection.types.abon.resource.type'),
			'link'=>'resource_types.php?id=[abon_resource_type]',
			'control'=>'lookup',
			'label'=>'[abon_resource_type_name]',
			'source'=>'?lookup=resource_type',
			'id'=>'lookup_resource_type',
		),
		'abon_dst'=>array(
			'title'=>getResource('connection.types.abon.dst'),
			'comment'=>getResource('connection.types.abon.dst.comment'),
			'link'=>'system_accounts.php?id=[abon_dst]',
			'control'=>'lookup',
			'label'=>'[abon_dst_name]',
			'source'=>'?lookup=abon_dst',
			'id'=>'lookup_abon_dst',
		),
		'abon_amount'=>array(
			'title'=>getResource('connection.types.abon.amount'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'positive'=>1,
			'default'=>0,
		),
		'start_always'=>array(
			'title'=>getResource('connection.types.start.always'),
			'comment'=>getResource('connection.types.start.always.comment'),
			'control'=>'checkbox',
			'default'=>0,
		),
		'unshape_charge_type'=>array(
			'title'=>getResource('connection.types.unshape.charge.type'),
			'link'=>'charge_types.php?id=[unshape_charge_type]',
			'control'=>'lookup',
			'label'=>'[unshape_charge_type_name]',
			'source'=>'?lookup=charge_type',
			'id'=>'lookup_charge_type',
		),
		'allow_enter'=>array(
			'title'=>getResource('connection.types.allow.enter'),
			'comment'=>getResource('connection.types.allow.enter.comment'),
			'control'=>'checkbox',
			'default'=>1,
		),
		'enter_cost'=>array(
			'title'=>getResource('connection.types.enter.cost'),
			'comment'=>getResource('connection.types.enter.cost.comment'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'positive'=>1,
			'default'=>0,
		),
		'max_hosts'=>array(
			'title'=>getResource('connection.types.max.hosts'),
			'comment'=>getResource('connection.types.max.hosts.comment'),
			'control'=>'short',
			'default'=>0,
		),
		'allow_leave'=>array(
			'title'=>getResource('connection.types.allow.leave'),
			'comment'=>getResource('connection.types.allow.leave.comment'),
			'control'=>'checkbox',
			'default'=>1,
		),
		'allow_credits'=>array(
			'title'=>getResource('connection.types.allow.credits'),
			'comment'=>getResource('connection.types.allow.credits.comment'),
			'control'=>'checkbox',
			'default'=>1,
		),
		'port_speed'=>array(
			'title'=>getResource('connection.types.port.speed'),
			'comment'=>getResource('connection.types.port.speed.comment'),
			'control'=>'short',
		),
		'gigabit'=>array(
			'title'=>getResource('connection.types.gigabit'),
			'comment'=>getResource('connection.types.gigabit.comment'),
			'control'=>'checkbox',
		),
		/*
		'public'=>array(
			'title'=>getResource('connection.types.public'),
			'comment'=>getResource('connection.types.public.comment'),
			'control'=>'checkbox',
			'default'=>1,
		),
		*/
		'replace_by'=>array(
			'title'=>getResource('connection.types.replace.by'),
			'comment'=>getResource('connection.types.replace.by.comment'),
			'link'=>'connection_types.php?id=[replace_by]',
			'control'=>'lookup',
			'label'=>'[replace_by_name]',
			'source'=>'?lookup=replace_by',
			'id'=>'lookup_replace_by',
		),
		'replace_after'=>array(
			'title'=>getResource('connection.types.replace.after'),
			'comment'=>getResource('connection.types.replace.after.comment'),
			'control'=>'short',
		),
		'replace_date'=>array(
			'title'=>getResource('connection.types.replace.date'),
			'comment'=>getResource('connection.types.replace.date.comment'),
			'control'=>'date',
			'with_time'=>1,
		),
		'first_charge_amount'=>array(
			'title'=>getResource('connection.types.first.charge.amount'),
			'comment'=>getResource('connection.types.first.charge.amount.comment'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
		),
		'first_free_amount'=>array(
			'title'=>getResource('connection.types.first.free.amount'),
			'comment'=>getResource('connection.types.first.free.amount.comment'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
		),
		'first_free_limit'=>array(
			'title'=>getResource('connection.types.first.free.limit'),
			'comment'=>getResource('connection.types.first.free.limit.comment'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
		),
		'igmp_profile'=>array(
			'title'=>getResource('connection.types.igmp.profile'),
			'control'=>'short',
		),
		'igmp_max_groups'=>array(
			'title'=>getResource('connection.types.igmp.max.groups'),
			'control'=>'short',
		),
		'igmp_block'=>array(
			'title'=>getResource('connection.types.igmp.block'),
			'comment'=>getResource('connection.types.igmp.block.comment'),
			'control'=>'checkbox',
		),
		'credit_con_type'=>array(
			'title'=>getResource('connection.types.credit.con.type'),
			'comment'=>getResource('connection.types.credit.con.type.comment'),
			'link'=>'connection_types.php?id=[credit_con_type]',
			'control'=>'lookup',
			'label'=>'[credit_con_type_name]',
			'source'=>'?lookup=credit_con_type',
			'id'=>'lookup_credit_con_type',
		),
		'action'=>array(
			'title'=>getResource('connection.types.action'),
			'comment'=>getResource('connection.types.action.comment'),
			'link'=>'actions.php?id=[action]',
			'control'=>'lookup',
			'label'=>'[action_name]',
			'source'=>'?lookup=action',
			'id'=>'lookup_action',
		),
		'offline_type'=>array(
			'title'=>getResource('connection.types.offline.type'),
			'comment'=>getResource('connection.types.offline.type.comment'),
			'link'=>'connection_types.php?id=[offline_type]',
			'control'=>'lookup',
			'label'=>'[offline_type_name]',
			'source'=>'?lookup=offline_type',
			'id'=>'lookup_offline_type',
		),
		'created'=>array(
			'readonly'=>1,
			'title'=>getResource('connection.types.created'),
		),
		'created_name'=>array(
			'title'=>getResource('connection.types.created.by'),
			'readonly'=>1,
		),
		'modified'=>array(
			'readonly'=>1,
			'title'=>getResource('connection.types.modified'),
		),
		'modified_name'=>array(
			'title'=>getResource('connection.types.modified.by'),
			'readonly'=>1,
		),
	),
);
?>