<?
$obj = array(
	'name'=>'ecalls',
	'nick'=>'ecls',
	'BeforePost'=>'before_stamped_post',
	'BeforeInsert'=>'before_stamped_insert',
	'AfterInsert'=>'after_logged_insert, correct_house',
	'AfterPost'=>'after_logged_post, correct_house',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'ecalls e
	LEFT JOIN clients ic ON ic.id=e.in_client
	LEFT JOIN back_count bc ON bc.ecall=e.id
	LEFT JOIN ecalls_back eb ON eb.id=bc.last
	LEFT JOIN client_links x ON x.house_id = e.assumed_house AND x.apartment = e.apartment
	LEFT JOIN clients c ON c.id=x.id
	LEFT JOIN has_pay p ON p.account=c.account
	LEFT JOIN connection_types ct ON ct.id=c.connection_type
	LEFT JOIN tv_types tt ON tt.id=c.tv_type
	LEFT JOIN houses h ON h.id=e.assumed_house
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN stamps st ON st.id=e.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'e.id',
		),
		'in_client_id'=>array(
			'selector'=>'e.in_client',
		),
		'in_client'=>array(
			'selector'=>'IF(e.in_client > 0, "'.getResource('ecalls.in.client.1').'", "'.getResource('ecalls.in.client.0').'")',
		),
		'in_client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(ic.last_name, " ", ic.first_name, " (", IFNULL(ic.contract, ""),")")',
		),
		'in_state'=>array(
			'selector'=>'CASE e.in_state
				WHEN 1 THEN "'.getResource('ecalls.in.state.1').'"
				WHEN 2 THEN "'.getResource('ecalls.in.state.2').'"
				WHEN 3 THEN "'.getResource('ecalls.in.state.3').'"
				ELSE "" END',
		),
		'filename'=>array(
			'selector'=>'e.filename',
		),
		'ecall_id'=>array(
			'selector'=>'e.ecall_id',
		),
		'src'=>array(
			'selector'=>'e.src',
			'log_by'=>'src_name',
		),
		'src_name'=>array(
			'selector'=>'CASE e.src 
				WHEN 1 THEN "'.getResource('ecalls.src.1').'"
				WHEN 2 THEN "'.getResource('ecalls.src.2').'"
				WHEN 3 THEN "'.getResource('ecalls.src.3').'"
				ELSE "" END',
		),
		'street'=>array(
			'selector'=>'e.street',
		),
		'house'=>array(
			'selector'=>'e.house',
		),
		'apartment'=>array(
			'selector'=>'e.apartment',
		),
		'contact'=>array(
			'selector'=>'e.contact',
		),
		'phone'=>array(
			'selector'=>'e.phone',
		),
		'mobile'=>array(
			'selector'=>'e.mobile',
		),
		'tariff'=>array(
			'selector'=>'e.tariff',
		),
		'tariff_tv'=>array(
			'selector'=>'e.tariff_tv',
		),
		'concurent'=>array(
			'selector'=>'e.concurent',
		),
		'ecall_operator'=>array(
			'selector'=>'e.ecall_operator',
		),
		'notes'=>array(
			'selector'=>'e.notes',
		),
		'date'=>array(
			'selector'=>'e.date',
		),
		'state'=>array(
			'selector'=>'e.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'CASE e.state
				WHEN 0 THEN "'.getResource('ecalls.state.0').'"
				WHEN 1 THEN "'.getResource('ecalls.state.1').'"
				WHEN 2 THEN CONCAT("'.getResource('ecalls.state.2').'", " ", IFNULL(DATE_FORMAT(eb.recall_date, "%Y-%m-%d %H:%i"), ""))
				WHEN 3 THEN "'.getResource('ecalls.state.3').'"
				WHEN 4 THEN "'.getResource('ecalls.state.4').'"
				WHEN 5 THEN "'.getResource('ecalls.state.5').'"
				ELSE "" END',
		),
		'connection_type'=>array(
			'selector'=>'e.connection_type',
			'nullable'=>1,
			'log_by'=>'connection_type_name',
		),
		'connection_type_name'=>array(
			'selector'=>'ct.name',
		),
		'tv_type'=>array(
			'selector'=>'e.tv_type',
			'nullable'=>1,
			'log_by'=>'tv_type_name',
		),
		'tv_type_name'=>array(
			'selector'=>'tt.name',
		),
		'district'=>array(
			'selector'=>'h.district',
		),
		'district_name'=>array(
			'selector'=>'d.name',
		),
		'street_name'=>array(
			'selector'=>'s.name',
		),
		'assumed_house'=>array(
			'selector'=>'e.assumed_house',
			'nullable'=>1,
		),
		/*'assumed_house_sign'=>array(
			'selector'=>'IF(h.id IS NOT NULL, IF(h.state=1, "+", "-"), "")',
		),*/
		'assumed_house_sign'=>array(
			'selector'=>'case h.internet
				when 2 then "*"
				when 1 then "+"
				when 0 then "-"
				else "" end',
		),
		'has_pay_sign'=>array(
			'selector'=>'IF(p.account IS NULL, "-", "+")'
		),
		'sale_date'=>array(
			'selector'=>'e.sale_date',
		),
		'backs'=>array(
			'selector'=>'IFNULL(bc.amount, 0)',
		),
		'stamp'=>array(
			'selector'=>'e.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>