<?
$obj = array(
	'name'=>'exp_materials',
	'nick'=>'exm',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert,after_materials_post',
	'AfterPost'=>'after_logged_post,after_materials_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, after_materials_delete',
	'source'=>'exp_materials s
	LEFT JOIN materials_in_use mu ON mu.material=s.id
	LEFT JOIN materials_storage ms ON ms.material=s.id
	LEFT JOIN materials_off mo ON mo.material=s.id
	LEFT JOIN materials_awaiting ma ON ma.material=s.id
	LEFT JOIN stamps st ON st.id=s.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'s.id',
		),
		'name'=>array(
			'desc'=>1,
			'selector'=>'s.name',
		),
		'amount_in_use'=>array(
			'selector'=>'IFNULL(mu.amount,0)',
			'aggregate'=>'sum',
		),
		'amount_storage'=>array(
			'selector'=>'IFNULL(ms.amount,0)',
			'aggregate'=>'sum',
		),
		'amount_off'=>array(
			'selector'=>'IFNULL(mo.amount,0)',
			'aggregate'=>'sum',
		),
		'amount_awaiting'=>array(
			'selector'=>'IFNULL(ma.amount,0)',
			'aggregate'=>'sum',
		),
		'amount_total'=>array(
			'selector'=>'(IFNULL(mu.amount,0) + IFNULL(ms.amount,0) + IFNULL(mo.amount,0))',
			'aggregate'=>'sum',
		),
		'unit'=>array(
			'selector'=>'s.unit',
			'log_by'=>'unit_name',
		),
		'unit_name'=>array(
			'selector'=>'case s.unit
				when 1 then "'.getResource('exp.materials.unit.1').'"
				when 2 then "'.getResource('exp.materials.unit.2').'"
				when 3 then "'.getResource('exp.materials.unit.3').'"
				when 4 then "'.getResource('exp.materials.unit.4').'"
				else "" end',
		),
		'code'=>array(
			'selector'=>'s.code',
		),
		'description'=>array(
			'selector'=>'s.description',
		),
		'notes'=>array(
			'selector'=>'s.notes',
		),
		'has_photo'=>array(
			'selector'=>'IF(s.photo_file IS NOT NULL, "+", "-")',
		),
		'photo_file'=>array(
			'selector'=>'s.photo_file',
		),
		'stamp'=>array(
			'selector'=>'s.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>