<?
$obj = array(
	'name'=>'exp_trunks',
	'nick'=>'ext',
	'BeforeInsert'=>'before_stamped_insert, check_trunk_city',
	'BeforePost'=>'before_stamped_post, check_trunk_city',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'exp_trunks s
	LEFT JOIN cities c ON c.id=s.city
	LEFT JOIN exp_executors ex ON ex.id=s.executor
	LEFT JOIN exp_points bp ON bp.id=s.begin_point
	LEFT JOIN houses bh ON bh.id=bp.house
	LEFT JOIN streets bs ON bs.id=bh.street
	LEFT JOIN exp_points ep ON ep.id=s.end_point
	LEFT JOIN houses eh ON eh.id=ep.house
	LEFT JOIN streets es ON es.id=eh.street
	LEFT JOIN exp_materials m ON m.id=s.material
	LEFT JOIN stamps st ON st.id=s.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'s.id',
		),
		'city'=>array(
			'selector'=>'s.city',
			'log_by'=>'city_name',
			'desc'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'begin_point'=>array(
			'selector'=>'s.begin_point',
			'log_by'=>'begin_point_name',
		),
		'begin_point_name'=>array(
			'selector'=>'CONCAT(bs.name, " ", bh.house, " '.getResource('exp.points.entrance.short').'", IFNULL(bp.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case bp.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(bp.floor,"") end)',
		),
		'end_point'=>array(
			'selector'=>'s.end_point',
			'log_by'=>'end_point_name',
		),
		'end_point_name'=>array(
			'selector'=>'CONCAT(es.name, " ", eh.house, " '.getResource('exp.points.entrance.short').'", IFNULL(ep.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case ep.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(ep.floor,"") end)',
		),
		'type'=>array(
			'selector'=>'s.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'case s.type
				when 1 then "'.getResource('exp.trunks.type.1').'"
				when 2 then "'.getResource('exp.trunks.type.2').'"
				when 3 then "'.getResource('exp.trunks.type.3').'"
				else "" end',
		),
		'executor'=>array(
			'selector'=>'s.executor',
			'nullable'=>1,
			'log_by'=>'executor_name',
		),
		'executor_name'=>array(
			'selector'=>'ex.name',
		),
		'material'=>array(
			'selector'=>'s.material',
			'log_by'=>'material_name',
		),
		'material_name'=>array(
			'selector'=>'m.name',
		),
		'length'=>array(
			'selector'=>'s.length',
			'aggregate'=>'sum',
		),
		'notes'=>array(
			'selector'=>'s.notes',
		),
		'date'=>array(
			'selector'=>'s.date',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'s.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>