<?
$obj = array(
	'name'=>'job_problem_types',
	'nick'=>'jpts',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'job_problem_types p
	LEFT JOIN cities c ON c.id=p.city
	LEFT JOIN stamps st ON st.id=p.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'p.id',
		),
		'city'=>array(
			'selector'=>'p.city',
			'nullable'=>1,
			'log_by'=>'city_name',
		),
		'city_name'=>array(
			'selector'=>"c.name",
		),
		'name'=>array(
			'desc'=>1,
			'selector'=>'p.name',
		),
		'service_type'=>array(
			'desc'=>1,
			'selector'=>'p.service_type',
			'log_by'=>'service_type_name',
		),
		'service_type_name' => array(
			'selector'=>'case p.service_type
				when 1 then "'.getResource('jpt.service.type.1').'"
				when 2 then "'.getResource('jpt.service.type.2').'"
				when 3 then "'.getResource('jpt.service.type.3').'"
				else "" end',
		),
		'notes'=>array(
			'selector'=>'p.notes',
		),
		'stamp'=>array(
			'selector'=>'p.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
			'skip_log'=>1,
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>