<?
$obj = array(
	'fields'=>array(
		'id'=>array(
			'readonly'=>1,
		),
		'contract'=>array(
			'comment'=>getResource('jobs.contract.comment'),
			'control'=>'short',
		),
		'date'=>array(
			'control'=>'date',
			'with_time'=>1,
			'default'=>$GLOBALS['calendar']->getDate().' 00:00:00',
			'comment'=>'<select id="worker_candidates"></select>',
		),
		'client_id'=>array(
			'control'=>'lookup',
			'comment'=>'<a href="javascript:cliTracker.track();">'.getResource('jobs.full.by.client').'</a>',
			'label'=>'[client_name]',
			'source'=>'?lookup=client',
			'link'=>'clients.php?id=[client_id]',
			'id'=>'lookup_client',
		),
		'city'=>array(
			'title'=>getResource('jobs.city'),
			'link'=>'cities.php?id=[city]',
			'default'=>isset($GLOBALS['def']['city']) ? $GLOBALS['def']['city'] : 1,
			'required'=>1,
			'control'=>'select',
			'list'=>'getCities',
			'skip_finder'=>1,
		),
		'house_id'=>array(
			'required'=>1,
			'link'=>'houses.php?id=[house_id]',
			'control'=>'lookup',
			'label'=>'[street_name] [house]',
			'source'=>'?lookup=house',
			'default'=>$GLOBALS['def']['house_id'],
			'id'=>'lookup_house',
			'comment'=>'[district_name] [served_by]',
		),
		'apartment'=>array(
			'control'=>'short',
			'positive'=>1,
			'default'=>$GLOBALS['def']['apartment'],
			'comment'=>'<span id="existent"></span>',
		),
		'entrance'=>array(
			'control'=>'short',
			'positive'=>1,
		),
		'floor'=>array(
			'control'=>'short',
			'positive'=>1,
		),
		'client'=>array(
			'default'=>$GLOBALS['def']['contact'],
		),
		'phone'=>array(
			'default'=>$GLOBALS['def']['phone'],
		),
		'type'=>array(
			'control'=>'select',
			'required'=>1,
			'control'=>'lookup',
			'source'=>'?lookup=job_type',
			'default'=>isset($GLOBALS['def']['type']) ? $GLOBALS['def']['type'] : 1,
			'id'=>'lookup_job_type',
		),
		'worker'=>array(
			'control'=>'select',
			'list'=>'getWorkersByJob',
			'link'=>'staff.php?id=[worker]',
		),
		'state'=>array(
			'control'=>'select',
			'skip_finder'=>1,
			'table'=>1,
			'list'=>array(
				'1'=>getResource('jobs.state.1'),
				'2'=>getResource('jobs.state.2'),
				'3'=>getResource('jobs.state.3'),
				'4'=>getResource('jobs.state.4'),
				'5'=>getResource('jobs.state.5'),
			),
		),
		'notes'=>array(
			'control'=>'textarea',
			'height'=>6,
		),
		'found_by'=>array(
			'skip_finder'=>1,
			'control'=>'select',
			'list'=>'getJobsFinders',
			'link'=>'jobs_finders.php?id=[found_by]',
		),
		'found_by_client'=>array(
			'control'=>'lookup',
			'label'=>'[found_by_client_name]',
			'source'=>'?lookup=client',
			'id'=>'lookup_fclient',
		),
		'found_by_memo'=>array(
			'control'=>'textarea',
			'height'=>3,
		),
		'used_before'=>array(
			'skip_finder'=>1,
			'control'=>'select',
			'list'=>array(
				'0'=>getResource('jobs.used.before.0'),
				'1'=>getResource('jobs.used.before.1'),
			),
		),
		'used_before_memo'=>array(
		),
		'skip_graph'=>array(
			'control'=>'checkbox',
		),
		'created'=>array(
			'readonly'=>1,
		),
		'created_name'=>array(
			'readonly'=>1,
		),
		'modified'=>array(
			'readonly'=>1,
		),
		'modified_name'=>array(
			'readonly'=>1,
		),
	),
);
?>