<?
$obj = array(
	'name'=>'modems',
	'nick'=>'mds',
	'BeforeInsert'=>'before_modem_apply, before_stamped_insert, check_modem_city',
	'BeforePost'=>'before_modem_apply, before_stamped_post, check_modem_city',
	'BeforeDelete'=>'before_modem_delete',
	'AfterInsert'=>'after_modem_insert, after_logged_insert',
	'AfterPost'=>'after_modem_post, after_logged_post',
	'AfterDelete'=>'after_modem_delete, after_stamped_delete, after_logged_delete',
	'source'=>'modems m
	LEFT JOIN cities c ON c.id=m.city
	LEFT JOIN modems ms ON ms.id=m.modem
	LEFT JOIN trunk_modems tm ON tm.id=m.id
	LEFT JOIN modems_models mm ON mm.model=m.model
	LEFT JOIN domains d ON d.id = m.domain
	LEFT JOIN domains msd ON msd.id = ms.domain
	LEFT JOIN modem_profiles p ON p.id = m.profile
	LEFT JOIN exp_points ex ON ex.id=m.exp_point
	LEFT JOIN houses ph ON ph.id=ex.house
	LEFT JOIN districts ds ON ds.id=ph.district
	LEFT JOIN admin_districts ad ON ad.id=ds.admin
	LEFT JOIN streets ps ON ps.id=ph.street
	LEFT JOIN streets s ON s.id = m.street
	LEFT JOIN departments dp ON dp.id = m.department
	LEFT JOIN modems_states x ON x.id = m.state_id
	LEFT JOIN modems_clients mc ON mc.modem=m.id
	LEFT JOIN modems_gigabit g ON g.modem=m.id
	LEFT JOIN stamps st ON st.id=m.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'m.id',
		),
		'city'=>array(
			'selector'=>'m.city',
			'log_by'=>'city_name',
			'desc'=>1,
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'name'=>array(
			'bin'=>1,
			'desc'=>1,
			'selector'=>'m.name',
		),
		'managment_vlan'=>array(
			'selector'=>'m.managment_vlan',
		),
		'vlan'=>array(
			'selector'=>'m.vlan',
			'nullable'=>1,
		),
		'check_power'=>array(
			'selector'=>'m.check_power',
		),
		'auto_update'=>array(
			'selector'=>'m.auto_update',
		),
		'ip'=>array (
			'desc'=>1,
			'selector'=>'m.ip',
			'order_by'=>'INET_ATON(m.ip)',
		),
		'mac'=>array(
			'selector'=>'m.mac',
			'nullable'=>1,
		),
		'cacti_id'=>array(
			'selector'=>'m.cacti_id',
			'nullable'=>1,
		),
		'exp_point'=>array(
			'selector'=>'m.exp_point',
			'nullable'=>1,
			'log_by'=>'exp_point_name',
		),
		'exp_point_name'=>array(
			'selector'=>'CONCAT(ps.name, " ", ph.house, " '.getResource('exp.points.entrance.short').'", IFNULL(ex.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case ex.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(ex.floor,"") end)',
		),
		'house_internet' => array(
			'selector'=>'case ph.internet
				when 2 then "*"
				when 1 then "+"
				when 0 then "-"
				else "" end',
		),
		'type'=>array(
			'selector'=>'m.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE m.type 
				WHEN 1 THEN "'.getResource('modems.type.1').'" 
				WHEN 2 THEN "'.getResource('modems.type.2').'" 
				WHEN 3 THEN "'.getResource('modems.type.3').'" 
				ELSE "" END',
		),
		'ip_core_route'=>array(
			'selector'=>'tm.ip_core_route',
			'bin'=>1,
			'nullable'=>1,
		),
		'real_ip_vlan'=>array(
			'selector'=>'tm.real_ip_vlan',
		),
		'modem'=>array(
			'selector'=>'m.modem',
			'nullable'=>1,
			'log_by'=>'modem_name',
		),
		'modem_name'=>array(
			'bin'=>1,
			'selector'=>"CONCAT(IFNULL(CONCAT(msd.name, '.'), ''), ms.name, ' (', ms.ip, ')')",
		),
		'uplink'=>array(
			'selector'=>'m.uplink',
		),
		'port'=>array(
			'selector'=>'m.port',
		),
		'address_space'=>array(
			'selector'=>'m.address_space',
			'bin'=>1,
			'nullable'=>1,
		),
		'domain'=>array(
			'selector'=>'m.domain',
			'nullable'=>1,
			'log_by'=>'domain_name',
		),
		'domain_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'profile'=>array(
			'selector'=>'m.profile',
			'log_by'=>'profile_name',
		),
		'profile_name'=>array(
			'bin'=>1,
			'selector'=>'p.name',
		),
		'street'=>array(
			'selector'=>'m.street',
			'nullable'=>1,
			'log_by'=>'street_name',
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'district'=>array(
			'selector'=>'ph.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'admin_district'=>array(
			'selector'=>'ds.admin',
		),
		'admin_district_name'=>array(
			'selector'=>'ad.name',
		),
		'house'=>array(
			'selector'=>'m.house',
		),
		'entrance'=>array(
			'selector'=>'m.entrance',
		),
		'floor'=>array(
			'selector'=>'m.floor',
		),
		'check_address'=>array(
			'selector'=>'m.check_address',
		),
		'up_since'=>array(
			'selector'=>'m.up_since',
		),
		'model'=>array(
			'selector'=>'m.model',
		),
		'firmware'=>array(
			'selector'=>'m.firmware',
		),
		'loader'=>array(
			'selector'=>'m.loader',
		),
		'diag'=>array(
			'selector'=>'m.diag',
		),
		'power'=>array(
			'selector'=>'m.power',
		),
		'power_name'=>array(
			'selector'=>'CASE m.power
				WHEN 1 THEN "'.getResource('modems.power.1').'"
				WHEN 2 THEN "'.getResource('modems.power.2').'"
				WHEN 3 THEN "'.getResource('modems.power.3').'"
				ELSE "" END',
		),
		'model_id'=>array(
			'selector'=>'mm.id',
		),
		'm_firmware'=>array(
			'selector'=>'mm.firmware',
		),
		'm_loader'=>array(
			'selector'=>'mm.loader',
		),
		'm_diag'=>array(
			'selector'=>'mm.diag',
		),

		'x_firmware'=>array(
			'selector'=>'CONCAT(m.firmware, IF(mm.firmware, IF(m.firmware=mm.firmware, "+", "-"), ""))',
		),
		'x_loader'=>array(
			'selector'=>'CONCAT(m.loader, IF(mm.loader, IF(m.loader=mm.loader, "+", "-"), ""))',
		),
		'x_diag'=>array(
			'selector'=>'CONCAT(m.diag, IF(mm.diag, IF(m.diag=mm.diag, "+", "-"), ""))',
		),

		'department'=>array(
			'selector'=>'m.department',
			'log_by'=>'department_name',
		),
		'department_name'=>array(
			'bin'=>1,
			'selector'=>'dp.name',
		),
		'notes'=>array(
			'selector'=>'m.notes',
		),
		'state'=>array(
			'selector'=>'x.state',
		),
		'loss_in'=>array(
			'selector'=>'(x.loss_in - x.loss_in_prev)',
		),
		'loss_out'=>array(
			'selector'=>'(x.loss_out - x.loss_out_prev)',
		),
		'state_sign'=>array(
			'selector'=>'IF((m.audit=0) || (x.state IS NULL), "", IF(x.state, "+", "-"))',
		),
		'state_date'=>array(
			'selector'=>'IF(m.audit=0, "", x.date)',
		),
		'audit'=>array(
			'selector'=>'m.audit',
		),
		'clients'=>array(
			'selector'=>'IFNULL(mc.amount,0)',
		),
		'clients_2'=>array(
			'selector'=>'IFNULL(mc.amount_2,0)',
			'aggregate'=>'sum',
		),
		'apartments'=>array(
			'selector'=>'IFNULL(mc.apartments,0)',
		),
		'apartments_mask'=>array(
			'selector'=>'32 - ROUND(LOG2((IFNULL(mc.apartments,0) - IFNULL(mc.amount,0)) * 0.4 + IFNULL(mc.amount,0)))',
		),
		'population'=>array(
			'selector'=>'round(IFNULL(mc.amount,0) / IFNULL(mc.apartments,0) * 100,2)',
		),
		'off_all'=>array(
			'selector'=>'CONCAT(m.off_all DIV 3600 , " ", LPAD((m.off_all MOD 3600) DIV 60, 2, "0"), "")',
			'order_by'=>'m.off_all',
		),
		'off_month'=>array(
			'selector'=>'CONCAT(m.off_month DIV 3600 , " ", LPAD((m.off_month MOD 3600) DIV 60, 2, "0"), "")',
			'order_by'=>'m.off_month',
		),
		'clients_gig'=>array(
			'selector'=>'IFNULL(g.amount, 0)',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'m.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['fields']['department']['auto_insert'] = $d;
	$obj['filters']['department'] = "m.department='$d'";
}
?>