<?
$obj = array(
	'name'=>'resource_uses',
	'nick'=>'rus',
	'masters'=>array(
		'periods'=>array(
			'table'=>$GLOBALS['personal_periods'],
			'on'=>'id',
			'by'=>'personal_period',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterDelete'=>'after_stamped_delete',
	'source'=>'resource_uses ru
	LEFT JOIN calendar_periods cp ON cp.id=ru.calendar_period
	LEFT JOIN personal_periods pp ON pp.id=ru.personal_period
	LEFT JOIN clients c ON c.id=pp.client
	LEFT JOIN resource_types rt ON rt.id=ru.resource_type
	LEFT JOIN src_names s ON s.id=ru.src
	LEFT JOIN dst_names d ON d.id=ru.dst
	LEFT JOIN movements m ON m.id=ru.movement
	LEFT JOIN stamps st ON st.id=ru.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'ru.id',
		),
		'calendar_period'=>array(
			'selector'=>'ru.calendar_period',
		),
		'calendar_period_begin'=>array(
			'bin'=>1,
			'selector'=>'cp.period_begin',
		),
		'calendar_period_end'=>array(
			'bin'=>1,
			'selector'=>'cp.period_end',
		),
		'personal_period'=>array(),
		'personal_period_begin'=>array(
			'bin'=>1,
			'selector'=>'pp.period_begin',
		),
		'personal_period_end'=>array(
			'bin'=>1,
			'selector'=>'pp.period_end',
		),
		'client'=>array(
			'selector'=>'pp.client',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login, ")")',
		),
		'resource_type'=>array(),
		'resource_type_name'=>array(
			'bin'=>1,
			'selector'=>'rt.name',
		),
		'amount'=>array(
			'selector'=>'ru.amount',
			'aggregate'=>'sum',
		),
		'unit_size'=>array(
			'selector'=>'ru.unit_size',
		),
		'price'=>array(
			'selector'=>'ru.price',
		),
		'price_cur'=>array(
			'selector'=>'ru.price/100',
		),
		'cost'=>array(
			'selector'=>'floor(ru.amount * ru.price / ru.unit_size)',
		),
		'cost_cur'=>array(
			'selector'=>'floor(ru.amount * ru.price / ru.unit_size)/100',
			'aggregate'=>'sum',
		),
		'src'=>array(
			'selector'=>'ru.src',
		),
		'src_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'src_type'=>array(
			'bin'=>1,
			'selector'=>'s.type',
		),
		'src_link'=>array(
			'bin'=>1,
			'selector'=>'s.link',
		),
		'dst'=>array(
			'selector'=>'ru.dst',
		),
		'dst_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'dst_type'=>array(
			'bin'=>1,
			'selector'=>'d.type',
		),
		'dst_link'=>array(
			'bin'=>1,
			'selector'=>'d.link',
		),
		'movement'=>array(
			'selector'=>'ru.movement',
		),
		'moved'=>array(
			'bin'=>1,
			'selector'=>'m.date',
		),
		'stamp'=>array(
			'selector'=>'ru.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>