<?
$obj = array(
	'name'=>'personal_periods',
	'nick'=>'pps',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_personal_period_post,before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_personal_period_post, after_logged_post',
	'AfterDelete'=>'after_personal_period_delete,after_stamped_delete, after_logged_delete',
	'source'=>'personal_periods pp
	LEFT JOIN clients c ON c.id = pp.client
	LEFT JOIN cities ci ON ci.id=c.city
	LEFT JOIN connection_types ct ON ct.id = pp.connection_type
	LEFT JOIN tv_types tt ON tt.id = pp.tv_type
	LEFT JOIN state_names sn ON sn.state=pp.state
	LEFT JOIN stamps st ON st.id=pp.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'pp.id',
		),
		'next'=>array(
			'selector'=>'pp.next',
		),
		'client'=>array(
			'desc'=>1,
			'log_by'=>'client_name',
			'selector'=>'pp.client',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'city'=>array(
			'selector'=>'c.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'connection_type'=>array(
			'selector'=>'pp.connection_type',
			'log_by'=>'connection_type_name',
		),
		'connection_type_name'=>array(
			'bin'=>1,
			'selector'=>'ct.name',
		),
		'tv_type'=>array(
			'selector'=>'pp.tv_type',
			'log_by'=>'tv_type_name',
			'nullable'=>1,
		),
		'tv_type_name'=>array(
			'bin'=>1,
			'selector'=>'tt.name',
		),
		'period_begin'=>array(
			'desc'=>1,
		),
		'period_end'=>array(
			'desc'=>1,
		),
		'state'=>array(
			'selector'=>'pp.state',
		),
		'state_name'=>array(
			'selector'=>'sn.name',
		),
		'note'=>array(
			'selector'=>'pp.note',
		),
		'stamp'=>array(
			'selector'=>'pp.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>