<?
$obj = array(
	'name'=>'portmone_bills',
	'nick'=>'pmbs',
	'source'=>'portmone_bills pm
	LEFT JOIN portmone_bills_pays pp ON pp.bill=pm.id
	LEFT JOIN portmone_bills_orders_details d ON d.pay=pp.id
	LEFT JOIN portmone_bills_orders o ON o.id=d.portmone_order
	LEFT JOIN movements m ON m.id = pp.movement
	LEFT JOIN clients c ON c.id = pm.client
	LEFT JOIN cities ci ON ci.id=c.city',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'pm.id',
		),
		'client'=>array(
			'selector'=>'pm.client',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'city'=>array(
			'selector'=>'c.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'contract'=>array(
			'selector'=>'pm.contract',
		),
		'payee'=>array(
			'selector'=>'pm.payee',
		),
		'period'=>array(
			'selector'=>'pm.period',
		),
		'date'=>array(
			'selector'=>'pm.date',
			'selector'=>'DATE_FORMAT(pm.date, "%Y-%m-%d %H:%i")',
		),
		'amount'=>array(
			'selector'=>'pm.amount / 100',
			'aggregate'=>'sum',
		),
		'pay'=>array(
			'selector'=>'pp.id',
		),
		'portmone_id'=>array(
			'selector'=>'pp.portmone_id',
		),
		'pay_date'=>array(
			'selector'=>'DATE_FORMAT(pp.date, "%Y-%m-%d")',
		),
		'pay_amount'=>array(
			'selector'=>'pp.amount / 100',
			'aggregate'=>'sum',
		),
		'movement'=>array(
			'selector'=>'pp.movement',
		),
		'movement_amount'=>array(
			'selector'=>'m.amount/100',
			'aggregate'=>'sum',
		),
		'detail'=>array(
			'selector'=>'d.id',
		),
		'detail_amount'=>array(
			'selector'=>'d.amount / 100',
			'aggregate'=>'sum',
		),
		'detail_commission'=>array(
			'selector'=>'d.commission / 100',
			'aggregate'=>'sum',
		),
		'porder'=>array(
			'selector'=>'o.id',
		),
		'porder_id'=>array(
			'selector'=>'o.order_id',
		),
		'porder_date'=>array(
			'selector'=>'DATE_FORMAT(o.date, "%Y-%m-%d")',
		),
		'porder_bank'=>array(
			'selector'=>'o.bank_name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>