<?
$obj = array(
	'name'=>'ip_uses',
	'nick'=>'ipus',
	'masters'=>array(
		'resource_uses'=>array(
			'table'=>$GLOBALS['personal_period_resource_uses'],
			'on'=>'id',
			'by'=>'personal_period_resource_use',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert, after_ip_use_insert',
	'AfterPost'=>'after_logged_post, after_ip_use_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, after_ip_use_delete',
	'source'=>'ip_uses iu
	LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN hosts h ON h.id=iu.host
	LEFT JOIN rules r ON r.id=iu.rule
	LEFT JOIN stamps st ON st.id=iu.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'iu.id',
		),
		'personal_period_resource_use'=>array(
			'selector'=>'iu.personal_period_resource_use',
		),
		'resource_use'=>array(
			'selector'=>'ppru.resource_use',
		),
		'host'=>array(
			'desc'=>1,
		),
		'host_ip'=>array(
			'bin'=>1,
			'selector'=>'h.ip',
			'order_by'=>'INET_ATON(h.ip)',
		),
		'rule'=>array(
			'desc'=>1,
		),
		'rule_name'=>array(
			'bin'=>1,
			'selector'=>'r.name',
		),
		'bytes'=>array(
			'selector'=>'iu.bytes',
			'aggregate'=>'sum',
		),
		'label'=>array(
			'selector'=>'iu.label',
			'nullable'=>1,
		),
		'cost'=>array(
			'selector'=>'iu.bytes * ru.price / ru.unit_size / 100',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'iu.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>