<?
$obj = array(
	'name'=>'jobs',
	'nick'=>'rls',
	
	'BeforeInsert'=>'before_rule_insert, before_stamped_insert',
	'BeforePost'=>'before_rule_post, before_stamped_post',
	'BeforeDelete'=>'before_rule_delete',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_rule_delete, after_stamped_delete, after_logged_delete',
	'source'=>'jobs j 
	LEFT JOIN job_types jt ON jt.id = j.type
	LEFT JOIN jobs_extras_fee jef ON jef.job=j.id
	LEFT JOIN houses h ON h.street=j.street AND h.house=j.house
	LEFT JOIN entrances e ON e.house=h.id AND e.number=j.entrance
	LEFT JOIN clients cl ON cl.id=j.client_id
	LEFT JOIN streets str ON str.id=j.street
	LEFT JOIN staff s ON s.id=j.worker
	LEFT JOIN stamps st ON st.id=j.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'j.id',
		),

		'name'=>array(
			'selector'=>'s.name',
		),
		
		'name_id'=>array(
			'selector'=>'s.id',
		),
		
		'date'=>array(
			'selector'=>'j.date',
		),
		
		'street'=>array(
			'selector'=>'str.name',
		),
		
		'street_id'=>array(
			'selector'=>'str.id',
		),
		
		'house'=>array(
			'selector'=>'j.house',
		),
		
		'entrance'=>array(
			'selector'=>'j.entrance',
		),
		
		'floor'=>array(
			'selector'=>'j.floor',
		),
		
		'apartment'=>array(
			'selector'=>'j.apartment',
		),
		
		'client'=>array(
			'selector'=>'CONCAT(cl.last_name, " ", cl.first_name, " ", cl.patronymic )',
		),
		
		'client_id'=>array(
			'selector'=>'cl.id',
		),
		
		/*'type'=>array(
			'desc'=>1,
			'selector'=>'case j.type '.
				'when 1 then "'.getResource('jobs.type.1').'" '.
				'when 2 then "'.getResource('jobs.type.2').'" '.
				'when 3 then "'.getResource('jobs.type.3').'" '.
				'when 4 then "'.getResource('jobs.type.4').'" '.
				'when 5 then "'.getResource('jobs.type.5').'" '.
				'else j.type end',
		),*/
		
		'type'=>array(
			'selector'=>'jt.name',
		),
		
		'entrance_type' => array(
			'desc'=>1,
			'selector'=>'case j.entrance_type '.
				'when 0 then "'.getResource('entrance_type.type.1').'" '.
				'when 1 then "'.getResource('entrance_type.type.2').'" '.
				'end',
		),
		'podkl' => array(
			'selector' => 'j.cost / 100',
			'aggregate'=>'sum',
		),
		'fee' => array(
			'selector' => 'IFNULL(jef.fee, 0)',
			'aggregate'=>'sum',
		),
		'sum' => array(
			'selector' => 'j.cost / 100 + IFNULL(jef.fee, 0)',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'j.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

if(isset($GLOBALS['oper']->system_access['worker_features'])){
 $obj['filters']['by_worker'] = "j.worker='".$GLOBALS['oper']->person."'";
}

$obj['filters']['worker'] = "j.state=1 AND j.client_id IS NOT NULL";
?>