<?
$obj = array(
	'name'=>'snapshots_w',
	'nick'=>'snshw',
	'source'=>'snapshots_w s
		LEFT JOIN snapshots ss ON ss.id=s.id
		LEFT JOIN cities c ON c.id=ss.city',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'s.id',
		),
		'city'=>array(
			'selector'=>'ss.city',
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'date_f'=>array(
			'selector'=>'DATE_FORMAT(SUBDATE(ss.date, INTERVAL 1 HOUR), "%Y-%m-%d")',
			'order_by'=>'ss.date',
		),
		'date'=>array(
			'selector'=>'ss.date',
		),
		'week'=>array(
			'selector'=>'date_format(SUBDATE(ss.date, INTERVAL 1 HOUR), "%u")',
		),

		'payed'=>array(
			'selector'=>'s.payed/100',
			'aggregate'=>'sum',
		),
		'arpu'=>array(
			'selector'=>'s.arpu/100',
			'aggregate'=>'avg',
		),

		'int_clients'=>array(
			'selector'=>'ss.int_clients',
		),
		'int_clients_diff'=>array(
			'selector'=>'s.int_clients_diff',
			'aggregate'=>'sum',
		),
		'int_new'=>array(
			'selector'=>'s.int_new',
			'aggregate'=>'sum',
		),
		'int_return'=>array(
			'selector'=>'s.int_return',
			'aggregate'=>'sum',
		),
		'int_off'=>array(
			'selector'=>'s.int_new + s.int_return - s.int_clients_diff',
			'aggregate'=>'sum',
		),
		'int_payed'=>array(
			'selector'=>'s.int_payed/100',
			'aggregate'=>'sum',
		),
		'int_arpu'=>array(
			'selector'=>'s.int_arpu/100',
			'aggregate'=>'avg',
		),

		'tv_clients'=>array(
			'selector'=>'ss.tv_clients',
		),
		'tv_clients_diff'=>array(
			'selector'=>'s.tv_clients_diff',
			'aggregate'=>'sum',
		),
		'tv_new'=>array(
			'selector'=>'s.tv_new',
			'aggregate'=>'sum',
		),
		'tv_return'=>array(
			'selector'=>'s.tv_return',
			'aggregate'=>'sum',
		),
		'tv_off'=>array(
			'selector'=>'s.tv_new + s.tv_return - s.tv_clients_diff',
			'aggregate'=>'sum',
		),
		'tv_payed'=>array(
			'selector'=>'s.tv_payed/100',
			'aggregate'=>'sum',
		),
		'tv_arpu'=>array(
			'selector'=>'s.tv_arpu/100',
			'aggregate'=>'avg',
		),

		'both_clients'=>array(
			'selector'=>'ss.both_clients',
		),
		'both_clients_diff'=>array(
			'selector'=>'s.both_clients_diff',
			'aggregate'=>'sum',
		),
		'both_new'=>array(
			'selector'=>'s.both_new',
			'aggregate'=>'sum',
		),
		'both_return'=>array(
			'selector'=>'s.both_return',
			'aggregate'=>'sum',
		),
		'both_off'=>array(
			'selector'=>'s.both_new + s.both_return - s.both_clients_diff',
			'aggregate'=>'sum',
		),
		'both_payed'=>array(
			'selector'=>'s.both_payed/100',
			'aggregate'=>'sum',
		),
		'both_arpu'=>array(
			'selector'=>'s.both_arpu/100',
			'aggregate'=>'avg',
		),

		'cover_int'=>array(
			'selector'=>'ss.cover_int',
		),
		'cover_int_diff'=>array(
			'selector'=>'s.cover_int_diff',
			'aggregate'=>'sum',
		),

		'cover_tv'=>array(
			'selector'=>'ss.cover_tv',
		),
		'cover_tv_diff'=>array(
			'selector'=>'s.cover_tv_diff',
			'aggregate'=>'sum',
		),
	),
);
?>