<?
$obj = array(
	'name'=>'staff',
	'nick'=>'stf',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert,after_staff_post,modify_access',
	'AfterPost'=>'after_logged_post,after_staff_post,modify_access',
	'AfterDelete'=>'after_stamped_delete,after_logged_delete,after_staff_delete',
	'source'=>'staff w
	LEFT JOIN cities c ON c.id=w.city
	LEFT JOIN clients cl ON cl.id=w.client
	LEFT JOIN exp_executors_staff ees ON ees.member = w.id
	LEFT JOIN exp_executors ee ON ee.id = ees.executor
	LEFT JOIN ranks r ON r.id=w.rank
	LEFT JOIN (SELECT DISTINCT person FROM operators) x on x.person=w.id
	LEFT JOIN stamps st ON st.id=w.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'w.id',
		),
		'city'=>array(
			'selector'=>'w.city',
			'nullable'=>1,
			'log_by'=>'city_name',
			'desc'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'client'=>array(
			'selector'=>'w.client',
			'log_by'=>'client_name',
			'nullable'=>1,
		),
		'client_name'=>array(
			'selector'=>'CONCAT(cl.last_name, " ", cl.first_name, " (", IFNULL(cl.contract, ""), ")")',
		),
		'client_contract'=>array(
			'selector'=>'cl.contract',
		),
		'executors' => array(
			'selector' => 'ee.name',
		),
		'biom_id' =>array(
			'selector'=>'w.biom_id',
		),
		'asterisk_agent' =>array(
			'selector'=>'w.asterisk_agent',
			'nullable'=>1,
		),
		'name'=>array(
			'bin'=>1,
			'desc'=>1,
			'selector'=>'w.name',
		),
		
		'place_name' => array(
			'selector' => 'case
				when w.place=1 then "'.getResource('staff.place.1').'"
				when w.place=2 then "'.getResource('staff.place.2').'"
				when w.place=3 then "'.getResource('staff.place.3').'"
				when w.place=4 then "'.getResource('staff.place.4').'"
				else "" end',
		),
		
		'place' => array(
			'selector' => 'w.place',
			'log_by'=>'place_name',
		),
		
		'department'=>array(
			'selector'=>'w.department',
			'log_by'=>'department_name',
		),
		'department_name'=>array(
			'selector'=>'case w.department
				when 1 then "'.getResource('staff.department.1').'"
				when 2 then "'.getResource('staff.department.2').'"
				when 3 then "'.getResource('staff.department.3').'"
				else "" end',
		),
		'section'=>array(
			'selector'=>'w.section',
			'log_by'=>'section_name',
		),
		'section_name'=>array(
			'selector'=>'case
				when w.section=1 then "'.getResource('staff.section.1').'"
				when w.section=2 then "'.getResource('staff.section.2').'"
				when w.section=3 then "'.getResource('staff.section.3').'"
				when w.section=4 then "'.getResource('staff.section.4').'"
				when w.section=5 then "'.getResource('staff.section.5').'"
				when w.section=6 then "'.getResource('staff.section.6').'"
				else "" end',
		),
		'status'=>array(
			'selector'=>'w.status',
			'log_by'=>'status_name',
		),
		'status_name'=>array(
			'selector'=>'case
				when w.status=1 then "'.getResource('staff.status.1').'"
				when w.status=2 then "'.getResource('staff.status.2').'"
				when w.status=3 then "'.getResource('staff.status.3').'"
				when w.status=4 then "'.getResource('staff.status.4').'"
				when w.status=5 then "'.getResource('staff.status.5').'"
				else "" end',
		),
		'duties'=>array(
			'selector'=>'w.duties',
		),
		'rank'=>array(
			'selector'=>'w.rank',
			'nullable'=>1,
			'log_by'=>'rank_name',
		),
		'rank_name'=>array(
			'selector'=>'r.name',
		),
		'has_op'=>array(
			'selector'=>'IF(x.person IS NULL, "-", "+")',
		),
		'phone'=>array(
			'selector'=>'w.phone',
		),
		'work_phone'=>array(
			'selector'=>'w.work_phone',
		),
		'mobile'=>array(
			'selector'=>'w.mobile',
		),
		'sip_id'=>array(
			'selector'=>'w.sip_id',
			'nullable'=>1,
		),
		'email'=>array(
			'selector'=>'w.email',
		),
		'birthday'=>array(
			'selector'=>'w.birthday',
			'nullable'=>1,
		),
		'birthday_day'=>array(
			'selector'=>'IFNULL(DATE_FORMAT(w.birthday, "%e %M"), "")',
			'order_by'=>'IFNULL(DATE_FORMAT(w.birthday, "%m-%d"), "")',
		),
		'notes'=>array(
			'selector'=>'w.notes',
		),
		'private'=>array(
			'selector'=>'w.private',
		),
		'photo_file'=>array(
			'selector'=>'w.photo_file',
		),
		'has_photo'=>array(
			'selector'=>'IF(w.photo_file IS NULL, "-", "+")',
		),
		'stamp'=>array(
			'selector'=>'w.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>