<?
$obj = array(
	'name'=>'clients',
	'nick'=>'stcls',
	'readonly'=>1,
	'source'=>'clients c
	LEFT JOIN stats_clients sc ON sc.id=c.id
	LEFT JOIN stats_pays sp ON sp.client=c.id
	LEFT JOIN calendar_account_states cas ON cas.account=c.account AND cas.calendar_period="'.getCurrentCalendarPeriod().'"
	LEFT JOIN houses h ON h.id=c.house_id
	LEFT JOIN streets s ON h.street = s.id
	LEFT JOIN departments d ON c.department = d.id
	LEFT JOIN connection_types ct ON c.connection_type = ct.id
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'c.id',
		),
		'account'=>array(
			'selector'=>'c.account',
		),
		'last_name'=>array('bin'=>1,),
		'first_name'=>array('bin'=>1,),
		'patronymic'=>array('bin'=>1),
		'name'=>array(
			'selector'=>'CONCAT(last_name, " ", first_name)',
			'desc'=>1,
		),
		'department'=>array('selector'=>'c.department',),
		'department_name'=>array(
			'selector'=>'d.name',
			'bin'=>1,
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
		),
		'connection_type_name'=>array(
			'bin'=>1,
			'selector'=>'ct.name',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house_id'=>array(
			'selector'=>'c.house_id',
		),
		'house'=>array(
			'selector'=>'h.house',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'building'=>array(),
		'letter'=>array(),
		'entrance'=>array(),
		'floor'=>array(),
		'apartment'=>array(),
		'surveyor'=>array('bin'=>1),
		'phone'=>array(
			'selector'=>'c.phone',
		),
		'login'=>array('selector'=>'c.login'),
		'pass'=>array('selector'=>'c.pass'),
		'email'=>array(
			'selector'=>'c.email',
		),
		'bank_account'=>array(),
		'contract'=>array(
			'selector'=>'c.contract',
		),
		'notice'=>array(),
		'alarm'=>array(
			'selector'=>'c.alarm',
		),
		'alarm_cur'=>array(
			'selector'=>'c.alarm/100',
		),
		'block'=>array(
			'selector'=>'c.block',
		),
		'block_cur'=>array(
			'selector'=>'c.block/100',
		),
		'reduction'=>array(
			'selector'=>'c.reduction',
		),
		'reduction_cur'=>array(
			'selector'=>'c.reduction/100',
		),
		'blockable'=>array(),
		'deposit'=>array(
			'selector'=>'ifnull(cas.state_end,0)/100',
			'aggregate'=>'sum',
		),
		'bytes'=>array(
			'selector'=>'ifnull(sc.bytes, 0)',
			'aggregate'=>'sum',
		),
		'cost'=>array(
			'selector'=>'ifnull(sc.cost, 0)',
		),
		'cost_cur'=>array(
			'selector'=>'ifnull(sc.cost, 0)/100',
			'aggregate'=>'sum',
		),
		'payed_cur'=>array(
			'selector'=>'ifnull(sp.amount, 0)/100',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}

?>