<?
$obj = array(
	'name'=>'hosts',
	'nick'=>'sthts',
	'readonly'=>1,
	'source'=>'hosts h
	LEFT JOIN stats_hosts sh ON sh.id=h.id
	LEFT JOIN domains d ON d.id = h.domain
	LEFT JOIN clients c ON c.id = h.client
	LEFT JOIN modems m ON m.id = h.modem
	LEFT JOIN stamps st ON st.id=h.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'h.id',
		),
		'ip'=>array(
			'desc'=>1,
			'selector'=>'h.ip',
			'order_by'=>'INET_ATON(h.ip)',
		),
		'mac'=>array(
			'selector'=>'h.mac',
		),
		'name'=>array(
			'selector'=>'h.name',
		),
		'login'=>array(
			'selector'=>'h.login',
		),
		'password'=>array(
			'selector'=>'h.password',
		),
		'domain'=>array(
			'selector'=>'h.domain',
		),
		'domain_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'client'=>array(
			'desc'=>1,
			'selector'=>'h.client',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'client_login'=>array(
			'selector'=>'c.login',
		),
		'client_department'=>array(
			'bin'=>1,
			'selector'=>'c.department',
		),
		'modem'=>array(
		    'selector'=>'h.modem',
		),
		'modem_name'=>array(
			'bin'=>1,
			'selector'=>'m.name',
		),
		'port'=>array(
			'selector'=>'h.port',
		),
		'notes'=>array(
			'selector'=>'h.notes',
		),
		'countable'=>array(
		),
		'countable_sign'=>array(
			'selector'=>'IF(h.countable=1, "+", "-")',
			'aggregate'=>'sum',
		),
		'bytes'=>array(
			'selector'=>'ifnull(sh.bytes, 0)',
			'aggregate'=>'sum',
		),
		'cost'=>array(
			'selector'=>'ifnull(sh.cost, 0)',
		),
		'cost_cur'=>array(
			'selector'=>'ifnull(sh.cost, 0)/100',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'h.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>