<?
$obj = array(
	'name'=>'tv_connections',
	'nick'=>'tvcs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert, recalc_tv_clients',
	'AfterPost'=>'after_logged_post, recalc_tv_clients',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, recalc_tv_clients',
	'source'=>'tv_connections tc
	LEFT JOIN tv_boxes tb ON tb.id=tc.tv_box
	LEFT JOIN tv_nodes tn ON tn.id=tc.tv_node
	LEFT JOIN clients c ON c.id = tc.client
	LEFT JOIN personal_periods pp ON pp.id=c.personal_period
	LEFT JOIN tv_types tt ON tt.id=c.tv_type
	LEFT JOIN cities ci ON ci.id=c.city
	LEFT JOIN departments p ON p.id = c.department
	LEFT JOIN houses hs ON hs.id=c.house_id
	LEFT JOIN streets s ON hs.street = s.id
	LEFT JOIN districts ds ON ds.id=hs.district
	LEFT JOIN stamps st ON st.id=tc.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'tc.id',
		),
		'period_begin'=>array(
			'selector'=>'pp.period_begin',
		),
		'period_end'=>array(
			'selector'=>'pp.period_end',
		),
		'card_code'=>array(
			'selector'=>'tc.card_code',
			'nullable'=>1,
		),
		'tv_box'=>array(
			'selector'=>'tc.tv_box',
			'log_by'=>'tv_box_name',
			'desc'=>1,
		),
		'tv_box_name'=>array(
			'selector'=>'tb.floor',
		),
		'tv_node'=>array(
			'selector'=>'tc.tv_node',
			'log_by'=>'tv_node_name',
			'nullable'=>1,
		),
		'tv_node_name'=>array(
			'selector'=>'tn.name',
		),
		'city'=>array(
			'selector'=>'c.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'district'=>array(
			'selector'=>'hs.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'client'=>array(
			'selector'=>'tc.client',
			'log_by'=>'client_name',
			'desc'=>1,
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'street'=>array(
			'selector'=>'hs.street',
		),
		'street_name'=>array(
			'selector'=>'s.name',
		),
		'house_id'=>array(
			'selector'=>'c.house_id',
		),
		'house'=>array(
			'selector'=>'hs.house',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", hs.house)',
		),
		'entrance'=>array(
			'selector'=>'c.entrance',
		),
		'floor'=>array(
			'selector'=>'c.floor',
		),
		'apartment'=>array(
			'selector'=>'c.apartment',
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
		),
		'tv_type'=>array(
			'selector'=>'c.tv_type',
		),
		'tv_type_name'=>array(
			'selector'=>'tt.name',
		),
		'notes'=>array(
			'selector'=>'tc.notes',
		),
		'state'=>array(
			'selector'=>'tc.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'CASE tc.state
				WHEN 1 THEN "'.getResource('tv.connections.state.1').'"
				WHEN 2 THEN "'.getResource('tv.connections.state.2').'"
				WHEN 3 THEN "'.getResource('tv.connections.state.3').'"
				WHEN 4 THEN "'.getResource('tv.connections.state.4').'"
				ELSE "" END',
		),
		'stamp'=>array(
			'selector'=>'tc.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>