<?
$obj = array(
	'name'=>'clients',
	'nick'=>'cls',
	'masters'=>array(
		'connection_types'=>array(
			'table'=>$GLOBALS['connection_types'],
			'on'=>'id',
			'by'=>'connection_type',
		),
	),
	'BeforePost'=>'pre_client_post, before_stamped_post',
	'BeforeInsert'=>'pre_client_insert, before_sub_account_insert, before_stamped_insert',
	'BeforeDelete'=>'pre_client_delete',
	'AfterInsert'=>'client_insert, after_logged_insert',
	'AfterPost'=>'client_post, after_logged_post',
	'AfterDelete'=>'after_sub_account_delete, after_stamped_delete, after_logged_delete',
	'source'=>'clients c
	LEFT JOIN calendar_account_states cas ON cas.account=c.account AND cas.calendar_period="'.getCurrentCalendarPeriod().'"
	LEFT JOIN personal_periods pp ON pp.client=c.id AND pp.marker=1
	LEFT JOIN streets s ON c.street = s.id
	LEFT JOIN departments d ON c.department = d.id
	LEFT JOIN connection_types ct ON c.connection_type = ct.id
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'c.id',
		),
		'account'=>array(
			'selector'=>'c.account',
		),
/*		'access_admin'=>array(
			'selector'=>'if(bs.blocks IS NULL ,"+", "-")',
		),
		'access_period'=>array(
			'selector'=>'if(ifnull(pp.state,0)=1,"+", "-")',
		),
		'access_deposit'=>array(
			'selector'=>'if((ifnull(cas.state_end,0) >= c.block) || not blockable, "+", "-")',
		),
		'access_firewall'=>array(
			'selector'=>'if(fs.blocks IS NULL ,"+", "-")',
		),
		'access_limitations'=>array(
			'selector'=>'if(ls.state IS NULL ,"+", "-")',
		),
*/
		'last_name'=>array('bin'=>1,),
		'first_name'=>array('bin'=>1,),
		'patronymic'=>array('bin'=>1),
		'name'=>array(
			'selector'=>'CONCAT(last_name, " ", first_name)',
			'desc'=>1,
		),
		'department'=>array(
			'selector'=>'c.department',
		),
		'department_name'=>array(
			'selector'=>'d.name',
			'bin'=>1,
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
		),
		'connection_type_name'=>array(
			'bin'=>1,
			'selector'=>'ct.name',
		),
		'street'=>array(
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house'=>array(),
		'building'=>array(),
		'letter'=>array(),
		'entrance'=>array(),
		'floor'=>array(),
		'apartment'=>array(),
		'surveyor'=>array('bin'=>1),
		'phone'=>array(),
		'login'=>array(
			'selector'=>'c.login',
			'desc'=>1,
		),
		'pass'=>array(
			'selector'=>'c.pass',
		),
		'email'=>array(),
		'bank_account'=>array(),
		'contract'=>array(),
		'notice'=>array(),
		'alarm'=>array(
			'selector'=>'c.alarm',
		),
		'alarm_cur'=>array(
			'selector'=>'c.alarm/100',
		),
		'block'=>array(
			'selector'=>'c.block',
		),
		'block_cur'=>array(
			'selector'=>'c.block/100',
		),
		'reduction'=>array(
			'selector'=>'c.reduction',
		),
		'reduction_cur'=>array(
			'selector'=>'c.reduction/100',
		),
		'blockable'=>array(),
		'deposit'=>array(
			'selector'=>'ifnull(cas.state_end/100,0)',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['fields']['department']['auto_insert'] = $d;
	$obj['filters']['department'] = "c.department='$d'";
}
?>