<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:17 $
$Revision: 1.9 $
*/
include_once('includes/global.php');
include_once('functions/accounts.php');
include_once('functions/mail.php');
include_once('functions/homedir.php');
include_once('functions/host.php');
include_once('functions/exchange.php');
include_once('classes/cells/HighlightCellRenderer.php');
loadStrings(BOOT.'jobs/strings.txt');
loadStrings(BOOT.'jobs2/strings.txt');
loadStrings(BOOT.'houses/strings.txt');
loadStrings(BOOT.'tv_connections/strings.txt');
loadStrings(BOOT.'exp_points/strings.txt');

$doc->title .= ' :: '.getResource('jobs.title.2');

required_access('jobs2');

if(isset($_GET['check_login'])){
	header("Content-Type: text/plain; charset=".$doc->charset);
	if(loadRecord(sprintf("SELECT id FROM clients WHERE login='%s'", addslashes(trim($_GET['check_login']))))){
		echo "<span style='color:red;'>   </span>";
	}
	exit;
}

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'house':	lookup('house', $_GET['city'] ? array('h.city='.addslashes($_GET['city'])) : array());
	case 'modem':
		$filters = array();
		if($_GET['city']){
			$filters[] = 'm.city='.addslashes($_GET['city']);
		}
		if($_GET['house']){
			$house = loadRecord("SELECT street, house FROM houses WHERE id='".addslashes($_GET['house'])."'");
			$filters[] = sprintf("(m.street='%s' AND m.house='%s')", $house['street'], $house['house']);
		}
		lookup('modem2',  $filters);
	case 'domain':	lookup('domain');
	case 'tv_type':	$filters = array();
		if($_GET['connection_type']){
			$filters[] = "id='".addslashes($_GET['save_tv'])."' OR id IN (SELECT tv_type FROM connection_type_tv WHERE connection_type='".addslashes($_GET['connection_type'])."')";
		}
		if($_GET['job_type']){
			$filters[] = "id='".addslashes($_GET['save_tv'])."' OR id IN (SELECT tv_type FROM job_types_tv_types WHERE job_type='".addslashes($_GET['job_type'])."')";
		}
		new Lookup('id', 'name', 'tv_types', $filters, 'name');
	case 'tv_box':
		$client = loadRecord("SELECT id, house_id, entrance FROM clients WHERE id='".addslashes($_GET['client'])."'");
		new Lookup('b.id', 'CONCAT("'.getResource('exp.points.floor.short').' ", b.floor)',
			"tv_boxes b",
			array('b.house="'.$client['house_id'].'" AND b.entrance="'.$client['entrance'].'"'), 'b.floor');
	case 'tv_node':
		$client = loadRecord("SELECT id, house_id, entrance FROM clients WHERE id='".addslashes($_GET['client'])."'");
		new Lookup('n.id', 'CONCAT(n.name, " (", IFNULL(n.entrances, ""), ")")',
			"tv_nodes n
			LEFT JOIN exp_points p ON p.id=n.point",
			array('p.house="'.$client['house_id'].'"', 'LENGTH(n.entrances) > 0'));
}

class StateCellRenderer {
	function render($column, $record){
		return sprintf("<td class='state%s' style='width: 7em;'>%s</td>", $record['state'], $record['state_name']);
	}
}
$state_cell = new StateCellRenderer();

function keep_job_connection_type($table){
	global $jobs, $db;
	$db->Execute(sprintf("UPDATE jobs SET connection_type='%s' WHERE id='%s'", $table->current_record['connection_type'], $jobs->active_record['id']));
}

function spread_client($table){
	global $db;
	$clid = $table->current_record['id'];
	$contract = $table->current_record['contract'];
	if($contract){
		$db->Execute("UPDATE jobs SET client_id='".$clid."' WHERE contract='".$contract."' AND client_id IS NULL");
	}
}

function client_insert2($table){
	global $jobs, $db;
	$db->Execute(sprintf("UPDATE jobs SET client_id='%s' WHERE id='%s'", $table->new_record['id'], $jobs->active_record['id']));
	return client_insert($table);
}

function getPublicConnectionTypes2(){
	global $clients, $job;
	$ct = $clients->isOn() ? $clients->active_record['connection_type'] : 0;
	return loadByQuery(sprintf("SELECT ct.id, ct.name AS value
		FROM connection_types ct
		LEFT JOIN job_types_connection_types jtct ON jtct.job_type='%s' AND jtct.connection_type=ct.id
		WHERE (ct.public AND jtct.id IS NOT NULL) OR (ct.id='%s') ORDER BY ct.name", $job['type'], $ct));
}

function set_contract_from_job($table){
	global $job;
	$table->new_record['contract'] = $job['contract'];
}

//$db->debug = 1;

$jobs = new PTable($db,BOOT.'jobs2/table.php');
$jobs->readonly = !$oper->system_access['jobs2'];
$jobs->filters['worker'] = 'j.worker='.$oper->person;
$jobs->filters['not-complete'] = 'j.state!=1 AND j.state!=3 AND j.state!=4';

$doc->page->contents['jobs'] = new PMyAccess($jobs,array(
	'title'=>getResource('jobs.title.2'),
	'icon'=>HREF.'images/jobs.gif',
	'grid_boot'=>BOOT.'jobs2/grid.php',
));

$coil_own = loadRecord("SELECT sum(ci.rest) rest FROM coil_uses cu LEFT JOIN coil_items ci ON ci.id=cu.item 
WHERE cu.person='".$oper->person."' AND cu.end_date IS NULL");

if(!($coil_own['rest'] > 0)){
	$doc->page->contents['warning'] = '<br><font color="red"><b>       ,    .</b></font> (<a href="my_coil.php"> </a>)';
}elseif($jobs->isOn()){
	$job = $jobs->active_record;
	$expense = loadRecord("SELECT e.*, s.created, s.modified FROM client_expenses e LEFT JOIN stamps s ON s.id=e.stamp WHERE e.job='".$job['id']."' LIMIT 1");
	$jmenu = new PNamedMenu($nil,BOOT.'jobs2/menu.php');
	$doc->page->contents['jobs2_menu'] = $jmenu;
	switch($jmenu->selected){
		case 'jno':
			loadStrings(BOOT.'jobs/notes/strings.txt');
			$notes = new PTable($db,BOOT.'jobs/notes/table.php');
			$notes->readonly = !$oper->system_access['jobs_notes'];
			$doc->page->contents['notes'] = new PMyAccess($notes, array(
				'title'=>getResource('jobs.notes.title'),
				'icon'=>HREF.'images/rules.gif',
				'grid_boot'=>BOOT.'jobs/notes/grid.php',
				'form_boot'=>BOOT.'jobs/notes/form.php',
			));
			break;
		case 'mat':
			###
			class ExpensesForm extends PForm {
				function Process(){
					global $job, $db, $expense;
					$db->Begin();
					try {
						if(!$this->fields['id']->value){
							$stamp = create_stamp();
							$db->Execute("INSERT INTO client_expenses (job, stamp) VALUES (".$job['id'].", '".$stamp."')");
							$eid = $db->getJustInserted('client_expenses', 'id');
						}else{
							$eid = $this->fields['id']->value;
							update_stamp($expense['stamp']);
						}
						//$db->debug = 1;
						$db->Execute(sprintf("UPDATE client_expenses SET no_materials='%s', connection='%s', connection_port='%s', cable='%s', cable_in='%s', cable_type='%s' WHERE id='%s'", 
							addslashes($this->fields['no_materials']->value),
							addslashes($this->fields['connection']->value),
							addslashes($this->fields['connection_port']->value),
							addslashes($this->fields['cable']->value),
							addslashes($this->fields['cable_in']->value),
							addslashes($this->fields['cable_type']->value),
							$eid));
						foreach($this->fields as $name=>$field){
							if(substr($name, 0, 9)=='coil_all_'){
								$coil_use_id = substr($name, 9);
								$coil_all = $field->value;
								$coil_in = $this->fields['coil_in_'.$coil_use_id]->value;
								if($detail = loadRecord(sprintf("SELECT id, stamp FROM coil_uses_details WHERE expense='%s' AND coil_use='%s'", $eid, $coil_use_id))){
									update_stamp($detail['stamp']);
									$db->Execute(sprintf("UPDATE coil_uses_details SET cable='%s', cable_in='%s' WHERE id='%s'", 
										$coil_all, $coil_in, $detail['id']));
								}else{
									$stamp = create_stamp();
									$db->Execute(sprintf("INSERT INTO coil_uses_details(coil_use, expense, cable, cable_in, stamp) VALUES ('%s', '%s', '%s', '%s', '%s')", 
										$coil_use_id, $eid, $coil_all, $coil_in, $stamp));
								}
								recalc_coil_use($coil_use_id);
								$use = loadRecord("SELECT * FROM coil_uses WHERE id='".$coil_use_id."'");
								if(($field->value > 0) && ($use['end_length'] < 0)){
									$coil = loadRecord("SELECT code FROM coil_items WHERE id='".$use['item']."'");
									throw new Exception(sprintf(getResource('client.expenses.coil.overflow'), ($use['end_length'] + $field->value), $coil['code']));
								}
							}
							if(substr($name, 0, 4)=='mat_'){
								$mat_id = substr($name, 4);
								$mat_amount = $field->value;
								if($detail = loadRecord(sprintf("SELECT id, stamp FROM client_expenses_details WHERE expense='%s' AND material='%s'", $eid, $mat_id))){
									update_stamp($detail['stamp']);
									$db->Execute(sprintf("UPDATE client_expenses_details SET amount='%s' WHERE id='%s'", 
										$mat_amount,$detail['id']));
								}else{
									$stamp = create_stamp();
									$db->Execute(sprintf("INSERT INTO client_expenses_details(material, expense, amount, stamp) VALUES ('%s', '%s', '%s', '%s')", 
										$mat_id, $eid, $mat_amount, $stamp));
								}
							}
						}
						$db->Commit();
					}catch(Exception $ex){
						$db->Rollback();
						return $ex->getMessage();
					}
				}
			}
			loadStrings(BOOT.'client_expenses/strings.txt');
			loadStrings(BOOT.'jobs2/client_expenses/strings.txt');
			loadStrings(BOOT.'houses/strings.txt');
			loadStrings(BOOT.'coil_supplies/strings.txt');
			//$db->debug = 1;
			
			/*
			if(!$expense){
				$db->Execute("INSERT INTO client_expenses(job) VALUES ('".$job['id']."')");
				$expense = loadRecord("SELECT * FROM client_expenses WHERE job='".$job['id']."' LIMIT 1");
			}
			*/
			include_once BOOT.'jobs2/client_expenses/form.php';
			if(!($job['jt_type'] & 1)){
				unset($obj['fields']['connection']);
				unset($obj['fields']['connection_port']);
				$obj['fields']['cable_type'] = array(
					'type'=>'hidden',
					'value'=>1,
				);
			}
			if(USE_COILS){
				unset($obj['fields']['cable']);
				unset($obj['fields']['cable_in']);
				unset($obj['fields']['cable_type']);
			}
			$coil_mask = (($job['jt_type'] & 1) ? 6 : 0) + (($job['jt_type'] & 2) ? 1 : 0);
			
			$coil_uses = loadRecords("SELECT cu.id, ci.code, ci.cable_type FROM coil_uses cu LEFT JOIN coil_items ci ON ci.id=cu.item 
				WHERE cu.person='".$oper->person."' AND cu.end_date IS NULL AND (ci.cable_type & $coil_mask) ORDER BY ci.code");
			foreach($coil_uses as $use){
				$detail = '';
				if($expense){
					$detail = loadRecord(sprintf("SELECT id, cable, cable_in FROM coil_uses_details WHERE expense='%s' AND coil_use='%s'", $expense['id'], $use['id']));
				}
				$obj['fields']['coil_all_'.$use['id']] = array(
					'title'=>sprintf(getResource('client.expenses.coil.all'), $use['code']),
					'value'=>$detail ? $detail['cable'] : '0',
					'comment'=>getResource('cs.cable_type.'.$use['cable_type']),
					'control'=>'short',
				);
				$obj['fields']['coil_in_'.$use['id']] = array(
					'title'=>sprintf(getResource('client.expenses.coil.in'), $use['code']),
					'value'=>$detail ? $detail['cable_in'] : '0',
					'comment'=>getResource('cs.cable_type.'.$use['cable_type']),
					'control'=>'short',
				);
			}
			$old_details = loadRecords(sprintf("SELECT i.id, SUM(d.cable) cable, sum(d.cable_in) cable_in, i.code, i.cable_type 
				FROM coil_uses_details d 
				LEFT JOIN coil_uses u ON u.id=d.coil_use 
				LEFT JOIN coil_items i ON i.id=u.item
				WHERE d.expense='%s' AND u.end_date IS NOT NULL AND d.cable>0
				GROUP BY i.id", $expense ? $expense['id'] : ''));
			foreach($old_details as $detail){
				if($detail['cable'] > 0 || $detail['cable_in'] > 0){
					$obj['fields']['view_all_'.$detail['coil_use']] = array(
						'title'=>sprintf(getResource('client.expenses.coil.all'), $detail['code']),
						'value'=>$detail['cable'],
						'comment'=>getResource('cs.cable_type.'.$detail['cable_type']),
						'readonly'=>'1',
					);
					$obj['fields']['view_in_'.$detail['id']] = array(
						'title'=>sprintf(getResource('client.expenses.coil.in'), $detail['code']),
						'value'=>$detail['cable_in'],
						'comment'=>getResource('cs.cable_type.'.$detail['cable_type']),
						'readonly'=>'1',
					);
				}
			}
			
			$mat_types = loadRecords("SELECT t.id, t.name FROM expense_material_types t
				INNER JOIN expense_material_job_types jt ON jt.material_type=t.id AND jt.job_type='" . $job['type'] . "'
				ORDER BY t.name");
			foreach($mat_types as $type){
				$detail = '';
				if($expense){
					$detail = loadRecord(sprintf("SELECT amount FROM client_expenses_details WHERE expense='%s' AND material='%s'", $expense['id'], $type['id']));
				}
				$obj['fields']['mat_'.$type['id']] = array(
					'title'=>$type['name'],
					'value'=>$detail ? $detail['amount'] : '0',
					'control'=>'short',
				);
			}
			$obj['fields']  = array_merge($obj['fields'], array(
				'created'=>array(
					'readonly'=>1,
					'title'=>getResource('client.expenses.created'),
					'value'=>$expense ? $expense['created'] : '',
				),
				'modified'=>array(
					'readonly'=>1,
					'title'=>getResource('client.expenses.modified'),
					'value'=>$expense ? $expense['modified'] : '',
				),
			));
			if(!$expense){
				$obj['submits']['ok']['title'] = getResource('pe6yc.form.submit.insert');
			}
			$doc->page->contents['client_expenses'] = new ExpensesForm($nill, $obj);
			ob_start();
			?>
			<script>
			
			var f = document.forms['clx'];
<?if($job['type']!=5){?>
			var pcable = f.connection[0];
			var vrezko = f.connection[1];
			var povtor = f.connection[2];
			var vport = f.connection_port;
			if(!vrezko.checked){
				vport.disabled = 1;
				//vport.parentNode.parentNode.style.display = 'none';
			}
			vrezko.onclick = function(){
				vport.disabled = 0;
			};
			pcable.onclick = function(){
				vport.disabled = 1;
			};
			povtor.onclick = function(){
				vport.disabled = 1;
			};
<?}?>
			f.no_materials.onclick = function(){
				for(var i=0; i<f.elements.length; i++){
					var e = this.form.elements[i];
					if(e.name.substring(0,4)=='mat_' || e.name.substring(0,5)=='coil_'){
						e.disabled = this.checked;
					}
				}
			};
			f.no_materials.onclick();
			
			</script>
			<?
			$doc->page->contents['vrezka_script'] = ob_get_clean();
			/*
			$client_expenses = new PTable($db,BOOT.'jobs2/client_expenses/table.php');
			$client_expenses->Locate(Array('id'=>$expense['id']));
			$client_expenses->readonly = !$oper->system_access['jobs2'];
			
			loadStrings(BOOT.'coil_uses_details/strings.txt');
			$details = new PTable($db,BOOT.'coil_uses_details/table.php');
			$details->readonly = $client_expenses->readonly;
			$doc->page->contents['details'] = new PMyAccess($details,array(
				'title'=>getResource('cu.title'),
				'icon'=>HREF.'images/picks.gif',
				'grid_boot'=>BOOT.'coil_uses_details/grid.php',
				'form_boot'=>BOOT.'coil_uses_details/form.php',
			));
			*/
			break;
		case 'cl':
			$defaults = array();
			if($arr = loadRecord(sprintf("SELECT id FROM houses WHERE street='%s' AND house='%s'", $job['street'], $job['house']))){
				$defaults['house'] = $arr['id'];
			}
			$name = preg_split("|\s+|", $job['client']);
			switch(count($name)){
				case 1: $defaults['first_name'] = $name[0]; break;
				case 2: list($defaults['first_name'], $defaults['patronymic']) = $name; break;
				case 3: list($defaults['last_name'], $defaults['first_name'], $defaults['patronymic']) = $name; break;
			}
		//	print_r($job);
			$clients = new PTable($db, BOOT.'jobs2/clients-table.php');
			$clients->Locate(array('id'=>$job['client_id']));
			$clients->readonly = $jobs->readonly;
			$doc->page->contents['clients-form'] = new PMyAccess($clients, array(
				'title'=>getResource('jobs.add.client'),
				'icon'=>HREF.'images/clients.gif',
				'form_boot'=>BOOT.'jobs2/clients-form.php',
				'briefable'=>0,
			));
			if($job['city']!=2){
				unset($doc->page->contents['clients-form']->form->fields['surveyor']);
			}
			ob_start();
			?>
			<script language="JavaScript" src="scripts/Ajaxer.js"></script>
			<script language="JavaScript" src="scripts/TvTypeTracker.js"></script>
			<script language="JavaScript">
			/*var tvTypeTracker = new TvTypeTracker('cls2');
			tvTypeTracker.track();
			tvTypeTracker.warn = true;
			*/
			var f = $("form[name=<?=$clients->nick?>]");
			$("[name=connection_type]", f).change(function(){
				lookup_tv.src = '?lookup=tv_type&target=lookup_tv&job_type=<?=$job['type']?>&connection_type=' + this.value + '&save_tv=<?=$clients->active_record['tv_type']?>';
				lookup_tv.loaded = false;
				lookup_tv.loadFirst();
			}).change();
			
			</script>
			<?
			$doc->page->contents['tv_type_tracker'] = ob_get_clean();
			if(!$job['client_id']){
			ob_start();
			?>
			<script type="text/javascript" src="scripts/ValueTracker.js"></script>
			<script type="text/javascript">
			new ValueTracker(document.forms['cls2'].elements['login'], '?check_login=', document.getElementById('loginMessage'));
			</script>
			<?
			$doc->page->contents['login_script'] = ob_get_clean();
			}
			if($clients->isOn()){
				$client = $clients->active_record;
				if(!$expense){
					$doc->page->contents['expenses.first'] = '<br><font color="red"><b>'.getResource('jobs2.fill.expenses.first').'</b></font><br><br>';
				}else{
					$cmenu = new PNamedMenu($nil,BOOT.'jobs2/client-menu.php');
					$doc->page->contents['client_menu'] = $cmenu;
					if(isset($cmenu->items[$cmenu->selected])){
						switch($cmenu->selected){
							case 'tv':
								$tv_connections = new PTable($db,BOOT.'clients/tv_connections/table.php');
								$tv_connections->readonly = $jobs->readonly;
								$doc->page->contents['tv_connections'] = new PMyAccess($tv_connections,array(
									'title'=>getResource('tv.connections.title'),
									'icon'=>HREF.'images/tv.png',
									'grid_boot'=>BOOT.'clients/tv_connections/grid.php',
									'form_boot'=>BOOT.'clients/tv_connections/form.php',
								));
								$doc->page->contents['tv_connections']->form->can_delete = false;
								break;
							case 'ho':
								loadStrings(BOOT.'hosts/strings.txt');
				//			    $db->debug = 1;
								$action_form = new PHostActionForm($nil,BOOT.'hosts/action_form.php');
								$hosts = new PTable($db,BOOT.'clients/hosts/table.php');
								$hosts->readonly = $jobs->readonly;
								$doc->page->contents['hosts'] = new PMyAccess($hosts,array(
									'title'=>getResource('hosts.title'),
									'icon'=>HREF.'images/hosts.gif',
									'grid_boot'=>BOOT.'clients/hosts/grid.php',
									'form_boot'=>BOOT.'clients/hosts/form.php',
								));
								$doc->page->contents['hosts']->form->fields['modem']->source .= '&house='.$job['house_id'];
								if(!$hosts->readonly){
									$doc->page->contents['hosts']->form->fields['ip']->comment = '<select id="candidates_ip"></select>';
								}
								ob_start();
								?>
								<script type="text/javascript" src="scripts/Ajaxer.js"></script>
								<script type="text/javascript" src="scripts/modem-tracker.js"></script>
								<script type="text/javascript" src="scripts/ip-tracker.js"></script>
								<script type="text/javascript" src="scripts/strict-input-tracker.js"></script>
								<script type="text/javascript">
								<?if(!$doc->page->contents['hosts']->brief){?>
								var ipTracker = new IpTracker('chts');
								var tracker = new ModemTracker('chts');
								<?}?>
								StrictInputTracker(document.forms['g_chts'].elements['chts_mac_filter'], /.*/, /[\-;\.]/g, ":");
								StrictInputTracker(document.forms['chts'].elements['mac'], /.*/, /[\-;\.]/g, ":");
								</script>
								<?
								$doc->page->contents['hosts_script'] = ob_get_clean();
								include 'includes/under_hosts.php';
								break;
							case 'ma':
								loadStrings(BOOT.'mailboxes/strings.txt');
								$mailboxes = new PTable($db,BOOT.'clients/mailboxes/table.php');
								$mailboxes->readonly = $jobs->readonly;
								$doc->page->contents['mailboxes'] = new PMyAccess($mailboxes,array(
									'title'=>getResource('mailboxes.title'),
									'icon'=>HREF.'images/box.gif',
									'grid_boot'=>BOOT.'clients/mailboxes/grid.php',
									'form_boot'=>BOOT.'clients/mailboxes/form.php',
								));
								break;
						}
					}
				}
			}
			break;
		case 'mo':
			loadStrings(BOOT.'modems/strings.txt');
			$modems = new PTable($db, BOOT.'jobs2/modems/table.php');
			$modems->filters['this_house'] = sprintf("(m.street='%s' AND m.house='%s')", $job['street'], $job['house']);
			$modems->readonly = 1;
			$doc->page->contents['modems'] = new PMyAccess($modems, array(
				'title'=>getResource('modems.title'),
				'icon'=>HREF.'images/modems.gif',
				'grid_boot'=>BOOT.'jobs2/modems/grid.php',
			));
			break;
		case 'vi':
			$visits = new PTable($db, BOOT.'jobs2/visits/table.php');
			$visits->filters['not_me'] = "j.id!='".$job['id']."'";
			$visits->filters['this_house'] = sprintf("(j.street='%s' AND j.house='%s')", $job['street'], $job['house']);
			$visits->filters['date'] = "(j.date BETWEEN subdate(now(), INTERVAL 5 MONTH) AND adddate(now(), INTERVAL 2 MONTH))";
			$visits->readonly = 1;
			$doc->page->contents['visits'] = new PMyAccess($visits, array(
				'title'=>getResource('jobs2.visits.title'),
				'icon'=>HREF.'images/log.gif',
				'grid_boot'=>BOOT.'jobs2/visits/grid_full.php',
			));
			if($visits->isOn()){
				loadStrings(BOOT.'jobs/notes/strings.txt');
				$hack_jobs = $jobs;
				$jobs = $visits;
				$notes = new PTable($db,BOOT.'jobs/notes/table.php');
				$jobs = $hack_jobs;
				$notes->readonly = 1;
				$doc->page->contents['notes'] = new PMyAccess($notes, array(
					'title'=>getResource('jobs.notes.title'),
					'icon'=>HREF.'images/rules.gif',
					'grid_boot'=>BOOT.'jobs/notes/grid.php',
				));
			}
			break;
		case 'po':
			loadStrings(BOOT.'hosts/strings.txt');
			loadStrings(BOOT.'client_expenses/strings.txt');
			loadStrings(BOOT.'jobs2/client_expenses/strings.txt');
			//$db->debug = 1;
			$db->Execute("CREATE TEMPORARY TABLE client_inset ENGINE=Memory SELECT DISTINCT client, connection_port FROM client_expenses WHERE connection=2 AND connection_port > 0");
			$hosts = new PTable($db, BOOT.'jobs2/hosts/table.php');
			$hosts->filters['this_house'] = sprintf("(hs.street='%s' AND hs.house='%s')", $job['street'], $job['house']);
			$hosts->readonly = 1;
			$doc->page->contents['hosts'] = new PMyAccess($hosts, array(
				'title'=>getResource('jobs2.population.title'),
				'icon'=>HREF.'images/hosts.gif',
				'grid_boot'=>BOOT.'jobs2/hosts/grid.php',
			));
			break;
		case 'potv':
			$tv_connections = new PTable($db,BOOT.'jobs2/tv_connections/table.php');
			$tv_connections->readonly = 1;
			$tv_connections->filters['by_house'] = sprintf('tb.house="%s"', $job['house_id']);
			$doc->page->contents['tv_connections'] = new PMyAccess($tv_connections,array(
				'title'=>getResource('jobs2.population.tv.title'),
				'icon'=>HREF.'images/tv.png',
				'grid_boot'=>forceCity(BOOT.'jobs2/tv_connections/grid.php'),
			));
			break;
		case 'off':
			loadStrings(BOOT.'hosts/strings.txt');
			$offline = new PTable($db, BOOT.'jobs2/offline/table.php');
			$offline->filters['this_house'] = sprintf("(hs.street='%s' AND hs.house='%s')", $job['street'], $job['house']);
			$offline->readonly = 1;
			$doc->page->contents['offline'] = new PMyAccess($offline, array(
				'title'=>getResource('jobs2.offline.title'),
				'icon'=>HREF.'images/hosts.gif',
				'grid_boot'=>BOOT.'jobs2/offline/grid.php',
			));
			break;
		case 'map':
			$coords = explode(",", $job['house_coords']);
			if(count($coords)==2){
				ob_start();
				?>
				<div id="map_canvas" style="width:800px; height:600px"></div>
				<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
				<script type="text/javascript">
					function initialize() {
						var latlng = new google.maps.LatLng(<?=$coords[1]?> + 0.000120, <?=$coords[0]?>);
						var myOptions = {
							zoom:16,
							center: latlng,
							mapTypeId: google.maps.MapTypeId.ROADMAP
						};
						var map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
						var marker = new google.maps.Marker({
							position: latlng, 
							map: map, 
							title:"<?=$job['street_name'].' '.$job['house']?>"
						 }); 
					}
					initialize();
				</script>
				<?
				$doc->page->contents['map'] = ob_get_clean();
			}
			break;
		case 'ent':
			include_once('classes/cells/UpCellRenderer.php');
			loadStrings(BOOT.'houses/entrances/strings.txt');
			$entrance = new PTable($db,BOOT.'jobs2/entrances/table.php');
			//$entrance->readonly = !$oper->system_access['houses'];
			$entrance->filters['house'] = 'e.house="'.$job['house_id'].'"';
			$doc->page->contents['entrance'] = new PMyAccess($entrance,array(
				'title'=>getResource('entrances.title'),
				'icon'=>HREF.'images/streets.gif',
				'grid_boot'=>BOOT.'jobs2/entrances/grid.php',
				'form_boot'=>BOOT.'jobs2/entrances/form.php',
			));
			break;
		case 'no':
			loadStrings(BOOT.'houses/notes/strings.txt');
			$notes = new PTable($db, BOOT.'jobs2/notes/table.php');
			//$notes->readonly = !$oper->system_access['houses'];
			$doc->page->contents['notes'] = new PMyAccess($notes,array(
				'title'=>getResource('houses.notes.title'),
				'icon'=>HREF.'images/rules.gif',
				'grid_boot'=>BOOT.'jobs2/notes/grid.php',
				'form_boot'=>BOOT.'jobs2/notes/form.php',
			));
			$note = $notes->active_record;
			$doc->page->contents['notes']->form->can_post = $note['created_by']==$oper->id;
			$doc->page->contents['notes']->form->can_delete = $note['created_by']==$oper->id;
			break;
		case 'ho':
			loadStrings(BOOT.'houses/strings.txt');
			loadStrings(BOOT.'koops/strings.txt');
//			$db->debug = 1;
			$houses = new PTable($db, BOOT.'jobs2/house/table.php');
			$houses->readonly = 1;
			$houses->Locate(array('street'=>$job['street'], 'house'=>$job['house']));
			if($houses->isOn()){
				$house = $houses->active_record;
				$doc->page->contents['house'] = new PMyAccess($houses, array(
					'title'=>getResource('jobs2.house.title'),
					'icon'=>HREF.'images/streets.gif',
					'form_boot'=>BOOT.'jobs2/house/form-'.($house['served_by']==3 || $house['served_by']==4 ? '2' : '1').'.php',
					'briefable'=>0,
				));
				if(($house['served_by']==1) && $house['kpreo']){
					loadStrings(BOOT.'kpreos/strings.txt');
					$kpreos = new PTable($db,BOOT.'kpreos/table.php');
					$kpreos->readonly = 1;
					$kpreos->Locate(array('id'=>$house['kpreo']));
					$doc->page->contents['kpreos'] = new PMyAccess($kpreos,array(
						'title'=>getResource('jobs2.kpreo.title'),
						'icon'=>HREF.'images/streets.gif',
						'form_boot'=>BOOT.'jobs2/house/form-kpreo.php',
						'briefable'=>0,
					));
				}
				if(($house['served_by']==2) && $house['koop']){
					loadStrings(BOOT.'koops/strings.txt');
					$koops = new PTable($db,BOOT.'jobs2/house/koop-table.php');
					$koops->readonly = 1;
					$koops->Locate(array('id'=>$house['koop']));
					$doc->page->contents['koops'] = new PMyAccess($koops,array(
						'title'=>getResource('jobs2.koop.title'),
						'icon'=>HREF.'images/streets.gif',
						'form_boot'=>BOOT.'jobs2/house/form-koop.php',
						'briefable'=>0,
					));
				}
			}
			break;
	}
}
ob_start();
?>
<style>
.state1 {background-color:#bfb;}
.state2 {background-color:#fbb;}
.state3 {background-color:#ccc;}
.state4 {background-color:#9af;}
.stateSelect {width: 100%; border: 1px solid #888;}
</style>
<?
$doc->page->contents['all'] = ob_get_clean();
echo $doc->Paint();
?> 