<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:16 $
$Revision: 1.9 $
*/
include_once('includes/global.php');
include('functions/accounts.php');
include('functions/uses.php');
include_once('classes/period.php');
loadStrings(BOOT.'movements/strings.txt');
loadStrings(BOOT.'personal_periods/strings.txt');
loadStrings(BOOT.'calendar_periods/strings.txt');

$doc->title .= ' :: '.getResource('calendar.periods.title');

required_access('calendar_periods');
//$db->debug = 1;

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'account':	lookup('account');
	case 'client':	lookup('client');
	case 'resource_type':	lookup('resource_type');
	case 'src':	lookup('client_and_bonus_account');
	case 'dst':	lookup('system_dst_account_s');
	case 'mov_src':
		switch($_GET['menu']){
			case 'pay':
			case 'bpa':
				lookup('system_src_account_s');
			case 'chr':
				lookup('client_account_s');
			case 'bch':
				lookup('bonus_account_s');
			case 'fre':
				lookup('src_account');
		}
	case 'mov_dst':
		switch($_GET['menu']){
			case 'chr':
			case 'bch':
				lookup('system_dst_account_s');
			case 'pay':
				lookup('client_account_s');
			case 'bpa':
				lookup('bonus_account_s');
			case 'fre':
				lookup('dst_account');
		}
}

function getResourceUseMovements(){
	global $resource_use;
	$date_format = "[%Y-%m-%d %H:%i:%s]";
	return loadByQuery(sprintf("SELECT id, CONCAT(DATE_FORMAT(date, '%s'), ' ', amount/100, ' ', IFNULL(note,'')) as value
		FROM movements
		WHERE calendar_period='%s' AND src='%s' AND dst='%s'",
		$date_format,
		$resource_use['calendar_period'],
		$resource_use['src'],
		$resource_use['dst']
		));
}

function getClientPersonalPeriods(){
	global $resource_use;
	$format1 = "%Y-%m-%d";
	$format2 = "%Y-%m-%d";
	return loadByQuery(sprintf("SELECT pp.id, CONCAT(DATE_FORMAT(pp.period_begin, '%s'), ' &ndash; ', DATE_FORMAT(pp.period_end, '%s'), ' (', ct.name, ')') as value 
		FROM personal_periods pp 
		LEFT JOIN connection_types ct ON ct.id=pp.connection_type
		WHERE pp.client=%s ORDER BY pp.period_end DESC",
		$format1,
		$format2,
		$resource_use['client']
	));
}

function getMovementSourceCandidates(){
	global $db, $mmenu;
	switch($mmenu->selected){
		case 'pay':
		case 'bpa':
			return getSignedSrcSystemAccounts();
		case 'chr':
			return getSignedClientAccounts();
		case 'bch':
			return getSignedBonusAccounts();
		case 'fre':
			return getAllSrcAccounts();
	}
}

function getMovementDestinationCandidates(){
	global $mmenu;
	switch($mmenu->selected){
		case 'chr':
		case 'bch':
			return getSignedDstSystemAccounts();
		case 'pay':
			return getSignedClientAccounts();
		case 'bpa':
			return getSignedBonusAccounts();
		case 'fre':
			return getAllDstAccounts();
	}
}

$db->Execute("CREATE TEMPORARY TABLE state_names (state tinyint not null primary key, name varchar(255)) ENGINE=Memory");
$db->Execute(sprintf("INSERT INTO state_names VALUES (0, '%s'), (1, '%s'), (2, '%s')",
	getResource('personal.periods.state.none'),
	getResource('personal.periods.state.open'),
	getResource('personal.periods.state.closed')
));

$periods = new PTable($db,BOOT.'calendar_periods/table.php');
$periods->readonly = !$oper->system_access['calendar_periods'];
$doc->page->contents['periods'] = new PMyAccess($periods,array(
	'title'=>getResource('calendar.periods.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/calendar_periods.gif',
	'grid_boot'=>BOOT.'calendar_periods/grid.php',
	'form_boot'=>BOOT.'calendar_periods/form.php',
));

if($periods->isOn()){
	$calendar_period = $periods->active_record;
	$pmenu = new PNamedMenu($nil,BOOT.'calendar_periods/menu.php');
	$doc->page->contents['pmenu'] = $pmenu;
	switch($pmenu->selected){
		case 'mo':
			//createAccountReference('src_names');
			//createAccountReference('dst_names');
			$mmenu = new PNamedMenu($nil,BOOT.'movements/menu.php');
			$movements = new PTable($db,BOOT.'calendar_periods/movements/table.php');
			$movements->readonly = !$oper->system_access['movements'];
			$doc->page->contents['movements'] = new PMyAccess($movements,array(
				'title'=>getResource('movements.title'),
				'icon'=>HREF.'images/dollar.gif',
				'icon_attributes'=>'width=29 height=42',
				'grid_boot'=>BOOT.'calendar_periods/movements/grid.php',
				'form_boot'=>BOOT.'calendar_periods/movements/form.php',
			));
			if(!$doc->page->contents['movements']->brief){
				$doc->page->contents['movements_menu'] = $mmenu;
			}
			break;
		case 'ba':
			$db->Execute("CREATE TEMPORARY TABLE balance (
				account int not null,
				amount bigint not null, 
				date datetime not null,
				movement bigint not null,
				index (account),
				index (movement),
				index (date)) ENGINE=Memory");
			$filter = sprintf("calendar_period='%s'", $calendar_period['id']);
			$db->Execute(sprintf("INSERT INTO balance 
			SELECT src, -amount, date, id FROM movements WHERE %s
			UNION
			SELECT dst, amount, date, id FROM movements WHERE %s", $filter, $filter));
			//createAccountReference('account_names');
			$balance = new PTable($db,BOOT.'balance/table.php');
			$doc->page->contents['balance'] = new PMyAccess($balance,array(
				'title'=>getResource('balance.title'),
				'icon'=>HREF.'images/dollar.gif',
'icon_attributes'=>'width=29 height=42',
				'grid_boot'=>BOOT.'balance/grid.php',
			));
			break;
		case 'st':
			//createAccountReference('account_names');
			$states = new PTable($db,BOOT.'calendar_periods/calendar_account_states/table.php');
			$states->readonly = !$oper->system_access['calendar_periods'];
			$doc->page->contents['states'] = new PMyAccess($states,array(
				'title'=>getResource('calendar.account.states.title'),
				'icon'=>HREF.'images/dollar.gif',
'icon_attributes'=>'width=29 height=42',
				'grid_boot'=>BOOT.'calendar_periods/calendar_account_states/grid.php',
				'form_boot'=>BOOT.'calendar_periods/calendar_account_states/form.php',
			));
			break;
		case 're':
			$doc->page->contents['report_form'] = new PForm($nil, BOOT.'calendar_periods/report/form.php');
			break;
		case 'ru':
			//createAccountReference('src_names');
			//createAccountReference('dst_names');
			$resource_uses = new PTable($db,BOOT.'calendar_periods/resource_uses/table.php');
			$resource_uses->readonly = !$oper->system_access['resource_uses'];
			$doc->page->contents['resource_uses'] = new PMyAccess($resource_uses,array(
				'title'=>getResource('resource.uses.title'),
				'icon'=>HREF.'images/resource_uses.gif',
				'grid_boot'=>BOOT.'calendar_periods/resource_uses/grid.php',
				'form_boot'=>BOOT.'calendar_periods/resource_uses/form.php',
			));
			if($resource_uses->isOn()){
				$resource_use = $resource_uses->active_record;
				$personal_period_resource_uses = new PTable($db,BOOT.'calendar_periods/resource_uses/personal_period_resource_uses/table.php');
				$personal_period_resource_uses->readonly = !$oper->system_access['resource_uses'];
				$doc->page->contents['personal_period_resource_uses'] = new PMyAccess($personal_period_resource_uses,array(
					'title'=>getResource('personal.period.resource.uses.title'),
					'icon'=>HREF.'images/resource_uses.gif',
					'grid_boot'=>BOOT.'calendar_periods/resource_uses/personal_period_resource_uses/grid.php',
					'form_boot'=>BOOT.'calendar_periods/resource_uses/personal_period_resource_uses/form.php',
				));
				if($personal_period_resource_uses->isOn()){
					$personal_period_resource_use = $personal_period_resource_uses->active_record;
					include('includes/resource_uses_details.php');
				}
			}
			break;
	}
}
echo $doc->Paint();
?>
