<?
class DBFExport {

var $title;
var $query;
var $rowMapper;
var $tag;

function DBFExport($title, $query, $colmap, $tag, $rowMapper = ''){
	$this->title = $title;
	$this->query = $query;
	$this->colmap = $colmap;
	$this->tag = $tag;
	$this->rowMapper = $rowMapper;
}

function getTitle(){
	return $this->title;
}

function process(){
	global $db, $clients;
	$scope = $clients->getScope();
	$query = "CREATE TEMPORARY TABLE clients_export (id INT UNSIGNED NOT NULL PRIMARY KEY) ENGINE=Memory
		SELECT c.id FROM ".$clients->source.($scope ? " WHERE ".implode(" AND ", $scope) : "");
	$db->Execute($query);
	$file_name = TMP_DIR.'/dbf-export-'.session_id().'.dbf';
	$dbf = dbase_create($file_name, $this->colmap);
	$records = loadRecords($this->query);
	foreach($records as $rec){
		if(is_object($this->rowMapper)){
			if(is_callable($this->rowMapper)){
				$rec = call_user_func($this->rowMapper, $rec);
			}else{
				$rec = $this->rowMapper->map($rec);
			}
		}elseif(function_exists($this->rowMapper)){
			$rec = call_user_func($this->rowMapper, $rec);
		}
		$values = array();
		foreach($this->colmap as $inf){
			$val = $rec[$inf[0]];
			if(strlen($val) > 0){
				if($inf[1]=='C'){
					$val = iconv('cp1251', 'cp866', str_replace(array('', ''), array('i', 'I'), $val));
				}
				if($inf[1]=='N'){
					$val = number_format($val, $inf[3], '.', '');
				}
			}
			$values[] = $val;
		}
		dbase_add_record($dbf, $values);
	}
	dbase_close($dbf);
	
	ob_end_clean();
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");

	header("Content-Type: application/dbase");
	header("Content-Length: ".filesize($file_name));
	header("Content-Disposition: attachment; filename=\"bill-clients-".$this->tag."-".date("Ymd-His").".dbf\"");
	header("Content-Transfer-Encoding: binary");
	echo file_get_contents($file_name);
	unlink($file_name);
	exit;
}
}
?>