<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

include_once(dirname(__FILE__)."/IpSetBuilder.php");

class RemoteIpSetBuilder extends IpSetBuilder {

var $host;
var $user;
var $timeout = 3;

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('remote.ipset.builder');
}

function setHost($str){
	$this->host = $str;
}

function setUser($str){
	$this->user = $str;
}

function setTimeout($i){
	$this->timeout = $i;
}

function setPort($str){
    $this->port = $str;
}

function getScriptFileName($name){
	return $this->host.'-'.$name;
}

function buildScriptCommand($filename){
	$copy = sprintf("scp -P %d -o BatchMode=yes -o ConnectTimeout=%s %s %s@%s:%s 2>&1", $this->port, $this->timeout, $filename, $this->user, $this->host, $filename);
	$this->logger->debug($copy);
	exec($copy, $out, $err);
	if($err){
		$this->logger->error("can't send script: %s, exit code: %s, output:\n%s", $copy, $err, implode("\n", $out));
		return sprintf('echo script sending failed');
	}else{
		$cmd = parent::buildScriptCommand($filename);
		return sprintf("ssh -p %d -o BatchMode=yes -o ConnectTimeout=%s %s@%s \"%s\" 2>&1", $this->port, $this->timeout, $this->user, $this->host, $cmd);
	}
}

function buildHashInfoCommand($name){
	$cmd = parent::buildHashInfoCommand($name);
	return sprintf("ssh -p %d -o BatchMode=yes -o ConnectTimeout=%s %s@%s \"%s\" 2>&1", $this->port, $this->timeout, $this->user, $this->host, $cmd);
}

function buildHashReadCommand($name){
	$cmd = parent::buildHashReadCommand($name);
	return sprintf("ssh -p %d -o BatchMode=yes -o ConnectTimeout=%s %s@%s \"%s\" 2>&1", $this->port, $this->timeout, $this->user, $this->host, $cmd);
}


}
?>