<?
include_once(dirname(__FILE__).'/../tools/IpAddress.php');

class SplitAccountingDriver {

var $netmap;
var $beanName;

function setBeanName($str){
	$this->beanName = $str;
}

function setNetmap($arr){
	uksort($arr, array($this, 'sortByExpansion'));
	$this->netmap = $arr;
}

function sortByExpansion($i1, $i2){
	$ip1 = new SlashedIpAddress($i1);
	$ip2 = new SlashedIpAddress($i2);
	if($ip1->contains($ip2)){
		return 1;
	}else{
		if($ip2->contains($ip1)){
			return -1;
		}else{
			return $ip1->address - $ip2->address;
		}
	}
}

function unique($arr){
	// array_unique,     
	$urr = array();
	foreach($arr as $k=>$v){
		$found = false;
		foreach($urr as $v1){
			if($v1==$v){
				$found = true;
				break;
			}
		}
		if(!$found){
			$urr[$k]=$v;
		}
	}
	return $urr;
}


function readCounters(){
	$arr = $this->unique($this->netmap);
	foreach($arr as $net=>$d){
		$this->netmap[$net]->readCounters();
	}
}

function loadCounters(){
	$arr = $this->unique($this->netmap);
	foreach($arr as $net=>$d){
		$this->netmap[$net]->loadCounters();
	}
}

function getCounter($ip){
	$driver = $this->getDriver($ip);
	return $driver->getCounter($ip);
}

function beginSetup(){
	$arr = $this->unique($this->netmap);
	foreach($arr as $net=>$d){
		$this->netmap[$net]->beginSetup();
	}
}

function setCounter($ip, $block){
	$driver = $this->getDriver($ip);
	$driver->setCounter($ip, $block);
}

function finishSetup(){
	$arr = $this->unique($this->netmap);
	foreach($arr as $net=>$d){
		$this->netmap[$net]->finishSetup();
	}
}

function getDriver($i){
	$ip = new SlashedIpAddress($i);
	foreach($this->netmap as $net=>$d){
		$netIp = new SlashedIpAddress($net);
		if($netIp->contains($ip)){
			return $this->netmap[$net];
		}
	}
	echo "cant get driver for $i\n";
}

}
?>