<?
class JobsCalendarModel {

var $connection;
var $jobTemplate;
var $records;

function setConnection($obj){
	$this->connection = $obj;
}

function setJobTemplate($obj){
	$this->jobTemplate = $obj;
}

function prepare($from, $calendar){
	global $oper;
	$typeMarks = array(
		'1'=>'',
		'2'=>'',
		'3'=>'',
		'4'=>'',
	);
	$to = $from + 60*60*24*35;
	$sel = $this->connection->select("SELECT j.id, j.type, t.abbr, j.state, j.alarm, s.name as street_name, house, UNIX_TIMESTAMP(date) as date
		FROM jobs j
		LEFT JOIN job_types t ON t.id=j.type
		LEFT JOIN operators_cities oc ON oc.city=j.city AND oc.operator=$oper->id
		LEFT JOIN streets s ON s.id=j.street
		WHERE ".($oper->city_mode ? "oc.city IS NOT NULL AND " : "")." j.date >= '%s' AND j.date < '%s' ORDER BY j.date",
		date("Y-m-d H:i:s", $from), date("Y-m-d H:i:s", $to));
	$this->records = array();
	while($arr = $sel->next()){
		$day = date("Ymd", $arr['date']);
		$arr['time'] = date("H:i", $arr['date']);
		$arr['title'] = $arr['street_name'].' '.$arr['house'];
		$arr['repair'] = $arr['type'] == 2;
		$arr['link'] = $calendar->buildRecordLink(array('jbs_id'=>$arr['id']));
		$arr['type_mark'] = $arr['abbr'];
		$this->records[$day][] = $arr;// $this->jobTemplate->render($arr);
	}
	$this->hints = array();
	$sel = $this->connection->select("SELECT sum(IF(j.state=1, 1, 0)) complete, sum(IF(j.state=1, 0, 1)) incomplete, DATE_FORMAT(j.date, '%%Y%%m%%d') day
		FROM jobs j	WHERE j.date >= '%s' AND j.date < '%s' GROUP BY 3", date("Y-m-d H:i:s", $from), date("Y-m-d H:i:s", $to));
	while($arr = $sel->next()){
		$this->hints[$arr['day']] = '+'.($arr['complete']+0).',&ndash;'.($arr['incomplete']+0);
	}
}

function getRenderedRecords($year, $month, $day, $calendar){
	global $oper;
	/*$typeMarks = array(
		'1'=>'',
		'2'=>'',
		'3'=>'',
		'4'=>'',
	);
	$from = sprintf("%d-%02d-%02d", $year, $month, $day);
	$to = sprintf("%d-%02d-%02d", $year, $month, $day + 1);
	$sel = $this->connection->select("SELECT j.id, j.type, j.state, j.alarm, s.name as street_name, house, UNIX_TIMESTAMP(date) as date
		FROM jobs j
		LEFT JOIN operators_cities oc ON oc.city=j.city AND oc.operator=$oper->id
		LEFT JOIN streets s ON s.id=j.street
		WHERE ".($oper->city_mode ? "oc.city IS NOT NULL AND " : "")." j.date >= '%s' AND j.date < '%s' ORDER BY j.date", $from, $to);
	$records = array();
	while($arr = $sel->next()){
		$arr['time'] = date("H:i", $arr['date']);
		$arr['title'] = $arr['street_name'].' '.$arr['house'];
		$arr['repair'] = $arr['type'] == 2;
		$arr['link'] = $calendar->buildRecordLink(array('jbs_id'=>$arr['id']));
		$arr['type_mark'] = $typeMarks[$arr['type']];
		$records[] = $this->jobTemplate->render($arr);
	}*/
	$result = array();
	$k = $year.$month.$day;
	if(isset($this->records[$k])){
		foreach($this->records[$k] as $arr){
			$result[] = $this->jobTemplate->render($arr);
		}
	}
	return $result;
}

function getHint($year, $month, $day, $calendar){
	/*$from = sprintf("%d-%02d-%02d", $year, $month, $day);
	$to = sprintf("%d-%02d-%02d", $year, $month, $day + 1);
	$sel = $this->connection->select("SELECT sum(IF(j.state=1, 1, 0)) complete, sum(IF(j.state=1, 0, 1)) incomplete
		FROM jobs j	WHERE j.date >= '%s' AND j.date < '%s'", $from, $to);
	$arr = $sel->next();
	return '+'.($arr['complete']+0).',&ndash;'.($arr['incomplete']+0);
	*/
	return $this->hints[$year.$month.$day];
}

}
?>