<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class CommandLineInterface {

var $info;
var $options;
var $args;
var $count;
var $index;

function setInfo($info){
	$this->info = $info;
}

function setOptions($options){
	$this->options = $options;
}

function getOption($key){
	return $this->options[$key];
}

function parse(){
	$this->args = array_slice($_SERVER['argv'], 1);
	$this->count = count($this->args);
	$this->index = 0;
	while($token = $this->get(0)){
		$valid = false;
		foreach($this->options as $k=>$opt){
			if($valid = $this->options[$k]->parse($this)){
				break;
			}
		}
		if(!$valid){
			$this->consume();
			//$this->error("Invalid argument: %s", $token);
		}
	}
}

function error($msg){
	if(func_num_args() > 1){
		$args = func_get_args();
		$msg = call_user_func_array('sprintf', $args);
	}
	printf("%s\n\n", $msg);
	$this->showHelp();
	exit(1);
}

function get($i){
	$j = $this->index + $i;
	return $j < $this->count ? $this->args[$j] : '';
}

function consume(){
	$this->index++;
}

function showHelp(){
	$indent = 0;
	foreach($this->options as $opt){
		$indent = max($indent, $opt->getDesiredIndent());
	}
	printf("%s\n", sprintf($this->info, basename($_SERVER['argv'][0])));
	foreach($this->options as $opt){
		$opt->showHelp($indent);
	}
}

}
?>