<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class ValueOption {

var $short_key;
var $long_key;
var $example;
var $description;
var $value;
var $desired_indent;
var $target;
var $targetProperty;

function setTarget($obj){
	$this->target = $obj;
}

function setTargetProperty($str){
	$this->targetProperty = $str;
}

function setShortKey($short_key){
	$this->short_key = $short_key;
}

function setLongKey($long_key){
	$this->long_key = $long_key;
}

function setExample($example){
	$this->example = $example;
}

function setDescription($description){
	$this->description = $description;
}

function setValue($value){
	$this->value = $value;
}

function initBean(){
	$this->desired_indent = strlen($this->short_key) + strlen($this->long_key);
	if($this->short_key && $this->long_key){
		$this->desired_indent += 2;
	}
	$this->desired_indent += 3 + strlen($this->example);
}

function parse($lexer){
	$token = $lexer->get(0);
	if($token==$this->short_key || $token==$this->long_key){
		$lexer->consume();
		$value = $lexer->get(0);
		if(!$value){
			$lexer->error("option '%s' require <%s> argument ", $token, $this->example);
		}else{
			$lexer->consume();
			$this->value = $value;
			if(isset($this->target)){
				$prop = $this->targetProperty;
				$setter = 'set'.strtoupper(substr($prop,0,1)).substr($prop,1);
				$this->target->$setter($value);
			}
			return true;
		}
	}
}

function getValue(){
	return $this->value;
}

function getDesiredIndent(){
	return $this->desired_indent;
}

function showHelp($indent){
	$use_case = $this->long_key;
	if($this->short_key){
		$use_case .= ($use_case ? ', ' : '').$this->short_key;
	}
	$use_case .= sprintf(" <%s>", $this->example);
	$padding = str_repeat(" ", $indent);
	$desc = str_replace("\n", "\n   ".$padding, $this->description);
	printf("%-".$indent."s - %s\n", $use_case, $desc);
}

}
?>