<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class CalendarPeriodsDAO {

var $connection;
var $logger;
var $queries = array(
	'select_by_id'=>"SELECT id, state, marker, UNIX_TIMESTAMP(period_begin) period_begin, UNIX_TIMESTAMP(period_end) period_end FROM calendar_periods WHERE id='%s'",
	'select'=>"SELECT id, state, marker, UNIX_TIMESTAMP(period_begin) period_begin, UNIX_TIMESTAMP(period_end) period_end FROM calendar_periods WHERE marker=1",
	'select_last_marked'=>"SELECT id, state, marker, UNIX_TIMESTAMP(period_begin) as period_begin, UNIX_TIMESTAMP(period_end) as period_end FROM calendar_periods WHERE id IN (SELECT min(id) FROM calendar_periods WHERE next IS NULL)",
	'select_next_candidate'=>"SELECT id, state, marker, UNIX_TIMESTAMP(period_begin) as period_begin, UNIX_TIMESTAMP(period_end) as period_end FROM calendar_periods WHERE (FROM_UNIXTIME(%s) BETWEEN period_begin AND period_end) AND (next IS NULL) AND (state=0) ORDER BY period_begin LIMIT 1",
	'insert'=>"INSERT INTO calendar_periods (period_begin, period_end) VALUES (FROM_UNIXTIME(%s), FROM_UNIXTIME(%s))",
	'append'=>"UPDATE calendar_periods SET next=%s WHERE id=%s",
	'change_state'=> "UPDATE calendar_periods SET state=%s WHERE id=%s",
	'change_marker'=>"UPDATE calendar_periods SET marker=%s WHERE id=%s",
);

function setConnection($connection){
	$this->connection = $connection;
}

function getById($id) {
	$it = $this->connection->select($this->queries['select_by_id'], $id);
	if($p = $it->next()){
		return $p;
	}
}

function getLastMarked() {
	$it = $this->connection->select($this->queries['select_last_marked']);
	if($p = $it->next()){
		return $p;
	}
}

function getNextCandidate($time) {
	$it = $this->connection->select($this->queries['select_next_candidate'], $time);
	if($p = $it->next()){
		return $p;
	}
}

function getCurrent(){
	$sel = $this->connection->select($this->queries['select']);
	return $sel->next();
}

function insert($period_begin, $period_end){
	return $this->connection->insert_auto($this->queries['insert'], $period_begin, $period_end);
}

function append($prev, $next){
	return $this->connection->update($this->queries['append'], $next, $prev);
}

function changeState($pid, $state){
	return $this->connection->update($this->queries['change_state'], $state, $pid);
}

function changeMarker($pid, $value){
	return $this->connection->update($this->queries['change_marker'], $value ? $value : "NULL", $pid);
}

}
?>