<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class ClientsDAO {

var $connection;
var $splitter;
var $queries = array(
	'list_all'=>"SELECT id, account, connection_type, tv_type, department, login, first_name, last_name, email, notice, alarm, block, reduction, blockable, acl_pref, stamp, state
		FROM clients",
	'get_by_id'=>"SELECT id, account, connection_type, tv_type, department, login, first_name, last_name, email, notice, alarm, block, reduction, blockable, acl_pref, stamp, state
		FROM clients WHERE id=%s",
	'change_connection_type'=>'UPDATE clients SET connection_type=%s WHERE id=%s',
	'change_tv_type'=>'UPDATE clients SET tv_type=%s WHERE id=%s',
	'replace_expired_connection_types'=>"UPDATE clients c
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		SET c.connection_type=ct.replace_by
		WHERE ct.replace_by IS NOT NULL AND ct.replace_date < NOW()",
	'replace_expired_tv_types'=>"UPDATE clients c
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		LEFT JOIN connection_type_tv ctv ON ctv.connection_type=ct.id AND ctv.tv_type=c.tv_type
		SET c.tv_type=ctv.replace_by
		WHERE ctv.replace_by IS NOT NULL AND ctv.replace_date < NOW()",
	'get_count'=>"SELECT count(id) cnt FROM clients",
	'get_shift_id'=>"SELECT id FROM clients ORDER BY id LIMIT %s, 1",
	'get_last_id'=>"SELECT id FROM clients ORDER BY id DESC LIMIT 1",
);

function setConnection($connection){
	$this->connection = $connection;
}

function setSplitter($splitter){
	$this->splitter = $splitter;
}

function iterator(){
	$q = $this->queries['list_all'];
	$q = $this->splitter->patch($q. " WHERE id >= [client_from] AND id < [client_to]", $q);
	return $this->connection->select($q);
}

function getCount(){
	$sel = $this->connection->select($this->queries['get_count']);
	$arr = $sel->next();
	return $arr['cnt'];
}

function getShiftId($shift){
	$sel = $this->connection->select($this->queries['get_shift_id'], $shift);
	if($arr = $sel->next()){
		return $arr['id'];
	}
}

function getLastId(){
	$sel = $this->connection->select($this->queries['get_last_id']);
	if($arr = $sel->next()){
		return $arr['id'];
	}
}

function getById($id){
	$it = $this->connection->select($this->queries['get_by_id'], $id);
	return $it->next();
}

function changeConnectionType($clid, $ctid){
	$this->connection->update($this->queries['change_connection_type'], $ctid, $clid);
}

function changeTvType($clid, $tvid){
	$this->connection->update($this->queries['change_tv_type'], $tvid, $clid);
}

function replaceExpiredConnectionTypes(){
	$this->connection->update($this->queries['replace_expired_connection_types']);
}

function replaceExpiredTvTypes(){
	$this->connection->update($this->queries['replace_expired_tv_types']);
}


}
?>