<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class TransactionManager {

var $con;
var $logger;
var $profiler;

function setProfiler($obj){
	$this->profiler = $obj;
}

function setConnection($con){
	$this->con = $con;
}

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('transaction');
}

function begin(){
	$this->logger->debug("starting new transaction");
	$this->con->query("BEGIN");
}

function end(){
	if($this->con->hasErrors()){
		$this->logger->debug("rollbacking transaction");
		$this->con->query("ROLLBACK");
		$this->con->clearErrors();
		return false;
	}else{
		$this->logger->debug("commiting transaction");
		$this->profiler->enter('dao.commit');
		$this->con->query("COMMIT");
		$this->profiler->leave('dao.commit');
		return true;
	}
}

}
?>