<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/08/04 07:53:20 $
$Revision: 1.4 $
*/
include_once(PE6YC.'db/graph.php');

class PLogGraph extends PDBGraph {

	var $date;

	function Create($owner,$data){
		parent::Create($owner,$data);
		$this->date = time();
		$this->LoadParams();
	}

	function getHMarkText($y){
		$label = sprintf("% 6s",$y.'k');
		if($y>1024)
			$label = sprintf("% 6s",(round($y/1024)).'M');
		elseif($y<1)
			$label = sprintf("% 6s",$y*1024);
		return $label;
	}

	function LoadParams(){
		$this->x_field = 'x';
		$this->y_field = 'y';
		$this->owner->filter = "x>='".$this->min_x."' AND x<='".$this->max_x."'";
		$this->min_y = 0;
		$this->max_y = max(1,_Float($this->owner->_Aggregate('y','max')));
		$this->grid_y_step = ceil($this->max_y*1.05/4);//
		$this->max_y = 4 * $this->grid_y_step;
	}

	function DrawGrid(){
		parent::DrawGrid();
		ImageString(
			$this->img,2,
			$this->left + $this->mark_h_x,
			$this->top + $this->mark_h_y,
			sprintf("% 6s",'bit/s'),
			$this->c_border
		);
	}
}

class PDayLogGraph extends PLogGraph {

	function getNextGridX($x){
		return mktime(date("H",$x)+2,0,0,date("m",$x),date("d",$x),date("Y",$x));
	}

	function getVMarkText($x){
		return date("G",$x);
	}

	function LoadParams(){
		$this->min_x = mktime (0,0,0,date("m",$this->date),date("d",$this->date),date("Y",$this->date));
		$this->max_x = mktime (0,0,0,date("m",$this->date),date("d",$this->date)+1,date("Y",$this->date));
		parent::LoadParams();
	}

}

class PMonthLogGraph extends PLogGraph {

	function getNextGridX($x){
		return mktime(0,0,0,date("m",$x),date("d",$x)+2,date("Y",$x));
	}

	function getVMarkText($x){
		return date("j",$x);
	}

	function LoadParams(){
		$this->min_x = mktime (0,0,0,date("m",$this->date),1,date("Y",$this->date));
		$this->max_x = mktime (0,0,0,date("m",$this->date)+1,1,date("Y",$this->date));
		parent::LoadParams();
	}

}

class PYearLogGraph extends PLogGraph {

	function getNextGridX($x){
		return mktime(0,0,0,date("m",$x)+1,1,date("Y",$x));
	}

	function getVMarkText($x){
		return date("n",$x);
	}

	function LoadParams(){
		$this->min_x = mktime (0,0,0,1,1,date("Y",$this->date));
		$this->max_x = mktime (0,0,0,1,1,date("Y",$this->date)+1);
		parent::LoadParams();
	}

}

?>