<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class DefaultLogger {

var $levels = array(
	'DEBUG'=>1,
	'INFO'=>2,
	'WARNING'=>3,
	'ERROR'=>4,
	'NONE'=>5,
);
var $level = 1;
var $appender;

function setName($name){
	$this->name = $name;
}

function setAppender($appender){
	$this->appender = $appender;
}

function setLevel($level){
	if(is_integer($level)){
		$this->level = $level;
	}else{
		if(isset($this->levels[$level])){
			$this->level = $this->levels[$level];
		}else{
			$this->level = 5;
		}
	}
}

function debug($msg){
	if($this->level <= $this->levels['DEBUG']){
		if(func_num_args() > 1){
			$args = func_get_args();
			$msg = call_user_func_array('sprintf', $args);
		}
		$this->appender->append('DEBUG', $this->name, $msg);
	}
}

function info($msg){
	if($this->level <= $this->levels['INFO']){
		if(func_num_args() > 1){
			$args = func_get_args();
			$msg = call_user_func_array('sprintf', $args);
		}
		$this->appender->append('INFO', $this->name, $msg);
	}
}

function warning($msg){
	if($this->level <= $this->levels['WARNING']){
		if(func_num_args() > 1){
			$args = func_get_args();
			$msg = call_user_func_array('sprintf', $args);
		}
		$this->appender->append('WARNING', $this->name, $msg);
	}
}

function error($msg){
	if($this->level <= $this->levels['ERROR']){
		if(func_num_args() > 1){
			$args = func_get_args();
			$msg = call_user_func_array('sprintf', $args);
		}
		$this->appender->append('ERROR', $this->name, $msg);
	}
}

}
?>