<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class FileAppender {

var $fileName;
var $error = false;
var $file;
var $dateFormat = "Y-m-d H:i:s";
var $recordFormat = "%s %-8s [%s] %s: %s\n";
var $writeMode = "a+";
var $pid;

function FileAppender($fileName = ''){
	$this->setFileName($fileName);
	$this->pid = getmypid();
}

function setFileName($fileName){
	$this->fileName = $fileName;
}

function setDateFormat($dateFormat){
	$this->dateFormat = $dateFormat;
}

function setRecordFormat($recordFormat){
	$this->recordFormat = $recordFormat;
}

function setWriteMode($str){
	$this->writeMode = $str;
}

function append($type, $name, $msg){
	if(!$this->file){
		if($this->error){
			return;
		}
		if(!$this->file = @fopen($this->fileName, $this->writeMode)){
			printf("FileAppender: Can't open %s for writing", $this->fileName);
			$this->error = true;
			return;
		}
	}
//	list($msec, $time) = explode(" ", microtime()); substr($msec,2,4),
	$record = sprintf($this->recordFormat, date($this->dateFormat), $type, $this->pid, $name, trim($msg));
	fwrite($this->file, $record);
}

}
?>