<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class LoggerRegistryFactory {

var $registry = array();
var $loggers = array();

function setRegistry($registry){
	$this->registry = $registry;
}

function getLogger($name){
	if(isset($this->loggers[$name])){
		return $this->loggers[$name];
	}else{
		$factory = $this->getLoggerFactory($name);
		$logger = $factory->createLogger($name);
		$this->registerLogger($name, $logger);
		return $logger;
	}
}

function registerLogger($name, $logger){
	$this->loggers[$name] = $logger;
}

function getLoggerFactory($name){
	foreach($this->registry as $key=>$factory){
		if(($key==$name) || @preg_match($key, $name)){
			return $this->registry[$key];
		}
	}
	return $this->registry['default'];
}

function show(){
	print_r($this->config);
	print_r($this->loggers);
}

}
?>