<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

include_once 'Excel/reader.php';

class EcallReportProcessor {

var $stampManager;
var $connection;

function setStampManager($obj){
	$this->stampManager = $obj;
}

function setConnection($obj){
	$this->connection = $obj;
}

function processReport($report, $name, $src){
	$stamp = $this->stampManager->createStamp();
	$date = substr($name, 6, 4).'-'.substr($name, 3, 2).'-'.substr($name, 0, 2);
	$r_id = $this->connection->insert_auto("INSERT INTO ecall_reports (src, date, filename, stamp)
		VALUES ('%s', '%s', '%s', '%s')",
		$src, $date, $name, $stamp);
	$excel = new Spreadsheet_Excel_Reader();
	$excel->setUTFEncoder('iconv');
	$excel->setOutputEncoding('Windows-1251');
	$excel->read($report, true);
	$sheet = $excel->sheets[0];
	$g_id = 0;
	for($i=1; $i<=$sheet['numRows']; $i++) {
		if(isset($sheet['cells'][$i])){
			$row = $sheet['cells'][$i];
			if(strstr($row[1], ' ')){
				$g_name = trim(str_replace('  ', '', $row[2]));
				$g_id = $this->getGroup($g_name);
				continue;
			}
			if(stristr($row[1], ' ')){
				continue;
			}
			if($g_id > 0){
				$f_name = trim($row[1]);
				if(!empty($f_name)){
					if(isset($row[2])){
						$f_id = $this->getField($g_id, $f_name);
						$value = intval(trim($row[2]));
						$this->connection->insert("INSERT INTO ecall_report_values (report, field, value) VALUES ('%s', '%s', '%s')",
							$r_id, $f_id, $value);
					}
				}
			}
		}
	}
}

function getGroup($name){
	if(!isset($this->groups)){
		$this->groups = array();
		$sel = $this->connection->select("SELECT id, name FROM ecall_report_groups");
		while($arr = $sel->next()){
			$this->groups[$arr['name']] = $arr['id'];
		}
	}
	if(!isset($this->groups[$name])){
		$g_id = $this->connection->insert_auto("INSERT INTO ecall_report_groups (name) VALUES ('%s')", $name);
		$this->groups[$name] = $g_id;
	}
	return $this->groups[$name];
}

function getField($g_id, $name){
	if(!isset($this->fields)){
		$this->fields = array();
		$sel = $this->connection->select("SELECT id, gid, name FROM ecall_report_fields");
		while($arr = $sel->next()){
			$this->fields[$arr['gid']][$arr['name']] = $arr['id'];
		}
	}
	if(!isset($this->fields[$g_id][$name])){
		$f_id = $this->connection->insert_auto("INSERT INTO ecall_report_fields (gid, name) VALUES ('%s', '%s')", $g_id, $name);
		$this->fields[$g_id][$name] = $f_id;
	}
	return $this->fields[$g_id][$name];
}

}
?>