<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class RequestDelegate {

var $titlePattern;
var $toPattern;
var $stampManager;
var $connection;
var $logger;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('mail.request');
}

function setTitlePattern($str){
	$this->titlePattern = $str;
}

function setToPattern($str){
	$this->toPattern = $str;
}

function setStampManager($obj){
	$this->stampManager = $obj;
}

function setConnection($obj){
	$this->connection = $obj;
}

/*
nme:
adr:.  91
ent:3
flr:6
app:184
tel:0962979299
trf:Flash_75
*/
function parse($str){
	$result = array();
	$lines = explode("\n", $str);
	foreach($lines as $line){
		$pos = strpos($line, ":");
		if($pos > 0){
			$key = substr($line, 0, $pos);
			$value = substr($line, $pos + 1);
			$result[$key] = $value;
		}
	}
	return $result;
}

function get($arr, $key, $def = ''){
	return isset($arr[$key]) ? $arr[$key] : $def;
}

function guessHouse($street_name, $house){
	$sel = $this->connection->select("SELECT h.id FROM houses h LEFT JOIN streets s ON s.id=h.street 
		WHERE h.house='%s' AND (s.name='%s' OR s.name_alt='%s')", $house, $street_name, $street_name);
	if($arr = $sel->next()){
		return $arr['id'];
	}
	$sel = $this->connection->select("SELECT h.id FROM houses h LEFT JOIN streets s ON s.id=h.street 
		WHERE h.house='%s'
		AND (
			'%s' LIKE CONCAT('%%', substring_index(s.name, ' ', 1), '%%')
			OR
			'%s' LIKE CONCAT('%%', substring_index(s.name_alt, ' ', 1), '%%')
		)", $house, $street_name, $street_name);
	if($arr = $sel->next()){
		return $arr['id'];
	}
}

function process($msg){
	if(preg_match($this->toPattern, $msg['addr_to'])){
		$this->logger->info("found request message");
		if($msg['body']=='HTML body saved in attachment.'){
			$msg['body'] = $msg['attachments'][0]['body'];
		}
		$msg['body'] = str_replace("<br/>", "\n", $msg['body']);
		$values = $this->parse($msg['body']);
		if(isset($values['adr'])){
			$this->logger->debug("request: %s", $msg['body']);
			$stamp = $this->stampManager->createStamp();
			if(preg_match ("/^(.+)(,|\s)(\w+)$/", trim($values['adr']), $m)){
				$street = $m[1];
				if(substr($street, -1)==','){
					$street = substr($street, 0, -1);
				}
				$house = $m[3];
			}else{
				$street = $values['adr'];
				$house = '';
			}
			$house_id = $this->guessHouse($street, $house);
			$this->connection->insert("INSERT INTO con_requests (source, type, client, street_name, house, entrance, floor, appartment, phone, notes, stamp, house_id)
				VALUES (1, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', %s)",
				(trim($this->get($values, 'trf')) ? 1 : 0)  + (trim($this->get($values, 'tv')) ? 2 : 0),
				$this->get($values, 'nme'),
				$street,
				$house,
				$this->get($values, 'ent'),
				$this->get($values, 'flr'),
				$this->get($values, 'app'),
				$this->get($values, 'tel'),
				"internet: ".$this->get($values, 'trf')."\ntv: ".$this->get($values, 'tv'),
				$stamp,
				$house_id ? $house_id : 'null');
			return true;
		}else{
			$this->logger->error("wrong request: %s", $msg['body']);
		}
	}
	return false;
}

}
?>