<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class AccountsManager {

var $logger;
var $calculator;
var $accountsDAO;
var $accountStatesDAO;
var $movementsDAO;
var $timeService;
var $calendarPeriodsManager;
var $calendarPeriod;
var $clientsManager; //     
var $accountTypes;
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('accounts');
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function setAccountsDAO($obj){
	$this->accountsDAO = $obj;
}

function setAccountStatesDAO($obj){
	$this->accountStatesDAO = $obj;
}

function setMovementsDAO($obj){
	$this->movementsDAO = $obj;
}

function setTimeService($obj){
	$this->timeService = $obj;
}

function setCalendarPeriodsManager($obj){
	$this->calendarPeriodsManager = $obj;
}

function setClientsManager($obj){
	$this->clientsManager = $obj;
}

function load(){
	if(!$this->loaded){
		$this->calendarPeriod = $this->calendarPeriodsManager->getCurrent();
		$this->accounts = array();
		$it = $this->accountStatesDAO->iterator($this->calendarPeriod['id'], $this->timeService->getTime());
		$counter = 0;
		while($arr = $it->next()){
			//$arr['actual']  = $this->calculator->add($arr['begin'],  $arr['actual']);
			//$arr['virtual'] = $this->calculator->add($arr['actual'], $arr['virtual']);
			$this->accounts[$arr['account']] = $arr;
			$counter++;
		}
		$this->logger->debug("%s account states loaded in calendar period [%s]", $counter, $this->calendarPeriod['id']);
		$this->loaded = true;
	}
}

function getVirtualState($acc){
	return $this->accounts[$acc]['virtual'];
}

function createAccount($type, $name){
	$id = $this->accountsDAO->insert($type, $name);
	$this->accounts[$id] = array(
		'id'=>$id,
		//'actual'=>'0',
		'virtual'=>'0',
	);
	$this->logger->debug("created account: [%s]", $id);
	return $this->accounts[$id];
}

function virtualMove($src, $dst, $amount){
	$this->logger->debug("virtual movement [%s]->[%s], %s", $src, $dst, $amount);
	$this->accounts[$src]['virtual'] = $this->calculator->sub($this->accounts[$src]['virtual'], $amount);
	$this->accounts[$dst]['virtual'] = $this->calculator->add($this->accounts[$dst]['virtual'], $amount);
}

function actualMove($src, $dst, $amount){
	$time = $this->timeService->getTime();
	$this->logger->debug("actual movement [%s]->[%s], %s", $src, $dst, $amount);
	if($id = $this->movementsDAO->insert($this->calendarPeriod['id'], $src, $dst, $amount, $time)){
//		$this->accounts[$src]['actual']  = $this->calculator->sub($this->accounts[$src]['actual'],  $amount);
//		$this->accounts[$dst]['actual']  = $this->calculator->add($this->accounts[$dst]['actual'],  $amount);
		$this->accounts[$src]['virtual'] = $this->calculator->sub($this->accounts[$src]['virtual'], $amount);
		$this->accounts[$dst]['virtual'] = $this->calculator->add($this->accounts[$dst]['virtual'], $amount);
		return $id;
	}
}

}
?>