<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class AccountsNotificator {

var $accountsManager;
var $bonusesManager;
var $resourceTypesManager;
var $currencyFormat;
var $calculator;
var $loaded;

function setAccountsManager($obj){
	$this->accountsManager = $obj;
}

function setBonusesManager($obj){
	$this->bonusesManager = $obj;
}

function setResourceTypesManager($obj){
	$this->resourceTypesManager = $obj;
}

function setCurrencyFormat($obj){
	$this->currencyFormat = $obj;
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function load(){
	if(!$this->loaded){
		$this->bonusesManager->load();
		$this->accountsManager->load();
		$this->loaded = true;
	}
}

function notifyClient($client, &$context){
	$context['deposit'] = $this->currencyFormat->format($this->accountsManager->getVirtualState($client['account']));
	$this->bonuses = array();
	$this->bonusesManager->walkClientActualBonuses($client['id'], array($this, 'notifyBonusState'));
	$context['bonuses'] = $this->bonuses;
}

function notifyBonusState($bonus){
	$state = $this->accountsManager->getVirtualState($bonus['account']);
	if($this->calculator->cmp($state, '0') > 0){
		$this->bonuses[] = array(
			'name'=>$bonus['name'],
			'state'=>$this->currencyFormat->format($state),
		);
	}
}

}
?>