<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class BlocksManager {

var $logger;
var $blocksDAO;
var $blocks;
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('blocks');
}

function setBlocksDAO($obj){
	$this->blocksDAO = $obj;
}

function load(){
	if(!$this->loaded){
		$this->blocks = array();
		$it = $this->blocksDAO->iterator();
		$counter = 0;
		while($a = $it->next()){
			$this->blocks[$a['client']][$a['resource_type']][$a['id']] = $a;
			$counter++;
		}
		$this->logger->debug("%s blocks loaded", $counter);
		$this->loaded = true;
	}
}

function isResourceBlocked($clid, $rtid){
	return isset($this->blocks[$clid][$rtid]);
}

function isClientDisconnected($clid){
	return isset($this->blocks[$clid]['']);
}

function isClientAdminDisconnected($clid){
	if(isset($this->blocks[$clid][''])){
		foreach($this->blocks[$clid][''] as $a){
			if($a['type']==1){
				return true;
			}
		}
	}
	return false;
}

function show(){
	print_r($this->blocks);
}

}
?>