<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class BlocksManager2 {

var $logger;
var $blocksDAO;
var $blocks = array();
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('blocks');
}

function setBlocksDAO($obj){
	$this->blocksDAO = $obj;
}

function load(){
}

function getClientBlocks($clid){
	if(!isset($this->blocks[$clid])){
		$this->blocks[$clid] = array();
		$it = $this->blocksDAO->iteratorByClient($clid);
		$counter = 0;
		while($a = $it->next()){
			$this->blocks[$a['client']][$a['resource_type']][$a['id']] = $a;
			$counter++;
		}
		$this->logger->debug("%s blocks loaded for client [%s]", $counter, $clid);
	}
	return $this->blocks[$clid];
}

function isResourceBlocked($clid, $rtid){
	$blocks = $this->getClientBlocks($clid);
	return isset($blocks[$rtid]);
}

function isClientDisconnected($clid){
	$blocks = $this->getClientBlocks($clid);
	return isset($blocks['']);
}


function isClientAdminDisconnected($clid){
	$blocks = $this->getClientBlocks($clid);
	if(isset($blocks[''])){
		foreach($blocks[''] as $a){
			if($a['type']!=2){
				return true;
			}
		}
	}
	return false;
}

function show(){
	print_r($this->blocks);
}

}
?>