<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class ChargeTypesManager {

var $logger;
var $chargeTypesDAO;
var $chargeTypes;
var $beanFactory;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('charge.types');
}

function setBeanFactory($obj){
	$this->beanFactory = $obj;
}

function setChargeTypesDAO($obj){
	$this->chargeTypesDAO = $obj;
}

function initBean(){
	$this->chargeTypes = array();
	$it = $this->chargeTypesDAO->iterator();
	while($arr = $it->next()){
		if($arr['driver']){
			$arr['driver_obj'] = $this->beanFactory->getBean($arr['driver']);
		}
		$this->chargeTypes[$arr['id']] = $arr;
	}
	$this->logger->debug("%s charge types loaded", count($this->chargeTypes));
}

function getChargeType($id){
	return $this->chargeTypes[$id];
}

function driverStart($sub, $client, $period){
	$type = $this->chargeTypes[$sub['type']];
	if(isset($type['driver_obj'])){
		$driver = $type['driver_obj'];
		return $driver->start($sub, $type, $client, $period);
	}else{
		return true;
	}
}

function show(){
	print_r($this->chargeTypes);
}

}
?>