<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class ClientsManager {

var $logger;
var $clientsDAO;
var $clients;
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('clients');
}

function setClientsDAO($obj){
	$this->clientsDAO = $obj;
}

function load(){
	if(!$this->loaded){
		$this->clients = array();
		$it = $this->clientsDAO->iterator();
		$counter = 0;
		while($arr = $it->next()){
			$this->clients[$arr['id']] = $arr;
			$counter++;
		}
		$this->logger->debug("%s clients loaded", $counter);
		$this->loaded = true;
	}
}

function walk($callback){
	foreach($this->clients as $client){
		call_user_func($callback, $client);
	}
}

function getClient($id){
	return $this->clients[$id];
}

function changeConnectionType($clid, $ctid){
	$this->clientsDAO->changeConnectionType($clid, $ctid);
}

function changeTvType($clid, $tvid){
	$this->clientsDAO->changeTvType($clid, $tvid);
}

function replaceExpiredConnectionTypes(){
	$this->clientsDAO->replaceExpiredConnectionTypes();
}

function replaceExpiredTvTypes(){
	$this->clientsDAO->replaceExpiredTvTypes();
}

function show(){
	print_r($this->clients);
}

}
?>