<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class DepositBlocker {

var $accountsManager;
var $clientsManager;
var $calculator;
var $currencyFormat;
var $init;
var $creditsDAO;
var $credits;
var $loaded;

function setAccountsManager($obj){
	$this->accountsManager = $obj;
}

function setClientsManager($obj){
	$this->clientsManager = $obj;
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function setCurrencyFormat($obj){
	$this->currencyFormat = $obj;
}

function setCreditsDAO($obj){
	$this->creditsDAO = $obj;
}

function load(){
	if(!$this->loaded){
		$this->credits = array();
		$it = $this->creditsDAO->iterator();
		while($a = $it->next()){
			$this->credits[$a['client']] = $a['amount'];
		}
		$this->init = array();
		$this->accountsManager->load();
		$this->clientsManager->load();
		$this->clientsManager->walk(array($this, 'initClient'));
		$this->loaded = true;
	}
}

function initClient($client){
	$this->init[$client['id']] = $this->accountsManager->getVirtualState($client['account']);
	if(!isset($this->credits[$client['id']])){
		$this->credits[$client['id']] = '0';
	}
}

function isDepositBlocked($client, $deposit){
	$val = $this->calculator->add($this->credits[$client['id']], $deposit);
	return $client['blockable'] && ($this->calculator->cmp($val, $client['block']) < 0);
}

function isDepositAlarm($client, $deposit){
	$val = $this->calculator->add($this->credits[$client['id']], $deposit);
	return $client['blockable'] && ($this->calculator->cmp($val, $client['alarm']) <= 0);
}

function isResourceBlocked($clid, $rtid){
	$client = $this->clientsManager->getClient($clid);
	$deposit = $this->accountsManager->getVirtualState($client['account']);
	return $this->isDepositBlocked($client, $deposit);
}

function notifyClient($client, &$context){
	if($client['blockable']){
		$deposit = $this->accountsManager->getVirtualState($client['account']);
		$init = $this->init[$client['id']];
		if($this->isDepositBlocked($client, $deposit)){
			if(!$this->isDepositBlocked($client, $init)){
				$context['blocked'] = 1;
				return true;
			}
		}else{
			if($this->isDepositAlarm($client, $deposit)){
				if(!$this->isDepositAlarm($client, $init)){
					$context['alarm'] = $this->currencyFormat->format($client['block']);
					return true;
				}
			}
		}
	}
}

function isClientDisconnected($clid){
	$client = $this->clientsManager->getClient($clid);
	$deposit = $this->accountsManager->getVirtualState($client['account']);
	return $this->isDepositBlocked($client, $deposit);
}

}
?>