<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class HostsManager {

var $logger;
var $hostsDAO;
var $hosts;
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('hosts');
}

function setHostsDAO($obj){
	$this->hostsDAO = $obj;
}

function load(){
	if(!$this->loaded){
		$this->hosts = array();
		$it = $this->hostsDAO->iterator();
		$counter = 0;
		while($arr = $it->next()){
			$this->hosts[$arr['client']][$arr['id']] = $arr;
			$counter++;
		}
		$this->logger->debug("%s hosts loaded", $counter);
		$this->loaded = true;
	}
}

function getClientHosts($clid){
	return isset($this->hosts[$clid]) ? $this->hosts[$clid] : array();
}

function walkClientHosts($clid, $callback){
	if(isset($this->hosts[$clid])){
		foreach($this->hosts[$clid] as $host){
			call_user_func($callback, $host);
		}
	}
}

function show(){
	print_r($this->hosts);
}

}
?>