<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class LockInterceptor {

var $locker;
var $lock;
var $timeout;
var $logger;
var $dieOnLocked = true;

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('locker');
}

function setLocker($obj){
	$this->locker = $obj;
}

function setLock($str){
	$this->lock = $str;
}

function setTimeout($i){
	$this->timeout = $i;
}

function setDieOnLocked($boolean){
	$this->dieOnLocked = $boolean;
}

function invoke($invocation){
	$name = $invocation->getMethodName();
	if($this->locker->getLock($this->lock, $this->timeout)){
		$this->logger->debug("lock '%s' acquired for method '%s'", $this->lock, $name);
		$result = $invocation->proceed();
		$this->locker->release($this->lock);
		return $result;
	}else{
		$this->logger->debug("can't get lock '%s' for method '%s' with timeout", $this->lock, $name, $this->timeout);
		if($this->dieOnLocked){
			die(sprintf("%s locked\n", $name));
		}
	}
}

}
?>