<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class Notificator {

var $logger;
var $clientsManager;
var $optionsManager;
var $members;
var $template;
var $sendProcessor = 'sendmail -t';
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('notificator');
}

function setClientsManager($obj){
	$this->clientsManager = $obj;
}

function setOptionsManager($obj){
	$this->optionsManager = $obj;
}

function setMembers($arr){
	$this->members = $arr;
}

function setSendProcessor($str){
	$this->sendProcessor = $str;
}

function load(){
	if(!$this->loaded){
		foreach($this->members as $k=>$v){
			$this->members[$k]->load();
		}
		$this->loaded = true;
	}
}

function notify(){
	$this->logger->debug("begin");
	$opt = $this->optionsManager->getOption('NOTIFICATION_SCRIPT');
	if($opt['actual']){
		$this->template = $opt['value'];
		$this->logger->debug("begin notification process");
		$this->clientsManager->walk(array($this, 'notifyClient'));
		$this->logger->debug("end notification process");
	}else{
		$this->logger->debug("notifications is disabled by configuration");
	}
	$this->logger->debug("end");
}

function notifyClient($client){
	if($client['email']){
		$send = false;
		$context = array();
		$context['client'] = $client;
		foreach($this->members as $k=>$v){
			$send = $this->members[$k]->notifyClient($client, $context) || $send;
		}
		if($send){
			$this->logger->debug("sending notifications to '%s' (%s)", $client['login'], $client['email']);
			$msg = $this->render($context);
			$this->send($msg);
		}
	}else{
		$this->logger->debug("no email address for '%s', skipping", $client['login']);
	}
}

function render($context){
	extract($context);
	ob_start();
	eval("?>".$this->template."<?");
	return ob_get_clean();
}

function send($msg){
	if($proc = popen($this->sendProcessor, "w")){
		fputs($proc, $msg, strlen($msg));
		pclose($proc);
	}else{
		$this->logger->error("can't open process '%s'", $this->sendProcessor);
	}
}

}
?>