<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class PayManager {

var $logger;
var $accountsManager;
var $accountTypesManager;
var $bonusesManager;
var $calculator;
var $resourceUsesManager;
var $personalPeriodResourceUsesManager;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('pay.manager');
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function setAccountsManager($obj){
	$this->accountsManager = $obj;
}

function setAccountTypesManager($obj){
	$this->accountTypesManager = $obj;
}

function setBonusesManager($obj){
	$this->bonusesManager = $obj;
}

function setResourceUsesManager($obj){
	$this->resourceUsesManager = $obj;
}

function setPersonalPeriodResourceUsesManager($obj){
	$this->personalPeriodResourceUsesManager = $obj;
}

function load(){
	$this->personalPeriodResourceUsesManager->load();
	$this->resourceUsesManager->load();
	$this->bonusesManager->load();
	$this->accountsManager->load();
}

function payThis($client, $pid, $dst, $rtid, $unit, $price, $amount){
	$this->ru = '';
	$this->client = $client;
	$this->pid = $pid;
	if($this->calculator->cmp($unit, 1) > 0){
		$price = $this->calculator->divLow($this->calculator->mul($amount, $price), $unit);
		$unit = 1;
		$amount = 1;
	}
	for($i=0; $i<$amount; $i++){
		$this->payThisState = array('dst'=>$dst, 'rtid'=>$rtid, 'cost'=>$price);
		if($rtid){
			$this->bonusesManager->walkClientActualBonuses($this->client['id'], array($this, 'payThisBonus'));
		}
		if($this->calculator->cmp($this->payThisState['cost'], 0) > 0){
			$this->logger->debug('%s pay %s resource [%s] from depo', $this->client['login'], $this->payThisState['cost'], $rtid);
			$this->ru = $this->resourceUsesManager->addAmount($this->client['id'], $this->client['account'], $dst, $rtid, 1, $this->payThisState['cost'], 1);
			if($this->pid){
				$this->personalPeriodResourceUsesManager->addAmount($this->pid, $this->ru, 1);
			}
		}
	}
	return $this->ru;
}

function payThisBonus($bonus){
	if($this->calculator->cmp($this->payThisState['cost'], 0) > 0){
		if($this->accountTypesManager->isApplicable($bonus['account_type'], $this->payThisState['rtid'])){
			$state = $this->accountsManager->getVirtualState($bonus['account']);
			if($this->calculator->cmp($state, 0) > 0){
				$fit = $this->calculator->min($state, $this->payThisState['cost']);
				$this->logger->debug('%s pay %s resource [%s] from bonus type [%s]', $this->client['login'], $fit, $this->payThisState['rtid'], $bonus['account_type']);
				$this->payThisState['cost'] = $this->calculator->sub($this->payThisState['cost'], $fit);
				$this->ru = $this->resourceUsesManager->addAmount($this->client['id'], $bonus['account'], $this->payThisState['dst'], $this->payThisState['rtid'], 1, $fit, 1);
				if($this->pid){
					$this->personalPeriodResourceUsesManager->addAmount($this->pid, $this->ru, 1);
				}
			}
		}
	}
}

}
?>