<?
class SnapshotMaker {

var $connection;
var $logger;
var $pathTemplate;
var $pathInfo;

function setConnection($connection){
	$this->connection = $connection;
}

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('snapshots');
}

function setPathTemplate($str){
	$this->pathTemplate = $str;
}

function setPathInfo($arr){
	$this->pathInfo = $arr;
}

function alt(&$var, $val){
	return isset($var) ? $var : $val;
}

function fixArpu(){
	$date = time();
	$sel = $this->connection->select("SELECT id, city, unix_timestamp(date) date FROM snapshots WHERE arpu>0");
	while($arr = $sel->next()){
		$sel2 = $this->connection->select("SELECT
			FLOOR(IFNULL(SUM(int_payed + tv_payed + both_payed) / AVG(int_clients + tv_clients + both_clients), 0)) arpu,
			FLOOR(IFNULL(SUM(int_payed)  / AVG(int_clients)  , 0)) int_arpu,
			FLOOR(IFNULL(SUM(tv_payed)   / AVG(tv_clients)   , 0)) tv_arpu,
			FLOOR(IFNULL(SUM(both_payed) / AVG(both_clients) , 0)) both_arpu
			FROM snapshots
			WHERE city='%s' AND date BETWEEN SUBDATE('%s', INTERVAL 1 MONTH) AND '%s'",
			$arr['city'],
			date("Y-m-d H:i:s", $arr['date']),
			date("Y-m-d H:i:s", $arr['date']));
		$arpu = $sel2->next();
		$this->connection->update("UPDATE snapshots SET arpu='%s', int_arpu='%s', tv_arpu='%s', both_arpu='%s' WHERE id='%s'",
			$arpu['arpu'], $arpu['int_arpu'], $arpu['tv_arpu'], $arpu['both_arpu'], $arr['id']);
	}
}

function process(){
	$date = time();
	$cities = array();
	$sel = $this->connection->select("SELECT id FROM cities ORDER BY id");
	while($arr = $sel->next()){
		$cities[] = $arr['id'];
	}
	foreach($cities as $cid){ // 
		$sel = $this->connection->select("SELECT
			IFNULL(SUM(IF(ct.service_type&1=1 AND (c.tv_type IS NULL OR tt.offline=1), 1, 0)), 0) internet,
			IFNULL(SUM(IF(ct.service_type=2 AND c.tv_type IS NOT NULL AND tt.offline=0, 1, 0)), 0) tv,
			IFNULL(SUM(IF(ct.service_type=3 AND c.tv_type IS NOT NULL AND tt.offline=0, 1, 0)), 0) `both`
			FROM clients c
			LEFT JOIN connection_types ct ON ct.id=c.connection_type
			LEFT JOIN tv_types tt ON tt.id=c.tv_type
			WHERE c.city='$cid'");
		$clients = $sel->next();
		
		$this->logger->info('city %s, clients: %s', $cid, print_r($clients, 1));
		
		$sel = $this->connection->select("SELECT *, unix_timestamp(date) as udate FROM snapshots WHERE city='$cid' ORDER BY date DESC LIMIT 1");
		$prev = $sel->next();
		
		$prev_date = isset($prev['udate']) ? $prev['udate'] : $date - 60*60*24;
		
		$sel = $this->connection->select("SELECT
			IFNULL(SUM(IF(jt.abon_incremental=1 AND jt.type=1 AND ct.service_type&1=1 AND (c.tv_type IS NULL OR tt.offline=1), 1, 0)), 0) internet_new,
			IFNULL(SUM(IF(jt.abon_incremental=1 AND jt.type=2 AND ct.service_type=2 AND c.tv_type IS NOT NULL AND tt.offline=0, 1, 0)), 0) tv_new,
			IFNULL(SUM(IF(jt.abon_incremental=1 AND jt.type IN (1,2,3) AND ct.service_type=3 AND c.tv_type IS NOT NULL AND tt.offline=0, 1, 0)), 0) both_new,
			
			IFNULL(SUM(IF(jt.abon_incremental=2 AND jt.type=1 AND ct.service_type&1=1 AND (c.tv_type IS NULL OR tt.offline=1), 1, 0)), 0) internet_ret,
			IFNULL(SUM(IF(jt.abon_incremental=2 AND jt.type=2 AND ct.service_type=2 AND c.tv_type IS NOT NULL AND tt.offline=0, 1, 0)), 0) tv_ret,
			IFNULL(SUM(IF(jt.abon_incremental=2 AND jt.type IN (1,2,3) AND ct.service_type=3 AND c.tv_type IS NOT NULL AND tt.offline=0, 1, 0)), 0) both_ret
			FROM jobs j
			LEFT JOIN job_types jt ON jt.id=j.type
			INNER JOIN clients c ON c.id=j.client_id
			LEFT JOIN connection_types ct ON ct.id=c.connection_type
			LEFT JOIN tv_types tt ON tt.id=c.tv_type
			WHERE (j.date BETWEEN '%s' AND '%s') AND j.state=1 AND j.city='$cid'",
			date("Y-m-d H:i:s", $prev_date), date("Y-m-d H:i:s", $date));
		$increment = $sel->next();

		$this->logger->info('city %s, increment: %s', $cid, print_r($increment, 1));

		$payed = array(
			'int'=>0,
			'tv'=>0,
			'both'=>0,
			'total'=>0,
		);
		$snames = array('int', 'tv', 'both');
		$sel = $this->connection->select("SELECT 
			IF(ct.service_type&1=1 AND (c.tv_type IS NULL OR tt.offline=1), 1, IF(ct.service_type=2, 2, 3)) as service,
			sum(m.amount) as amount
			FROM movements m
			LEFT JOIN stamps s ON s.id=m.stamp
			INNER JOIN clients c ON c.account=m.dst
			LEFT JOIN connection_types ct ON ct.id=c.connection_type
			LEFT JOIN tv_types tt ON tt.id=c.tv_type
			INNER JOIN system_accounts sa ON sa.account=m.src
			WHERE m.city='$cid' AND (s.created between '%s' AND '%s') AND sa.code LIKE '%%PAY%%'
			GROUP BY 1",
			date("Y-m-d H:i:s", $prev_date), date("Y-m-d H:i:s", $date));
		while($arr = $sel->next()){
			$payed[$snames[$arr['service'] - 1]] = $arr['amount'];
			$payed['total'] += $arr['amount'];
		}
		$this->logger->info('city %s, payed: %s', $cid, print_r($payed, 1));

		$sel = $this->connection->select("SELECT 
			FLOOR(IFNULL(SUM(int_payed + tv_payed + both_payed) / AVG(int_clients + tv_clients + both_clients), 0)) arpu,
			FLOOR(IFNULL(SUM(int_payed)  / AVG(int_clients)  , 0)) int_arpu,
			FLOOR(IFNULL(SUM(tv_payed)   / AVG(tv_clients)   , 0)) tv_arpu,
			FLOOR(IFNULL(SUM(both_payed) / AVG(both_clients) , 0)) both_arpu
			FROM snapshots
			WHERE city='$cid' AND date BETWEEN SUBDATE('%s', INTERVAL 1 MONTH) AND '%s'",
			date("Y-m-d H:i:s", $date),
			date("Y-m-d H:i:s", $date));
		$arpu = $sel->next();
		$this->logger->info('city %s, arpu: %s', $cid, print_r($arpu, 1));

		$sel = $this->connection->select("SELECT
			IFNULL(SUM(IF(internet=1, appartments, 0)), 0) internet,
			IFNULL(SUM(IF(tv=1, appartments, 0)), 0) tv
			FROM houses
			WHERE city='$cid'");
		$cover = $sel->next();

		$diff = array(
			'internet' => isset($prev['int_clients']) ? ($clients['internet'] - $prev['int_clients']) : $increment['internet_new'] + $increment['internet_ret'],
			'tv' => isset($prev['tv_clients']) ? ($clients['tv'] - $prev['tv_clients']) : $increment['tv_new'] + $increment['tv_ret'],
			'both' => isset($prev['both_clients']) ? ($clients['both'] - $prev['both_clients']) : $increment['both_new'] + $increment['both_ret'],
			'cover_tv' => isset($prev['cover_tv']) ? ($cover['tv'] - $prev['cover_tv']) : 0,
			'cover_internet' => isset($prev['cover_int']) ? ($cover['internet'] - $prev['cover_int']) : 0,
		);
		
		foreach(array('internet', 'tv', 'both') as $k){
			if($increment[$k.'_new'] + $increment[$k.'_ret'] < $diff[$k]){
				$increment[$k.'_new'] += $diff[$k] - ($increment[$k.'_new'] + $increment[$k.'_ret']);
			}
		}
		$this->connection->update("INSERT INTO snapshots (city, date, payed, arpu,
				int_clients, int_clients_diff, int_new, int_return, int_payed, int_arpu,
				tv_clients, tv_clients_diff, tv_new, tv_return, tv_payed, tv_arpu,
				both_clients, both_clients_diff, both_new, both_return, both_payed, both_arpu,
				cover_tv, cover_tv_diff, cover_int, cover_int_diff
			) VALUES ('%s', FROM_UNIXTIME(%s), %s, '%s',
				%s, %s, %s, %s, %s, '%s',
				%s, %s, %s, %s, %s, '%s',
				%s, %s, %s, %s, %s, '%s',
				%s, %s, %s, %s)",
			$cid, $date, $payed['total'], $arpu['arpu'],
			$clients['internet'], $diff['internet'], $increment['internet_new'], $increment['internet_ret'], $payed['int'], $arpu['int_arpu'],
			$clients['tv'], $diff['tv'], $increment['tv_new'], $increment['tv_ret'], $payed['tv'], $arpu['tv_arpu'],
			$clients['both'], $diff['both'], $increment['both_new'], $increment['both_ret'], $payed['both'], $arpu['both_arpu'],
			$cover['tv'], $diff['cover_tv'],
			$cover['internet'], $diff['cover_internet']
		);
		if(isset($this->pathInfo[$cid])){
			$info = $this->pathInfo[$cid];
			$str = $this->pathTemplate->render(array_merge($info, array(
				'created'=>date("Y-m-dTH:i:s"),
				'date'=>date("Y-m-d", time() - 60 * 60),
				'tv_new'=>$increment['tv_new'],
				'tv_ret'=>$increment['tv_ret'],
				'tv_off'=>$increment['tv_new'] + $increment['tv_ret'] - $diff['tv'],
				'int_new'=>$increment['internet_new'],
				'int_ret'=>$increment['internet_ret'],
				'int_off'=>$increment['internet_new'] + $increment['internet_ret'] - $diff['internet'],
				'both_new'=>$increment['both_new'],
				'both_ret'=>$increment['both_ret'],
				'both_off'=>$increment['both_new'] + $increment['both_ret'] - $diff['both'],
				'payed'=>$payed['total'],
				'covered_int'=>$diff['cover_internet'],
				'covered_tv'=>$diff['cover_tv'],
			)));
			$send = sprintf($info['send'], date("ymd"));
			if($proc = popen($send, "w")){
				fwrite($proc, iconv('windows-1251', 'utf-8', $str));
				pclose($proc);
			}
		}
	}
}

}
?>