<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class StateUpdateService {

var $connection;
var $accountsManager;
var $accountTypesManager;
var $calendarPeriodsManager;
var $connectionTypesManager;
var $clientsManager;
var $bonusesManager;
var $personalPeriodsManager;
var $calculator;
var $subscriptionsManager;
var $chargeTypesManager;
var $logger;
var $optionsManager;
var $splitter;
var $profiler;
var $transactionManager;

function setTransactionManager($obj){
	$this->transactionManager = $obj;
}

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('state.update.service');
}

function setProfiler($obj){
	$this->profiler = $obj;
}

function setSplitter($splitter){
	$this->splitter = $splitter;
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function setConnection($obj){
	$this->connection = $obj;
}

function setCalendarPeriodsManager($obj){
	$this->calendarPeriodsManager = $obj;
}

function setAccountsManager($obj){
	$this->accountsManager = $obj;
}

function setAccountTypesManager($obj){
	$this->accountTypesManager = $obj;
}

function setConnectionTypesManager($obj){
	$this->connectionTypesManager = $obj;
}

function setClientsManager($obj){
	$this->clientsManager = $obj;
}

function setBonusesManager($obj){
	$this->bonusesManager = $obj;
}

function setPersonalPeriodsManager($obj){
	$this->personalPeriodsManager = $obj;
}

function setSubscriptionsManager($obj){
	$this->subscriptionsManager = $obj;
}

function setChargeTypesManager($obj){
	$this->chargeTypesManager = $obj;
}

function setOptionsManager($obj){
    $this->optionsManager = $obj;
}

function update(){
	$this->profiler->enter('update');
	$this->logger->info("begin");
	$cp = $this->calendarPeriodsManager->getCurrent();

	$q = "UPDATE clients_states SET
		block=0,
		firewall=0,
		limits=0,
		use_plan=0,
		use_actual=0,
		incomplete=0,
		subscriptions=0,
		credit=0,
		modem_state=NULL";
	$q = $this->splitter->patch($q." WHERE client >= [client_from] AND client < [client_to]", $q);
	$this->connection->update($q);

	$q = "UPDATE clients_states
		SET block=1 WHERE client IN (
		SELECT DISTINCT client FROM blocks
		WHERE (actual_from IS NULL || now()>=actual_from) AND (actual_to IS NULL || now() < actual_to))";
	$q = $this->splitter->patch(str_replace("WHERE", "WHERE client >= [client_from] AND client < [client_to] AND ",$q), $q);
	$this->connection->update($q);
	
	$q = "UPDATE clients_states
		SET firewall=1 WHERE client IN (
		SELECT DISTINCT h.client FROM hosts_firewall hf LEFT JOIN hosts h ON h.id=hf.host LEFT JOIN rules r ON r.id=hf.rule WHERE [split] r.critical > 0
		UNION
		SELECT DISTINCT h.client
		FROM block_schedule s
		LEFT JOIN hosts h ON h.id=s.host
		WHERE [split] (
			(s.type=0 AND s.day_bits & POW(2, (DATE_FORMAT(NOW(), '%w') + 6) % 7)) OR
			(s.type=1 AND s.date = DATE_FORMAT(NOW(), '%Y-%m-%d'))
		) AND (
			EXTRACT(HOUR_SECOND FROM now()) BETWEEN s.from_time AND s.to_time
		))";
	$q1 = str_replace('[split]', '', $q);
	$q2 = str_replace('[split]', '(h.client >= [client_from] AND h.client < [client_to]) AND', $q);
	$q = $this->splitter->patch($q2, $q1);
	$this->connection->update($q);
	
	$q = "UPDATE clients_states
		SET limits=1 WHERE client IN (
		SELECT DISTINCT pp.client FROM personal_period_plans ppp
		INNER JOIN personal_periods pp ON pp.id=ppp.personal_period
		LEFT JOIN self_limitations sl ON pp.client=sl.client AND ppp.resource_type=sl.resource_type
		WHERE [split] pp.marker=1 AND pp.state=1 AND ((ppp.use_limit >0 AND ppp.use_actual>=ppp.use_limit)
		OR (sl.amount >0 AND ppp.use_actual>=sl.amount))
		)";
	$q1 = str_replace('[split]', '', $q);
	$q2 = str_replace('[split]', '(pp.client >= [client_from] AND pp.client < [client_to]) AND', $q);
	$q = $this->splitter->patch($q2, $q1);
	$this->connection->update($q);
	
	$q = "UPDATE 
		(SELECT
		pp.client,
		sum(ppp.use_plan) as use_plan,
		sum(ppp.use_actual) as use_actual,
		sum(
		if((pp.state=1) && (ppp.use_actual < ppp.use_plan), ppp.use_plan - ppp.use_actual, 0) + 
		if((pp.state=2) && (ctr.penalty_type=0) && (ppp.use_actual < ppp.use_plan), ppp.use_plan - ppp.use_actual, 0) + 
		if((pp.state=2) && (ctr.penalty_type=2), if(ppp.use_plan > ppp.use_actual, if((ppp.use_plan - ppp.use_actual) > ctr.use_plan, ctr.use_plan, ppp.use_plan - ppp.use_actual), 0), 0)
		) as incomplete
		FROM personal_period_plans ppp
		LEFT JOIN personal_periods pp ON pp.id=ppp.personal_period
		LEFT JOIN connection_type_resources ctr on ctr.connection_type=pp.connection_type and ctr.resource_type=ppp.resource_type
		WHERE pp.marker=1 [split]
		GROUP by pp.id) x LEFT JOIN clients_states cs ON cs.client=x.client
		SET cs.use_plan=x.use_plan, cs.use_actual=x.use_actual, cs.incomplete=x.incomplete";
	$q1 = str_replace('[split]', '', $q);
	$q2 = str_replace('[split]', 'AND (pp.client >= [client_from] AND pp.client < [client_to])', $q);
	$q = $this->splitter->patch($q2, $q1);
	$this->connection->update($q);
	
	$q = "UPDATE
		(
		SELECT cs.client, sum(floor(cs.amount * ct.price / ct.unit_size)) as amount
		FROM charge_subscriptions cs
		LEFT JOIN charge_types ct ON ct.id=cs.type
		[split]
		GROUP by cs.client
		) x LEFT JOIN clients_states s ON x.client=s.client
		SET s.subscriptions=x.amount";
	$q1 = str_replace('[split]', '', $q);
	$q2 = str_replace('[split]', 'WHERE (cs.client >= [client_from] AND cs.client < [client_to])', $q);
	$q = $this->splitter->patch($q2, $q1);
	$this->connection->update($q);
	
	$q = "UPDATE
		(
		SELECT client, sum(amount) as credit 
		FROM credits 
		WHERE (actual_from IS NULL || now()>=actual_from) AND (actual_to IS NULL || now() < actual_to) [split]
		GROUP BY client
		) x LEFT JOIN clients_states s ON x.client=s.client
		SET s.credit=x.credit";
	$q1 = str_replace('[split]', '', $q);
	$q2 = str_replace('[split]', 'AND (client >= [client_from] AND client < [client_to])', $q);
	$q = $this->splitter->patch($q2, $q1);
	$this->connection->update($q);
	
	$q = "UPDATE
		(
		SELECT IF(SUM(ms.state)=COUNT(*), 1, 0) state, h.client
		FROM hosts h
		LEFT JOIN modems m ON m.id = h.modem
		LEFT JOIN modems_states ms ON ms.id = m.state_id
		WHERE [split] m.audit=1 AND ms.state IS NOT NULL
		GROUP BY h.client
		) x LEFT JOIN clients_states s ON x.client=s.client
		SET s.modem_state=x.state";
	$q1 = str_replace('[split]', '', $q);
	$q2 = str_replace('[split]', '(h.client >= [client_from] AND h.client < [client_to]) AND ', $q);
	$q = $this->splitter->patch($q2, $q1);
	$this->connection->update($q);
	$this->clientsManager->load();
	$this->accountsManager->load();
	$this->bonusesManager->load();
	$this->personalPeriodsManager->load();
	$this->subscriptionsManager->load();
	$this->thresholds = array();
	$sel = $this->connection->select("SELECT client, threshold FROM clients_states");
	while($arr = $sel->next()){
		$this->thresholds[$arr['client']] = $arr['threshold'];
	}
	$this->updates = 0;
	$this->transactionManager->begin();
	$this->clientsManager->walk(array($this, 'walkClient'));
	$this->transactionManager->end();
	//$this->logger->info("%s updates", $this->updates);
	$this->logger->info("end");
	$this->profiler->leave('update');
	$this->profiler->dump();
}

function compareBonuses($tid1, $tid2){
	$t1 = $this->accountTypesManager->getAccountType($tid1);
	$t2 = $this->accountTypesManager->getAccountType($tid2);
	$p1 = $t1['priority'];
	$p2 = $t2['priority'];
	return $p2 - $p1;
}

function prepareBonus($bonus){
	$this->bonuses[$bonus['account_type']] = $this->accountsManager->getVirtualState($bonus['account']);
}

function closeBonus($ctBonus){
	if($ctBonus['end_dst']){
		if($bonus = $this->bonusesManager->getBonus($this->client['id'], $ctBonus['account_type'])){
			$this->bonuses[$ctBonus['account_type']] = $this->calculator->min($ctBonus['end_amount'], $this->bonuses[$ctBonus['account_type']]);
		}
	}
}

function openBonus($ctBonus){
	if($ctBonus['start_src'] && ($ctBonus['start_amount'] > 0)){
		if(isset($this->bonuses[$ctBonus['account_type']])){
			$this->bonuses[$ctBonus['account_type']] = $this->calculator->add($this->bonuses[$ctBonus['account_type']], $ctBonus['start_amount']);
		}else{
			$this->bonuses[$ctBonus['account_type']] = $ctBonus['start_amount'];
		}
	}
}

function walkClient($client){
	$this->client = $client;
	$this->bonuses = array();
	$this->bonusesManager->walkClientActualBonuses($this->client['id'], array($this, 'prepareBonus'));
	$period = $this->personalPeriodsManager->getClientPersonalPeriod($client['id']);
	if($period['state']==1){
		$this->connectionTypesManager->walkBonuses($period['connection_type'], array($this, 'closeBonus'));
	}
	$this->connectionTypesManager->walkBonuses($client['connection_type'], array($this, 'openBonus'));
	uksort($this->bonuses, array($this, 'compareBonuses'));
	
	$connection_type = $this->connectionTypesManager->getConnectionType($client['connection_type']);
	
	$this->sum = 0;
	
	if($connection_type['abon_resource_type'] && $connection_type['abon_dst'] && ($this->calculator->cmp($connection_type['abon_amount'], '0') > 0)){
		$this->payThis($connection_type['abon_resource_type'], 1, $connection_type['abon_amount'], 1);
	}
	if(!$connection_type['credit']){
		$this->payTv($connection_type, $client['tv_type']);
		$this->subscriptionsManager->walkClientSubscriptions($this->client['id'], array($this, 'paySubscription'));
	}
	if(!isset($this->thresholds[$client['id']]) || ($this->thresholds[$client['id']]!=$this->sum)){
		$this->connection->update("UPDATE clients_states SET threshold='%s' WHERE client='%s'", $this->sum, $client['id']);
		$this->updates++;
	}
}

function payTv($connection_type, $tv_id){
	if($tv_id){
		$tv = $this->connectionTypesManager->getTv($connection_type['id'], $tv_id);
		if(!$tv){
			return;
		}
		if($this->calculator->cmp($tv['cost'], '0') > 0){
			$rt = $this->optionsManager->getTrimOptionValue('TV_RESOURCE_TYPE');
			if(!$rt){
				return;
			}
			$this->payThis($rt, 1, $tv['cost'], 1);
		}
	}
}

function paySubscription($sub){
	$type = $this->chargeTypesManager->getChargeType($sub['type']);
	$this->payThis($type['resource_type'], $type['unit_size'], $type['price'], $sub['amount']);
}

function payThis($rtid, $unit, $price, $amount){
	if($this->calculator->cmp($unit, 1) > 0){
		$price = $this->calculator->divLow($this->calculator->mul($amount, $price), $unit);
		$unit = 1;
		$amount = 1;
	}
	for($i=0; $i<$amount; $i++){
		$this->payThisState = array('rtid'=>$rtid, 'cost'=>$price);
		foreach($this->bonuses as $tid=>$x){
			$this->payThisBonus($tid);
		}
		if($this->calculator->cmp($this->payThisState['cost'], 0) > 0){
			$this->sum = $this->calculator->add($this->sum, $this->payThisState['cost']);
		}
	}
}

function payThisBonus($account_type){
	if($this->calculator->cmp($this->payThisState['cost'], 0) > 0){
		if($this->accountTypesManager->isApplicable($account_type, $this->payThisState['rtid'])){
			$state = $this->bonuses[$account_type];
			if($this->calculator->cmp($state, 0) > 0){
				$fit = $this->calculator->min($state, $this->payThisState['cost']);
				$this->payThisState['cost'] = $this->calculator->sub($this->payThisState['cost'], $fit);
				$this->bonuses[$account_type] = $this->calculator->sub($this->bonuses[$account_type], $fit);
			}
		}
	}
}




}
?>