<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class SubscriptionsManager {

var $logger;
var $calculator;
var $subscriptionsDAO;
var $subscriptions;
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('subscriptions');
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function setSubscriptionsDAO($obj){
	$this->subscriptionsDAO = $obj;
}

function load(){
	if(!$this->loaded){
		$this->subscriptions = array();
		$it = $this->subscriptionsDAO->iterator();
		$counter = 0;
		while($arr = $it->next()){
			$this->subscriptions[$arr['client']][$arr['id']] = $arr;
			$counter++;
		}
		$this->logger->debug("%s subscriptions loaded", $counter);
		$this->loaded = true;
	}
}

function walkClientSubscriptions($clid, $callback){
	if(isset($this->subscriptions[$clid])){
		foreach($this->subscriptions[$clid] as $subscription){
			call_user_func($callback, $subscription);
		}
	}
}

function show(){
	print_r($this->subscriptions);
}

}
?>