<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class TariffsManager {

var $logger;
var $tariffsDAO;
var $tariffs;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('tariffs');
}

function setTariffsDAO($obj){
	$this->tariffsDAO = $obj;
}

function load($time){
	$this->tariffs = array();
	$it = $this->tariffsDAO->iterator();
	while($arr = $it->next()){
		$price = $this->calculatePrice($arr['id'], $arr['function'], $time);
		if(!is_numeric($price)){
			$this->logger->error("Wrong tariff's '%s' [%s] function: '%s' is not an integer value", $arr['name'], $arr['id'], $price);
			$price = '0';
		}
		$price = floor($price * 100);
		$price = "$price";
		$this->tariffs[$arr['id']] = array(
			'name'=>$arr['name'],
			'price'=>$price,
			'unit_size'=>$arr['unit_size'],
		);
	}
	$this->logger->debug("%s tariffs loaded", count($this->tariffs));
}

function calculatePrice($name, $body, $time){
	$funcName = "getPrice".$name;
	$definition = sprintf("function %s(\$time){\n%s\n}", $funcName, $body);
	eval($definition);
	return call_user_func($funcName, $time);
}

function getTariff($id){
	return $this->tariffs[$id];
}

function show(){
	print_r($this->tariffs);
}

}
?>