<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class TaskManager {

var $capacity = 48;
var $logger;
var $taskProcessors;
var $connection;
var $locker;
var $query = array(
	"count_in_process"=>"SELECT count(id) count_in_process FROM delayed_tasks WHERE status=1",
	"select_undone"=>"SELECT t.id 
		FROM delayed_tasks t
		LEFT JOIN stamps s ON s.id=t.stamp
		WHERE (t.status=0 OR t.status=3) AND (t.try_count < t.max_attempts) AND ((s.created IS NULL) OR (s.created < SUBDATE(NOW(), INTERVAL t.delay SECOND)))
		ORDER BY t.fork DESC, t.id
		LIMIT %s",
	"set_status"=>"UPDATE delayed_tasks SET status='%s' WHERE id='%s'",
	"lock_task"=>"SELECT * FROM delayed_tasks WHERE id='%s' AND (status!=2)AND try_count<max_attempts",
	"update"=>"UPDATE delayed_tasks SET status='%s', try_count=try_count+1, exec_time=exec_time+'%s' WHERE id='%s'",
);

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('task.manager');
}

function setTaskProcessors($arr){
	$this->taskProcessors = $arr;
}

function setConnection($obj){
	$this->connection = $obj;
	//$this->connection->query("SET SESSION TRANSACTION ISOLATION LEVEL READ UNCOMMITTED");
}

function setLocker($obj){
	$this->locker = $obj;
}

function execTask($id, $forked = false){
	$this->connection->query("BEGIN");
	$sel = $this->connection->select($this->query['lock_task'], $id);
	if($arr = $sel->next()){
		if(!$forked){
			$this->connection->update($this->query['set_status'], 1, $arr['id']);
		}
		if($arr['fork'] && !$forked){
			$cmd = 'nice -n 10 '.$_SERVER['argv'][0].' '.$id.' > /dev/null &';
			//exec($cmd, $out, $exit);
			proc_close(proc_open($cmd, array(), $foo));
		}else{
			$exec_time = 0;
			$status = 3;
			if(isset($this->taskProcessors[$arr['proc_type']])){
				try{
					$processor = $this->taskProcessors[$arr['proc_type']];
					$start = microtime(true);
					$status = $processor->execute($arr['data']);
					$end = microtime(true);
					$exec_time = intval(($end - $start)*1000);
				}catch(Exception $ex){
					$status = 3;
				}
			}else{
				$this->logger->error('unknown proc type [%s] in task [%s]', $arr['proc_type'], $arr['id']);
			}
			$this->connection->update($this->query['update'], $status, $exec_time, $arr['id']);
		}
	}
	$this->connection->query("COMMIT");
}

function process(){
	$hour = date("G");
	if(($hour > 3) && ($hour < 4)){
		exit;
	}

	$tid = isset($_SERVER['argv'][1]) ? intval($_SERVER['argv'][1]) : -1;
	if($tid > 0){
		$this->execTask($tid, true);
	}else{
		$wait = $tid==0 ? 20 : 0;
		if($this->locker->capture('task_manager1', $wait)){
			//echo "1\n";
			$sel = $this->connection->select($this->query['count_in_process']);
			$arr = $sel->next();
			$count_in_process = $arr['count_in_process'];
			$limit = $this->capacity - $count_in_process;
			$found = false;
			//echo "2\n";
			$this->logger->debug("capacity: %s, in process: %s, selecting: %s", $this->capacity, $count_in_process, $limit);
			if($limit > 0){
				$sel = $this->connection->select($this->query['select_undone'], $limit);
				//echo "3\n";
				while($arr = $sel->Next()){
					$found = true;
					$this->execTask($arr['id']);
					//echo "4\n";
				}
			}
			if(!$found){
				sleep(5);
			}
			//echo "5\n";
			$this->locker->release('task_manager1');
			$this->connection->close();
			//echo "6\n";
			//$cmd = implode(" ", $_SERVER['argv']).' > /dev/null &';
			$cmd = $_SERVER['argv'][0].' > /dev/null &';
			proc_close(proc_open($cmd, array(), $foo));
			//exec($cmd, $out, $exit);
			//echo "7\n";
		}else{
			$this->logger->info('already running');
		}
	}
}

}

?>