<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

include_once dirname(__FILE__).'/TaskException.php';
include_once dirname(__FILE__).'/Task.php';

class TaskObjectProcessor implements TaskProcessor {

var $logger;
var $beanFactory;
var $resultString;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('task.toi.processor');
}

function setBeanFactory($obj){
	$this->beanFactory = $obj;
}

function execute($data){
	$data = preg_split("|\s+|", $data);
	if(empty($data)){
		throw new TaskException('bean name not specified');
	}
	$beanName = array_shift($data);
	if(!$this->beanFactory->hasBean($beanName)){
		throw new TaskException(sprintf('bean "%s" not found', $beanName));
	}
	$bean = $this->beanFactory->getBean($beanName);
	if(!is_a($bean, 'Task')){
		throw new TaskException(sprintf('bean "%s" is not a task', $beanName));
	}
	$exit_code = $bean->execute($data);
	return $exit_code;
}

}
?>