<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

include_once dirname(__FILE__).'/Task.php';

class TaskTreeARP implements Task {

var $connection;
var $optionsManager;
var $logger;
var $scriptExecutor;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('task.arp.tree');
}

function setConnection($obj){
	$this->connection = $obj;
}

function setOptionsManager($obj){
	$this->optionsManager = $obj;
}

function setScriptExecutor($obj){
	$this->scriptExecutor = $obj;
}

function execute($split){
	switch($split[0]){
		case 'add':
			if(count($split)==5){
				return $this->add($split[1], $split[2], $split[3], $split[4]);
			}else{
				$this->logger->error('wrong add format: %s', $data);
				return 3;
			}
			break;
		case 'remove':
			if(count($split)==4){
				return $this->remove($split[1], $split[2], $split[3]);
			}else{
				$this->logger->error('wrong remove format: %s', $data);
				return 3;
			}
			break;
	}
}

function add($mid, $vlan, $ip, $mac){
	$this->logger->info('adding %s -> %s to modems arp-tables', $ip, $mac);
	$new_modems = $this->loadArpModemsChain($mid);
	$vlan += 1000;
	$exit = 0;
	foreach($new_modems as $modem){
		$cmd = "snmpset -v 1 -c security ".$modem['ip']." ".
			".1.3.6.1.2.1.4.22.1.1.".$vlan.".".$ip." i ".$vlan." ".
			".1.3.6.1.2.1.4.22.1.2.".$vlan.".".$ip." x ".str_replace(':','',$mac)." ".
			".1.3.6.1.2.1.4.22.1.3.".$vlan.".".$ip." a ".$ip." ".
			".1.3.6.1.2.1.4.22.1.4.".$vlan.".".$ip." i 4";
		$exit += $this->scriptExecutor->ExecuteScript($cmd, $this->logger);
	}
	return $exit ? 3 : 2;
}

function remove($mid, $vlan, $ip){
	$this->logger->info('removing %s from modems arp-tables', $ip);
	$old_modems = $this->loadArpModemsChain($mid);
	$vlan += 1000;
	$exit = 0;
	foreach($old_modems as $modem){
		$cmd = "snmpset -v 1 -c security ".$modem['ip']." .1.3.6.1.2.1.4.22.1.4.".$vlan.".".$ip." i 2";
		$exit += $this->scriptExecutor->ExecuteScript($cmd, $this->logger);
	}
	return $exit ? 3 : 2;
}

function loadArpModemsChain($mid){
	static $model = 'ES4612';
	$chain = array();
	while($mid){
		$sel = $this->connection->select("SELECT id, ip, name, model, modem FROM modems WHERE id='".$mid."'");
		$modem = $sel->next();
		if($modem['model']==$model){
			$chain[$modem['id']] = $modem;
			break;
		}
		$mid = $modem['modem'];
		if(isset($chain[$mid])){
			break;//   
		}
	}
	return $chain;
}

}
?>