<?
class BaseIpAddress {

var $address;
var $mask;

function setSmartAddress($address){
	if(is_numeric($address)){
		$this->address = $address;
	}else{
		$this->address = ip2long($address);
	}
}

function getAddress(){
	return $this->address;
}

function setSmartMask($mask){
	if (is_numeric($mask)) { // style 10.10.10.0/24
		$this->setNumericMask($mask);
	}else{ // style 10.10.10.0/255.255.255.0
		$this->setIpMask($mask);
	}
}

function setNumericMask($int){
	//$this->mask = ~((1<< (32-$int))-1);
	$this->mask = bindec(str_repeat("1", $int).str_repeat("0", 32 - $int));
}

function setIpMask($ip){
	$this->mask = ip2long($ip);
}

function getMask(){
	return $this->mask;
}

function contains($ipAddress){
	return ($ipAddress->mask >= $this->mask) && (($ipAddress->address & $this->mask) == ($this->address & $this->mask));
}

function toString(){
	return long2ip($this->address).'/'.long2ip($this->mask);
}

function toShortString(){
	$bin = decbin($this->mask);
	$m = 0;
	while($bin[$m]=='1'){
		$m++;
	}
	return long2ip($this->address).'/'.$m;
}


}

class IpAddress extends BaseIpAddress {

function IpAddress($address, $mask=32){
	$this->setSmartAddress($address);
	$this->setSmartMask($mask);
}

}

class SlashedIpAddress extends BaseIpAddress {

	function SlashedIpAddress($ip){
		$arr = explode("/", $ip);
		if(count($arr)==2){
			$this->address = ip2long($arr[0]);
			$this->setSmartMask($arr[1]);
		}else{
			$this->address = ip2long($arr[0]);
			$this->setNumericMask(32);
		}
	}
	
}

?>