<?
class StringXmlParser {

var $encoding;
var $options = array();

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('xml.parser');
}

function setEncoding($str){
	$this->encoding = $str;
}

function setOptions($arr){
	$this->options = $arr;
}

function parse($delegate, $data){
	$xml_parser = xml_parser_create($this->encoding);
	foreach($this->options as $k=>$v){
		xml_parser_set_option($xml_parser, $k, $v);
	}
	xml_set_element_handler($xml_parser, array($delegate, "startElement"), array($delegate, "endElement"));
	xml_set_character_data_handler($xml_parser, array($delegate, "acceptBody"));
	$result = xml_parse($xml_parser, $data, 1);
	if (!$result) {
		$this->logger->error("XML error: %s at line %d",
			xml_error_string(xml_get_error_code($xml_parser)),
			xml_get_current_line_number($xml_parser));
	}
	xml_parser_free($xml_parser);
	return $result;
}

}
?>