<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.22 $
*/
include_once('includes/global.php');
include_once('functions/accounts.php');
include_once('functions/mail.php');
include_once('functions/homedir.php');
include_once('functions/host.php');
include_once('functions/exchange.php');
include_once('classes/period.php');
include_once('classes/SwitchTool.php');
include_once('classes/ComboTool.php');
include_once('classes/ActionTool.php');
include_once('classes/DBFExport.php');
include_once('classes/cells/HighlightCellRenderer.php');
loadStrings(BOOT.'movements/strings.txt');
loadStrings(BOOT.'personal_periods/strings.txt');
loadStrings(BOOT.'mailboxes/strings.txt');
loadStrings(BOOT.'homedirs/strings.txt');
loadStrings(BOOT.'bonuses/strings.txt');
loadStrings(BOOT.'hosts/strings.txt');
loadStrings(BOOT.'calls/strings.txt');
loadStrings(BOOT.'client_info/strings.txt');
loadStrings(BOOT.'charge_subscriptions/strings.txt');
loadStrings(BOOT.'tv_connections/strings.txt');
loadStrings(BOOT.'exp_points/strings.txt');

$doc->title .= ' :: '.getResource('clients.title');

if(!isset($oper->system_access['clients'])){
       if(!isset($oper->system_access['clientssupport']))
       {
           $doc->page->contents['denied'] = getResource('access.denied');
           echo $doc->Paint();
           exit;
       }
}

//$db->debug = 1;

if(isset($_GET['login']))
{
    $_GET['cls_mode'] = "default";
    $_GET['r'] = "1";
    $_GET['cls_login_filter'] = $_GET['login'];
    $_GET['login'] = $_GET['login'];

}

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'house':	lookup('house', $_GET['city'] ? array('h.city='.addslashes($_GET['city'])) : array());
	case 'modem':	lookup('modem2', $_GET['city'] ? array('m.city='.addslashes($_GET['city'])) : array());
	case 'domain':	lookup('domain');
	case 'tv_box':
		$client = loadRecord("SELECT id, house_id, entrance FROM clients WHERE id='".addslashes($_GET['client'])."'");
		new Lookup('b.id', 'CONCAT("'.getResource('exp.points.floor.short').' ", b.floor)',
			"tv_boxes b",
			array('b.house="'.$client['house_id'].'" AND b.entrance="'.$client['entrance'].'"'), 'b.floor');
	case 'tv_node':
		$client = loadRecord("SELECT id, house_id, entrance FROM clients WHERE id='".addslashes($_GET['client'])."'");
		new Lookup('n.id', 'CONCAT(n.name, " (", IFNULL(n.entrances, ""), ")")',
			"tv_nodes n
			LEFT JOIN exp_points p ON p.id=n.point",
			array('p.house="'.$client['house_id'].'"', 'LENGTH(n.entrances) > 0'));
}

if(isset($_GET['list'])){
	ob_end_clean();
	foreach(getClients() as $id=>$name){
		printf("%s~%s\n", $id, $name);
	}
}

if(isset($_GET['aid'])){
	$res = $db->Execute(sprintf("SELECT id FROM clients WHERE account='%s'", $_GET['aid']));
	if($arr = $db->Next($res)){
		$_GET['id'] = $arr['id'];
	}
	unset($_GET['aid']);
}

class AccessCellRenderer {
	function render($column, $record){
		$val = $record[$column->name];
		$css = $val=='+' ? 'green_lighted' : ( $val=='-' ? 'red_lighted' : '');
		if($val=='-'){
			$val = '&ndash;';
		}
		return sprintf("<td class='%s' align='center'>%s</td>", $css, $val);
	}
}
$access_cell = new AccessCellRenderer();

class NameCellRenderer {
	function render($column, $record){
		$val = $record[$column->name];
		if(!$record['blockable']){
			return sprintf("<td class='green_lighted'>%s</td>", $val);
		}else{
			return sprintf("<td>%s</td>", $val);
		}
	}
}
$name_cell = new NameCellRenderer();

class DepositCellRenderer {
	function render($column, $record){
		$val = frmt_3_2($record[$column->name]);
		if($record['access_deposit']!='+'){
			return sprintf("<td class='red_lighted' align='right'>%s</td>", $val);
		}else{
			return sprintf("<td align='right'>%s</td>", $val);
		}
	}
}
$deposit_cell = new DepositCellRenderer();


function getClientBonuses(){
	global $client;
	static $bonuses;
	if(!isset($bonuses)){
		$bonuses = loadByQuery(sprintf("SELECT b.account as id, at.name as value
			FROM bonus_accounts b
			LEFT JOIN account_types at ON at.id=b.account_type
			WHERE b.client='%s'", $client['id']));
	}
	return $bonuses;
}

function getAllSrcAccountsForClient(){
	return getAllAccountsForClient(getSignedSrcSystemAccounts());
}

function getAllDstAccountsForClient(){
	return getAllAccountsForClient(getSignedDstSystemAccounts());
}

function getAllAccountsForClient($system_accounts){
	global $client;
	$accounts = array();
	arr_append($accounts, $system_accounts);
	$accounts['00'] = "--";
	$accounts[$client['account']] = sprintf("%s %s %s (%s)",
		getResource('accounts.sign.deposit'),
		$client['last_name'],
		$client['first_name'],
		$client['login']
	);
	$bonuses = getClientBonuses();
	if(!empty($bonuses)){
		$accounts['000'] = "--";
		foreach($bonuses as $account=>$name){
			$accounts[$account] = sprintf("%s %s",
				getResource('accounts.sign.bonus'),
				$name
			);
		}
	}
	return $accounts;
}

//$db->debug = 1;

$db->Execute("CREATE TEMPORARY TABLE ct_info (connection_type int unsigned primary key, plan bigint unsigned not null) ENGINE=Memory
SELECT ctrt.connection_type, sum(ctrt.use_plan) as plan
FROM connection_type_resources ctrt
LEFT JOIN connection_types ct on ct.id=ctrt.connection_type
GROUP BY ctrt.connection_type");

$query_tool = new SwitchTool('cqf', loadByQuery("SELECT id, name FROM queries WHERE is_filter=1 ORDER BY name", 'id', 'name', array(''=>':')), '', false);

$db->Execute("CREATE TEMPORARY TABLE cl_filter (id int unsigned primary key) ENGINE=Memory");

if($query_tool->value){
	$query = loadRecord("SELECT body FROM queries WHERE id='".addslashes($query_tool->value)."'");
	$select = prepare_multiquery($query['body']);
	$db->Execute("INSERT INTO cl_filter ".$select);
}

class MyTable extends PTable
{
    function getCount()
    {
	return $this->num_rows + 0;
	return min(10, parent::getCount());
    }
	
    function getAggregate($column){}
}

//$db->debug = 1;

$clients;
if($_GET['r'] == 1 && isset($oper->system_access['clientssupport']))
{
    $clients = new MyTable($db,BOOT.'clients/table.php');
    $clients->readonly = !$oper->system_access['clientssupport'];
}
else if(isset($oper->system_access['clients']))
{
    $clients = new PTable($db,BOOT.'clients/table.php');
    $clients->readonly = !$oper->system_access['clients'];
}
else if(isset($oper->system_access['clientssupport']))
{
    $clients = new MyTable($db,BOOT.'clients/table.php');
    $clients->readonly = !$oper->system_access['clientssupport'];
    if($_GET['id'])
	{
		$clients->filters['client'] = "c.id=" . (int)$_GET['id'];
	}
	else
	if($_GET['cls_id'])
	{
		$clients->filters['client'] = "c.id=" . (int)$_GET['cls_id'];
	}

}

if($query_tool->value){
	$clients->filters['filter'] = 'f.id IS NOT NULL';
}
addCityPolicy($clients, 'c.city');

function abon_code($city_code, $street_code, $house, $letter, $apartment, $surv=0){
	return sprintf("%02s%03s%03s%s%03s%s", $city_code, $street_code, $house, 0 + $letter, $apartment, 0 + $surv);
}

$export_query = 'SELECT 
		1017 as FIRMA,
		78 as KOD_PLATEZ,
		c.contract,
		c.surveyor NANIM,
		if(ifnull(cas.state_end,0) < 0, -cas.state_end, 0)/100 as DOLG,
		0 as POCL_NACSI,
		(ct.abon_amount + IFNULL(ctt.cost,0))/100 as TARIF,
		0 as SCHETCHIK,
		CONCAT(c.last_name, " ", substr(c.first_name, 1, 1), ".", substr(c.patronymic, 1, 1), ".") as FIO,
		9 as CITY,
		0 + s.code as STRIT,
		h.house + 0 as HOUSE,
		0 as KORPUS,
		case 
			WHEN h.house LIKE "%" THEN 1
			WHEN h.house LIKE "%" THEN 2
			WHEN h.house LIKE "%" THEN 3
			WHEN h.house LIKE "%" THEN 4
			WHEN h.house LIKE "%" THEN 5
			WHEN h.house LIKE "%" THEN 6
			WHEN h.house LIKE "%" THEN 7
			WHEN h.house LIKE "%" THEN 8
			WHEN h.house LIKE "%" THEN 9
			ELSE " " END as BUKVA,
		c.apartment as KVARTI,
		0 as SUBSIDI,
		ct.name as ct_name,
		ct.abon_amount/100 as ct_abon_amount,
		IFNULL(ctt.cost,0)/100 as tt_abon_amount,
		tt.name as tt_name
	FROM clients_export ce
	LEFT JOIN clients c ON c.id=ce.id
	LEFT JOIN clients_states cs ON cs.client=c.id
	LEFT JOIN calendar_account_states cas ON cas.account=c.account AND cas.calendar_period="'.getCurrentCalendarPeriod().'"
	LEFT JOIN ct_info ci ON ci.connection_type = c.connection_type
	LEFT JOIN connection_types ct ON c.connection_type = ct.id
	LEFT JOIN tv_types tt ON tt.id=c.tv_type
	LEFT JOIN connection_type_tv ctt ON ctt.connection_type=ct.id AND ctt.tv_type=c.tv_type
	LEFT JOIN houses h ON h.id=c.house_id
	LEFT JOIN streets s ON h.street = s.id
	ORDER BY c.last_name, c.first_name, c.id';

$bank_and_post_cols = array(
	array('FIRMA', 'N', 4, 0),
	array('KOD_PLATEZ', 'N', 3, 0),
	array('LIC_SCHET', 'C', 13),
	array('DOLG', 'N', 14, 2),
	array('POCL_NACSI', 'N', 14, 2),
	array('TARIF', 'N', 14, 3),
	array('SCHETCHIK', 'N', 9, 0),
	array('FIO', 'C', 28),
	array('CITY', 'N', 2, 0),
	array('STRIT', 'N', 3, 0),
	array('HOUSE', 'N', 3, 0),
	array('KORPUS', 'N', 1, 0),
	array('BUKVA', 'C', 1),
	array('KVARTI', 'N', 3, 0),
	array('NANIM', 'N', 1, 0),
	array('SUBSIDI', 'N', 14, 2),
	array('PRIM', 'C', 28),
);

$export_bank = new DBFExport('.    ', $export_query,
	$bank_and_post_cols,
	'bank',
	function($rec){
		$rec['PRIM'] = sprintf(":%s,:%s,:%s", $rec['contract'], number_format($rec['ct_abon_amount'],0), number_format($rec['tt_abon_amount'],0));
		$rec['LIC_SCHET'] = abon_code($rec['CITY'], $rec['STRIT'], $rec['HOUSE'], $rec['BUKVA'], $rec['KVARTI'], $rec['NANIM']);
		$rec['POCL_NACSI'] = $rec['SCHETCHIK'] = $rec['SUBSIDI'] = '';
		return $rec;
	}
);

$export_post = new DBFExport('.    ', $export_query,
	$bank_and_post_cols,
	'post',
	function($rec){
		$rec['PRIM'] = sprintf(":%s,:%s,:%s", $rec['contract'], number_format($rec['ct_abon_amount'],0), number_format($rec['tt_abon_amount'],0));
		$rec['POCL_NACSI'] = $rec['DOLG'];
		$rec['LIC_SCHET'] = abon_code($rec['CITY'], $rec['STRIT'], $rec['HOUSE'], $rec['BUKVA'], $rec['KVARTI'], $rec['NANIM']);
		$rec['DOLG'] = $rec['SCHETCHIK'] = $rec['SUBSIDI'] = '';
		return $rec;
	}
);

$export_erc = new DBFExport('.    ', $export_query,
	array(
		array('LIS', 'C', 9),
		array('ABCOUNT', 'C', 13),
		array('OST', 'N', 8, 2),
		array('NACH', 'N', 8, 2),
		array('RK', 'N', 8, 2),
		array('SUBS', 'N', 8, 2),
		array('UPL', 'N', 8, 2),
		array('OSTW', 'N', 8, 2),
		array('TARIFF1', 'N', 5, 3),
		array('TARIFF2', 'N', 5, 3),
		array('TARIFF3', 'N', 5, 3),
	),
	'erc',
	function($rec){
		$rec['OSTW'] = $rec['DOLG'];
		$rec['ABCOUNT'] = abon_code($rec['CITY'], $rec['STRIT'], $rec['HOUSE'], $rec['BUKVA'], $rec['KVARTI'], $rec['NANIM']);
		$rec['LIS'] = $rec['OST'] = $rec['NACH'] = $rec['RK'] = $rec['SUBS'] = $rec['UPL'] = $rec['TARIFF1'] = $rec['TARIFF2'] = $rec['TARIFF3'] = '';
		return $rec;
	}
);


$actions = array();
if($oper->system_access['clients_export']){
	$actions['ex_bank'] = $export_bank;
	$actions['ex_post'] = $export_post;
	$actions['ex_erc'] = $export_erc;
}

$action_tool = new ActionTool('clact', ': ', $actions);

$doc->page->contents['clients'] = new PMyAccess($clients,array(
	'title'=>getResource('clients.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/clients.gif',
	'grid_boot'=>forceCity(BOOT.'clients/grid.php'),
	'form_boot'=>forceCity(BOOT.'clients/form.php'),
	'tool'=>new ComboTool(array(
		new ComboToolCell($action_tool, 'padding-right: 5em;'),
		new ComboToolCell($query_tool, '')
	), ''),
));

$action_tool->process();

if(!$doc->page->contents['clients']->brief){
	ob_start();
	?>
	<script language="JavaScript" src="scripts/Ajaxer.js"></script>
	<script language="JavaScript" src="scripts/TvTypeTracker.js"></script>
	<script language="JavaScript">
	var tvTypeTracker = new TvTypeTracker('cls');
	tvTypeTracker.track();
	tvTypeTracker.warn = true;
	
	var f = $("form[name=<?=$clients->nick?>]");
	$("[name=city]", f).change(function(){
		lookup_house.src = '?lookup=house&target=lookup_house&city=' + this.value;
		lookup_house.loaded = false;
		lookup_house.loadFirst();
		$("[name=surveyor]", f).closest("tr").toggle(this.value==2);
	}).change();

	</script>
	<?
	$doc->page->contents['tv_type_tracker'] = ob_get_clean();
}

//$db->debug = 1;

if($clients->isOn()){
	$client = $clients->active_record;
	$cmenu = new PNamedMenu($nil,BOOT.'clients/menu.php');
	$doc->page->contents['client_menu'] = $cmenu;
	if(!$cmenu->empty){
		switch($cmenu->selected){
			case 'tv':
				$tv_connections = new PTable($db,BOOT.'clients/tv_connections/table.php');
				$tv_connections->readonly = !$oper->system_access['tv_connections'];
				$doc->page->contents['tv_connections'] = new PMyAccess($tv_connections,array(
					'title'=>getResource('tv.connections.title'),
					'help'=>HELP_PATH.'//',
					'icon'=>HREF.'images/tv.png',
					'grid_boot'=>BOOT.'clients/tv_connections/grid.php',
					'form_boot'=>BOOT.'clients/tv_connections/form.php',
				));
				break;
			case 'ho':
//			    $db->debug = 1;
				$state_cell = new ModemStateCellRenderer();
				$action_form = new PHostActionForm($nil,BOOT.'hosts/action_form.php');
				$hosts = new PTable($db,BOOT.'clients/hosts/table.php');
				$hosts->readonly = !$oper->system_access['hosts'];
				$doc->page->contents['hosts'] = new PMyAccess($hosts,array(
					'title'=>getResource('hosts.title'),
					'icon'=>HREF.'images/hosts.gif',
					'grid_boot'=>BOOT.'clients/hosts/grid.php',
					'form_boot'=>BOOT.'clients/hosts/form.php',
				));
				if(!$hosts->readonly){
					$doc->page->contents['hosts']->form->fields['ip']->comment = '<select id="candidates_ip"></select>';
				}
				ob_start();
				?>
				<script type="text/javascript" src="scripts/Ajaxer.js"></script>
				<script type="text/javascript" src="scripts/modem-tracker.js"></script>
				<script type="text/javascript" src="scripts/ip-tracker.js"></script>
				<script type="text/javascript" src="scripts/strict-input-tracker.js"></script>
				<script type="text/javascript">
				<?if(!$doc->page->contents['hosts']->brief){?>
				var ipTracker = new IpTracker('chts');
				var tracker = new ModemTracker('chts');
				StrictInputTracker(document.forms['chts'].elements['mac'], /.*/, /[\-;\.]/g, ":");
				<?}?>
				StrictInputTracker(document.forms['g_chts'].elements['chts_mac_filter'], /.*/, /[\-;\.]/g, ":");
				</script>
				<?
				$doc->page->contents['hosts_script'] = ob_get_clean();
				include 'includes/under_hosts.php';
				break;
			case 'hd':
				$homedirs = new PTable($db,BOOT.'clients/homedirs/table.php');
				$homedirs->readonly = !$oper->system_access['homedirs'];
				$doc->page->contents['homedirs'] = new PMyAccess($homedirs,array(
					'title'=>getResource('homedirs.title'),
					'icon'=>HREF.'images/homedir.gif',
					'grid_boot'=>BOOT.'clients/homedirs/grid.php',
					'form_boot'=>BOOT.'clients/homedirs/form.php',
				));
				break;
			case 'ma':
				$mailboxes = new PTable($db,BOOT.'clients/mailboxes/table.php');
				$mailboxes->readonly = !$oper->system_access['mailboxes'];
				$doc->page->contents['mailboxes'] = new PMyAccess($mailboxes,array(
					'title'=>getResource('mailboxes.title'),
					'icon'=>HREF.'images/box.gif',
					'grid_boot'=>BOOT.'clients/mailboxes/grid.php',
					'form_boot'=>BOOT.'clients/mailboxes/form.php',
				));
				break;
			case 'su':
				$subscriptions = new PTable($db,BOOT.'clients/charge_subscriptions/table.php');
				$subscriptions->readonly = !$oper->system_access['subscriptions'];
				$doc->page->contents['subscriptions'] = new PMyAccess($subscriptions,array(
					'title'=>getResource('charge.subscriptions.title'),
					'icon'=>HREF.'images/picks.gif',
					'grid_boot'=>BOOT.'clients/charge_subscriptions/grid.php',
					'form_boot'=>BOOT.'clients/charge_subscriptions/form.php',
				));
				break;
			case 'mo':
				$movements = new PTable($db,BOOT.'clients/movements/table.php');
				$movements->readonly = !$oper->system_access['movements'];
				$accounts = array_keys(getClientBonuses());
				$accounts[] = $client['account'];
				$acc_str = implode(",", $accounts);
				$movements->filters['owner'] = sprintf("(m.src IN (%s) OR m.dst IN (%s))", $acc_str, $acc_str);
				$doc->page->contents['movements'] = new PMyAccess($movements,array(
					'title'=>getResource('movements.title'),
					'icon'=>HREF.'images/dollar.gif',
					'icon_attributes'=>'width=29 height=42',
					'grid_boot'=>BOOT.'clients/movements/grid.php',
					'form_boot'=>BOOT.'clients/movements/form.php',
				));
				break;
			case 'pp':
				$db->Execute("CREATE TEMPORARY TABLE state_names (state tinyint not null primary key, name varchar(255)) ENGINE=Memory");
				$db->Execute(sprintf("INSERT INTO state_names VALUES (0, '%s'), (1, '%s'), (2, '%s')",
					getResource('personal.periods.state.none'),
					getResource('personal.periods.state.open'),
					getResource('personal.periods.state.closed')
				));
				$personal_periods = new PTable($db,BOOT.'clients/personal_periods/table.php');
				$personal_periods->readonly = !$oper->system_access['personal_periods'];
				$doc->page->contents['personal_periods'] = new PMyAccess($personal_periods,array(
					'title'=>getResource('personal.periods.title'),
					'icon'=>HREF.'images/picks.gif',
					'grid_boot'=>BOOT.'clients/personal_periods/grid.php',
					'form_boot'=>BOOT.'clients/personal_periods/form.php',
				));
				if($personal_periods->isOn()){
					$personal_period = $personal_periods->active_record;
/*					$pmenu = new PNamedMenu($nil, BOOT.'personal_periods/menu.php');
					$doc->page->contents['pmenu'] = $pmenu;
					switch($pmenu->selected){
						case 'ru':
							//createAccountReference('src_names');
							//createAccountReference('dst_names');
							$resource_uses = new PTable($db,BOOT.'personal_periods/resource_uses/table.php');
							$resource_uses->readonly = !$oper->system_access['resource_uses'];
							$doc->page->contents['resource_uses'] = new PMyAccess($resource_uses,array(
								'title'=>getResource('resource.uses.title'),
								'icon'=>HREF.'images/homedir.gif',
								'grid_boot'=>BOOT.'personal_periods/resource_uses/grid.php',
								'form_boot'=>BOOT.'personal_periods/resource_uses/form.php',
							));
							if($resource_uses->isOn()){
								$resource_use = $resource_uses->active_record;
								include('includes/resource_uses_details.php');
							}
							break;
						case 'pl':
*/							$plans = new PTable($db,BOOT.'personal_period_plans/table.php');
							$plans->readonly = !$oper->system_access['personal_periods'];
							$doc->page->contents['plans'] = new PMyAccess($plans,array(
								'title'=>getResource('personal.period.plans.title'),
								'icon'=>HREF.'images/plans.gif',
								'grid_boot'=>BOOT.'personal_period_plans/grid.php',
								'form_boot'=>BOOT.'personal_period_plans/form.php',
							));
/*							break;
					}
	*/			}
				break;
			case 'sl':
				$limitations = new PTable($db,BOOT.'clients/self_limitations/table.php');
				$limitations->readonly = $clients->readonly;
				$doc->page->contents['self_limitations'] = new PMyAccess($limitations, array(
					'title'=>getResource('self.limitations.title'),
					'icon'=>HREF.'images/limitations.gif',
					'grid_boot'=>BOOT.'clients/self_limitations/grid.php',
					'form_boot'=>BOOT.'clients/self_limitations/form.php',
				));
				break;
			case 'bo':
				$bonuses = new PTable($db,BOOT.'clients/bonuses/table.php');
				$bonuses->readonly = !$oper->system_access['bonuses'];
				$doc->page->contents['bonuses'] = new PMyAccess($bonuses,array(
					'title'=>getResource('bonuses.title'),
					'icon'=>HREF.'images/dollar.gif',
					'grid_boot'=>BOOT.'clients/bonuses/grid.php',
					'form_boot'=>BOOT.'clients/bonuses/form.php',
				));
				break;
			case 'no':
				if(!isset($oper->system_access['notes']))
				{
			            $doc->page->contents['denied'] = getResource('access.denied');
			            echo $doc->Paint();
			            exit;

				}
				else
				{
					$notes = new PTable($db,BOOT.'clients/notes/table.php');
					$notes->readonly = !$oper->system_access['notes'];
					$doc->page->contents['notes'] = new PMyAccess($notes,array(
						'title'=>getResource('client.notes.title'),
						'icon'=>HREF.'images/notes.gif',
						'grid_boot'=>BOOT.'clients/notes/grid.php',
						'form_boot'=>BOOT.'clients/notes/form.php',
					));
				}
				break;
			case 'cl':
				if(!isset($oper->system_access['calls']))
				{
			            $doc->page->contents['denied'] = getResource('access.denied');
			            echo $doc->Paint();
			            exit;

				}
				else
				{
					$type_tool = new SwitchTool('ccct', array(
						''=>getResource('client.calls.type').':',
						'1'=>getResource('client.calls.type.1'),
						'2'=>getResource('client.calls.type.2'),
						'4'=>getResource('client.calls.type.4'),
						'5'=>getResource('client.calls.type.5'),
						'6'=>getResource('client.calls.type.6'),
						'3'=>getResource('client.calls.type.3'),
						'7'=>getResource('client.calls.type.7'),
						'8'=>getResource('client.calls.type.8'),
						'9'=>getResource('client.calls.type.9'),
						'10'=>getResource('client.calls.type.10'),
					), '', true);
					$calls = new PTable($db,BOOT.'clients/calls/table.php');
					if($force_type = $type_tool->value){
						$calls->filters['type'] = sprintf("cc.type = '%s'", addslashes($force_type));
					}
					$calls->readonly =  !$oper->system_access['calls'];
					include BOOT.'clients/calls/form.php';
					if($client['lang']){
						unset($obj['fields']['client_lang']);
					}
					$doc->page->contents['calls'] = new PMyAccess($calls,array(
						'title'=>getResource('client.calls.title'),
						'icon'=>HREF.'images/calls.gif',
						'grid_boot'=>BOOT.'clients/calls/grid.php',
						'form_boot'=>$obj,
						'tool'=>$type_tool,
					));
					
					if($force_type){
						$doc->page->contents['calls']->form->fields['type']->type = 'hidden';
						$doc->page->contents['calls']->form->fields['type']->default = $force_type;
						$doc->page->contents['calls']->form->fields['type']->value = $force_type;
					}
					ob_start();
					?>
					<script language="JavaScript" src="scripts/call-tracker.js"></script>
					<script language="JavaScript">
					CallTypeTracker(document.forms['ccls']);
					</script>
					<?
					$doc->page->contents['all'] = ob_get_clean();
				}
				break;
			case 'bl':
				if(!isset($oper->system_access['blocks']))
				{
			            $doc->page->contents['denied'] = getResource('access.denied');
			            echo $doc->Paint();
			            exit;

				}
				else
				{
					$blocks = new PTable($db,BOOT.'clients/blocks/table.php');
					$blocks->readonly = !$oper->system_access['blocks'];
					$doc->page->contents['blocks'] = new PMyAccess($blocks,array(
						'title'=>getResource('blocks.title'),
						'icon'=>HREF.'images/blocks.gif',
						'grid_boot'=>BOOT.'clients/blocks/grid.php',
						'form_boot'=>BOOT.'clients/blocks/form.php',
					));
				}
				break;
			case 'cr':
				$credits = new PTable($db,BOOT.'clients/credits/table.php');
				$credits->readonly = !$oper->system_access['movements'];
				$doc->page->contents['credits'] = new PMyAccess($credits, array(
					'title'=>getResource('credits.title'),
					'icon'=>HREF.'images/dollar.gif',
					'grid_boot'=>BOOT.'clients/credits/grid.php',
					'form_boot'=>BOOT.'clients/credits/form.php',
				));
				break;
			case 'tr':
				include_once('functions/troubles.php');
				$troubles = new PTable($db,BOOT.'clients/troubles/table.php');
				$troubles->readonly = !$oper->system_access['support'];
				$doc->page->contents['troubles'] = new PMyAccess($troubles, array(
					'title'=>getResource('troubles.title'),
					'icon'=>HREF.'images/question.gif',
					'grid_boot'=>BOOT.'clients/troubles/grid.php',
					'form_boot'=>BOOT.'clients/troubles/form.php',
				));
				if($troubles->isOn()){
					$answers = new PTable($db,BOOT.'clients/troubles/answers/table.php');
					$answers->readonly = !$oper->system_access['movements'];
					$doc->page->contents['answers'] = new PMyAccess($answers, array(
						'title'=>getResource('trouble.answers.title'),
						'icon'=>HREF.'images/troubles.gif',
						'grid_boot'=>BOOT.'clients/troubles/answers/grid.php',
						'form_boot'=>BOOT.'clients/troubles/answers/form.php',
					));
					include_once('includes/answer_files_script.php');
				}
				break;
			case 'jo':
				function subst_client_contacts($table){
					global $client;
					$arr = loadRecord(sprintf("SELECT 
						concat(c.last_name, ' ', c.first_name, ' ', c.patronymic) contact,
						c.phone, h.street, h.house, c.apartment, c.entrance, c.floor
						FROM clients c LEFT JOIN houses h ON h.id=c.house_id WHERE c.id='%s'", $client['id']));
					$table->new_record['client'] = $arr['contact'];
					$table->new_record['phone'] = $arr['phone'];
					$table->new_record['street'] = $arr['street'];
					$table->new_record['house'] = $arr['house'];
					$table->new_record['apartment'] = $arr['apartment'];
					$table->new_record['entrance'] = $arr['entrance'];
					$table->new_record['floor'] = $arr['floor'];
				}
				loadStrings(BOOT.'houses/strings.txt');
				loadStrings(BOOT.'jobs/strings.txt');
				$jobs = new PTable($db,BOOT.'clients/jobs/table.php');
				$jobs->readonly = !$oper->system_access['jobs'];
				$doc->page->contents['jobs'] = new PMyAccess($jobs, array(
					'title'=>getResource('jobs.title'),
					'icon'=>HREF.'images/jobs.gif',
					'grid_boot'=>BOOT.'clients/jobs/grid.php',
					'form_boot'=>BOOT.'clients/jobs/form.php',
				));
				break;
       		case 'hi':
				loadStrings(BOOT.'action_log/strings.txt');
				$action_log = new PTable($db, BOOT.'action_log/table.php');
				$action_log->filters['by_item'] = '(alo.name="clients" AND l.item_id="'.$clients->active_record['id'].'")';
				$doc->page->contents['history'] =  new PMyAccess($action_log, array(
					'title'=>getResource('action.log.title'),
					'icon'=>HREF.'images/log.gif',
					'grid_boot'=>BOOT.'action_log/grid_alt.php',
				));
				break;
    		}
	}
}
echo $doc->Paint();
?>