<?php
include_once('includes/global.php');
loadStrings(BOOT.'coil_uses/strings.txt');
loadStrings(BOOT.'coil_supplies/strings.txt');

$doc->title .= ' :: '.getResource('cu.title');

required_access('coil_uses');

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'expense':	lookup('client_expense');
	case 'worker':	lookup('worker');
	case 'item': 	$filter = array();
					if($oper->city_mode){
						$filter['by_city'] = "(oc.city IS NOT NULL)";
					}
					new Lookup('i.id', $oper->force_city ? 'i.code' : 'CONCAT(IFNULL(c.name,""), " - ", i.code)',
						"coil_items i
						LEFT JOIN cities c ON c.id=i.city
						LEFT JOIN operators_cities oc ON oc.city=i.city AND oc.operator='$oper->id'",
						$filter);
}

function fix_item($table){
	$table->new_record['item'] = $table->new_record['item_'];
	unset($table->new_record['item_']);
}

function recalc_coil_use_detail($table){
	recalc_coil_use($table->current_record['coil_use']);
}

function getCoilItems(){
	global $oper;
	if($oper->force_city)
	return loadByQuery("SELECT coil_items.id as id, coil_items.code as value FROM coil_items");
}

//$db->debug = 1;

$db->Execute("CREATE TEMPORARY TABLE coil_uses_info (coil_use INT UNSIGNED NOT NULL PRIMARY KEY, amount BIGINT NOT NULL) ENGINE=Memory");
insertSelectOverFile('coil_uses_info',"-- INSERT INTO coil_uses_info
SELECT coil_use, sum(cable) FROM coil_uses_details GROUP BY coil_use");

$coil_uses = new PTable($db,BOOT.'coil_uses/table.php');
$coil_uses->readonly = !$oper->system_access['coil_uses'];
addCityPolicy($coil_uses, 'ci.city');

$doc->page->contents['coil_uses'] = new PMyAccess($coil_uses,array(
	'title'=>getResource('cu.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/streets.gif',
	'grid_boot'=>forceCity(BOOT.'coil_uses/grid.php'),
	'form_boot'=>forceCity(BOOT.'coil_uses/form.php'),
));

if($coil_uses->isOn()){
	loadStrings(BOOT.'jobs/strings.txt');
	$details = new PTable($db,BOOT.'coil_uses/details/table.php');
	$details->readonly = $coil_uses->readonly;
	$doc->page->contents['details'] = new PMyAccess($details, array(
		'title'=>getResource('cu.details.title'),
		'icon'=>HREF.'images/streets.gif',
		'grid_boot'=>BOOT.'coil_uses/details/grid.php',
		'form_boot'=>BOOT.'coil_uses/details/form.php',
	));
}

echo $doc->Paint();
?>
