<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.12 $
*/
include_once('includes/global.php');
include_once('functions/arp.php');
include_once('functions/dhcp.php');
include_once('functions/commons.php');
include_once('functions/mail.php');
include_once('functions/named.php');
include_once('functions/network.php');
include_once('functions/vpn.php');
include_once('functions/accounts.php');
loadStrings(BOOT.'config/strings.txt');

$doc->title .= ' :: '.getResource('configuration.title');

if(!isset($oper->system_access['config'])){
	$doc->page->contents['denied'] = getResource('access.denied');
	exit;
}

//$db->debug = 1;

function SafeForTitle16($val){
	$control = substr($val,0,1);
	$val = substr($val, 2);
	if($control!=3){
		$arr = explode("\n", $val);
		if(count($arr) > 16){
			$arr = array_slice($arr,0,16);
			$arr[] = "...\n";
			$val = implode( "\n",$arr);
		}
		return SafeForTitle($val);
	}
}

function getConfigIdDescription($id, $record){
	if(count($record)>0){
		return getResource("configuration.$id.description");
	}else{
		return $id;
	}
}

function before_config_post($table){
	global $db;
	if($table->new_record['actual']){
		$value = $table->new_record['value'];
		switch($table->current_record['id']){
			case 'PAK_PERIODS':
				$PAK = explodePAK($value);
				if(!is_array($PAK)){
					$table->error(getResource('configuration.PAK_PERIODS.malformed').": ".$PAK);
				}
				break;
			case 'WM_OPERATOR':
				if(!$db->Next($db->Execute("SELECT id FROM operators WHERE login='$value'"))){
					$table->error(getResource('configuration.WM_OPERATOR.invalid'));
				}
		}
	}
}

function call($msg){

}

function after_config_post($table){
	reloadOptions();
	switch($table->current_record['id']){
		case 'VPN_CONFIG':
			$table->warning(RemakeVPN());
			break;
		case 'SHAPER_TEMPLATE':
		case 'SHAPER_RESTARTER':
		case 'SHAPER_CONFIG':
			$table->warning(RemakeShapers());
			break;
		case 'NETWORK_RESTARTER':
            $table->warning(RestartNETWORK());
            break;
   		case 'DHCP_TEMPLATE':
		case 'DHCP_RESTARTER':
		case 'DHCP_CONFIG':
			$table->warning(RemakeDHCPAll());
			break;
		case 'DNS_RESTARTER':
			$table->warning(RestartDNS());
			break;
		case 'DNS_DIR':
			$table->warning(RemakeDomain());
			$table->warning(RestartDNS());
			break;
		case 'DNS_BACK_DIR':
			$table->warning(RemakeNetwork());
			$table->warning(RestartDNS());
			break;
		case 'ARP_STATIC':
		case 'ARP_RESTARTER':
		case 'ARP_CONFIG':
			$table->warning(RemakeARP());
			break;
		case 'MAIL_LIST_DIR':
			break;
		case 'TEAPOP_CONFIG':
		case 'TEAPOP_TEMPLATE':
			$table->warning(rebuild_teapop_config());
			break;
	}
}

function getConfigControl(){
	global $config;
	$config_control = array(
		'title'=>getResource('configuration.value'),
	);
	switch($config->active_record['control']){
		case 0:
			$config_control['control'] = 'editor';
			$config_control['width'] = '60em';
			$config_control['height'] = '25';
			break;
		case 2:
			$config_control['control'] = 'short';
			break;
		case 3:
			$config_control['control'] = 'password';
			break;
		case 4:
			$config_control['control'] = 'select';
			$config_control['list'] = $config->active_record['list'];
			break;
	}
	return $config_control;
}

$hmenu = new PNamedMenu($nil,BOOT.'config/menu.php');
$doc->page->contents['hmenu'] = $hmenu;

switch($hmenu->selected){

case 'cfg':
	$db->Execute("CREATE TEMPORARY TABLE config_desc (id varchar(255) not null primary key, description varchar(255) not null) ENGINE=Memory");
	$res = $db->Execute("SELECT id FROM config");
	$ins = array();
	while($arr = $db->Next($res)){
		$ins[] = sprintf("('%s', '%s')", $arr['id'], addslashes(getResource("configuration.".$arr['id'].".description")));
	}
	$db->Execute("INSERT INTO config_desc (id, description) VALUES ".implode(", ", $ins));
	$config = new PTable($db,BOOT.'config/table.php');
	$config->readonly = !$oper->system_access['config'];
	$doc->page->contents['config'] = new PMyAccess($config,array(
		'title'=>getResource('configuration.title'),
		'help'=>HELP_PATH.'//',
		'icon'=>HREF.'images/config.gif',
		'grid_boot'=>BOOT.'config/grid.php',
		'form_boot'=>BOOT.'config/form.php',
	));
	if($config->isOn() && $config->active_record['allow_city_alt']){
		$config_city = new PTable($db,BOOT.'config/city/table.php');
		$config_city->readonly = $config->readonly;
		$doc->page->contents['config_city'] = new PMyAccess($config_city, array(
			'title'=>getResource('configuration.city.title'),
			'icon'=>HREF.'images/config.gif',
			'grid_boot'=>BOOT.'config/city/grid.php',
			'form_boot'=>BOOT.'config/city/form.php',
		));
	}
	break;
case 'dhcp':
	loadStrings(BOOT.'config/dhcp/strings.txt');
	$dhcp = new PTable($db,BOOT.'config/dhcp/table.php');
	$dhcp->readonly = !$oper->system_access['config'];
	$doc->page->contents['dhcp'] = new PMyAccess($dhcp, array(
		'title'=>getResource('dhcp.title'),
		'help'=>HELP_PATH.'//',
		'icon'=>HREF.'images/config.gif',
		'grid_boot'=>BOOT.'config/dhcp/grid.php',
		'form_boot'=>BOOT.'config/dhcp/form.php',
	));
	if(!$doc->page->contents['dhcp']->brief){
		ob_start();
		?>
		<script>
			var f = $("form[name=<?=$dhcp->nick?>]");
			var button = document.createElement("button");
			button.type = "button";
			button.innerHTML = "<?=getResource('dhcp.broadcast.auto')?>";
			$(button).appendTo($("[name=broadcast]", f).closest("td")).click(function(event){
				var b = ~ip2long(this.form.elements['mask'].value) | ip2long(this.form.elements['subnet'].value);
				this.form.elements['broadcast'].value = long2ip(b);
			});
		</script>
		<?
		$doc->page->contents['dhcp_js'] .= ob_get_clean();
	}
}

echo $doc->Paint();
?>
