<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:16 $
$Revision: 1.13 $
*/
include_once('includes/global.php');
include_once('includes/lookups.php');
include_once('classes/SwitchTool.php');
include_once 'Excel/reader.php';
include_once('classes/period.php');

loadStrings(BOOT.'ecalls/strings.txt');

$doc->title .= ' :: '.getResource('ecalls.title');

if(!($oper->system_access['ecalls'] > 0)){
	$doc->page->contents['denied'] = getResource('access.denied');
	echo $doc->Paint();
	exit;
}

$period = new PPeriod($nil, BOOT.'ecalls/period.php');

switch($_GET['lookup']){
	case 'client':	lookup('client_contract_account');
	case 'src':	lookup('system_src_account');
	case 'calendar_period':	lookup('calendar_period');
	case 'house':	lookup('house', $_GET['city'] ? array('h.city='.addslashes($_GET['city'])) : array());
}

//$db->debug = 1;

class ValidCellRenderer {
	function render($column, $record){
		switch($record[$column->name]){
			case '+': return "<td class='green_lighted' align='center'>+</td>";
			case '-': return "<td class='red_lighted' align='center'>&ndash;</td>";
			default: return "<td></td>";
		}
	}
}
$valid_cell = new ValidCellRenderer();

class LoadForm extends PForm {

function Process(){
	global $db, $oper, $action_logger;
	$fieldMap = array(
		'ecall_id'=>1,
		'street'=>6,
		'house'=>7,
		'apartment'=>8,
		'contact'=>array(2,3,4),
		'phone'=>9,
		'mobile'=>10,
		'tariff'=>12,
		'notes'=>13,
		'date'=>15,
	);
	$fieldMap = array(
		'ecall_id'=>1,
		'street'=>6,
		'house'=>7,
		'apartment'=>8,
		'contact'=>array(2,3,4),
		'phone'=>9,
		'mobile'=>10,
		'tariff'=>12,
		'concurent'=>13,
		'notes'=>14,
		'ecall_operator'=>15,
		'date'=>16,
	);
	
	$info = $_FILES['file'];
//	$db->Execute(sprintf("INSERT INTO stamps (created, created_by) VALUES (now(), %s)", $oper->id ? $oper->id : 'NULL'));
//	$stamp = $db->getJustInserted('stamps', 'id');
//	$db->Execute(sprintf("INSERT INTO ecall_uploads (filename, stamp) VALUES ('%s', %s)", addslashes($info['name']), $stamp));
//	$this->uid = $db->getJustInserted('ecall_uploads', 'id');
	$excel = new Spreadsheet_Excel_Reader();
	$excel->setUTFEncoder('iconv');
	$excel->setOutputEncoding('Windows-1251');
	$excel->read($info['tmp_name']);
	$sheet = $excel->sheets[0];
	if(trim($sheet['cells'][1][17])){
		$fieldMap = array(
			'ecall_id'=>1,
			'street'=>6,
			'house'=>7,
			'apartment'=>8,
			'contact'=>array(2,3,4),
			'phone'=>9,
			'mobile'=>10,
			'tariff'=>12,
			'tariff_tv'=>13,
			'concurent'=>14,
			'notes'=>15,
			'ecall_operator'=>16,
			'date'=>17,
		);
	}
	
	for($x=2; $x<=$sheet['numRows']; $x++) {
		$rec = array();
		$values = array();
		$row = $sheet['cells'][$x];
		$eid = $row[$fieldMap['ecall_id']];
		if(!preg_match('|\d+|', trim($eid))){
			continue;
		}
		//print_r($row);
		$db->Begin();
		$db->Execute(sprintf("INSERT INTO stamps (created, created_by) VALUES (now(), %s)", $oper->id ? $oper->id : 'NULL'));
		$stamp = $db->getJustInserted('stamps', 'id');
		foreach($fieldMap as $field=>$index){
			if($field=='contact'){
				$val = trim($row[$index[0]].' '.$row[$index[1]].' '.$row[$index[2]]);
			}else{
				$val = isset($sheet['cells'][$x][$index]) ? trim($sheet['cells'][$x][$index]) : '';
				if($field=='date'){
					$time = mktime(substr($val, 11, 2), substr($val, 14, 2), 0, substr($val, 3, 2), substr($val, 0, 2), substr($val, 6, 4));
					if($this->fields['src']->value==1){
						// $time -= 60 * 60 * (2 + 24);    
					}
					if($this->fields['src']->value==2){
						$time -= 60 * 60 * 24;
					}
					$val = date("Y-m-d H:i:s", $time);
					//$val = substr($val, 6, 4).'-'.substr($val, 3, 2).'-'.substr($val, 0, 2).' '.substr($val, 11);
				}
			}
			$values[] = "'".addslashes($val)."'";
			$rec[$field] = $val;
		}
		$fieldList = implode(", ", array_keys($fieldMap));
		$query = "INSERT INTO ecalls (".$fieldList.", filename, sale_date, src, stamp)
			VALUES (".implode(", ", $values).", '".addslashes($info['name'])."', '".addslashes($this->fields['sale_date']->value)."', '".addslashes($this->fields['src']->value)."', ".$stamp.")";
		//echo $query."<br>\n";
		$db->Execute($query);
		//continue;
		if($db->hasErrors()){
			$db->Rollback();
		}else{
			$eid = $db->getJustInserted('ecalls', 'id');
			$hid = guess_house($eid, $rec['street'], $rec['house']);
			guess_client($eid, $hid, $rec['apartment']);
			$db->Commit();
		}
	}
	$action_logger->log_inserted('ecall_uploads', '', array('filename'=>$info['name']));
	//return 'ok';
}

}

function correct_house($table){
	$new = $table->current_record;
	guess_house($new['id'], $new['street'], $new['house']);
}

function guess_house($eid, $street_name, $house){
	global $db;
	if($arr = loadRecord(sprintf("SELECT h.id FROM houses h LEFT JOIN streets s ON s.id=h.street 
		WHERE h.house='%s' AND s.name='%s'", $house, $street_name))){
		$hid = $arr['id'];
	}else{
		if($arr = loadRecord(sprintf("SELECT h.id FROM houses h LEFT JOIN streets s ON s.id=h.street 
			WHERE h.house='%s' AND '%s' LIKE CONCAT('%%', substring_index(s.name, ' ', 1), '%%')", $house, $street_name))){
			$hid = $arr['id'];
		}else{
			$hid = 'null';
		}
	}
	$db->Execute("UPDATE ecalls SET assumed_house=".$hid." WHERE id='".$eid."'");
	return $hid;
}

function guess_client($eid, $house_id, $apartment){
	global $db;
	$cid = '';
	if($arr = loadRecord(sprintf("SELECT max(id) id FROM clients WHERE house_id='%s' AND apartment='%s'", $house_id, $apartment))){
		$cid = $arr['id'];
	}
	$in_state = 0;
	if($cid){
		$state = loadRecord("SELECT sum(IF(ct.service_type&1, 1, 0)) inet, sum(IF(pp.tv_type IS NULL OR tt.offline=1, 0, 1)) tv 
			FROM personal_periods pp
			LEFT JOIN connection_types ct ON ct.id=pp.connection_type
			LEFT JOIN tv_types tt ON tt.id=pp.tv_type
			WHERE pp.client=".$cid);
		$in_state = ($state['inet'] ? 1 : 0) + ($state['tv'] ? 2 : 0);
	}
	$db->Execute("UPDATE ecalls SET in_client=".($cid ? $cid : 'null').", in_state=".$in_state." WHERE id='".$eid."'");
}

function Upload($field,&$spool){
	return $_FILES[$field->name]['name'];
}

function after_back_apply($table){
	global $db;
	$new = $table->current_record;
	$db->Execute(sprintf("UPDATE ecalls SET state='%s', recall_date='%s' WHERE id='%s'", $new['state'], $new['recall_date'], $new['ecall']));
}

$umenu = new PNamedMenu($nil,BOOT.'ecalls/up-menu.php');
$doc->page->contents['ecalls_up_menu'] = $umenu;
switch($umenu->selected){
	case 'rq':
		$db->Execute("CREATE TEMPORARY TABLE client_links ENGINE=Memory SELECT max(id) id, house_id, apartment FROM clients GROUP BY house_id, apartment");
		$db->Execute("ALTER TABLE client_links ADD PRIMARY KEY(id), add KEY(house_id, apartment)");
		
		//$db->debug = 1;
		
		$db->Execute("CREATE TEMPORARY TABLE back_count (ecall INT NOT NULL PRIMARY KEY, amount INT, last INT UNSIGNED) ENGINE=Memory SELECT ecall, count(*) as amount, max(id) last FROM ecalls_back GROUP BY ecall ");
		$db->Execute("CREATE TEMPORARY TABLE has_pay (account INT UNSIGNED NOT NULL PRIMARY KEY) ENGINE=Memory SELECT DISTINCT dst as account FROM movements");
		
		$ecalls = new PTable($db,BOOT.'ecalls/table.php');
		$ecalls->readonly = !$oper->system_access['ecalls'];
		if($period->active){
			if($from = $period->getFrom()){
				$ecalls->filters['from'] = sprintf("e.date >= '%s'", $from);
			}
			if($to = $period->getTo()){
				$ecalls->filters['to'] = sprintf("e.date <= '%s'", $to);
			}
		}
		
		$doc->page->contents['ecalls'] = new PMyAccess($ecalls,array(
			'title'=>getResource('ecalls.title'),
			'help'=>HELP_PATH.'//eCall',
			'icon'=>HREF.'images/calls.gif',
			'grid_boot'=>BOOT.'ecalls/grid.php',
			'form_boot'=>BOOT.'ecalls/form.php',
			'tool'=>$period,
		));
		
		ob_start();
		?>
		<?if(!$doc->page->contents['ecalls']->brief){?>
		<script language="JavaScript">
		var a = document.createElement("a");
		$(a).html("+").attr("href", "").appendTo("#toggleInfo").click(function(event){
			this.val = !this.val;
			$(this).html(this.val ? "+" : "&ndash;").closest("tr").next().nextUntil("tr input").toggle(!this.val);
			return false;
		}).click();
		</script>
		<?}
		
		$doc->page->contents['js_ecall'] .= ob_get_clean();
		
		$emenu = new PNamedMenu($nil,BOOT.'ecalls/menu.php');
		$doc->page->contents['ecalls_menu'] = $emenu;
		switch($emenu->selected){
			case 'load':
				$doc->page->contents['actions_icon'] = '<br><div class="access_head"><img src="'.HREF.'images/move_uses.gif" vspace="2" hspace="2" style="vertical-align: middle;">'.getResource('ecall.uploads.load').'</div>';
				$doc->page->contents['load'] = new LoadForm($nil, BOOT.'ecalls/upload/load_form.php');
				break;
			case 'back':
				$back = new PTable($db,BOOT.'ecalls/back/table.php');
				$back->readonly = !$oper->system_access['ecalls'];
				$doc->page->contents['back'] = new PMyAccess($back,array(
					'title'=>getResource('ecalls.back.title'),
					'icon'=>HREF.'images/calls.gif',
					'grid_boot'=>BOOT.'ecalls/back/grid.php',
					'form_boot'=>BOOT.'ecalls/back/form.php',
				));
				ob_start();
				if(!$doc->page->contents['back']->brief){?>
				<script>
				var f = $("form[name=<?=$back->nick?>]");
				$("[name=state]", f).change(function(){
					$("[name='recall_date[year]']", f).closest("tr").toggle(this.value==2);
					$("[name='refuse_reason']", f).closest("tr").toggle(this.value==4);
				}).change();
				</script>
				<?}
				$doc->page->contents['back_js'] .= ob_get_clean();
				break;
			case 'make':
				$doc->page->contents['actions_icon'] = '<br><div class="access_head"><img src="'.HREF.'images/rules.gif" vspace="2" hspace="2" style="vertical-align: middle;">'.getResource('ecalls.menu.make').'</div>';
				$doc->page->contents['load'] = new LoadForm($nil, BOOT.'ecalls/report/form.php');
				break;
		}
	break;
	case 'rp':
		include_once(BOOT.'ecalls/reports/table.php');
		include_once(BOOT.'ecalls/reports/grid.php');
		$groups = loadByQuery("SELECT id, name as value FROM ecall_report_groups ORDER BY id");
		$fields = loadRecords("SELECT id, gid, name FROM ecall_report_fields ORDER BY gid, id");
		$group_by_tool = new SwitchTool('ergt', array(
			'1'=>getResource('ecalls.reports.grouper.1'),
			'2'=>getResource('ecalls.reports.grouper.2'),
			'3'=>getResource('ecalls.reports.grouper.3'),
		), '1', true);
		$group_by_values = array(
			'1'=>'er.date',
			'2'=>'DATE_FORMAT(FROM_UNIXTIME(FLOOR(UNIX_TIMESTAMP(er.date)/604800) * 604800 - 259200), "%Y-%m-%d+")',
			'3'=>'DATE_FORMAT(er.date, "%Y-%m")',
		);
		$grid['modes'] = $groups;
		$prepare_src = 'ecall_reports er';
		$prepare_fields = array();
		$form = array();
		foreach($fields as $field){
			$fid = $field['id'];
			$group = $groups[$field['gid']];
			$prepare_src .= "\nLEFT JOIN ecall_report_values ev_$fid ON ev_$fid.report=er.id AND ev_$fid.field=$fid";
			$prepare_fields[] = "SUM(IFNULL(ev_$fid.value, 0)) as f_$fid";
			$table['fields']["f_$fid"] = array(
				'selector'=>"es.f_$fid",
				'aggregate'=>'sum',
			);
			$grid['columns']["f_$fid"] = array(
				'title'=>$field['name'],
				'modes'=>$field['gid'],
				'align'=>'right',
			);
			$form['fields']["f_$fid"] = array(
				'title'=>$group.' - '.$field['name'],
			);
		}
		$grouper = $group_by_values[$group_by_tool->value];
		$db->Execute("CREATE TEMPORARY TABLE ecall_stat ENGINE=Memory
			SELECT er.src, $grouper as date, max(er.id) as id, ".implode(", ", $prepare_fields)." FROM ".$prepare_src." GROUP BY er.src, $grouper");
		$grid['columns']['date']['title'] = getResource('ecalls.reports.grouper.'.$group_by_tool->value);
			
		$reports = new PTable($db, $table);
		$doc->page->contents['reports'] = new PMyAccess($reports, array(
			'title'=>getResource('ecalls.reports.title'),
			'icon'=>HREF.'images/calls.gif',
			'grid_boot'=>$grid,
			//'form_boot'=>$form,
			'tool'=>$group_by_tool,
		));
	break;
}

echo $doc->Paint();
?>
