<?
function getAccountState($cp, $acc){
	global $db;
	$res = $db->Execute(sprintf("SELECT state_begin, state_end FROM calendar_account_states WHERE calendar_period='%s' AND account='%s'", $cp, $acc));
	if($arr = $db->Next($res)){
		return $arr;
	}else{
		return array(
			'state_begin'=>'0',
			'state_end'=>'0',
		);
	}
}

function setAccountState($cp, $acc, $state){
	global $db;
	$db->Execute(sprintf("UPDATE calendar_account_states SET state_begin='%s', state_end='%s' WHERE calendar_period='%s' AND account='%s'", $state['state_begin'], $state['state_end'], $cp, $acc));
	if(!$db->affected_rows){
		$db->Execute(sprintf("INSERT INTO calendar_account_states (calendar_period, account, state_begin, state_end) VALUES ('%s', '%s', '%s', '%s')", $cp, $acc, $state['state_begin'], $state['state_end']));
	}
}

function moveState($cp, $src, $dst, $amount){
	if($amount==0){
		return;
	}
	$src_state = getAccountState($cp, $src);
	$s = $src_state['state_end'];
	$src_state['state_end'] = gmp_strval(gmp_sub("$s", "$amount"));
	
	$dst_state = getAccountState($cp, $dst);
	$d = $dst_state['state_end'];
	$dst_state['state_end'] = gmp_strval(gmp_add("$d", "$amount"));

	if($src < $dst){ // to avoid deadlocks
		setAccountState($cp, $src, $src_state);
		setAccountState($cp, $dst, $dst_state);
	}else{
		setAccountState($cp, $dst, $dst_state);
		setAccountState($cp, $src, $src_state);
	}

	while($next = loadRecord(sprintf("SELECT n.id FROM calendar_periods cp INNER JOIN calendar_periods n ON n.id=cp.next WHERE cp.id='%s'", $cp))){
		$cp = $next['id'];
		$src_state = getAccountState($cp, $src);
		$s = $src_state['state_begin'];
		$src_state['state_begin'] = gmp_strval(gmp_sub("$s", "$amount"));
		$s = $src_state['state_end'];
		$src_state['state_end'] = gmp_strval(gmp_sub("$s", "$amount"));
		
		$dst_state = getAccountState($cp, $dst);
		$d = $dst_state['state_begin'];
		$dst_state['state_begin'] = gmp_strval(gmp_add("$d", "$amount"));
		$d = $dst_state['state_end'];
		$dst_state['state_end'] = gmp_strval(gmp_add("$d", "$amount"));
		
		if($src < $dst){ // to avoid deadlocks
			setAccountState($cp, $src, $src_state);
			setAccountState($cp, $dst, $dst_state);
		}else{
			setAccountState($cp, $dst, $dst_state);
			setAccountState($cp, $src, $src_state);
		}
	}

}

function check_movement($table){
	global $db;
	$new = $table->new_record;
	$cp = loadRecord(sprintf("SELECT id, UNIX_TIMESTAMP(period_begin) period_begin, UNIX_TIMESTAMP(period_end) period_end FROM calendar_periods WHERE id='%s'", $new['calendar_period']));
	$date = _parse_datetime($new['date']);
	if(!($date >= $cp['period_begin'] && $date<=$cp['period_end'])){
		$table->error(getResource('movements.error.date'));
	}
	$src = $db->Next($db->Execute(sprintf("SELECT id, name, type FROM accounts WHERE id='%s'", $new['src'])));
	$dst = $db->Next($db->Execute(sprintf("SELECT id, name, type FROM accounts WHERE id='%s'", $new['dst'])));
	$err = false;
	switch($src['type']){
		case 'S':
			$err = $dst['type']=='S';
			break;
		case 'D':
		case 'B':
			$err = $dst['type']!='S';
			break;
	}
	if($err){
		$table->error(sprintf(getResource('movements.error.accounts'), $src['name'], $dst['name']));
	}
}

function after_move_insert($table){
	$new = $table->new_record;
	$time = _parse_datetime($new['date']);
	if($time <= mktime()){
		moveState($new['calendar_period'], $new['src'], $new['dst'], $new['amount']);
	}
}

function after_move_post($table){
	if($table->isChanged('date,calendar_period,amount,src,dst')){
		after_move_delete($table);
		after_move_insert($table);
	}
}

function after_move_delete($table){
	$old = $table->old_record;
	$time = _parse_datetime($old['date']);
	if($time <= mktime()){
		moveState($old['calendar_period'], $old['dst'], $old['src'], $old['amount']);
	}
}

function move($src, $dst, $amount, $stamp = '', $date='', $note = ''){
	global $db, $oper;
	if(!$stamp){
		$db->Execute(sprintf("INSERT INTO stamps (created, created_by) VALUES (now(), %s)", $oper->id ? $oper->id : 'NULL'));
		$stamp = $db->getJustInserted('stamps', 'id');
	}
	if(!$date){
		$date = date("Y-m-d H:i:s");
	}
	$cp = getCurrentCalendarPeriod();
	$db->Execute(sprintf("INSERT INTO movements (calendar_period, src, dst, amount, date, note, stamp) 
		VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s')",
		$cp, $src, $dst, $amount, $date, $note, $stamp));
	$mov_id = $db->getJustInserted('movements', 'id');
	moveState($cp, $src, $dst, $amount);
	return $mov_id;
}

function before_bonus_account_insert($table){
	global $db;
	$new = $table->new_record;
	$client = loadRecord(sprintf("SELECT last_name, first_name, login FROM clients WHERE id='%s'", $new['client']));
	$type = loadRecord("SELECT name FROM account_types WHERE id='".$new['account_type']."'");
	$table->Execute(sprintf("INSERT INTO accounts (type, name) VALUES ('%s', '%s')", 'B', 
		addslashes($client['last_name'].' '.$client['first_name'].' ('.$client['login'].') - '.$type['name'])
	));
	$acc = $table->owner->getJustInserted('accounts', 'id');
	$table->new_record['account'] = $acc;
}

function before_bonus_account_post($table){
	global $db;
	if($table->isChanged('client,account_type')){
		$new = $table->new_record;
		$type = loadRecord("SELECT name FROM account_types WHERE id='".$new['account_type']."'");
		$client = loadRecord(sprintf("SELECT last_name, first_name, login FROM clients WHERE id='%s'", $new['client']));
		$table->Execute(sprintf("UPDATE accounts SET name='%s' WHERE id='%s'",
			addslashes($client['last_name'].' '.$client['first_name'].' ('.$client['login'].') - '.$type['name']),
			$table->current_record['account']
		));
	}
}

function acc_link($record){
	return account_link($record, 'account_type', 'account');
}

function src_link($record){
	return account_link($record, 'src_type', 'src');
}

function dst_link($record){
	return account_link($record, 'dst_type', 'dst');
}

function account_link($record, $type_by, $link_by){
	switch($record[$type_by]){
		case 'S':
			return sprintf("system_accounts.php?id=%s", $record[$link_by]);
		case 'D':
			return sprintf("clients.php?aid=%s", $record[$link_by]);
		case 'B':
			return sprintf("bonuses.php?id=%s", $record[$link_by]);
	}
}

function formatList($list, $format){
	$result = array();
	foreach($list as $k=>$v){
		$result[$k] = sprintf($format, $v);
	}
	return $result;
}

function getClientAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = loadByQuery("SELECT account as id, CONCAT(last_name,' ',first_name, ' (', login ,')') as value 
		FROM clients 
		ORDER BY last_name, first_name");
	}
	return $accounts;
}

function getClientAccountsWithContracts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = loadByQuery("SELECT account as id, CONCAT(last_name,' ',first_name, ' (', IFNULL(contract,'') ,')') as value 
		FROM clients 
		ORDER BY last_name, first_name");
	}
	return $accounts;
}


function getBonusAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = loadByQuery("SELECT b.account as id, CONCAT(c.last_name,' ',c.first_name, ' (', c.login ,')', ' - ', ac.name) as value
		FROM bonus_accounts b 
		LEFT JOIN account_types ac ON ac.id=b.account_type
		LEFT JOIN clients c ON c.id=b.client 
		ORDER BY c.last_name, c.first_name, b.name");
	}
	return $accounts;
}

function getSystemAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = loadByQuery("SELECT account as id, name as value FROM system_accounts WHERE type>0 ORDER BY name");
	}
	return $accounts;
}

function getSystemSrcAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = loadByQuery("SELECT account as id, name as value FROM system_accounts WHERE type&1 ORDER BY name");
	}
	return $accounts;
}

function getSystemDstAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = loadByQuery("SELECT account as id, name as value FROM system_accounts WHERE type&2 ORDER BY name");
	}
	return $accounts;
}

function getSignedClientAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = formatList(getClientAccounts(), getResource('accounts.sign.deposit').'%s');
	}
	return $accounts;
}

function getSignedBonusAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = formatList(getBonusAccounts(), getResource('accounts.sign.bonus').'%s');
	}
	return $accounts;
}

function getSignedSystemAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = formatList(getSystemAccounts(), getResource('accounts.sign.system').'%s');
	}
	return $accounts;
}

function getSignedSrcSystemAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = formatList(getSystemSrcAccounts(), getResource('accounts.sign.system').'%s');
	}
	return $accounts;
}

function getSignedDstSystemAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = formatList(getSystemDstAccounts(), getResource('accounts.sign.system').'%s');
	}
	return $accounts;
}

function getAllSrcAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = array();
		arr_append($accounts, getSignedSrcSystemAccounts());
		$accounts['00'] = "--";
		arr_append($accounts, getSignedClientAccounts());
		$accounts['000'] = "--";
		arr_append($accounts, getSignedBonusAccounts());
	}
	return $accounts;
}

function getAllDstAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = array();
		arr_append($accounts, getSignedDstSystemAccounts());
		$accounts['00'] = "--";
		arr_append($accounts, getSignedClientAccounts());
		$accounts['000'] = "--";
		arr_append($accounts, getSignedBonusAccounts());
	}
	return $accounts;
}

function getAllAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = array();
		arr_append($accounts, getSignedSystemAccounts());
		$accounts['00'] = "--";
		arr_append($accounts, getSignedClientAccounts());
		$accounts['000'] = "--";
		arr_append($accounts, getSignedBonusAccounts());
	}
	return $accounts;
}

function getClientAndBonusAccounts(){
	static $accounts;
	if(!isset($accounts)){
		$accounts = array();
		arr_append($accounts, getSignedClientAccounts());
		$accounts['00'] = "--";
		arr_append($accounts, getSignedBonusAccounts());
	}
	return $accounts;
}

?>