<?
function getClientGecos($id){
	global $db;
	$query = sprintf("SELECT c.first_name, c.last_name, s.name as street, h.house, c.apartment, c.phone 
	FROM clients c
	LEFT JOIN houses h ON h.id=c.house_id
	LEFT JOIN streets s ON h.street = s.id
	WHERE c.id='%s'", $id);
	$arr = $db->Next($db->Execute($query));
	return _Translit($arr['first_name'].' '.$arr['last_name'].','.$arr['street'].' '.$arr['house'].($arr['apartment']?','.$arr['apartment']:'').($arr['phone']?','.$arr['phone']:''));
}

function change_client_gecos($table){
	if($table->isChanged('first_name,last_name,house,apartment,phone')){
		$format = getOption('HOMEDIR_CMD_FORMAT');
		$client = $table->current_record['id'];
		$gecos = getClientGecos($client);
		$res = $table->Execute(sprintf("SELECT id, login FROM homedirs WHERE client='%s' AND active AND description=''", $client));
		$script = '';
		while($arr = $table->Next($res)){
			$script .= "\n". sprintf($format, sprintf("usermod -c '%s' %s", $gecos, $arr['login']));
		}
		if($script){
			PrintStrings("Changes", $script);
			$table->warning(ExecuteScript($script,1));
		}
	}
}

function after_homedir_type_post($table){
	$format = getOption('HOMEDIR_CMD_FORMAT');
	$tarr = $table->current_record;
	$q = $tarr['quota'];
	$n = $q * 10;
	$home = termBySlash($tarr['home']);
	$quota_changed = $table->isChanged('quota');
	$home_changed = $table->isChanged('home');
	$info_changed = $home_changed || $table->isChanged('gid,shell');
	$res = $table->Execute(sprintf("SELECT id, uid, login FROM homedirs WHERE type='%s' AND active", $table->current_record['id']));
	while($arr = $table->Next($res)){
		if($info_changed){
			$script .= "\n". sprintf("usermod -u %s -g %s -s '%s'", $arr['uid'], $tarr['gid'], $tarr['shell']);
			if($home_changed){
				$script .= sprintf(" -l %s -d '%s' -m", $arr['login'], $home.$arr['login']);
			}
			$script .= " ".$arr['login'];
			$script = sprintf($format, $script);
		}
		if($quota_changed){
			$script .= "\n". sprintf($format, sprintf("setquota %s %d %d %d %d -a", $arr['login'], $q, $q, $n, $n));
		}
	}
	if($script){
		PrintStrings("Changes", $script);
//		return "ok";
		$table->warning(ExecuteScript($script,1));
	}
}

function loadPasswd(){
	static $passwd;
	if(!isset($passwd)){
		$format = getOption('HOMEDIR_CMD_FORMAT');
		$cmd = sprintf($format, 'cat /etc/passwd');
		$passwd = array(
			'by_login'=>array(),
			'by_uid'=>array(),
		);
		if($fd = popen($cmd, "r")){
			while (!feof($fd)) {
				$line = fgets($fd, 4096);
				if(trim($line)){
					$item = explode(":",$line);
					$passwd['by_login'][$item[0]] = $item;
					$passwd['by_uid'][$item[2]] = $item;
				}
			}
			pclose($fd);
		}
	}
	return $passwd;
}

function getFreeUids($amount){
	global $db;
	$passwd = loadPasswd();
	$known = array_keys($passwd['by_uid']);
	$bases = array();
	$res = $db->Execute("SELECT base_uid FROM homedir_types ORDER BY base_uid");
	while($arr = $db->Next($res)){
		$bases[] = $arr['base_uid'];
	}
	if(empty($bases)){
		$bases[] = 1000;
	}
	$found = findUIDs($known, array_unique($bases), $amount);
	$result = array();
	foreach($found as $uids){
		$result[] = createLinkEditCandidates('uid', $uids);// implode(",", $uids);
	}
	return implode("; ", $result);
}

function findUIDs($known, $bases, $amount){
	$found = array();
	foreach($bases as $base){
		for($i=0; $i<$amount; $i++){
			$found[$base][$i] = $base + $i;
		}
	}
	sort($known, SORT_NUMERIC);
	foreach($known as $uid){
		foreach($bases as $base){
			for($i=0; $i<$amount; $i++){
				$x = $found[$base][$i];
				if($x==$uid){
					for($j=$i; $j<$amount;$j++){
						$found[$base][$j]+=1;
					}
				}
			}
		}
	}
	return $found;
}

function before_homedir_insert($table){
	global $db;
	$arr = $table->new_record;
	$table->new_record['password'] = crypt($arr['password']);
	if($arr['active']){
		$passwd = loadPasswd();
		if(isset($passwd['by_login'][$arr['login']])){
			return $table->error(sprintf(getResource('homedirs.post.error.login.registered'), $arr['login']));
		}
		$uid = $table->new_record['uid'];
		if($arr['uid'] && isset($passwd['by_uid'][$arr['uid']])){
			return $table->error(sprintf(getResource('homedirs.post.error.uid.registered'), $arr['uid']));
		}
		$tarr = $table->Next($table->Execute(sprintf("SELECT * FROM homedir_types WHERE id='%s'", $arr['type'])));
		if(!$arr['uid']){
			$found = findUIDs(array_keys($passwd['by_uid']), array($tarr['base_uid']), 1);
			$table->new_record['uid'] = $found[$tarr['base_uid']][0];
		}
	}
}

function after_homedir_insert($table){
	$arr = $table->current_record;
	if($arr['active']){
		$format = getOption('HOMEDIR_CMD_FORMAT');
		$tarr = $table->Next($table->Execute(sprintf("SELECT * FROM homedir_types WHERE id='%s'", $arr['type'])));
		$desc = $arr['description'] ? $arr['description'] : getClientGecos($arr['client']);
		$home = termBySlash($tarr['home']).$arr['login'];
		$script = sprintf($format,  sprintf("useradd -u %s -g %s -d %s -s '%s' -c '%s' -p '%s' %s", $arr['uid'], $tarr['gid'], $home, $tarr['shell'], $desc, str_replace('$', '\$', $arr['password']), $arr['login']));
		$script .= "\n".sprintf($format, sprintf("chmod o+X %s", $home));
		if($tarr['quota']){
			$q = $tarr['quota'];
			$script .= "\n". sprintf($format, sprintf("setquota %s %d %d %d %d -a", $arr['login'], $q, $q, $q*10, $q*10));
		}
		PrintStrings("Changes", $script);
	//	return "ok";
		$table->warning(ExecuteScript($script,1));
	}
}

function before_homedir_post($table){
	$arr = $table->new_record;
	if($table->isChanged('password')){
		$table->new_record['password'] = crypt($arr['password']);
	}
	if($arr['active']){
		$activated = !$table->old_record['active'];
		$passwd = loadPasswd();
		if($activated || $table->isChanged('login')){
			if(isset($passwd['by_login'][$arr['login']])){
				return $table->error(sprintf(getResource('homedirs.post.error.login.registered'), $arr['login']));
			}
		}
		if($activated || $table->isChanged('uid')){
			$uid = $table->new_record['uid'];
			if($arr['uid'] && isset($passwd['by_uid'][$arr['uid']])){
				return $table->error(sprintf(getResource('homedirs.post.error.uid.registered'), $arr['uid']));
			}
		}
		$tarr = $table->Next($table->Execute(sprintf("SELECT * FROM homedir_types WHERE id='%s'", $arr['type'])));
		if(!$arr['uid']){
			$found = findUIDs(array_keys($passwd['by_uid']), array($tarr['base_uid']), 1);
			$table->new_record['uid'] = $found[$tarr['base_uid']][0];
		}
	}
}

function termBySlash($str){
	return substr($str,-1)=='/' ? $str : $str.'/';
}

function after_homedir_post($table){
	if($table->isChanged('client,login,uid,password,type,description,active')){
		$format = getOption('HOMEDIR_CMD_FORMAT');
		$arr = $table->current_record;
		$tarr = $table->Next($table->Execute(sprintf("SELECT * FROM homedir_types WHERE id='%s'", $arr['type'])));
		if($arr['active']){
			$home = termBySlash($tarr['home']).$arr['login'];
			$desc = $arr['description'] ? $arr['description'] : getClientGecos($arr['client']);
			if(!$table->old_record['active']){
				$script = sprintf($format, sprintf("useradd -u %s -g %s -d %s -s '%s' -c '%s' -p '%s' %s", $arr['uid'], $tarr['gid'], $home, $tarr['shell'], $desc, str_replace('$', '\$', $arr['password']), $arr['login']));
				$script .= "\n".sprintf($format, sprintf("chmod o+X %s", $home));
				if($tarr['quota']){
					$q = $tarr['quota'];
					$script .= "\n". sprintf($format, sprintf("setquota %s %d %d %d %d -a", $arr['login'], $q, $q, $q*10, $q*10));
				}
				PrintStrings("Changes", $script);
				return $table->warning(ExecuteScript($script,1));
			}else{
				$password_changed = $table->isChanged('password');
				$password = $arr['password'];
				$uid_changed = $table->isChanged('uid');
				$desc_changed = $table->isChanged('description') || $table->isChanged('client');
				$login_changed = $table->isChanged('login');
				$type_changed = $table->isChanged('type');
				if($uid_changed || $desc_changed || $login_changed || $password_changed || $type_changed){
					$script = sprintf("usermod -u %s -g %s -s '%s' -c '%s' -p '%s'", $arr['uid'], $tarr['gid'], $tarr['shell'], $desc, str_replace('$', '\$', $password));
					if($login_changed){
						$script .= sprintf(" -l %s -d '%s' -m", $arr['login'], $home);
					}
					$script .= " ".$table->old_record['login'];
					$script = sprintf($format, $script);
					if($type_changed || $login_changed){
						if($tarr['quota']){
							$q = $tarr['quota'];
							$script .= "\n". sprintf($format, sprintf("setquota %s %d %d %d %d -a", $arr['login'], $q, $q, $q*10, $q*10));
						}
					}
					PrintStrings("Changes", $script);
					return $table->warning(ExecuteScript($script,1));
				}
			}
		}else{
			if($table->old_record['active']){
				$script = sprintf($format, sprintf("userdel %s", $table->old_record['login']));
				PrintStrings("Changes", $script);
				return $table->warning(ExecuteScript($script,1));
			}
		}
	}
}

function after_homedir_delete($table){
	if($table->old_record['active']){
		$passwd = loadPasswd();
		$login = $table->old_record['login'];
		if(isset($passwd['by_login'][$login])){
			$format = getOption('HOMEDIR_CMD_FORMAT');
			$script = sprintf($format, sprintf("userdel %s", $login));
			PrintStrings("Changes", $script);
			return $table->warning(ExecuteScript($script,1));
		}
	}
}

function getHomedirTypes(){
	return loadByQuery("SELECT id, name AS value FROM homedir_types ORDER BY name");
}
?>