<?
include_once(dirname(__FILE__).'/arp.php');
include_once(dirname(__FILE__).'/dhcp.php');
include_once(dirname(__FILE__).'/named.php');
include_once(dirname(__FILE__).'/vpn.php');
include_once 'classes/ZabbixAPI.class.php';
loadStrings(BOOT.'hosts_restricted_names/strings.txt');

function show_zabbix($modem_id, $port){
	global $pe6yc_storage;
	ZabbixAPI::login(getTrimOption('ZABBIX_URL'), getTrimOption('ZABBIX_USER'), getTrimOption('ZABBIX_PASSWORD'));
	$modem = loadRecord("SELECT zabbix_id FROM modems WHERE id='".addslashes($modem_id)."'");
	$result = '';
	$ids = array();
	foreach(preg_split("|[\s,;]+|", getTrimOption('ZABBIX_KEYS'), -1, PREG_SPLIT_NO_EMPTY) as $k){
		$items = ZabbixAPI::fetch_array('item', 'get', array("hostids"=>$modem['zabbix_id'], 'output'=>'extend', 'filter'=>array("key_"=>$k.".".$port)));
		if(isset($items['0']['itemid'])){
			$graph = ZabbixAPI::fetch_array('graph', 'get',array("itemids"=>$items['0']['itemid']));
			$period = $pe6yc_storage->restore('zx_'.$k, 60 * 60 * 24);
			if(isset($graph['0']['graphid'])){
				$gid = $graph['0']['graphid'];
				$ids['zx_'.$k] = $period;
				// $items['0']['description'].
				$result .= "<div align=\"center\">
				<br>
				<a href=\"".getDirOption('ZABBIX_URL')."charts.php?graphid=$gid\" target=\"zabbix\">
				<img id=\"zx_$k\" src=\"zabbix-pump.php?graphid=$gid&period=$period&height=150\" style=\"margin: 4px;\"></a>
				</div>";
			}
		}
	}
	if(!empty($ids)){
		ob_start();
		?>
		<script>
		var zoom = {
			'': 60 * 60,
			'': 60 * 60 * 24,
			'': 60 * 60 * 24 * 7,
			'': 60 * 60 * 24 * 31,
		};
		
		function show_selected(gid, period){
			$.each(zoom, function(i, v){
				$("#" + gid + v).html(v==period ? "[" + i + "]" : i);
			});
		}
		
		function make_zbx_zoomer(gid){
			var g = $('#' + gid), zoomers = [];
			var src = g.attr('src');
			$.each(zoom, function(i, v){
				var z = $("<a id=\"" + gid + v + "\" href=\"#\">" + i + "</a>").css('margin', '4px').click(function(e){
					g.attr('src', src + '&period=' + v);
					store_pref(gid, v);
					show_selected(gid, v);
					return false;
				});
				g.parent().before(z);
			});
			g.parent().before("<br>");
		}
		
		$.each(<?=json_encode($ids)?>, function(id, period){
			make_zbx_zoomer(id);
			show_selected(id, period);
		})
		</script>
		<?
		$result .= ob_get_clean();
	}
	return $result;
}

function verify_restricted_names($table){
	global $db;
	if(isset($GLOBALS['oper']->system_access['worker_features'])){
		$name = $table->new_record['name'];
		$rezult = $db->Execute("SELECT * FROM `hosts_restricted_names` WHERE name='$name'");
		if($db->Next($rezult)){
			$table->error(sprintf(getResource("host.blocked"),$name));
		}
	}
	/*
	 if(isset($GLOBALS['oper']->system_access['worker_features'])){
  -    ($table->new_record['name'])    hosts_restricted_names,
   \ 
 (   $table->error()   -)
}*/
}

class PHostActionForm extends PForm {
	function Process(){
		global $db;
		$host = $this->fields['host']->value;
		$action = $this->fields['action']->value;
		//load pattern
		$res = $db->Execute("SELECT * FROM hosts_actions WHERE id='$action'");
		$act_arr = $db->Next($res);
		$executor = $act_arr['action_pattern'];
		//load host
		$res = $db->Execute("SELECT * FROM hosts WHERE id='$host'");
		$host_arr = $db->Next($res);
		//fill pattern by host info
		$executor = str_replace(array("%id","%mac","%ip","%name"),array($host_arr['id'],$host_arr['mac'],$host_arr['ip'],$host_arr['name']),$executor);
		//execute
		$err = ExecuteScript($executor);
		if($err){
			PrintStrings("Host Action", $executor);
		}
		return $err;
	}
}

function recalc_modems_clients(){
	global $db;
	$modems = loadRecords("SELECT m.id, m.modem, mc.amount, 0 as new_amount, mc.amount_2, 0 as new_amount_2, mc.apartments, 0 as new_apartments
		FROM modems m
		LEFT JOIN modems_clients mc ON mc.modem=m.id",
		"id");
	$hosts = loadRecords("SELECT DISTINCT h.client, h.modem 
		FROM hosts h 
		LEFT JOIN clients c ON c.id=h.client 
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		WHERE ct.service_type > 0");
	foreach($hosts as $host){
		if(isset($modems[$host['modem']])){
			$modem = $modems[$host['modem']];
			$modems[$host['modem']]['new_amount_2']++;
			$branch = array();
			while($modem && !in_array($modem['id'], $branch)){
				$branch[] = $modem['id'];
				$modems[$modem['id']]['new_amount']++;
				$modem = isset($modems[$modem['modem']]) ? $modems[$modem['modem']] : '';
			}
		}
	}
	$apartments = loadRecords("SELECT max(m.modem) modem, hs.id, hs.appartments
		FROM hosts h
		LEFT JOIN modems m ON m.id=h.modem
		LEFT JOIN clients c ON c.id=h.client
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		LEFT JOIN houses hs ON hs.id=c.house_id
		WHERE m.modem IS NOT NULL AND ct.service_type > 0
		GROUP BY hs.id");
	foreach($apartments as $arr){
		if(isset($modems[$arr['modem']])){
			$modem = $modems[$arr['modem']];
			$branch = array();
			while($modem && !in_array($modem['id'], $branch)){
				$branch[] = $modem['id'];
				$modems[$modem['id']]['new_apartments'] += $arr['appartments'];
				$modem = isset($modems[$modem['modem']]) ? $modems[$modem['modem']] : '';
			}
		}
	}
	foreach($modems as $id=>$modem){
		if(($modem['amount']!=$modem['new_amount']) || ($modem['amount_2']!=$modem['new_amount_2']) || ($modem['apartments']!=$modem['new_apartments'])){
			$db->Execute(sprintf("REPLACE INTO modems_clients (modem, amount, amount_2, apartments) VALUES ('%s', '%s', '%s', '%s')", 
				$id, $modem['new_amount'], $modem['new_amount_2'], $modem['new_apartments']));
		}
	}
}

function validate_host_duplicate($table, $key){
	global $db;
	static $check = "SELECT id FROM %s WHERE %s='%s'";
	static $msgs = array(
		'hosts'=>"hosts.error.host.duplicate",
		'modems'=>"hosts.error.modem.duplicate",
	);
	$new = $table->new_record;
	$old = $table->old_record;
	$id = $old['id'];
	$value = $new[$key];
	if($value){
		foreach($msgs as $tab=>$msg){
			if($arr = $db->Next($db->Execute(sprintf($check, $tab, $key, $value)))){
				if($arr['id'] && !(($table->name==$tab) && ($id==$arr['id']))){
					$table->error(sprintf(getResource($msg), $value));
					break;
				}
			}
		}
	}
}

function validate_host_ip_duplicate($table){
	global $db;
	$check = array(
		'hosts'=>array(
			'fields'=>array('ip'),
			'query'=>"SELECT h.id FROM hosts h WHERE h.ip='[value]'",
			'message'=>"hosts.error.host.duplicate",
		),
		'modems'=>array(
			'fields'=>array('ip', 'ip_core_route'),
			'query'=>"SELECT m.id FROM modems m LEFT JOIN trunk_modems tm ON tm.id=m.id WHERE m.ip='[value]' OR tm.ip_core_route='[value]'",
			'message'=>"hosts.error.modem.duplicate",
		),
		'tv_nodes'=>array(
			'fields'=>array('ip'),
			'query'=>"SELECT n.id FROM tv_nodes n WHERE n.ip='[value]'",
			'message'=>"hosts.error.tv.node.duplicate",
		),
	);
	$new = $table->new_record;
	$old = $table->old_record;
	$id = $old['id'];
	$fields = $check[$table->name]['fields'];
	foreach($fields as $key){
		$value = $new[$key];
		if($value){
			foreach($check as $tab=>$data){
				$query = str_replace('[value]', $value, $data['query']);
				if($arr = loadRecord($query)){
					if($arr['id'] && !(($table->name==$tab) && ($id==$arr['id']))){
						$table->error(sprintf(getResource($data['message']), $value));
						break;
					}
				}
			}
		}
	}
}

function validate_host_name_duplicate($table){
	global $db;
	static $check = "SELECT id FROM %s WHERE name='%s' and domain='%s'";
	static $msgs = array(
		'hosts'=>"hosts.error.host.duplicate",
		'modems'=>"hosts.error.modem.duplicate",
	);
	$new = $table->new_record;
	$old = $table->old_record;
	$id = $old['id'];
	if($new['name']){
		foreach($msgs as $tab=>$msg){
			if($arr = $db->Next($db->Execute(sprintf($check, $tab, $new['name'], $new['domain'])))){
				if($arr['id'] && !(($table->name==$tab) && ($id==$arr['id']))){
					$name = $new['name'];
					if($new['domain']){
						if($darr = $db->Next($db->Execute(sprintf("SELECT name FROM domains WHERE id='%s'", $new['domain'])))){
							if($darr['name']){
								$name .= '.'.$darr['name'];
							}
						}
					}
					$table->error(sprintf(getResource($msg), $name));
					break;
				}
			}
		}
	}
}

function before_computer_apply($table){
	global $db;
//	$db->debug = 1;
	$new = $table->new_record;
	$old = $table->old_record;
	$client = $new['client'] ? $new['client'] : $old['client'];
	$modem_addr = $db->Next($db->Execute(sprintf("SELECT m.uplink, m.check_address, m.street, m.house, s.name as street_name 
	FROM modems m
	LEFT JOIN streets s ON s.id=m.street
	WHERE m.id='%s'", $new['modem'])));
	if($new['port']){
		$res = $db->Execute(sprintf("SELECT
			h.id, h.client, h.ip,
			CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ')') as client_name
			FROM hosts h
			LEFT JOIN clients c ON c.id=h.client
			WHERE h.modem='%s' AND h.port='%s' AND h.client!='%s' AND h.id!='%s'", $new['modem'], $new['port'], $client, $old['id']));
		while($arr = $db->Next($res)){
			$table->error(sprintf(getResource('hosts.error.port.collision'), $new['port'], $arr['client_name'], $arr['ip']));
		}
		
		if($new['vlan']){
			$res = $db->Execute(sprintf("SELECT vlan FROM hosts WHERE modem='%s' AND port='%s' AND vlan>0 AND vlan!='%s' AND id!='%s' LIMIT 1",
				$new['modem'], $new['port'], $new['vlan'], $old['id']));
			if($arr = $db->Next($res)){
				$table->error(sprintf(getResource('hosts.vlan.error.port.conflict'), $new['port'], $arr['vlan']));
			}
		}
		
		if($new['port']==$modem_addr['uplink']){
			$table->error(sprintf(getResource('hosts.error.port.collision.uplink'), $new['port']));
		}
		$res = $db->Execute(sprintf("SELECT id, name FROM modems
			WHERE modem='%s' AND port='%s'", $new['modem'], $new['port']));
		if($arr = $db->Next($res)){
			$table->error(sprintf(getResource('hosts.error.port.collision.modem'), $new['port'], $arr['name']));
		}
	}
	if($modem_addr['check_address']){
		$client_addr = $db->Next($db->Execute(sprintf("SELECT h.street, h.house, s.name as street_name 
			FROM clients c
			LEFT JOIN houses h ON h.id=c.house_id
			LEFT JOIN streets s ON h.street = s.id
			WHERE c.id='%s'", $client)));
	//	print_r($modem_addr);
	//	print_r($client_addr);
		if($modem_addr['street'] && 
			$modem_addr['house'] && 
			$client_addr['street'] && 
			$client_addr['house'] && 
			!(($modem_addr['street'] == $client_addr['street']) && (str_replace("","a",$modem_addr['house']) == str_replace("","a",$client_addr['house'])))
		){
			$table->error(sprintf(getResource('hosts.error.modem.wrong.address'),
				$modem_addr['street_name'], $modem_addr['house'],
				$client_addr['street_name'], $client_addr['house']));
		}
	}
	before_host_apply($table);
//	$table->warning("ok");
}

function before_host_apply($table){
	global $oper;
	if(isset($table->new_record['name'])){
		if($table->isChanged('name')){
			//    
			$pattern = isset($oper->system_access['worker_features']) ? '|^[a-z][0-9a-z\-]*$|' : '|^[a-z][0-9a-z\-\.]*$|';
			if(!preg_match($pattern, $table->new_record['name'])){
				$table->error(getResource('hosts.error.bad.name'));
			}
		}
	}
	$table->new_record['mac'] = str_replace('-', ':', $table->new_record['mac']);
	$id = $table->new_record['id'];
	$ip = $table->new_record['ip'];
	$mac = $table->new_record['mac'];
	if($mac){
		$table->error(ValidateMac($mac));
	}
	if($ip){
		$table->error(ValidateIp($ip));
	}
	if(!$table->hasErrors()){
		//validate_host_duplicate($table, 'ip');
		validate_host_ip_duplicate($table);
		validate_host_duplicate($table, 'mac');
		validate_host_name_duplicate($table);
	}
}

function add_auto_firewall($table){
	global $db;
	$hid = $table->current_record['id'];
	$db->Execute("INSERT INTO hosts_firewall (host, rule) SELECT $hid, id FROM rules WHERE auto_firewall");
}

function after_computer_post($table){
	after_host_post($table);
	if($table->isChanged('ip,login,password')){
		$table->warning(RemakeVPN($old));
	}
	if($table->isChanged('ip,mac,modem,port,vlan')){
		$old = $table->old_record['modem'];
		$new = $table->new_record['modem'];
		if($old && $old!=$new){
			//$table->warning(RemakeModemProfile($old));
			RemakeModemProfileTask($old);
		}
		if($new){
			//$table->warning(RemakeModemProfile($new));
			RemakeModemProfileTask($new);
		}
	}
	if($table->isChanged('ip,mac,modem,vlan')){
		ReplaceTreeArp($table);
	}
	if($table->isChanged('ip')){
		$table->warning(RemakeShapers());
	}
}

function after_host_post($table){
	global $beans;
	if($table->isChanged('modem')){
		recalc_modems_clients();
	}
	$restart_dns = false;
	if($table->isChanged('ip,name')){
		$old = GetHostNetwork($table->old_record['ip']);
		$new = GetHostNetwork($table->new_record['ip']);
		if($old && $old!=$new){
			$table->warning(RemakeNetwork($old));
			$restart_dns = true;
		}
		if($new){
			$table->warning(RemakeNetwork($new));
			$restart_dns = true;
		}
	}
	if($table->isChanged('ip,mac')){
		$table->warning(RemakeARP());
	}
	if($table->isChanged('ip,name,domain')){
		$old = $table->old_record['domain'];
		$new = $table->new_record['domain'];
		if($old && $old!=$new){
			$table->warning(RemakeDomain($old));
			$restart_dns = true;
		}
		if($new){
			$table->warning(RemakeDomain($new));
			$restart_dns = true;
		}
	}
	if($table->isChanged('ip')){
		$builder = $beans->getBean('dhcpSubnetBuilder');
		if($table->name=='hosts'){
			$sub = $builder->link_host($table->current_record);
			//$table->warning($sub);
		}else{
			$builder->link_modem($table->current_record);
		}
	}
	if($table->isChanged('ip,mac,name,domain')){
		$table->warning(RemakeDHCP());
	}
	if($restart_dns){
		$table->warning(RestartDNS());
	}
}

function after_host_delete($table){
	recalc_modems_clients();
	$ip = $table->old_record['mac'];
	$mac = $table->old_record['mac'];
	$domain = $table->old_record['domain'];
	$restart_dns = false;
	$net = GetHostNetwork($ip);
	if($net){
		$table->warning(RemakeNetwork($net));
		$restart_dns = true;
	}
	if($domain){
		$table->warning(RemakeDomain($domain));
		$restart_dns = true;
	}
	if($restart_dns){
		$table->warning(RestartDNS());
	}
	if($mac){
		$table->warning(RemakeARP());
		$table->warning(RemakeDHCP());
	}
}

function after_computer_delete($table){
	$id = $table->old_record['id'];
	//$table->owner->Execute("DELETE FROM ip_log WHERE host='$id'");
	//$table->owner->Execute("DELETE FROM hosts_firewall WHERE host='$id'");
	after_host_delete($table);
	RemoveTreeArp($table);
	//$table->warning(RemakeModemProfile($table->old_record['modem']));
	RemakeModemProfileTask($table->old_record['modem']);
	$table->warning(RemakeShapers());
	$table->warning(RemakeVPN());
}

//remake_dhcp_links();

?>