<?php

/**
 * @author tregub
 * @copyright 2010
 */

include_once('includes/global.php');
loadStrings(BOOT.'groups/strings.txt');
include_once('includes/lookups.php');
$doc->title .= ' :: ' . getResource('groups.title');

//$db->debug = 1;

class AccessSwitchForm extends PForm 
{
	function Process()
	{
		global $db, $groups;
		$group = $groups->active_record;
		$replace = array();
		$delete = array();
		foreach($this->fields as $entity=>$obj){
			if($obj->value < 0){
				$delete[] = $entity;
			}else{
				$replace[] = sprintf("(%s, %s, %d)", $group['id'], $entity, $obj->value);
			}
		}
		if(count($replace) > 0){
			$query  = "REPLACE INTO groups_access (group_id, entity, access) VALUES ".implode(", ", $replace);
			$db->Execute($query);
		}
		if(count($delete) > 0){
			$query  = sprintf("DELETE FROM groups_access WHERE group_id=%s AND entity IN (%s)", $group['id'], implode(", ", $delete));
			$db->Execute($query);
		}
	}
}

required_access('operators');

$groups = new PTable($db,BOOT.'groups/table.php');
$groups->readonly = !$oper->system_access['operators'];


$doc->page->contents['groups'] = new PMyAccess($groups,array(
	'title'=>getResource('groups.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/operators.gif',
	'grid_boot'=>BOOT.'groups/grid.php',
	'form_boot'=>BOOT.'groups/form.php',
));


if($groups->active_record['id'] > 0)
{

	$doc->page->contents['access_title'] = '<img src="'.HREF.'/images/keys.gif" align="middle" vspace="6"><span class="access_head">'.getResource('groups.access').'</span>';
	$res = $db->Execute(sprintf("		SELECT se.id, se.name, IFNULL(oa.access, -1) as access
										FROM system_entities se
										LEFT JOIN groups_access oa ON oa.entity=se.id AND oa.group_id=%s
										ORDER BY se.name", $groups->active_record['id']));
	while($arr = $db->Next($res))
	{
		$access_fields[$arr['id']] = array(
					'control'=>'radio',
					'title'=>$arr['name'],
					'value'=>$arr['access'],
					'inline'=>1,
					'list'=>array(
						'-1'=>getResource('groups.access.none'),
						'0'=>getResource('groups.access.read'),
						'1'=>getResource('groups.access.full'),
			),
			'readonly'=>!$oper->system_access['operators'],
		);
	}
	$doc->page->contents['access'] = new AccessSwitchForm($nil,BOOT.'groups/access/form.php');

}


echo $doc->Paint();

?>