<?
class DRWEBForm extends PForm {

	var $result;

	function query($query){
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $query);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Basic ".base64_encode(sprintf("%s:%s", DRWEB_USER, DRWEB_PASSWORD))));
		ob_start();
		curl_exec($ch);
		$result = trim(ob_get_contents());
		ob_end_clean();
		$this->result = $result;
		return $result;
	}

	function init($login, $end){
		$query = sprintf('%s/add-customer.ds?count=1&id=%s&pgrp=%s&year=%s&month=%s&day=%s',
			DRWEB_API_URL, $login, DRWEB_GROUP, date("Y", $end), date("m", $end), date("d", $end));
		$result = $this->query($query);
		if(!strstr($result, 'rc="true"')){
			if(preg_match('|message="([^"]*)"|imxs', $result, $m)){
				return $m[1];
			}else{
				return 'error';
			}
		}
	}

	function prolong($login, $end){
		$query = sprintf('%s/set-expiration.ds?id=%s&year=%s&month=%s&day=%s',
			DRWEB_API_URL, $login, date("Y", $end), date("m", $end), date("d", $end));
		$result = $this->query($query);
		if(!strstr($result, 'rc="true"')){
			if(preg_match('|message="([^"]*)"|imxs', $result, $m)){
				return $m[1];
			}else{
				return 'error';
			}
		}
	}

	function Process(){
		global $db, $client, $has_prev_period, $last_drweb;
		$term = intval($this->fields['term']->value);
		if($term > 0){
			$cost = intval(strval(DRWEB_COST * 100)) * $term;
			if($client['deposit'] >= $cost){
				$begin = ($has_prev_period && $last_drweb['actual']) ? $last_drweb['period_end'] : time();
				$end = mktime(date('H', $begin), date('i', $begin), date('s', $begin), date('m', $begin) + $term, date('d', $begin), date('Y', $begin));
				if($init_msg = $this->init($client['login'], $end)){
					if(strstr($init_msg, 'already exists')){
						if($prolong_msg = $this->prolong($client['login'], $end)){
							//echo $this->result;
							//return $prolong_msg;
							return getResource('clientroom.drweb.error');
						}
					}else{
						//echo $this->result;
						//return $init_msg;
						return getResource('clientroom.drweb.error');
					}
				}
				$db->Begin();
				$ru = addResourceUse($client['id'], DRWEB_RESOURCE_TYPE, 1, intval(strval(DRWEB_COST * 100)), $client['account'], DRWEB_ACCOUNT, $term);
				$db->Execute(sprintf("INSERT INTO drweb_uses (client, resource_use, period_begin, period_end) VALUES ('%s', '%s', FROM_UNIXTIME(%s), FROM_UNIXTIME(%s))",
					$client['id'], $ru, $begin, $end));
				$dwid = $db->getJustInserted('drweb_uses', 'id');
				$db->Execute(sprintf("REPLACE INTO drweb_state (client, drweb_use) VALUES ('%s', '%s')", $client['id'], $dwid));
				if($db->hasErrors()){
					$db->Rollback();
				}else{
					$db->Commit();
				}
			}else{
				return getResource('clientroom.drweb.low.deposit');
			}
		}
	}
}

function getDrWebTerms(){
	$arr = array();
	for($i=1; $i<13; $i++){
		$mode = 3;
		if($i<5) $mode = 2;
		if($i<2) $mode = 1;
		$arr[$i] = sprintf(getResource('clientroom.drweb.term.variant'.$mode), $i, $i * DRWEB_COST);
	}
	return $arr;
}

$res = $db->Execute(sprintf('SELECT du.id, UNIX_TIMESTAMP(du.period_begin) period_begin, UNIX_TIMESTAMP(du.period_end) period_end
	FROM drweb_state ds LEFT JOIN drweb_uses du ON du.id=ds.drweb_use WHERE ds.client="%s"', $client['id']));
if($last_drweb = $db->Next($res)){
	$has_prev_period = $last_drweb['id'] ? true : false;
	$last_drweb['actual'] = $last_drweb['id'] && ($last_drweb['period_end'] > time());
}else{
	$has_prev_period = false;
}

$doc->page->contents['drweb_confirm'] = '
<script language="Javascript">
	function DRWEBValidator(name){
		if(CommonFormCheck(name)){
			var deposit = '.$client['deposit'].';
			var conf = "'.getResource('clientroom.drweb.confirm.'.($has_prev_period ? 'prolong' : 'init')).'";
			var frm = document.forms[name];
			var term = frm.term.value;
			var cost = term * '.intval(strval(DRWEB_COST * 100)).';
			if(cost > deposit){
				alert("'.getResource('clientroom.drweb.low.deposit').'");
				return false;
			}
			var label = frm.term.options[term].text;
			return confirm(sprintf(conf, label));
		}else{
			return false;
		}
	}
</script>';

$doc->page->contents['drweb_title'] = '<img src="'.HREF.'/images/drweb.gif" align="middle" vspace="6" hspace="2"><span class="access_head">'.getResource('clientroom.drweb.title').'</span>';
$doc->page->contents['drweb_form'] = new DRWEBForm($nil,BOOT.'client_info/drweb/form.php');
if($has_prev_period){
ob_start();
?>
<br>
<a href="<?=dirname(DRWEB_API_URL)?>/download.ds?id=<?=$client['login']?>"> Dr.Web    .</a>
<br><br>
  Dr.Web   <?=date('d.m.Y', $last_drweb['period_end']);?>
<?
$doc->page->contents['drweb_more'] = ob_get_clean();
}?>