<?

include_once('classes/Lookup.php');

function lookup($name, $filter = array()){
global $oper, $db;

switch($name){

case 'tv_node_profile':		new Lookup('id', 'name', 'tv_node_profiles', array_merge($filter, array('actual=1')));
case 'action':				new Lookup('id', 'name', 'actions', $filter);
case 'tv_box':				if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('b.id', 
								"CONCAT(s.name,' ', h.house, ' ".getResource('exp.points.entrance.short')."', b.entrance,  ' ".getResource('exp.points.floor.short')."', b.floor)",
								"tv_boxes b
								LEFT JOIN houses h ON h.id=b.house
								LEFT JOIN streets s ON s.id=h.street
								LEFT JOIN operators_cities oc ON oc.city=h.city AND oc.operator='$oper->id'",
								$filter);

case 'ivr_message':			
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('m.id', "m.name",
								"ivr_messages m
								LEFT JOIN operators_cities oc ON oc.city=m.city AND oc.operator='$oper->id'",
								$filter, 'm.name');
							}else{
								new Lookup('m.id', "m.name", 'ivr_messages m', $filter, 'm.name');
							}

case 'tv_node':				if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('n.id', "n.name",
								"tv_nodes n
								LEFT JOIN operators_cities oc ON oc.city=n.city AND oc.operator='$oper->id'",
								$filter, 'n.name');
							}else{
								new Lookup('n.id', "n.name", 'tv_nodes n', $filter, 'n.name');
							}
case 'tv_node_ent':			
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('n.id', "CONCAT(n.name, ' (', IFNULL(n.entrances, ''),')')",
								"tv_nodes n
								LEFT JOIN operators_cities oc ON oc.city=n.city AND oc.operator='$oper->id'",
								$filter, 'n.name');
							}else{
								new Lookup('n.id', "CONCAT(n.name, ' (', IFNULL(n.entrances, ''),')')", 'tv_nodes n', $filter, 'n.name');
							}

case 'job_type':			if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							$filter['actual'] = '(t.actual=1)';
							new Lookup('t.id', 't.name',
								"job_types t
								LEFT JOIN operators_cities oc ON oc.city=t.city AND oc.operator='$oper->id'",
								$filter, 't.number, t.name');

case 'tz':					if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('tz.id', 'tz.name',
								"tech_zones tz
								LEFT JOIN operators_cities oc ON oc.city=tz.city AND oc.operator='$oper->id'",
								$filter);
case 'tzt':					if($oper->city_mode){
								$filter['by_city'] = "(x.oc_city IS NOT NULL)";
							}
							new Lookup('x.id', 'CONCAT(x.name, " -> ", x.time_name)',
								"(SELECT -tz.id as id, tz.name, '  ' as time_name, CAST(0 AS TIME) as from_time, tz.city, oc.city oc_city
									FROM tech_zones tz
									LEFT JOIN operators_cities oc ON oc.city=tz.city AND oc.operator='$oper->id'
									UNION
									SELECT tzt.id, tz.name, tzt.time_name, tzt.from_time, tz.city, oc.city oc_city
									FROM tech_zone_times tzt
									LEFT JOIN tech_zones tz ON tzt.tech_zone = tz.id 
									LEFT JOIN operators_cities oc ON oc.city=tz.city AND oc.operator='$oper->id'
								) as x",
								$filter);
case 'worker':				if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							$filter['worker'] = '(s.status=1 AND r.accept_jobs=1)';
							new Lookup('s.id', 's.name',
								"staff s
								LEFT JOIN ranks r ON r.id=s.rank
								LEFT JOIN operators_cities oc ON oc.city=s.city AND oc.operator='$oper->id'", 
								$filter);
case 'job':					if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('j.id', 'CONCAT(j.id, " - ", IFNULL(jt.name, ""), " - ", IFNULL(s.name,""), " ", IFNULL(h.house,""), ", ", IFNULL(j.apartment, ""))', 
								"jobs j
								LEFT JOIN job_types jt ON jt.id=j.type
								LEFT JOIN houses h ON h.id=j.house_id 
								LEFT JOIN streets s ON s.id=h.street
								LEFT JOIN operators_cities oc ON oc.city=j.city AND oc.operator='$oper->id'", 
								$filter);
case 'client_expense':		if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							$filter['with_job'] = "(j.id is not null)";
							new Lookup('ce.id', 'CONCAT(j.id, " - ", IFNULL(s.name,""), " ", IFNULL(h.house,""), ", ", IFNULL(j.apartment, ""))', 
								"client_expenses ce
								LEFT JOIN jobs j ON j.id=ce.job
								LEFT JOIN houses h ON h.id=j.house_id
								LEFT JOIN streets s ON s.id=h.street
								LEFT JOIN operators_cities oc ON oc.city=j.city AND oc.operator='$oper->id'",
								$filter, "j.id DESC");
case 'staff':				if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('s.id', 's.name',
								"staff s
								LEFT JOIN operators_cities oc ON oc.city=s.city AND oc.operator='$oper->id'",
								$filter);
case 'city':				new Lookup('id', 'name', 'cities', $filter);
case 'street':				if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('id', 'name',
								"streets s
								LEFT JOIN operators_cities oc ON oc.city=s.city AND oc.operator='$oper->id'",
								$filter);
case 'shaper':				new Lookup('id', 'name', 'shapers', $filter);
case 'house':				if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('h.id', 'CONCAT(s.name, " ", h.house)',
								"houses h
								LEFT JOIN streets s ON s.id=h.street
								LEFT JOIN operators_cities oc ON oc.city=h.city AND oc.operator='$oper->id'",
								$filter, 's.name, h.house + 0');
case 'connection_type':		if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('ct.id', 'ct.name', "connection_types ct
								LEFT JOIN operators_cities oc ON oc.city=ct.city AND oc.operator='$oper->id'", $filter);
case 'department':			new Lookup('id', 'name', 'departments', $filter);
case 'charge_type':			new Lookup('id', 'name', 'charge_types', $filter);
case 'rule':				new Lookup('id', 'name', 'rules', $filter);
case 'resource_type':		new Lookup('id', 'name', 'resource_types', $filter);
case 'mailbox_type':		new Lookup('id', 'name', 'mailbox_types', $filter);
case 'homedir_type':		new Lookup('id', 'name', 'homedir_types', $filter);
case 'domain':				$filter['not_hidden'] = 'hidden=0';
							new Lookup('id', 'name', 'domains', $filter);
case 'host':				if($oper->department){
								$filter['by_dep'] = "(c.department='".$oper->department."')";
							}
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('h.id', "CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ') - ', h.ip)",
								"hosts h
								LEFT JOIN clients c ON c.id=h.client
								LEFT JOIN operators_cities oc ON oc.city=c.city AND oc.operator='$oper->id'",
								$filter);
								
case 'client_contract_account':	new Lookup('account', 
								"CONCAT(last_name, ' ', first_name, ' (', IFNULL(contract,''), ')')", 'clients',
								$oper->department ? array("(department='".$oper->department."')") : $filter);
case 'client_contract_account_address':
								if($oper->city_mode){
									$filter['by_city'] = "(oc.city IS NOT NULL)";
								}
								new Lookup('account', 
								"CONCAT(c.last_name, ' ', c.first_name, ' (', IFNULL(c.contract, ''), ') ', IFNULL(s.name,''), ' ', IFNULL(h.house,''), ', ', IFNULL(c.apartment,''))",
								'clients c
								LEFT JOIN houses h ON h.id=c.house_id
								LEFT JOIN streets s ON s.id=h.street
								LEFT JOIN operators_cities oc ON oc.city=c.city AND oc.operator="'.$oper->id.'"',
								$oper->department ? array("(c.department='".$oper->department."')") : $filter);

case 'client_account':		new Lookup('id', 'name', 'accounts', array("type='D'"));
case 'bonus_account':		new Lookup('id', 'name', 'accounts', array("type='B'"));
case 'system_account':		new Lookup('account', 'name', 'system_accounts', array("type=>0"));
case 'system_src_account':	new Lookup('account', 'name', 'system_accounts', array("type&1"));
case 'system_dst_account':	new Lookup('account', 'name', 'system_accounts', array("type&2"));
case 'client_account_s':	new Lookup('id', "CONCAT('[D] ', name)", 'accounts', array("type='D'"));
case 'bonus_account_s':		new Lookup('id', "CONCAT('[B] ', name)", 'accounts', array("type='B'"));
case 'system_account_s':	new Lookup('account', "CONCAT('[S] ', name)", 'system_accounts', array("type>=0"));
case 'system_src_account_s':new Lookup('account', "CONCAT('[S] ', name)", 'system_accounts', array("type&1"));
case 'system_dst_account_s':new Lookup('account', "CONCAT('[S] ', name)", 'system_accounts', array("type&2"));
case 'client_and_bonus_account':	new Lookup('id', "CONCAT('[', type,'] ', name)", 'accounts', array("(type='D' OR type='B')"), 'type DESC, name');
case 'src_account':			new Lookup('a.id', "CONCAT('[', a.type,'] ', a.name)",
								'accounts a LEFT JOIN system_accounts sa ON sa.account=a.id',
								array("(sa.account IS NULL OR sa.type&1)"),
								"IF(a.type='S',0,IF(a.type='D', 1, 2))");
case 'dst_account':			new Lookup('a.id', "CONCAT('[', a.type,'] ', a.name)",
								'accounts a LEFT JOIN system_accounts sa ON sa.account=a.id',
								array("(sa.account IS NULL OR sa.type&2)"),
								"IF(a.type='S',0,IF(a.type='D', 1, 2))");
case 'account':				new Lookup('id', "CONCAT('[', type,'] ', name)", 'accounts', $filter,
								"IF(type='S',0,IF(type='D', 1, 2))");
case 'query':				new Lookup('id', 'name', 'queries', $filter);
case 'client':				if($oper->department){
								$filter['by_dep'] = "(department='".$oper->department."')";
							}
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('c.id', "CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ')')",
								"clients c LEFT JOIN operators_cities oc ON oc.city=c.city AND oc.operator='$oper->id'",
								$filter);
							}else{
								new Lookup('c.id', "CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ')')", 'clients c', $filter);
							}
case 'client_contract':		if($oper->department){
								$filter['by_dep'] = "(c.department='".$oper->department."')";
							}
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('c.id', "CONCAT(c.last_name, ' ', c.first_name, ' (', IFNULL(c.contract, ''), ')')",
								"clients c LEFT JOIN operators_cities oc ON oc.city=c.city AND oc.operator='$oper->id'",
								$filter);
							}else{
								new Lookup('c.id', "CONCAT(c.last_name, ' ', c.first_name, ' (', IFNULL(c.contract, ''), ')')", 'clients c', $filter);
							}
case 'client_contract_address':
							if($oper->department){
								$filter['by_dep'] = "(department='".$oper->department."')";
							}
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('c.id', "CONCAT(c.last_name, ' ', c.first_name, ' (', IFNULL(c.contract, ''), ')', s.name, ' ', h.house, ' ', c.apartment)",
								"clients c
								LEFT JOIN houses h ON h.id=c.house_id
								LEFT JOIN streets s ON s.id=h.street
								LEFT JOIN operators_cities oc ON oc.city=c.city AND oc.operator='$oper->id'",
								$filter);
							}else{
								new Lookup('c.id', "CONCAT(c.last_name, ' ', c.first_name, ' (', IFNULL(c.contract, ''), ')', s.name, ' ', h.house, ' ', c.apartment)",
									'clients c
									LEFT JOIN houses h ON h.id=c.house_id
									LEFT JOIN streets s ON s.id=h.street', $filter);
							}

case 'modem':				if($oper->department){
								$filter['by_dep'] = "(department='".$oper->department."')";
							}
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('m.id', "CONCAT(m.ip, ' (', m.name, ')')", 
								"modems m
								LEFT JOIN operators_cities oc ON oc.city=m.city AND oc.operator='$oper->id'",
								$filter, 'm.ip, m.name');
							}else{
								new Lookup('m.id', "CONCAT(m.ip, ' (', m.name, ')')", 'modems m', $filter, 'm.ip, m.name');
							}
case 'modem2':				if($oper->department){
								$filter['by_dep'] = "(department='".$oper->department."')";
							}
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
								new Lookup('m.id', "CONCAT(IFNULL(CONCAT(d.name, '.'), ''), m.name, ' (', m.ip, ')')", 
								"modems m
								LEFT JOIN domains d ON d.id=m.domain
								LEFT JOIN operators_cities oc ON oc.city=m.city AND oc.operator='$oper->id'",
								$filter);
							}else{
								new Lookup('m.id', "CONCAT(IFNULL(CONCAT(d.name, '.'), ''), m.name, ' (', m.ip, ')')",
								'modems m LEFT JOIN domains d ON d.id=m.domain', 
								$filter);
							}
case 'modem_profile':		new Lookup('id', 'name', 'modem_profiles', array_merge($filter, array('hidden=0')));
case 'trouble':				if($oper->department){
								$filter['by_dep'] = "(c.department='".$oper->department."')";
							}
							if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('t.id', "CONCAT(IFNULL(t.code, t.id), '/' ,c.login, ': ', t.title)", 
								"troubles t
								INNER JOIN clients c ON c.id=t.client
								LEFT JOIN operators_cities oc ON oc.city=c.city AND oc.operator='$oper->id'",
								$filter,
								't.id');
case 'exp_material':		new Lookup('id', 'name', 'exp_materials', $filter);
case 'exp_material_cable':	new Lookup('id', 'name', 'exp_materials', array('name like "%"'));
case 'exp_material_u':		new Lookup('id', 'CONCAT(name, " (", case unit
								when 1 then "'.getResource('exp.materials.unit.1').'"
								when 2 then "'.getResource('exp.materials.unit.2').'"
								when 3 then "'.getResource('exp.materials.unit.3').'"
								when 4 then "'.getResource('exp.materials.unit.4').'"
								else "" end,")")', 'exp_materials', $filter);
case 'exp_executor':		new Lookup('id', 'name', 'exp_executors', $filter);
case 'exp_tool':			new Lookup('id', 'name', 'exp_tools', $filter);
case 'exp_task':			new Lookup('id', 'name', 'exp_tasks', $filter);
case 'exp_storage_place':	new Lookup('id', 'name', 'exp_storage_places', $filter);
case 'exp_point':			if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('p.id', 'CONCAT(s.name, " ", h.house, " '.getResource('exp.points.entrance.short').'", IFNULL(p.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case p.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(p.floor,"") end)',
							"exp_points p
							LEFT JOIN operators_cities oc ON oc.city=p.city AND oc.operator='$oper->id'
							LEFT JOIN houses h on h.id=p.house
							LEFT JOIN streets s ON s.id=h.street",
							$filter, 's.name, h.house + 0, p.entrance, p.floor');
case 'exp_house_point':			if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('p.id', 'CONCAT("'.getResource('exp.points.entrance.short').'", IFNULL(p.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case p.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(p.floor,"") end,
								", ", IFNULL(p.inv_number,""), " ", IFNULL(p.place,""))',
							"exp_points p
							LEFT JOIN operators_cities oc ON oc.city=p.city AND oc.operator='$oper->id'",
							$filter, 'p.entrance, p.floor');
case 'exp_trunk':			if($oper->city_mode){
								$filter['by_city'] = "(oc.city IS NOT NULL)";
							}
							new Lookup('et.id', 'CONCAT(bs.name, " ", bh.house, " '.getResource('exp.points.entrance.short').'", IFNULL(bp.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case bp.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(bp.floor,"") end, 
								" -> ",
								es.name, " ", eh.house, " '.getResource('exp.points.entrance.short').'", IFNULL(ep.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case ep.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(ep.floor,"") end)',
							"exp_trunks et
							LEFT JOIN operators_cities oc ON oc.city=et.city AND oc.operator='$oper->id'
							LEFT JOIN exp_points bp ON bp.id=et.begin_point
							LEFT JOIN houses bh ON bh.id=bp.house
							LEFT JOIN streets bs ON bs.id=bh.street
							LEFT JOIN exp_points ep ON ep.id=et.end_point
							LEFT JOIN houses eh ON eh.id=ep.house
							LEFT JOIN streets es ON es.id=eh.street",
							$filter, 'bs.name, bh.house + 0, bp.entrance, bp.floor, es.name, eh.house + 0, ep.entrance, ep.floor');
}
}
?>