<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.16 $
*/
include_once('includes/global.php');
include_once('functions/host.php');
include_once('classes/tools/PhpTemplate.php');
loadStrings(BOOT.'modems/strings.txt');

$doc->title .= ' :: '.getResource('modems.struct.title');

required_access('netstruct');ob_start();
?>

<script type="text/javascript" src="scripts/modems.js"></script>

<?
$kids = array();
$modems = array();
$root = array();
$bad = array();

$res = $db->Execute('SELECT m.id, m.ip, m.mac, m.name, s.name as street_name, m.house, m.entrance, m.floor, m.audit,
	m.modem, m.port,
	CONCAT(m.off_all DIV 3600 , " ", LPAD((m.off_all MOD 3600) DIV 60, 2, "0"), "") as off_all,
	CONCAT(m.off_month DIV 3600 , " ", LPAD((m.off_month MOD 3600) DIV 60, 2, "0"), "") as off_month,
	UNIX_TIMESTAMP(m.up_since) up_since, m.ip, m.firmware,
	IF(m.audit=0, 1, x.state) as state, x.id as state_id,
	IF(oc.city IS NULL, 0, 1) allow
	FROM modems m
	LEFT JOIN operators_cities oc ON oc.city=m.city AND oc.operator="'.$oper->id.'"
	LEFT JOIN modems_states x ON x.id=m.state_id
	LEFT JOIN streets s ON s.id=m.street ORDER BY m.name');
while($arr = $db->Next($res)){
	$modems[$arr['id']] = $arr;
	if($arr['modem']){
		$kids[$arr['modem']][$arr['id']] = 1;
	}else{
		$root[] = $arr['id'];
	}
}

function checkAccess($mid){
	global $modems, $kids;
	$allow = false;
	if(isset($kids[$mid])){
		foreach($kids[$mid] as $kid=>$x){
			if(checkAccess($kid)){
				$allow = true;
			}
		}
	}
	$allow |= $modems[$mid]['allow'];
	if(!$allow){
		$modem = $modems[$mid];
		unset($modems[$mid]);
		if($modem['modem']){
			unset($kids[$modem['modem']][$mid]);
		}
	}
	return $allow;
}

if($oper->city_mode){
	foreach($root as $i=>$rid){
		if(!checkAccess($rid)){
			unset($root[$i]);
		}
	}
}

function checkCircle($mid, &$check_errors, $trace=array()){
	global $modems;
	$modem = $modems[$mid];
	if(in_array($mid, $trace)){
		if(!isset($check_errors[$mid])){
			$pos = array_search($mid, $trace);
			$check_errors[$mid] = array_slice($trace, $pos);
		}
		return false;
	}
	if(!$modem['modem']){
		return true;
	}else{
		$trace[] = $modem['id'];
		return checkCircle($modem['modem'], $check_errors, $trace);
	}
}

$check_errors = array();
foreach($modems as $modem){
	checkCircle($modem['id'], $check_errors);
}
foreach($check_errors as $trace){
	echo "Cyclic error :";
	foreach($trace as $id){
		echo '<a href="modems.php?id='.$id.'">'.$modems[$id]['ip'].'</a> => ';
	}
	echo $modems[$trace[0]]['ip'].'<br>';
}
?>

<script type="text/javascript"><!--

var icons = {
	node		: 'img/modem.gif',
	nodeBad		: 'img/modem_bad.gif',
	empty		: 'img/empty.gif',
	line		: 'img/line.gif',
	join		: 'img/join.gif',
	joinBottom	: 'img/joinbottom.gif',
	plus		: 'img/plus.gif',
	plusBottom	: 'img/plusbottom.gif',
	minus		: 'img/minus.gif',
	minusBottom	: 'img/minusbottom.gif',
	nlPlus		: 'img/nolines_plus.gif',
	nlMinus		: 'img/nolines_minus.gif'
};

var mTree = new ModemTree('mTree', icons);

<?

function sortByPort($id1, $id2){
	global $modems;
//	return strcasecmp($modems[$id1]['name'], $modems[$id2]['name']);
	return $modems[$id1]['port'] - $modems[$id2]['port'];
}

function addModem($mid, $pid){
	global $modems, $kids;
	$modem = $modems[$mid];
	printf("mTree.add(new ModemNode(%s, %s, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', %s, '%s', '%s'));\n",
		$pid,
		$modem['id'],
		htmlspecialchars($modem['name'], ENT_QUOTES),
		$modem['ip'],
		htmlspecialchars($modem['street_name'], ENT_QUOTES),
		$modem['house'],
		$modem['entrance'],
		$modem['floor'],
		$modem['state'],
		$modem['port'],
		$modem['audit'],
		$modem['off_all'],
		$modem['off_month']);
	if(isset($kids[$mid])){
		uksort($kids[$mid], 'sortByPort');
		foreach($kids[$mid] as $id=>$x){
			addModem($id, $mid);
		}
	}
}

foreach($root as $rid){
	addModem($rid,-1);
}
?>

//-->
</script>

<div class="modems">
<table>
	<tr>
		<td class="indent"><a href="javascript:mTree.toggleAll()"><img src="img/base.gif" height=18 width=19></a></td>
		<td class="indent"><img src="img/empty.gif" height=18 width=18></td>
		<td class="name"></td>
		<td class="street"></td>
		<td class="entrance"></td>
		<td class="floor"></td>
		<td class="model">IP</td>
		<td class="off"></td>
		<td class="off">  </td>
		<td class="port"></td>
		<td class="toCatalog"></td>
	</tr>
</table><div class="kids"></div><script type="text/javascript"><!--
document.write(mTree.draw());

<?if($_GET['id']){?>
mTree.select(<?=$_GET['id']?>);
<?}else{
	foreach($modems as $modem){
		if($modem['state']=='0' && $modem['modem']){
			printf("mTree.openTo(%s);\n", $modem['modem']);
		}
	}
}?>

mTree.registerHighLight("Over");
//-->
</script>
</div>
<?
$doc->page->contents['a'] = ob_get_clean();
echo $doc->Paint();
?>