<?php
include_once('includes/global.php');
include_once('classes/period.php');
loadStrings(BOOT.'asterisk_calls/strings.txt');

$doc->title .= ' :: '.getResource('asterisk.calls.my.title');

required_access('my_calls');

class StatusCellRenderer {
	var $style_map = array('1'=>'green_lighted', '2'=>'red_lighted');
	function render($column, $record){
		return sprintf("<td class='%s' align='center'>%s</td>", $this->style_map[$record['status']], $record[$column->name]);
	}
}

$status_cell = new StatusCellRenderer();

class StatusCellRenderer2 {
	var $style_map = array('1'=>'green_lighted', '2'=>'red_lighted');
	function render($column, $record){
		return sprintf("<td class='%s' align='center'>%s</td>", $record['complete'] ? $this->style_map[$record['status']] : '', $record[$column->name]);
	}
}
$status_cell2 = new StatusCellRenderer2();


$period = new PPeriod($nil,BOOT.'stats_asterisk/period-form.php');
$period->commented = false;

$filters = array();
$filters['has_caller'] = 'c.caller > ""';
$filters['has_callie'] = 'c.callie > ""';
if($period->active){
	if($from = $period->getFrom()){
		$filters['from'] = sprintf("c.start >= '%s'", $from);
	}
	if($to = $period->getTo()){
		$filters['to'] = sprintf("c.start <= '%s'", $to);
	}
}

$person = loadRecord("SELECT * FROM staff WHERE id='".$oper->person."'");
$f = array();
if($person['sip_id'] > ''){
	$f['caller'] = 'c.caller="'.$person['sip_id'].'"';
	$f['callie'] = 'c.callie="'.$person['sip_id'].'"';
}
if($person['asterisk_agent'] > ''){
	$f['agent'] = 'c.dstchannel="'.$person['asterisk_agent'].'"';
}
if(!empty($f)){
	$filters['my'] = '('.implode(" || ", $f).')';
}else{	
	$filters['my'] = 'c.id < 0';
}

$stats_calls = new PTable($db,BOOT.'asterisk_calls/plain/table.php');
$stats_calls->filters = $filters;
$stats_calls->readonly = 1;
$doc->page->contents['stats_calls'] = new PMyAccess($stats_calls,array(
	'title'=>getResource('asterisk.calls.my.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/log.gif',
	'grid_boot'=>BOOT.'asterisk_calls/plain/grid.php',
	'tool'=>$period,
));
include 'includes/asterisk_under_call.php';
echo $doc->Paint();
?>
