<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.1 $
*/
include_once('includes/global.php');
include_once('functions/arp.php');
include_once('functions/dhcp.php');
include_once('functions/named.php');
loadStrings(BOOT.'networks/strings.txt');

$doc->title .= ' :: '.getResource('networks.title');

if(isset($_GET['get_domain_for'])){
	$ip = $_GET['get_domain_for'];
	if($net = getHostNetwork($ip, 1)){
		if($net['domain']){
			$domain = loadRecord("SELECT id, name FROM domains WHERE id=".$net['domain']);
			header("Content-Type: text/plain; charset=".$doc->charset);
			echo $domain['id']."|".$domain['name'];
		}
	}
	exit;
}


required_access('config');

function delete_network_file($name){
	$fileName = getDirOption('DNS_BACK_DIR');
	if($fileName){
		$fileName .= $name;
		if(is_file($fileName)){
			ob_start();
			unlink($fileName);
			$err = ob_get_contents();
			ob_end_clean();
			return $err;
		}
	}
}

function before_network_post($table){
	$table->error(ValidateIp($table->new_record['ip']));
	$safe = _Translit($table->new_record['filename']);
	$safe = str_replace(" ", "_", $safe);
	$safe = preg_replace("'[^0-9a-zA-Z_\-\.]'","", $safe);
	$table->new_record['filename'] = $safe;
	if($table->isChanged('filename')){
		$table->warning(delete_network_file($table->old_record['filename']));
	}
}

function before_network_delete($table){
	global $db;
	// nothing to check?
}

function after_network_post($table){
	if($table->isChanged('ip,filename,template,host_template')){
		$table->warning(RemakeNetwork($table->current_record['id']));
		$table->warning(RestartDNS());
		$table->warning(RemakeDHCP());
	}
	if($table->isChanged('ip,local')){
		$table->warning(RemakeARP());
	}
}

function after_network_delete($table){
	$table->warning(RemakeARP());
	$table->warning(delete_network_file($table->old_record['filename']));
}

$networks = new PTable($db,BOOT.'networks/table.php');
$networks->readonly = !$oper->system_access['config'];

$doc->page->contents['networks'] = new PMyAccess($networks,array(
	'title'=>getResource('networks.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/networks.gif',
	'grid_boot'=>BOOT.'networks/grid.php',
	'form_boot'=>BOOT.'networks/form.php',
));
echo $doc->Paint();
?>
