<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:16 $
$Revision: 1.13 $
*/
include_once('includes/global.php');
include_once('functions/accounts.php');
include_once 'classes/PravexImport.php';
include_once 'classes/PravexImport1.php';
include_once 'classes/PravexImport2.php';
include_once 'classes/PrivateImport.php';
include_once 'classes/DBFImport.php';
include_once 'classes/UkrComunImport.php';
include_once 'classes/CreditDnieperImport.php';
include_once('includes/lookups.php');
loadStrings(BOOT.'pays_import/strings.txt');

$doc->title .= ' :: '.getResource('pays.import.title');

if(!($oper->system_access['movements'] > 0)){
	$doc->page->contents['denied'] = getResource('access.denied');
	echo $doc->Paint();
	exit;
}
switch($_GET['lookup']){
	case 'client':	lookup('client_contract_account_address');
	case 'src':	lookup('system_src_account');
	case 'calendar_period':	lookup('calendar_period');
}

$doc->page->contents['pre'] = '
<style>
pre {padding:0; margin:0;}
</style>';

class ValidCellRenderer {
	function render($column, $record){
		$val = $record[$column->name];
		return sprintf("<td class='%s' align='center'>%s</td>", $val=='+' ? 'green_lighted' : 'red_lighted', $val=='+'?'+':'&ndash;');
	}
}
$valid_cell = new ValidCellRenderer();

class InfoCellRenderer {
	function render($column, $record){
		$val = $record[$column->name];
		return sprintf("<td width='40%%'><pre><code class='info'>%s</code></pre></td>", $val);
	}
}
$info_cell = new InfoCellRenderer();

function FormatPre($value){
	return "<pre>$value</pre>";
}

//$db->debug = 1;

class LoadForm extends PForm {

function getRedirector(){
	return _href_change(array('pimh_id'=>$this->hid));
}

function Process(){
	global $db, $oper, $import_head, $action_logger, $delegates;
	$class = $this->fields['format']->value;
	$delegate = $delegates[$class];
	$result = $delegate->process($_FILES['file']);
	$db->Begin();
	$db->Execute(sprintf("INSERT INTO stamps (created, created_by) VALUES (now(), %s)", $oper->id ? $oper->id : 'NULL'));
	$stamp = $db->getJustInserted('stamps', 'id');
	$db->Execute(sprintf("INSERT INTO pays_import_head (head, stamp) VALUES ('%s', %s)", addslashes($result['head']), $stamp));
	$hid = $db->getJustInserted('pays_import_head', 'id');
	foreach($result['items'] as $k=>$item){
		$query = sprintf("INSERT INTO pays_import (head, pos, src, dst, amount, info, valid, note, calendar_period, date) 
			VALUES (%s, %s, %s, %s, %s, '%s', %s,  '%s', '%s', '%s')",
			$hid,
			$item['num'],  $this->fields['src']->value, $item['account'] ? $item['account'] : 'null' , $item['sum'], addslashes($item['info']), $item['valid'] ? 1 : 0,
			addslashes($this->fields['format']->list[$this->fields['format']->value]."\n".$this->fields['note']->value),
			$this->fields['calendar_period']->value,
			$this->fields['date']->value);
		$db->Execute($query);
	}
	$this->hid = $hid;
	$action_logger->log_inserted('pays_import_head', $hid,
		array(
			'id'=>$hid,
			'head'=>$result['head'],
			'date'=>$this->fields['date']->value,
		)
	);
	$db->End();
}

}

function Upload($field,&$spool){
	return $_FILES[$field->name]['name'];
}

class ExecForm extends PForm {

function Process(){
	global $db, $oper, $import_head, $action_logger;
	$head = $import_head->active_record['id'];
	switch($this->fields['action']->value){
	case 'delete':
		$db->Execute(sprintf("DELETE FROM pays_import WHERE head='%s'", $head));
		break;
	case 'move':
		$db->Begin();
		$records = loadRecords(sprintf("SELECT * FROM pays_import WHERE valid=1 AND (dst IS NOT NULL) AND (src IS NOT NULL) AND head='%s' ORDER BY dst", $head));
		$count = 0;
		$sum = 0;
		foreach($records as $arr){
			$db->Execute(sprintf("INSERT INTO stamps (created, created_by) VALUES (now(), %s)", $oper->id ? $oper->id : 'NULL'));
			$stamp = $db->getJustInserted('stamps', 'id');
			$db->Execute(sprintf("INSERT INTO movements (calendar_period, src, dst, amount, date, note, stamp) 
				VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s')", 
				$arr['calendar_period'], $arr['src'], $arr['dst'], $arr['amount'], $arr['date'], addslashes($arr['note']), $stamp));
			$mov_id = $db->getJustInserted('movements', 'id');
			moveState($arr['calendar_period'], $arr['src'], $arr['dst'], $arr['amount']);
			$db->Execute(sprintf("DELETE FROM pays_import WHERE id='%s'", $arr['id']));
			$count++;
			$sum += $arr['amount'];
		}
		if($db->hasErrors()){
			$db->Rollback();
			return implode("<br>", $db->errors);
		}else{
			$db->Commit();
		}
		break;
	}
}

}

class BankClientAddressValidator {

function validate($row, $street, $house, $apartment){
	$street = preg_replace("|[\"'.,]|", "", $street);
	return stristr(_Translit($row['NAME_STRIT']), _Translit(get_longest_word($street))) && (strcasecmp(trim($row['N_HOUSE'].$row['A_HOUSE']), $house) == 0) && ($row['N_ROOM'] == $apartment);
}

}

$bankClientAddressValidator = new BankClientAddressValidator();

class MailClientAddressValidator {

function validate($row, $street, $house, $apartment){
	$letters = '';
	$l = $row['SYMBOL'];
	$let = $l > 0 ? $letters[$l - 1] : '';
	$street = preg_replace("|[\"'.,]|", "", $street);
	return stristr(_Translit($row['STREET']), _Translit(get_longest_word($street)))
		&& (strcasecmp(intval($row['HOUSE']).$let, $house) == 0)
		&& (intval($row['ROOM']) == ($apartment * 10));
}

}

$mailClientAddressValidator = new MailClientAddressValidator();

$bank_contract_finder = new ClientContractFinder('ABCOUNT', $bankClientAddressValidator);
$bank_code_finder = new TVAbonCodeFinder('ABCOUNT', $bankClientAddressValidator);
$bank_finder = new ClientComboFinder(array($bank_code_finder, $bank_contract_finder));

$mail_contract_finder = new ClientContractFinder('CLIENT', $mailClientAddressValidator);
$mail_code_finder = new TVAbonCodeFinder('CLIENT', $mailClientAddressValidator);
$mail_finder = new ClientComboFinder(array($mail_code_finder, $mail_contract_finder));

$delegates = array(
	'PravexImport1'=>new PravexImport1(),
	'PravexImport2'=>new PravexImport2(),
	'PrivateImport'=>new PrivateImport(),
	'CreditDnieper'=>new CreditDnieperImport(new ClientContractFinder('contract')),
	'sd_DBFImport_bank'=>new DBFImport($bank_finder, 'SUMM', array('ABCOUNT', 'SUMM', 'CODE_PLAT', 'PDATE', 'ADDR', 'FIO')),
	'sd_DBFImport_mail'=>new DBFImport($mail_finder, 'COST', array('CLIENT', 'COST', 'DATE', 'STREET', 'HOUSE', 'SYMBOL', 'ROOM', 'NAME')),
	'sd_PrivateImport'=>new PrivateImport(),
	'sd_DBFImport_private_tv'=>new DBFImport(new TVAbonCodeFinder('client'), 'cost', array('number', 'client', 'cost', 'date', 'name')),
	'sd_UKC'=>new UkrComunImport(new TVAbonCodeFinder('account_num'), new BorderSplitter('+', 7, 7)),
);

$import_head = new PTable($db,BOOT.'pays_import/head/table.php');
$import_head->readonly = !$oper->system_access['movements'];
$doc->page->contents['import_head'] = new PMyAccess($import_head,array(
	'title'=>getResource('pays.import.head.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/move_uses.gif',
	'grid_boot'=>BOOT.'pays_import/head/grid.php',
	'form_boot'=>BOOT.'pays_import/head/form.php',
));
if($doc->page->contents['import_head']->brief){
	$doc->page->contents['load'] = new LoadForm($nil, BOOT.'pays_import/head/load_form.php');
}

if($import_head->isOn()){
	$import = new PTable($db,BOOT.'pays_import/table.php');
	$import->readonly = !$oper->system_access['movements'];
	$doc->page->contents['import'] = new PMyAccess($import,array(
		'title'=>getResource('pays.import.title'),
		'icon'=>HREF.'images/dollar.gif',
		'icon_attributes'=>'width=29 height=42',
		'grid_boot'=>BOOT.'pays_import/grid.php',
		'form_boot'=>BOOT.'pays_import/form.php',
	));
	if($doc->page->contents['import']->brief){
		$doc->page->contents['exec'] = new ExecForm($nil, BOOT.'pays_import/exec_form.php');
	}
}
echo $doc->Paint();
?>
