<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 13:46:51 $
$Revision: 1.16 $
*/
include_once(dirname(__FILE__).'/../grid.php');
include_once(dirname(__FILE__).'/../pager.php');
include_once(dirname(__FILE__).'/table.php');

class PDBGrid extends PGrid {

var $pager;
var $id;
var $navigatable = 1;

function Create($table,$data){
	$force_pager = 0;
	$this->keys = array();
	if(!is_object($table)){
		$this->Error('Invalid table');
	}else{
		foreach($table->fields as $name=>$field){
			if($field->key){
				$this->keys[$name] = '';
			}
		}
	}
	parent::Create($table,$data);
	if($this->id && isset($_GET['id']) && !$this->keys[$this->id]){
		$this->keys[$this->id] = $_GET['id'];
		$_GET[$this->Pedigree($this->id)] = $_GET['id'];
		unset($_GET['id']);
		$force_pager = 1;
	}
	foreach($this->columns as $name=>$col){
		if($col->filterable){
			if(isset($col->filterlookup) && isset($this->owner->fields[$col->filterlookup])){
				$this->owner->fields[$col->filterlookup]->filter = $col->filter;
			}elseif(is_array($col->filterlist)){
				$this->owner->fields[$name]->filter = $col->filter;
			}elseif(is_array($col->list)){
				$this->owner->fields[$name]->filter = array_search($col->filter,$col->list);
			}else{
				$this->owner->fields[$name]->filter = $col->filter;
			}
		}
		if(!isset($col->title) && isset($this->owner->fields[$name]->title)){
			$col->title = $this->owner->fields[$name]->title;
		}
	}
	$this->owner->sort_by = $this->sort;
	$this->owner->sort_order = $this->order;
	for($i=0; $i < $this->aux_count; $i++){
		$aux = $this->auxes[$i];
		if($aux['name'] && $this->aux_filters[$aux['name']] && isset($this->owner->fields[$aux['name']]) && strlen($aux['value'])){
			$this->owner->filters['aux'.$i] = $this->owner->fields[$aux['name']]->getFilter($aux['value']);
		}
	}
	if(strlen(implode("", array_values($this->keys)))>0 ){
		$this->owner->Locate($this->keys);
	}
	$this->pager = new PPager($this,array('total'=>$this->owner->getCount()));
	if($force_pager){
		$this->pager->set_page( ceil($this->owner->getPosition()/$this->pager->per) );
		$_GET[$this->Pedigree('page')] = $this->pager->page;
	}
}

function DressRows(){
	$this->keys = $this->owner->getPointer();
	$this->pager->total = $this->owner->getCount();
	if($this->for_printing){
		$this->owner->Open();
	}else{
		$this->owner->OpenRange($this->pager->getFrom(),$this->pager->per);
	}
	$rc=1;
	while($arr = $this->owner->NextRow()){
		$active = 1;
		foreach($this->keys as $k=>$v){
			if($arr[$k]!=$v){
				$active = 0;
				break;
			}
		}
		$active = $active && $this->navigatable;
		$record = $arr;
		$class = $active?"grid_selected":"grid_row";
		$result .= "	<tr class=\"$class\"";
		$result .= $this->RenderHint($record);
		if($this->navigatable && !$this->for_printing){
			$result .=' id="'.$this->Pedigree($rc).'" '.
			'onmouseover="change_class(\''.$this->Pedigree($rc).'\',\''.$class.'_shine\')" '.
			'onmouseout="change_class(\''.$this->Pedigree($rc).'\',\''.$class.'\')" '.
			'onclick="window.location=\''.$this->getNavigator($record).'\'"';
		}
		$result .=">\n";
		foreach($this->columns as $name=>$col){
			if($col->inMode($this->mode)){
				$result .= $this->columns[$name]->DressValue($record);
			}
		}
		$result .= "	</tr>\n";
		$rc++;
	}
	return $result;
}

function Dress(){
	$result = parent::Dress();
	if(!$this->for_printing){
		$result .= ($this->pager->total>$this->pager->per_page_array[0]?$this->pager->Draw():"");
	}
	return $result;
}

function DressFooters(){
	foreach($this->columns as $name=>$col){
		if(isset($this->owner->fields[$name]->aggregate)){
			$this->columns[$name]->footer = $this->owner->getAggregate($name);
		}
		if(isset($col->count)){
			$this->columns[$name]->footer = $this->owner->getCount();
		}
	}
	return parent::DressFooters();
}

function Draw(){
	foreach($this->columns as $name=>$col){
		if(isset($col->filterlookup) && isset($this->owner->fields[$col->filterlookup])){
			$this->columns[$name]->filterlist = $this->owner->fields[$name]->getCandidates();
		}
		if(isset($this->owner->fields[$name]->aggregate) || isset($col->count)){
			$this->columns[$name]->footer = '';
		}
	}
	return parent::Draw();
}

}


?>