<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:09:09 $
$Revision: 1.7 $
*/
include_once(dirname(__FILE__).'/db.php');

class PMySql extends PDB {

var $errors = array();

function Connect($host,$user,$pass,$db){
	if($this->link = mysqli_connect($host,$user,$pass,$db)){
		return $this->link;
	}else{
		$this->Error("Can't connect to $host as $user: ".mysqli_error());
		return false;
	}
}

function LimitQuery($query,$from,$count){
	return "$query LIMIT $from,$count";
}

function Binarize($str){
	return "IFNULL($str,'')";
}

function Execute($sql){
	if($this->link){
		if($this->debug){
			echo htmlspecialchars($sql).";<br>\n";
			if($this->debug > 1){
				if($fd=fopen("/var/log/pe6yc-db.log", "a")){
					fputs($fd, $sql."\n");
					fclose($fd);
				}
			}
		}
		$start = microtime(true);
		$res = mysqli_query($this->link, $sql);
		$end = microtime(true);
		$this->exec_time = $end - $start;
		if($this->debug){
			echo "-- ".round($this->exec_time, 3)." s<br><br>\n";
		}
		$this->last_error = mysqli_error($this->link);
		if($this->last_error){
			$ex = new Exception();
			
			$this->errors[] = $this->last_error;
			if($this->debug){
				echo $this->last_error.';<br><br>';
				if($this->debug > 1){
				}
			}
					if($fd=fopen("/var/log/pe6yc-db.log", "a")){
						fputs($fd, date("Y-m-d H:i:s")." ".$_SERVER['PHP_SELF']." ".$sql."\n");
						fputs($fd, "                    ".$this->last_error."\n");
						fputs($fd, "                    ".str_replace("\n", "\n                    ", $ex->getTraceAsString())."\n");
						fclose($fd);
					}
		}
		if($res){
			$this->affected_rows = mysqli_affected_rows($this->link);
			$this->insert_id = mysqli_insert_id($this->link);
		}
	}else{
		$this->Error("No connection");
	}
	return $res;
}

function hasErrors(){
	return count($this->errors) > 0;
}

function Begin(){
	$this->errors = array();
	$this->Execute("BEGIN");
}

function Commit(){
	$this->Execute("COMMIT");
}

function Rollback(){
	$this->Execute("ROLLBACK");
}

function End(){
	if($this->hasErrors()){
		$this->Rollback();
		return false;
	}else{
		$this->Commit();
		return true;
	}
}

function NumRows($res){
	return mysqli_num_rows($res);
}

function Next($res){
	return mysqli_fetch_assoc($res);
}

function NextObj($res){
	return mysqli_fetch_object($res);
}

function getJustInserted($table,$field){
	$arr = mysqli_fetch_assoc(mysqli_query($this->link, "SELECT LAST_INSERT_ID() as id"));
	return $arr['id'];
}

function Safe($str){
	return mysqli_escape_string($this->link, $str);
}

}
?>