<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/08/04 07:53:23 $
$Revision: 1.14 $
*/
include_once(dirname(__FILE__).'/permanent.php');

class PFormField extends PTransformer {
	var $name;

	function Dress(){
		$result = '';
		if($this->type=='hidden'){
			$result .= "		<input type=\"hidden\" name=\"".$this->name."\" value=\"".$this->Safe($this->value)."\" ".($this->id ? " id=\"".$this->id."\"" : "")."/>\n";
		}else{
			$result .= "	<tr class=\"form_field_row\">\n";
			if($this->owner->labeled){
				$result .= "		<td class=\"form_field_label".(($this->required || $this->required_by)?" form_field_label_required":"")."\">";
				if($this->link){
					$result .= "<a href=\"".$this->link."\">".$this->title."</a>";
				}else{
					$result .= $this->title;
				}
				$result .= "</td>\n";
			}
			$result .= "		<td class=\"form_field_value".($this->readonly?"_ro":"")."\">";
			$func = 'Dress_'.($this->control?$this->control:'text');
			$result .= $this->$func();
			$result .= "</td>\n";
			if($this->owner->commented){
				$comment = isset($this->comment_func) && function_exists($this->comment_func) ? call_user_func($this->comment_func) : $this->comment;
				$result .= "		<td class=\"form_field_comment\">".$comment."</td>\n";
			}
			$result .= "	</tr>\n";
		}
		return $result;
	}

	function Dress_format(){
		$val = $this->value;
		if($func = $this->format){
			if(method_exists($this,$func)){
				$val = $this->$func($val, $this->owner->getData());
			}else{
				$val = $func($val, $this->owner->getData(), $this);
			}
		}
		return $val;
	}

	function get_required_attr(){
		if($this->required){
			return 'required="1"';
		}
		if($this->required_by){
			return 'required_by="'.$this->required_by.'" required_if="'.$this->required_if.'" ';
		}
		return "";
	}

	function Dress_lookup(){
		static $lookUpCount;
		$rec = $this->owner->owner->active_record;
		$replace = array();
		if(is_array($rec))
		{
			foreach($rec as $k=>$v){
				$replace['['.$k.']'] = $v;
			}
		}
		
		$label = str_replace(array_keys($replace), $replace, $this->label);
		$this->source = str_replace(array_keys($replace), $replace, $this->source);
		//$label = $this->owner->owner->active_record[$this->label];
		if($this->readonly){
			return !empty($rec) ? $this->Safe($label) : '';
		}else{
			$lookUpCount++;
			$id = isset($this->id) ? $this->id : 'lookup'.$lookUpCount;
			$result = '';
			$result .= "<input type=\"hidden\" name=\"".$this->name."\" value=\"".$this->value."\" id=\"hidden-$id\" ".$this->get_required_attr()." title=\"".$this->title."\"/>\n";
			$result .= "<table cellspacing=0 class=\"selectControl\">\n";
			$result .= "<tr>\n";
			$result .= "<td class=\"selectView\" id=\"present-$id\">".$this->Safe($this->value ? $label : getResource("pe6yc.form.select.prompt"))."</td>\n";
			$result .= "<td class=\"selectFilter\"><input id=\"filter-$id\" title=\"".getResource('pe6yc.form.select.filter')."\"></td>\n";
			$result .= "<td class=\"selectButton\"><img src=\"images/combo_select.gif\" id=\"show-$id\"></td>\n";
			$result .= "</tr>\n";
			$result .= "</table>\n";
			$result .= "<iframe class=\"selectFrame\" id=\"list-$id\" ".($this->frame_width ? "style=\"width:".$this->frame_width." \"" : "")."></iframe>\n";
			$result .= "<script>\n";
			$result .= "var $id = new IframeSelect(\"hidden-$id\", \"present-$id\", \"show-$id\", \"filter-$id\", \"list-$id\", \"".$this->source."&target=$id\", ".($this->readonly ? 1 : 0).");\n";
			if(isset($this->default)){
				$result .= "$id.loadFirst();\n";
			}
			$result .= "</script>\n";
			return $result;
		}
	}

	function Dress_select(){
		if(isset($this->list) && !is_array($this->list)){
			if(function_exists($this->list)){
				$this->list = call_user_func($this->list);
			}else{
				$this->list = array('error');
			}
		}
		if($this->readonly){
			return $this->Safe($this->list[$this->value]);
		}else{
			$prompt = sprintf(getResource("pe6yc.form.select.prompt"), count($this->list));
			$result = "<span style=\"white-space: nowrap;\">";
			$result .= "<select class=\"form_select".($this->skip_finder ? '_wide': '')."\" name=\"".$this->name."\" ".$this->get_required_attr()." title=\"".$this->title."\">\n";
			$result .= "			<option value=\"\">$prompt</option>\n";
			foreach($this->list as $k=>$v){
				$result .= "			<option value=\"$k\" ".($k==$this->value?"SELECTED":"").">$v</option>\n";
			}
			$result .= "			</select>";
			if(!$this->skip_finder){
				$result .= "			<input name=\"".$this->name."_filter\" disabled=1 class=\"form_select_filter\" onkeyup=\"filter_select(this, '".$this->name."')\">";
			}
			$result .= "</span>";
			if(!$this->skip_finder){
				$result .= "<script type=\"text/javascript\">\n";
				$result .= "setTimeout('prepare_filter_select(\"".$this->owner->pedi_name."\", \"".$this->name."\")', 1)";
				$result .= "</script>";
			}
			return $result;
		}
	}

	function Dress_radio(){
		if($this->readonly){
			return $this->Safe($this->list[$this->value]);
		}else{
//			if($this->table){
				$table = "<table>";
				if($this->inline){
					$table .= "<tr>";
				}
				foreach($this->list as $k=>$v){
					if(!$this->inline){
						$table .= "<tr>";
					}
					$table .= "<td><input id=\"".$this->name."_$k\" class=\"form_radio\" type=\"radio\" name='".$this->name."' value=\"$k\" ".($k==$this->value?"CHECKED":"")."></td><td><label for=\"".$this->name."_$k\">$v</label></td>";
					if(!$this->inline){
						$table .= "</tr>";
					}
				}
				if($this->inline){
					$table .= "</tr>";
				}
				$table .= "</table>";
				return $table;
/*			}else{
				$items = array();
				foreach($this->list as $k=>$v){
					$items[] = "<input id=\"".$this->name."_$k\" class=\"form_radio\" type=\"radio\" name='".$this->name."' value=\"$k\" ".($k==$this->value?"CHECKED":"")."><label for=\"".$this->name."_$k\">$v</label>";
				}
				if($this->inline){
					return implode(" ", $items);
				}else{
					return implode("<br>", $items);
				}
			}
*/
		}
	}

	function Dress_textarea(){
		if($this->readonly){
			return "<pre><code>".$this->Safe($this->value)."</code></pre>";
		}else{
			return "<textarea ".($this->height?" rows=\"".$this->height."\"":"")." ".($this->width?"cols=\"".$this->width."\"":"class=\"form_textarea\"")." ".($this->nowrap?"WRAP=\"off\"":"WRAP=\"VIRTUAL\"")." name=\"".$this->name."\" ".$this->get_required_attr()." title=\"".$this->title."\">".$this->Safe($this->value)."</textarea>";
		}
	}

	function Dress_editor(){
		if($this->readonly){
			return nl2br($this->Safe($this->value));
		}else{
			return "<textarea ".($this->height?" rows=\"".$this->height."\"":"")." ".($this->width?" style=\"width:".$this->width.";\"":"")." WRAP=\"off\" name=\"".$this->name."\" ".$this->get_required_attr()." title=\"".$this->title."\">".$this->Safe($this->value)."</textarea>";
		}
	}

	function Dress_checkbox(){
		if($this->readonly){
			return $this->value?"&times;":"";
		}else{
			$result = "<input type=\"checkbox\" class=\"form_checkbox\" name=\"".$this->name."\" id=\"".$this->name."\" ".($this->value?"CHECKED":"")." value=1>";
			if($this->label){
				$result .= "<label for=\"".$this->name."\">".$this->label."</label>";
			}
			return $result;
		}
	}

	function Dress_password(){
		if($this->readonly){
			return "********";
		}else{
			$result = "<input type=\"password\" class=\"form_text\" name=\"".$this->name."\" value=\"".$this->Safe($this->value)."\" ".$this->get_required_attr()." title=\"".$this->title."\">";
			if($this->with_confirm){
				$result .= "<br><input type=\"password\" class=\"form_text\" name=\"".$this->name."_confirm\" value=\"".$this->Safe($this->value)."\" ".$this->get_required_attr()." title=\"\">";
			}
			return $result;
		}
	}

	function Dress_file(){
		if(!$this->readonly){
			$result = "<input type=\"file\" ".($this->size ? " size=\"".$this->size."\"" : '')." name=\"".$this->name."\" ".$this->get_required_attr()." title=\"".$this->title."\">";
			if($this->value){
				$result .= "\n		".$this->Safe($this->value);
			}
			return $result;
		}
	}

	function Dress_bitset(){
		if($this->readonly){
			return $this->Safe($this->list[$this->value]);
		}else{
			$result = '';
			foreach($this->list as $k=>$v){
				$result .= "<input id=\"".$this->name."_$k\" class=\"form_checkbox\" type=\"checkbox\" name=\"".$this->name."[$k]\" value=1 ".(($k & $this->value)?"CHECKED":"").">";
				$result .= "<label for=\"".$this->name."_$k\">$v</label>";
				if(!$this->inline){
					$result .= "<br>";
				}else{
					$result .= "&nbsp;";
				}
			}
			return $result;
		}
	}

	function Dress_date(){
		if($this->readonly){
			return $this->Safe($this->value);
		}else{
			$result = '';
			$time = substr($this->value,11,5);
			$day = substr($this->value,8,2);
			$month = substr($this->value,5,2);
			$year = substr($this->value,0,4);
			$result .= "		<input type=\"hidden\" ".$this->get_required_attr()." title=\"".$this->title."\" required_date=\"".$this->name."\">";
			$result .= "		<input maxlength=4 size=4 name=\"".$this->name."[year]\" value=\"$year\"/>";
			$result .= "		<select  name=\"".$this->name."[month]\">\n";
			$result .= "		<option  value=\"\"></option>\n";
			for($i=1;$i<13;$i++){
				$result .= "		<option value=\"$i\" ".($i==$month?"SELECTED":"").">".strftime("%B",mktime(0,0,0,$i,1,date("Y")))."</option>\n";
			}
			$result .= "		</select>\n";
			if(!$this->set_day){
				$result .= "<input maxlength=2 size=2 name=\"".$this->name."[day]\" value=\"$day\"/>\n";
			}
			if($this->with_time){
				$result .= "<input maxlength=5 size=5 name=\"".$this->name."[time]\" value=\"$time\"/>\n		";
			}
			$result .= "<button type=\"button\" onclick=\"setCurrentDate('".$this->owner->pedi_name."', '".$this->name."')\">&laquo;</button>";
			$result .= "<button type=\"button\" onclick=\"clearDate('".$this->owner->pedi_name."', '".$this->name."')\">&times;</button>";
			return $result;
		}
	}

	function Dress_text(){
		$val = isset($this->format) ? $this->format->toString($this->value) : $this->value;
		if($this->readonly==1){
			return $this->raw ? $val : $this->Safe($val);
		}else{
			return "<input ".$this->extension." class=\"form_text\" name=\"".$this->name."\" value=\"".$this->Safe($val)."\" ".($this->readonly ? "readonly" : "")." ".$this->get_required_attr()." positive=\"".$this->positive."\" email=\"".$this->email."\" title=\"".$this->title."\">";
		}
	}

	function Dress_short(){
		$val = isset($this->format) ? $this->format->toString($this->value) : $this->value;
		if($this->readonly==1){
			return $this->Safe($val);
		}else{
			return "<input ".$this->extension." class=\"form_short\" name=\"".$this->name."\" value=\"".$this->Safe($val)."\" ".($this->readonly ? "readonly" : "")." ".$this->get_required_attr()." positive=\"".$this->positive."\" title=\"".$this->title."\">";
		}
	}

	function Retrive(&$arr){
		$func=$this->retriving;
		if(function_exists($func)){
				$this->value = $func($this,$arr);
		}else{
			switch($this->control){
				case 'password':
					if($this->with_confirm && ($arr[$this->name]!=$arr[$this->name.'_confirm']) ){
						return getResource('pe6yc.form.error.password.mismatch');
					}else{
						$this->value = $arr[$this->name];
					}
					break;
				case 'checkbox':
					$this->value = isset($arr[$this->name]) ? 1 : 0;
					break;
				case 'bitset':
					$this->value = 0;
					if(is_array($arr[$this->name])){
						foreach($arr[$this->name] as $k=>$v){
							$this->value += $k;
						}
					}
					break;
				case 'editor':
					$this->value = str_replace("\r","",$arr[$this->name]);
					break;
				case 'date':
					if($arr[$this->name]['year']){
						$day = _ValidDay($this->set_day ? $this->set_day : $arr[$this->name]['day']);
						$this->value = _ValidYear($arr[$this->name]['year']).'-'._ValidMonth($arr[$this->name]['month']).'-'.$day;
						$time = '';
						if($this->with_time){
							$time = ' '._ValidTime($arr[$this->name]['time']);
						}
						if($this->set_time){
							$time = ' '._ValidTime($this->set_time);
						}
						$this->value .= $time;
					}else{
						$this->value = '';
					}
					break;
				case 'format':
					$this->value = $arr[$this->name];
					break;
				default:
					$this->value = $arr[$this->name];
					if(strlen($this->value)){
						if($this->float){
							$this->value = _Float($this->value);
						}
					}
					if(isset($this->format)){
						$this->value = $this->format->fromString($this->value);
					}
					break;
			}
		}
		if($this->positive && ($this->value<0)){
			return sprintf(getResource('pe6yc.form.error.negative'), $this->title);
		}
		if($this->required && !$this->value){
			return sprintf(getResource('pe6yc.form.error.required'), $this->title);
		}
	}
}

class PFormSubmit extends PBoot {
	var $css = 'form_submit';
	var $style;

	function Dress(){
		$css = $this->css ? " class=\"".$this->css."\" " : "";
		$style = $this->style ? " style=\"".$this->style."\" " : "";
		return "	<input $css $style type=\"submit\" name=\"".$this->name."\" value=\"".$this->title."\" onclick=\"form.submiter.value='".$this->name."';".$this->Pedigree('validator')."='".$this->validator."';".$this->onclick."\">\n";
	}
}

class PForm extends PPermanent {

	var $collections = array(
		'fields'=>'PFormField',
		'submits'=>'PFormSubmit',
	);

	var $method="post";
	var $clean_post=1;
	var $labeled = 0;
	var $commented = 1;
	var $fields=array();
	var $submits=array();
	var $submiter;
	var $anchor = false;

	function Create($owner,$data){
		$this->script = PE6YC_SCRIPTS.'form.php';
		parent::Create($owner,$data);
		$this->Retrive();
	}

	function Dress(){
		$result = "";
		if($this->anchor){
			$result .= "<a name=\"$this->pedi_name\"></a>\n";
		}
		$enctype='';
		foreach($this->fields as $field){
			if($field->control=='file'){
				$enctype = "enctype=\"multipart/form-data\"";
			}
			if($field->title){
				$this->labeled = 1;
			}
		}
		$result .= "<form novalidate=\"1\" method=\"".$this->method."\" name=\"".$this->pedi_name."\" action=\"".$this->Safe($this->action)."#".$this->getAnchor()."\" $enctype onsubmit=\"return ValidateForm('".$this->pedi_name."',".$this->Pedigree('validator').")\">\n";
		$result .= "	<input type=\"hidden\" name=\"".$this->Pedigree('omen')."\" value=1>\n";
		$first = reset($this->submits);
		$result .= "	<input type=\"hidden\" name=\"submiter\" value=\"".$first->name."\">\n";
		$result .= "<table class=\"form\" cellpadding=0 cellspacing=0 width=\"100%\">\n";
		$result .= "<tbody id=\"".$this->pedi_name."_form\">\n";
		if($this->error){
			$result .= "	<tr>\n";
			$result .= "		<td colspan=3 class=\"form_error\">".$this->error."</td>\n";
			$result .= "	</tr>\n";
		}
		$result .= $this->DressFields();
		if(count($this->submits)){
			$result .= "	<tr class=\"form_button_row\">\n";
			if($this->labeled){
				$result .= "		<td></td>\n";
			}
			$result .= "		<td nowrap>";
			$result .= $this->DressSubmits();
			$result .= "</td>\n";
			if($this->commented){
				$result .= "		<td></td>\n";
			}
			$result .= "	</tr>\n";
		}

		$result .= "</tbody>\n";
		$result .= "</table>\n";
		$result .= "</form>\n";
		return $result;
	}

	function DressSubmits(){
		$result = '';
		foreach($this->submits as $name=>$submit){
			if(!$result){
				$result .= "	<script type=\"text/javascript\">\n";
				$result .= "	".$this->Pedigree('validator')."='".$submit->validator."';\n";
				$result .= "	</script>\n";
			}
			$result .=  $this->submits[$name]->Dress();
		}
		return $result;
	}

	function DressFields(){
		$result = '';
		foreach($this->fields as $name=>$field){
			$result .= $this->fields[$name]->Dress();
		}
		return $result;
	}

	function getRedirector(){
		return $_SERVER['REQUEST_URI'];
	}

	function getData(){
		$data = array();
		foreach($this->fields as $name=>$field){
			if(!$field->readonly){
				$data[$name] = $field->value;
			}
		}
		return $data;
	}

	function RetriveSubmiter(){
		foreach($this->submits as $name=>$submit){
			if($this->spool[$name]){
				$this->submiter = $name;
				break;
			}
		}
		if(!$this->submiter){
			$this->submiter = $this->spool['submiter'];
		}
	}

	function RetriveFields(){
		foreach($this->fields as $key=>$val){
			$this->error = $this->fields[$key]->Retrive($this->spool);
			if($this->error){
				break;
			}
		}
	}

	function Retrive(){
		$this->spool = deep_unslash((stristr($this->method,'post')) ? $_POST : $_GET);
		if($this->spool[$this->Pedigree('omen')]){
			$this->RetriveSubmiter();
			$this->RetriveFields();
			if(!$this->error){
				$this->error = $this->Notify('BeforeProcess');
				if(!$this->error){
					$this->error = $this->Process();
					$this->Notify('AfterProcess');
				}
			}
			if(!$this->error && stristr($this->method,'post') && $this->clean_post){
				ob_end_clean();
				$this->StorePermanents();
				header("Location:".$this->getRedirector());
				exit;
			}
		}
	}

	function Process(){
	}

}

?>