<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/08/04 07:53:23 $
$Revision: 1.25 $
*/
include_once(dirname(__FILE__).'/permanent.php');

class PColumn extends PPermanent {
	var $name;
	var $filter;
	var $listen = array('filter');
	var $modes;
	var $filterable=1;

	function set_name($val){
		$this->name = $val;
		$this->nick = $this->name;
	}

	function BuildLink($record){
		if($this->navigator){
			return $this->owner->getNavigator($record);
		}else{
			if(function_exists($this->link)){
				$func = $this->link; 
				return $func($record);
			}else{
				return $this->owner->RenderByRecord($this->link, $record);
			}
		}
	}

	function set_modes($modes){
		if(is_array($modes)){
			$this->modes = $modes;
		}else{
			$this->modes = explode(",", $modes);
		}
	}
	
	function inMode($mode){
		return !isset($this->modes) || in_array($mode, $this->modes);
	}
	
	function Format($val,$record=array()){
		if($func = $this->format){
			if(method_exists($this,$func)){
				$val = $this->$func($val,$record);
			}else{
				$val = $func($val,$record);
			}
		}
		return $val;
	}

	function nl2br($val){
		return nl2br($val);
	}

	function pre($val){
		return "<pre>".$val."</pre>";
	}

	function format_lookup($val){
		return $this->list[$val];
	}

	function DressHead(){
		$sort_href = $this->owner->sort_href.$this->name.'&'.$this->owner->Pedigree('order').'=';
		$sorted = '';
		if($this->owner->sort==$this->name){
			$sorted = $this->owner->order;
			if($sorted=='asc'){
				$sort_href .= 'desc';
				$sort_char = '+';
			}else{
				$sort_href .= 'asc';
				$sort_char = '&ndash;';
			}
		}else{
			if(isset($this->order)){
				$sort_href .= $this->order;
			}else{
				$sort_href .= 'asc';
			}
		}
		$sort_href = $this->Safe($sort_href);
		$sort_href .= '#'.$this->owner->getAnchor();
		$result .= "		<td";
		$id = $this->Pedigree('');
		if(!$this->owner->for_printing){
			$result .= " id=\"".$id."\"";
			if($this->comment){
				$result .= " title=\"".$this->comment."\" ";
			}
		}
		if($this->align){
			$result .= " align=\"".$this->align."\" ";
		}
		if($this->width){
			$result .= " style=\"width:".$this->width."\"";
		}
		if($this->title && !$this->owner->for_printing){
			$result .= ' onmouseover="change_class(\''.$id.'\',\'grid_header_shine\')" '.
			'onmouseout="change_class(\''.$id.'\',\'grid_header\')" '.
			'onclick="window.location=\''.$sort_href.'\'"';
		}
		if($sorted){
			$result .= " sorted=\"".$sorted."\" ";
		}
		$result .= ">";
		$title = $this->title.$sort_char;
		if(!$this->owner->for_printing){
			$title = "<a class=\"sort\"  href=\"".$sort_href."\">".$title."</a>";
		}
		$result .= $title;
		$result .= "</td>\n";
		return $result;
	}

	function DressFoot(){
		if(isset($this->footer)){
			$this->footer = $this->Format($this->footer);
		}
		$result = "		<td";
		if($this->align){
			$result .= " align=\"".$this->align."\"";
		}
		$result .= ">";
		$result .= $this->footer_prefix.$this->footer;
		$result .= "</td>\n";
		return $result;
	}

	function DressFilter(){
		$result = "		<td";
		if($this->align){
			$result .= " align=\"".$this->align."\"";
		}
		if($this->width){
			$result .= " style=\"width:".$this->width."\"";
		}
		$result .= ">";
		if($this->filterable){
			if(is_array($this->filterlist)){
				$result .= "<select class=\"wide\" name=\"".$this->Pedigree('filter')."\" value=\"".$this->filter."\" onchange=\"FilterSubmit(event,form)\">\n";
				$result .= "		<option value=\"\">";
				foreach($this->filterlist as $k=>$v){
					$result .= "		<option value=\"$k\"".("$this->filter"=="$k"?" SELECTED":"").">".$this->Safe($v)."</option>\n";
				}
				$result .= "		</select>";
			}else{
				$result .= "<input title=\"".getResource('pe6yc.grid.filter.hint')."\"  name=\"".$this->Pedigree('filter')."\" value=\"".$this->Safe($this->filter)."\" onkeydown=\"FilterSubmit(event,form)\">";
			}
		}
		$result .= "</td>\n";
		return $result;
	}

	function DressHiddenFilter(){
		return "<input type=\"hidden\" name=\"".$this->Pedigree('filter')."\" value=\"".$this->Safe($this->filter)."\">";
	}
	
	function DressValue($record){
		if(isset($this->cell_renderer)){
			return $this->cell_renderer->render($this, $record);
		}else{
			$value = $record[$this->name];
			if($this->list){
				$value = $this->list[$value];
			}
			$value = $this->Format($value,$record);
			$result .= "		<td";
			if($this->align){
				$result .= " align=\"".$this->align."\"";
			}
			if(is_array($this->cell_attributes)){
				foreach($this->cell_attributes as $k=>$v){
					$result .= " $k=\"$v\"";
				}
			}
			if($this->hint){
				$hint = $this->owner->RenderByRecord($this->hint, $record);
				if($this->hint_format && function_exists($this->hint_format)){
					$hint = $this->Call($this->hint_format, $hint);
				}
				$result .= " title=\"$hint\"";
			}
			$result .= ">";
			if(!$this->owner->for_printing && $link=$this->BuildLink($record)){
				
				$result .= "<a class=\"".(!$this->navigator?'cross':'nav')."\" href=\"$link\">".$value."</a>";
			}else{
				$result .= $value;
			}
			$result .= "</td>\n";
			return $result;
		}
	}
}

class PGrid extends PPermanent {

	var $listen = array('keys','sort','order', 'mode');
	var $collections = array('columns'=>'PColumn');
	var $permanents = array('sort','order','mode');

	var $for_printing = 0;
	var $width = '100%';
	var $columns = array();
	var $keys = array();
	var $recordset = array();
	var $sort;
	var $order;
	var $aux_count = 1;
	var $auxes = array();
	var $draw_headers=1;
	var $column_sort=1;
	var $anchor = false;
	var $modes = array();
	var $mode;
	//var $filter;

	function Create($owner,$data){
		$this->script = PE6YC_SCRIPTS.'grid.php';
		parent::Create($owner,$data);
		if(!empty($this->modes) && !isset($this->modes[$this->mode])){
			reset($this->modes);
			$this->mode = key($this->modes);
		}
	}

	function GetListen(){
		parent::GetListen();
		for($i=0; $i < $this->aux_count; $i++){
			$aux = array('name'=>'', 'value'=>'');
			$ref = $this->Pedigree('aux_name'.$i);
			if(isset($_GET[$ref])){
				$aux['name'] = unslash($_GET[$ref]);
				if(strlen($_GET[$ref])==0){
					unset($_GET[$ref]);
				}
			}
			$ref = $this->Pedigree('aux_value'.$i);
			if(isset($_GET[$ref])){
				$aux['value'] = unslash($_GET[$ref]);
				if(strlen($_GET[$ref])==0){
					unset($_GET[$ref]);
				}
			}
			$this->auxes[$i] = $aux;
		}
	}
	
	function getNavigator($record){
		return $this->Safe($_SERVER['PHP_SELF'].'?'._get_params($this->PediValues(array_keys($this->keys))).implode("&",_Pair($this->PediArray(_Load($this->keys,$record))))).'#'.$this->getAnchor();
	}

	function Dress(){
		$this->sort_href = _URI(array($this->Pedigree('sort'), $this->Pedigree('order'))).$this->Pedigree('sort').'=';
		$result = "";
		if($this->anchor){
			$result .= "<a name=\"$this->pedi_name\"></a>\n";
		}
		$result .= "<form name=\"g_$this->pedi_name\" method=\"get\" action=\"".$this->Safe($_SERVER['PHP_SELF'])."#".$this->getAnchor()."\">\n";
		$menu = "";
		$modes = "";
		if(!$this->for_printing){
			if(is_array($this->menu)){
				$menu = $this->DressMenu();
			}
			$modes = $this->DressModes();
		}
		if($menu || $modes){
			$result .= sprintf("<table width=\"100%%\"><tr><td>%s</td><td align=right>%s</td></tr></table>", $menu, $modes);
		}
		$result .= "<table class=\"grid\" cellpadding=0 cellspacing=0 style=\"width:".$this->width."\">\n";
		$body = "";
		if($this->draw_headers){
			$body .= $this->DressHeaders();
		}
		$body .= $this->DressRows();
		$foots = 0;$this->filters_count=0;
		foreach($this->columns as $name=>$col){
			if(isset($this->columns[$name]->footer)){
				$foots++;
			}
			if($col->filterable){
				$this->filters_count++;
			}
		}
		if($foots){
			$body .= $this->DressFooters();
		}
		if(!$this->for_printing){
			$body = "<tbody id=\"".$this->pedi_name."_grid\" name=\"$this->title\">\n".$body."\n</tbody>\n";
		}
		$result .= $body;
		$this->filters_params = deep_unslash($_GET);
		$this->hidden_filters = "";
		if(!$this->for_printing && ($this->filters_count || count($this->aux_filters))){
			$result .= $this->DressFilters();
		}
		$result .= "</table>\n";
		foreach($this->filters_params as $k=>$v){
			$result .= "	<input type=\"hidden\" name=\"$k\" value=\"$v\">\n";
		}
		$result .= $this->hidden_filters;
		$result .= "</form>\n";
		return $result;
	}

	function DressMenu(){
		$result = '';
		foreach($this->menu as $k=>$v){
			if($result){
				$result .= ' &middot; ';
			}
			$result .= "<a class=\"tool\" href=\"Javascript:$k('".$this->pedi_name."')\">$v</a>\n";
		}
		return $result;
	}

	function DressModes(){
		if(count($this->modes) > 0){
			$result = '';
			$result .= sprintf('<select name="%s" onchange="FilterSubmit(event,form)">', $this->Safe($this->Pedigree('mode')));
			foreach($this->modes as $name=>$title){
				$result .= sprintf('<option value="%s"', $this->Safe($name));
				if($name==$this->mode){
					$result .= " selected";
				}
				$result .= sprintf(">%s</option>", $title);
			}
			$result .= "</select>";
			return $result;
		}
	}

	function DressHeaders(){
		$this->visible_count = 0;
		$result = "	<tr class=\"grid_header\">\n";
		foreach($this->columns as $name=>$col){
			if($col->inMode($this->mode)){
				$result .= $this->columns[$name]->DressHead();
				$this->visible_count++;
			}
		}
		$result .= "	</tr>\n";
		if($this->for_printing){
			$result = "<thead>\n".$result."\n</thead>\n";
		}
		return $result;
	}

	function DressFooters(){
		$result = "	<tr class=\"grid_footer\">\n";
		foreach($this->columns as $name=>$col){
			if($col->inMode($this->mode)){
				$result .= $this->columns[$name]->DressFoot();
			}
		}
		$result .= "	</tr>\n";
		if($this->for_printing){
			$result = "<tfoot>\n".$result."\n</tfoot>\n";
		}
		return $result;
	}

	function DressFilters(){
		$result = "<tfoot>\n";
		for($i=0; $i < $this->aux_count; $i++){
			unset($this->filters_params[$this->Pedigree('aux_name').$i]);
			unset($this->filters_params[$this->Pedigree('aux_value').$i]);
		}
		foreach($this->columns as $k=>$v){
			if($v->filterable){
				unset($this->filters_params[$this->Pedigree($k).'_filter']);
			}
		}
		if($this->filters_count){
			$result .= "	<tr class=\"grid_filters\">\n";
			foreach($this->columns as $name=>$col){
				if($col->inMode($this->mode)){
					$result .= $this->columns[$name]->DressFilter();
				}else{
					$this->hidden_filters .= $this->columns[$name]->DressHiddenFilter();
				}
			}
			$result .= "	</tr>\n";
		}
		if(count($this->aux_filters)){
			$result .= "	<tr class=\"grid_aux_filter\">\n";
			$result .= "		<td align=\"right\" colspan=\"".$this->visible_count."\">";
			$result .= "<table><tr valign=\"middle\">";
			for($i=0; $i < $this->aux_count; $i++){
				$result .= "<td><select name=\"".$this->Pedigree('aux_name').$i."\">\n";
				$result .= "		<option value=\"\">".getResource("pe6yc.grid.filter.aux.prompt")."</option>\n";
				$result .= "		<option value=\"\">--</option>\n";
				foreach($this->aux_filters as $k=>$v){
					$result .= "		<option value=\"$k\"".($this->auxes[$i]['name']==$k?" SELECTED":"").">$v</option>\n";
				}
				$result .= "		</select>";
				$result .= "<input name=\"".$this->Pedigree('aux_value').$i."\" value=\"".$this->auxes[$i]['value']."\" onkeydown=\"FilterSubmit(event,form)\">";
			}
			$result .= "</tr></table>";
			$result .= "</td>\n";
			$result .= "	</tr>\n";
		}
		$result .= "</tfoot>\n";
		return $result;
	}


	function DressRows(){
		foreach($this->recordset as $record){
			$result .= "	<tr class=\"".($record['active_record']?"grid_selected":"grid_row")."\"";
			$result .= $this->RenderHint($record);
			$result .= ">\n";
				foreach($this->columns as $name=>$col){
					if($col->inMode($this->mode)){
						$result .= $this->columns[$name]->DressValue($record);
					}
				}
			$result .= "	</tr>\n";
		}
		return $result;
	}

	function RenderHint($record){
		if($this->hint){
			$hint = $this->RenderByRecord($this->hint, $record);
			if($this->hint_format && function_exists($this->hint_format)){
				$hint = $this->Call($this->hint_format, $hint);
			}
			return " title=\"$hint\"";
		}
	}

	function RenderByRecord($str, $record){
		$result = $str;
		foreach($record as $key=>$val){
			$result = str_replace("[$key]","$val",$result);
		}
		return $result;
	}

}
?>