<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/08/04 07:53:23 $
$Revision: 1.7 $
*/
include_once(dirname(__FILE__).'/permanent.php');

class PSpy extends PPermanent {

var $skin = '';

var $protocol = 'udp://';
var $ip;
var $port;
var $timeout = 0;
var $query;

var $data='';
var $options = array();
var $players = array();

function Create($owner,$data){
	parent::Create($owner,$data);
	$this->RetriveData();
}

function SortByFrags($p1, $p2){
	$f1 = $p1['frags']+0;
	$f2 = $p2['frags']+0;
	return ($f1>$f2)?-1:( ($f2>$f1)?1:0 );
}

function DressParams(){
	$result = '';
	$result .= "	<tr>\n";
	$result .= "		<td class='access_grid'>";
	$result .= "<table class='grid' border='0' width='100%' cellspacing='0' cellpadding='0'>\n";
	$result .= "	<tr class='grid_header'>\n";
	$result .= "		<td colspan='2'>".getResource('pe6yc.spy.server.parameters')."</td>\n";
	$result .= "	</tr>\n";
	foreach($this->options as $k=>$v){
		$result .= "	<tr class='grid_row'>\n";
		$result .= "		<td width='20%' nowrap>".$v['key']."</td>\n";
		$result .= "		<td>".$v['value']."</td>\n";
		$result .= "	</tr>\n";
	}
	$result .= "</table>";
	$result .= "</td>\n";
	$result .= "	</tr>\n";
	return $result;
}

function DressPlayers(){
	$result = '';
	$result .= "	<tr>\n";
	$result .= "		<td class='access_grid'>";
	$result .= "<table class='grid' border='0' width='100%' cellspacing='0' cellpadding='0'>\n";
	$result .= "	<tr class='grid_header'>\n";
	$result .= "		<td colspan='2'>".getResource('pe6yc.spy.players')."</td>\n";
	$result .= "	</tr>\n";
	usort($this->players,array($this,"SortByFrags"));
	foreach($this->players as $k=>$v){
		$result .= "	<tr class='grid_row'>\n";
		$result .= "		<td width='20%' nowrap>".$v['name']."</td>\n";
		$result .= "		<td>".$v['frags']."</td>\n";
		$result .= "	</tr>\n";
	}
	$result .= "</table>";
	$result .= "</td>\n";
	$result .= "	</tr>\n";
	return $result;
}


function Dress(){
	$result = "<table border='0' width='100%' cellspacing='0' cellpadding='0'>\n";
	$result .= "	<tr>\n";
	$result .= "		<td class='access_head'>".$this->title."</td>\n";
	$result .= "	</tr>\n";
	$result .= $this->DressParams();
	$result .= $this->DressPlayers();
	$result .= "</table>\n";
	return $result;
}

function RetriveData(){
	$err_no = 0; $err_str = 'Ok';
	if($s = fsockopen($this->protocol.$this->ip,$this->port,&$err_no,&$err_str,1)){
		fputs($s,$this->query);
		socket_set_timeout($s,$this->timeout,100000);//+ 0.1 sec
		$this->data = fread($s,1024);
		fclose($s);
	}else{
		$this->data = $err_str;
	}
}

function ParseData(){
}

function Draw(){
	$this->ParseData();
	return parent::Draw();
}

}


//----------------------------
class PQuakeSpy extends PSpy {

function ParseData(){
	$s = strpos($this->data,'\\');
	$info = explode('\\',substr($this->data,strpos($this->data,'\\')+1));
	$size = count($info);
	$point = 0;
	$players = array();
	$this->options = array();
	for($i=0;($i+1)<$size;$i+=2){
		$arr = array();
		$arr['key'] = $info[$i];
		if($i+2==$size && $point=strpos($info[$i+1],"\n")){
			$arr['value'] = substr($info[$i+1],0,$point);
			$players = explode("\n",substr($info[$i+1],$point+1));
		}else{
			$arr['value'] = $info[$i+1];
		}
		$this->options[] = $arr;
	}
	$this->players = array();
	foreach($players as $pl){
		$pinfo = explode(" ",$pl);
		if($pinfo[2]){
			$arr = array();
			$arr['name'] = $pinfo[2];
			$arr['ping'] = $pinfo[1];
			$arr['frags'] = $pinfo[0];
			$this->players[] = $arr;
		}
	}
}

}

//----------------------------
class PHLSpy extends PSpy {

var $query = "\xFF\xFF\xFF\xFFinfo";
var $query_players = "\xFF\xFF\xFF\xFFplayers";

function ParseData(){
	$info = explode("\0",substr($this->data,strpos($this->data,"\0")+1));
	$this->options = array();
	if(count($info)>1){
		$this->options[0]['key'] = 'server_name';
		$this->options[0]['value'] = $info[0];
		$this->options[1]['key'] = 'map';
		$this->options[1]['value'] = $info[1];
		$this->options[2]['key'] = 'game';
		$this->options[2]['value'] = $info[2];
		$this->options[3]['key'] = 'gametype';
		$this->options[3]['value'] = $info[3];
		$this->options[4]['key'] = 'maxclients';
		$this->options[4]['value'] = ord($info[4][1]);
		$this->RetrivePlayers();
		$this->ParsePlayers();
	}
}

function ParsePlayers(){
	$pktlen = strlen($this->data_players);
	$arr=array();
	for($i=0;$i<$pktlen;$i++){
		$arr[$i]=$this->data_players[$i];
	}
	$this->players = array();
	if($arr[4] == 'D'){
		$ptr = 6;
		while($ptr < count($arr)){
			$player=array();
			$ptr++;
			# Get Name
			$i=$ptr;
			$name = '';
			while(ord($arr[$ptr])!=0)
				$name .= $arr[$ptr++];
			$ptr++;
			# Get Frags
			$player['frags'] = 0;
			$neg = (ord($arr[$ptr+3]) & 128)?1:0;
			for($i=0;$i<4;$i++){
				$player['frags'] += (ord($arr[$ptr+$i])-($neg?255:0))*pow(256,$i);
			}
			$player['frags'] -= $neg?1:0;
			$ptr += 4;
			$ptr += 4;//strange growing number (like a time)
			$player['name']=$name;
			if($ptr<=count($arr))
				$this->players[] = $player;
           }
	}
}

function RetrivePlayers(){
	$err_no = 0; $err_str = 'Ok';
	if($s = fsockopen("udp://".$this->ip,$this->port,&$err_no,&$err_str,1)){
		fputs($s,$this->query_players);
		socket_set_timeout($s,$this->timeout,100000);//+ 0.1 sec
		$this->data_players = fread($s,1024);
		fclose($s);
	}
}


}

?>