function getCelVal(c){
	return is.ie ? c.innerText : inText(c);
}

function GridColumnChart(container, table, bid){
	
	var drawChart = function() {
		var rc = table.rows.length - 1;
		var base, j, i;
		var columns = [];
		var preferer = {};
		var row = table.rows.item(0);
		for(j=0; j < row.cells.length; j++){
			var cell = row.cells.item(j);
			var text = getCelVal(cell);
			
			if(cell.id == bid){ //   
				base = [j, text];
				//alert(cell.id);	
			}else{
				//    
				var isnum = true;
				for(i=1; i < rc; i++){
					var r = table.rows.item(i);
					var c = r.cells.item(j);
					var t = getCelVal(c);
					if(!isNumber(t.replace(/\s+/g, ""))){
						isnum = false;
						break;
					}
				}
				//       -    
				if(isnum){
					columns.push([j, text, cell.id]);
					preferer[cell.id + '_chart'] = 1;
				}
			}
		}
		if(!base){
			alert('Base column not found');
			return;
		}
		if(columns.length == 0){
			alert('Data columns not found');
			return;
		}
	
		var data = new google.visualization.DataTable();
		data.addColumn('string', base[1]); //     
		for(i=0; i < columns.length; i++){
			data.addColumn('number', columns[i][1]); //  - ,  
		}
		data.addRows(rc - 1);
		//  
		for(i=1; i < rc; i++){
			var r = table.rows.item(i);
			var b = r.cells.item(base[0]);
			var t = getCelVal(b);
			data.setValue(i-1, 0, t);
			for(j=0; j < columns.length; j++){
				var c = r.cells.item(columns[j][0]);
				var t = getCelVal(c);
				data.setCell(i - 1, j + 1, parseFloat(t.replace(/\s+/g, "")));
			}
		}
		var chart = new google.visualization.ColumnChart(container);
		var view = new google.visualization.DataView(data)

		var bar = $("<div></div>").addClass('chart_bar');
		
		var redraw = function(){
			var visible = [0];
			$.each(columns, function(i, col){
				if(preferer[col[2] + '_chart'] > 0){
					visible.push(i + 1);
				}
			});
//			alert(visible);
			view.setColumns(visible);
			chart.draw(view, {hAxis: {title: base[1], titleTextStyle: {color: 'blue'}, slantedTextAngle:60}});
		
		}
		
		restore_prefs(preferer, function(response){
			$.each(columns, function(i, col){
				var id = col[2];
				preferer[id + '_chart'] = response[id + '_chart'] > 0 ? 1 : 0;
				$("<label></label>").
					appendTo(bar).
					append($("<input></input>").
						attr('type', 'checkbox').
						attr('checked', preferer[id + '_chart']).
						click(function(e){
							var c = this.checked ? 1 : 0;
							store_pref(id + '_chart', c);
							preferer[id + '_chart'] = c;
							redraw();
						})
					).append("<span>" + col[1] + "</span>");
			});
			$(container).before(bar);
			redraw();
		});
	}

	google.load("visualization", "1", {packages:["corechart"]});
	google.setOnLoadCallback(drawChart);
	
}