<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.2 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
loadStrings(BOOT.'stats_arpu/strings.txt');
loadStrings(BOOT.'connection_types/strings.txt');

$doc->title .= ' :: '.getResource('stat.arpu.title');

required_access('connection_types');
//$db->debug = 1;
//$db->Execute("SET SESSION TRANSACTION ISOLATION LEVEL READ UNCOMMITTED");

$period = new PPeriod($nil,BOOT.'period/form.php');
if($period->active){
	if($from = $period->getFrom()){
		$filters['from'] = sprintf("ii.from_time >= '%s'", $from);
	}
	if($to = $period->getTo()){
		$filters['to'] = sprintf("ii.to_time <= '%s'", $to);
	}
}

$db->Execute("CREATE TEMPORARY TABLE period_states (client INT UNSIGNED NOT NULL PRIMARY KEY, state TINYINT NOT NULL) ENGINE=Memory
SELECT c.id as client, IFNULL(p.state,0) as state FROM clients c LEFT JOIN personal_periods p ON p.client=c.id AND p.marker=1");

$p_filters = array();
if($period->active){
	if($from = $period->getFrom()){
		$p_filters['from'] = sprintf("m.date >= '%s'", $from);
	}
	if($to = $period->getTo()){
		$p_filters['to'] = sprintf("m.date <= '%s'", $to);
	}
}
if($oper->city_mode){
	$p_filters['city'] = "(c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id'))";
}
$p_filters['pays'] = "sa.code LIKE '%PAY%'";
$where = empty($p_filters) ? "" : " WHERE ".implode(" AND ", $p_filters);
$db->Execute(sprintf("CREATE TEMPORARY TABLE pays (client INT UNSIGNED NOT NULL PRIMARY KEY, amount BIGINT UNSIGNED NOT NULL) ENGINE=Memory
SELECT c.id as client, sum(m.amount) as amount
FROM movements m 
INNER JOIN clients c ON c.account=m.dst
INNER JOIN system_accounts sa ON sa.account=m.src
%s GROUP BY m.dst", $where));

$db->Execute("SET @client_count = (select count(*) from clients)");
$db->Execute("SET @pay_total = (select sum(amount) from pays)");

$c_filters = array();
if($period->active){
	if($from = $period->getFrom()){
		$c_filters['from'] = sprintf("st.created >= '%s'", $from);
	}
	if($to = $period->getTo()){
		$c_filters['to'] = sprintf("st.created <= '%s'", $to);
	}
}
$connected = empty($c_filters) ? "count(c.id)" : " sum(".implode(" AND ", $c_filters).")";
$db->Execute(sprintf("CREATE TEMPORARY TABLE stats_arpu  ENGINE=Memory
SELECT
c.city,
c.connection_type,
sum(ps.state=1) as count_non_dead,
sum(ps.state!=1) as count_dead,
count(c.id) as count_total,
sum(ps.state=1)/@client_count * 100  as p_count_non_dead,
sum(ps.state!=1)/@client_count * 100 as p_count_dead,
count(c.id)/@client_count * 100 as p_count_total,

sum(if(ps.state=1, ifnull(p.amount,0), 0)) as pay_non_dead,
sum(if(ps.state!=1, ifnull(p.amount,0), 0)) as pay_dead,
sum(ifnull(p.amount,0)) as pay_total,
sum(if(ps.state=1, ifnull(p.amount,0), 0)) /@pay_total * 100 as p_pay_non_dead,
sum(if(ps.state!=1, ifnull(p.amount,0), 0))/@pay_total * 100 as p_pay_dead,
sum(ifnull(p.amount,0))/@pay_total * 100 as p_pay_total,

sum(ifnull(p.amount,0))/count(c.id) as arpu,
%s as connected
FROM clients c
LEFT JOIN connection_types ct ON ct.id=c.connection_type
LEFT JOIN period_states ps ON ps.client=c.id
LEFT JOIN pays p ON p.client=c.id
LEFT JOIN stamps st ON st.id=c.stamp
".($oper->city_mode ? "WHERE c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id' )" : "")."
GROUP BY c.city, c.connection_type", $connected));

$stats_arpu = new PTable($db,BOOT.'stats_arpu/table.php');
$doc->page->contents['stats_arpu'] = new PMyAccess($stats_arpu,array(
	'title'=> getResource('stat.arpu.title'),
	'help'=>HELP_PATH.'//Arpu',
	'icon'=>HREF.'images/hpro.gif',
	'grid_boot'=>BOOT.'stats_arpu/grid.php',
	'tool'=>$period,
));
echo $doc->Paint();
?>
