<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.21 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('functions/uses.php');
loadStrings(BOOT.'hosts/strings.txt');

$doc->title .= ' :: '.getResource('stat.hosts.title');

required_access('hosts');
//$db->debug = 1;
//$db->Execute("SET SESSION TRANSACTION ISOLATION LEVEL READ UNCOMMITTED");

$period = new PPeriod2($nil,BOOT.'period/form2.php');

prepare_ip_use_data($period);

$db->Execute("CREATE TEMPORARY TABLE stats_resource_uses (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_resource_uses', "-- INSERT INTO stats_resource_uses (id, bytes, cost)
	SELECT iu.id, sum(l.bytes) bytes, floor(sum(l.bytes) * ru.price / ru.unit_size) cost
	FROM ip_use_data l
	LEFT JOIN ip_uses iu ON iu.id=l.ip_use
	LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN clients c ON c.id=ru.client
	".($oper->city_mode ? "WHERE c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id' )" : "")."
	GROUP BY iu.id");

$db->Execute("CREATE TEMPORARY TABLE stats_hosts (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_hosts', "-- INSERT INTO stats_hosts (id, bytes, cost)
	SELECT iu.host,  sum(s.bytes), sum(s.cost)
	FROM stats_resource_uses s
	LEFT JOIN ip_uses iu ON iu.id=s.id
	GROUP BY iu.host");

$stats_hosts = new PTable($db,BOOT.'stats_hosts/table.php');
addCityPolicy($stats_hosts, 'c.city');

$doc->page->contents['stats_hosts'] = new PMyAccess($stats_hosts,array(
	'title'=>getResource('stat.hosts.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/hosts.gif',
	'grid_boot'=>BOOT.'stats_hosts/grid.php',
	'tool'=>$period,
));

if($stats_hosts->isOn()){
//	$db->debug = 1;
	$hmenu = new PNamedMenu($nil,BOOT.'stats_hosts/menu.php');
	$doc->page->contents['host_menu'] = $hmenu;
	switch($hmenu->selected){
		case 'lo':
			$tables = array(
				'1'=>'table.php',
				'2'=>'table-hour.php',
				'3'=>'table-day.php',
			);
			if(isset($tables[$period->detail])){
				$log = new PTable($db,BOOT.'log/'.$tables[$period->detail]);
				$id = $stats_hosts->active_record['id'];
				$log->filters['host'] = "host='$id'";
				$from = $period->getFrom();
				$to = $period->getTo();
				if($from){
					$log->filters['from'] = sprintf($log->fields['from_time']->getSelector()." >= '%s'", $from);
				}
				if($to){
					if($from){
						$log->filters['from_to'] = sprintf($log->fields['from_time']->getSelector()." <= '%s'", $to);
					}
					$log->filters['to'] = sprintf($log->fields['to_time']->getSelector()." <= '%s'", $to);
				}
				$doc->page->contents['log'] = new PMyAccess($log,array(
					'title'=>sprintf(getResource('stat.hosts.log.title'), $stats_hosts->active_record['ip']),
					'icon'=>HREF.'images/log.gif',
					'grid_boot'=>BOOT.'log/grid.php',
				));
			}
			break;
		case 'ip':
			loadStrings(BOOT.'client_info/strings.txt');
			$ipcad_ip = $stats_hosts->active_record['ip'];
			//$db->debug = 1;
			include("includes/stat_ipcad.php");
			break;
		case 'gr':
			$doc->page->contents['graph'] = '<div align="center">
				<br><br>'.getResource('stat.graph.day').'<br>
				<img src="'.HREF.'graph/host.php?id='.$stats_hosts->active_record['id'].'&period=day">
				<br><br>'.getResource('stat.graph.month').'<br>
				<img src="'.HREF.'graph/host.php?id='.$stats_hosts->active_record['id'].'&period=month">
				<br><br>'.getResource('stat.graph.year').'<br>
				<img src="'.HREF.'graph/host.php?id='.$stats_hosts->active_record['id'].'&period=year">
				</div>';
			break;
	}
}
echo $doc->Paint();
?>
