<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.21 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('functions/uses.php');

$doc->title .= ' :: '.getResource('stat.modems.title');

required_access('modems');
//$db->debug = 1;
//$db->Execute("SET SESSION TRANSACTION ISOLATION LEVEL READ UNCOMMITTED");

$period = new PPeriod($nil,BOOT.'period/form.php');

prepare_ip_use_data($period);

$db->Execute("CREATE TEMPORARY TABLE stats_resource_uses (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_resource_uses', "-- INSERT INTO stats_resource_uses (id, bytes, cost)
	SELECT iu.id, sum(l.bytes) bytes, floor(sum(l.bytes) * IF(ru.dst IS NULL, 0, ru.price) / ru.unit_size) cost
	FROM ip_use_data l
	LEFT JOIN ip_uses iu ON iu.id=l.ip_use
	LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN clients c ON c.id=ru.client
	".($oper->city_mode ? "WHERE c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id' )" : "")."
	GROUP BY iu.id");

$db->Execute("CREATE TEMPORARY TABLE stats_modems (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_modems', "-- INSERT INTO stats_modems (id, bytes, cost)
	SELECT h.modem,  sum(s.bytes), sum(s.cost)
	FROM stats_resource_uses s
	LEFT JOIN ip_uses iu ON iu.id=s.id
	LEFT JOIN hosts h ON h.id=iu.host
	GROUP BY h.modem");

$stats_modems = new PTable($db,BOOT.'stats_modems/table.php');
addCityPolicy($stats_modems, 'm.city');

$doc->page->contents['stats_modems'] = new PMyAccess($stats_modems,array(
	'title'=> getResource('stat.modems.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/modems.gif',
	'grid_boot'=>BOOT.'stats_modems/grid.php',
	'tool'=>$period,
));

if($stats_modems->isOn()){
	$doc->page->contents['day'] = '
		<div align="center">
		<br><br>'.getResource('stat.graph.day').'<br>
		<img src="'.HREF.'graph/modem.php?id='.$stats_modems->active_record['id'].'&period=day">
		<br><br>'.getResource('stat.graph.month').'<br>
		<img src="'.HREF.'graph/modem.php?id='.$stats_modems->active_record['id'].'&period=month">
		<br><br>'.getResource('stat.graph.year').'<br>
		<img src="'.HREF.'graph/modem.php?id='.$stats_modems->active_record['id'].'&period=year">
		</div>';
}
echo $doc->Paint();
?>
