<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.20 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('functions/uses.php');
loadStrings(BOOT.'rules/strings.txt');

$doc->title .= ' :: '.getResource('stat.rules.title');

required_access('rules');
$period = new PPeriod($nil,BOOT.'period/form.php');

//$db->debug = 1;
//$db->Execute("SET SESSION TRANSACTION ISOLATION LEVEL READ UNCOMMITTED");

prepare_ip_use_data($period);

$filters = array();

if($oper->department){
	$filters['dep'] = sprintf("c.department='%s'",$oper->department);
}
if($oper->city_mode){
	$filters['city'] = "(c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id'))";
}
$where = !empty($filters) ? " WHERE ". implode(" AND ", $filters) : "";

$db->Execute("CREATE TEMPORARY TABLE stats_resource_uses (
	rule		INT UNSIGNED NOT NULL,
	price		BIGINT UNSIGNED NOT NULL,
	unit_size	BIGINT UNSIGNED NOT NULL,
	bytes		BIGINT UNSIGNED NOT NULL,
	cost		BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_resource_uses', sprintf("-- INSERT INTO stats_resource_uses (rule, price, unit_size, bytes, cost)
	SELECT iu.rule, ru.price, ru.unit_size, sum(l.bytes), floor(sum(l.bytes) * IF(ru.dst IS NULL, 0, ru.price) / ru.unit_size)
	FROM ip_use_data l
	LEFT JOIN ip_uses iu ON iu.id=l.ip_use
	LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN clients c ON c.id=ru.client
	%s GROUP BY iu.rule, ru.price, ru.unit_size", $where));

$db->Execute("CREATE TEMPORARY TABLE stats_rules (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_rules', "-- INSERT INTO stats_rules (id, bytes, cost)
	SELECT s.rule,  sum(s.bytes), sum(s.cost)
	FROM stats_resource_uses s
	GROUP BY s.rule");

$stats_rules = new PTable($db,BOOT.'stats_rules/table.php');
$doc->page->contents['stats_rules'] = new PMyAccess($stats_rules,array(
	'title'=>getResource('stat.rules.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/rules.gif',
	'grid_boot'=>BOOT.'stats_rules/grid.php',
	'tool'=>$period,
));
if($stats_rules->isOn()){
	$doc->page->contents['day'] = '<div align="center">
		<br><br>'.getResource('stat.graph.day').'<br>
		<img src="'.HREF.'graph/rule.php?id='.$stats_rules->active_record['id'].'&period=day">
		<br><br>'.getResource('stat.graph.month').'<br>
		<img src="'.HREF.'graph/rule.php?id='.$stats_rules->active_record['id'].'&period=month">
		<br><br>'.getResource('stat.graph.year').'<br>
		<img src="'.HREF.'graph/rule.php?id='.$stats_rules->active_record['id'].'&period=year">
		</div>';
}
echo $doc->Paint();
?>
