<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.3 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('functions/uses.php');
loadStrings(BOOT.'streets/strings.txt');

$doc->title .= ' :: '.getResource('stat.streets.title');

required_access('streets');

//$db->Execute("SET SESSION TRANSACTION ISOLATION LEVEL READ UNCOMMITTED");

$filters = array();
$filters['payable'] = "(ru.src IS NOT NULL) AND (ru.dst IS NOT NULL)";

if($oper->city_mode){
	$p_filters['city'] = "c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id')";
}

$period = new PPeriod($nil,BOOT.'period/form.php');

prepare_ip_use_data($period);

//$db->debug = 1;

$db->Execute("CREATE TEMPORARY TABLE stats_resource_uses (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_resource_uses', sprintf("-- INSERT INTO stats_resource_uses (id, bytes, cost)
	SELECT ru.id, sum(l.bytes) bytes, floor(sum(l.bytes) * ru.price / ru.unit_size) cost
	FROM ip_use_data l
	LEFT JOIN ip_uses iu ON iu.id=l.ip_use
	LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN clients c ON c.id=ru.client
	WHERE %s
	GROUP BY ru.id", implode(" AND ", $filters)));

$where = $oper->department ? sprintf("WHERE c.department='%s'",$oper->department) : "";
$db->Execute("CREATE TEMPORARY TABLE stats_streets (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_streets', sprintf("-- INSERT INTO stats_streets
	SELECT h.street , sum(s.bytes), sum(s.cost)
	FROM stats_resource_uses s
	LEFT JOIN resource_uses ru ON ru.id=s.id
	LEFT JOIN clients c ON c.id=ru.client
	LEFT JOIN houses h ON h.id=c.house_id
	%s GROUP BY h.street", $where));

$stats_streets = new PTable($db,BOOT.'stats_streets/table.php');
addCityPolicy($stats_streets, 's.city');

$doc->page->contents['stats_streets'] = new PMyAccess($stats_streets,array(
	'title'=> getResource('stat.streets.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/streets.gif',
	'grid_boot'=>BOOT.'stats_streets/grid.php',
	'tool'=>$period,
));
echo $doc->Paint();
?>
