<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:17 $
$Revision: 1.10 $
*/
include_once('includes/global.php');
loadStrings(BOOT.'tariffs/strings.txt');

$doc->title .= ' :: '.getResource('tariffs.title');

required_access('tariffs');
//$db->debug = 1;

class PDayForm extends PForm{

var $day;
var $method = 'post';

var $permanents = array('day');

function Process(){
	$this->day = $this->fields['day']->value;
}

function getTimestamp(){
	if(!$this->day){
		$this->day = date("Y-m-d H:i:s");
	}
	return _parse_datetime($this->day);
}

function Draw(){
	$this->fields['day']->value = $this->day;
	return parent::Draw();
}

}

$day = new PDayForm($nil,BOOT.'tariffs/day-form.php');

function execTest($name, $func, $date, &$values){
	$func = "function $name(\$time){\n$func\n}";
	$year = date("Y", $date);
	$month = date("m", $date);
	$day = date("d", $date);
	ob_start();
	eval($func);
	$err = ob_get_contents();
	if(!$err){
		for($h = 0; $h < 24; $h++){
			for($m = 0; $m < 60; $m += FETCH_PERIOD){
				$time = mktime($h,$m,1,$month, $day, $year);
				$price = call_user_func($name, $time);
				if(!is_numeric($price)){
					$err = $price." not a number at ".date("Y-m-d H:i:s", $time);
				}
				$values[$h][$m] = $price;
			}
		}
		$err .= ob_get_contents();
	}
	ob_end_clean();
	return $err;
}

function before_tariff_post($table){
	$func = $table->new_record['function'];
	$err = execTest("testPrice", $func, mktime(), $values);
	if($err){
		PrintStrings("function", "function testPrice(\$time){\n".$func."\n}");
	}
	$table->error($err);
}


$tariffs = new PTable($db,BOOT.'tariffs/table.php');
$tariffs->readonly = !$oper->system_access['tariffs'];
$doc->page->contents['tariffs'] = new PMyAccess($tariffs,array(
	'title'=>getResource('tariffs.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/tariffs.gif',
	'grid_boot'=>BOOT.'tariffs/grid.php',
	'form_boot'=>BOOT.'tariffs/form.php',
));

if($tariffs->isOn()){
	$err = execTest("previewPrice", $tariffs->current_record['function'], $day->getTimestamp(), $values);
	$colors = array('#bbffbb', '#ffffbb', '#ffbbff', '#bbffff', '#bbffff');
	$ecolor = '#ff6666';
	$cmap = array();
	ob_start();
?>

<span class="error"><?=$err?></span>

<table class="grid" width="100%" style="margin-bottom:1px;">
	<tr>
		<td class="grid_header"></td>
		<?for($m=0; $m < 60; $m+=FETCH_PERIOD){?>
		<td class="grid_header"><?printf("%02d",$m)?></td>
		<?}?>
	</tr>

	<?for($h=0; $h < 24; $h++){?>
	<tr>
		<td class="grid_header" align="right"><?printf("%02d",$h)?></td>
		<?for($m=0; $m < 60; $m+=FETCH_PERIOD){
			$price = $values[$h][$m];
			if(!is_numeric($price)){
				$price = "<span class=crossed>$price</span>";
			}
			if(!isset($cmap["$price"])){
				if(!is_numeric($price)){
					$color = $ecolor;
				}else{
					$color = $colors[count($cmap) % count($colors)];
				}
				$cmap["$price"] = $color;
			}else{
				$color = $cmap["$price"];
			}
		?>
		<td bgcolor="<?=$color?>"><?=$price?></td>
		<?}?>
	</tr>
	<?}?>
</table>
<?
$doc->page->contents['preview'] = ob_get_contents();
ob_end_clean();
$doc->page->contents['day'] = $day;
}
echo $doc->Paint();
?>
