#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

$ip = $_SERVER['argv'][1];
$name = $_SERVER['argv'][2];

ini_set('include_path', DIRNAME(__FILE__). '/../');

$tftp_server = '194.50.85.2';

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

$model_oid = @snmpget($ip, $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);

if(isset($edgecore_models[$model_oid])){
	if($model_oid == '.1.3.6.1.4.1.259.8.1.6'){
		$model_oid = '.1.3.6.1.4.1.259.8.1.5';
	}
	printf("EdgeCore %s:\t", $name);
	$cfg_name = $name.'-confg';
	$filename = "/var/lib/tftpboot/".$cfg_name;
	if(!is_file($filename)){
		touch($filename);
		chmod($filename, 0666);
	}
	$oid = array(
		'copy_src' => $model_oid.".1.24.1.1.0",
		'copy_src_name' => $model_oid.".1.24.1.2.0",
		'copy_dst' => $model_oid.".1.24.1.3.0",
		'copy_filename' => $model_oid.".1.24.1.4.0",
		'tftp_server' => $model_oid.".1.24.1.6.0",
		'copy_action' => $model_oid.".1.24.1.8.0",
	);
	if(snmpset($ip, $options['snmp-writer'], $oid['copy_src'], 'i', 2, $options['snmp-timeout'], $options['snmp-retries']) && 
		snmpset($ip, $options['snmp-writer'], $oid['copy_src_name'], 's', 'running-config', $options['snmp-timeout'], $options['snmp-retries']) && 
		snmpset($ip, $options['snmp-writer'], $oid['copy_dst'], 'i', 4, $options['snmp-timeout'], $options['snmp-retries']) && 
		snmpset($ip, $options['snmp-writer'], $oid['copy_filename'], 's', $cfg_name, $options['snmp-timeout'], $options['snmp-retries']) && 
		snmpset($ip, $options['snmp-writer'], $oid['tftp_server'], 'a', $tftp_server, $options['snmp-timeout'], $options['snmp-retries']) && 
		snmpset($ip, $options['snmp-writer'], $oid['copy_action'], 'i', 2, $options['snmp-timeout'], $options['snmp-retries'])){
		printf("ok\n");
	}else{
		printf("failed\n");
	}
	
}else{
	printf("not edge-core\n");
}
?>