#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;

error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');

include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));

$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.fix.oid');

$logger->info("BEGIN");

$tftp_server = '10.0.0.2';

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
);

$options = array(
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	return snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();

$modems = array();

while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
}

usort($modems, 'compareByLevelDesc');

foreach($modems as $modem){
	if($modem['model'] == 'ES4612' && $modem['firmware'] == '1.0.6.5'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$success = true;

//				echo "./add_device.php --description=".$modem['name']." --ip=".$modem['name'].".lanet --template=10 --avail=snmp --version=2\n";

//				$success &= _snmpset('1.3.6.1.2.1.17.7.1.4.3.1.5.11', 'i', 6);																// delete vlan 11

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.1.7.0', 'i', 2);														// disable jumbo frames

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.7.3.0', 'i', 3);														// hard reboot

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.2.0', 'a', '10.255.255.242');												// set default gateway
/*
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1021.1', 'a', '194.50.85.2');											// set vlan 21 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1022.1', 'a', '194.50.85.2');											// set vlan 22 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1023.1', 'a', '194.50.85.2');											// set vlan 23 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1024.1', 'a', '194.50.85.2');											// set vlan 24 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1025.1', 'a', '194.50.85.2');											// set vlan 25 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1026.1', 'a', '194.50.85.2');											// set vlan 26 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1027.1', 'a', '194.50.85.2');											// set vlan 27 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1028.1', 'a', '194.50.85.2');											// set vlan 28 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1029.1', 'a', '194.50.85.2');											// set vlan 29 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1037.1', 'a', '194.50.85.2');											// set vlan 37 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1038.1', 'a', '194.50.85.2');											// set vlan 38 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1039.1', 'a', '194.50.85.2');											// set vlan 39 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1041.1', 'a', '194.50.85.2');											// set vlan 41 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1044.1', 'a', '194.50.85.2');											// set vlan 44 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1048.1', 'a', '194.50.85.2');											// set vlan 48 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1049.1', 'a', '194.50.85.2');											// set vlan 49 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1077.1', 'a', '194.50.85.2');											// set vlan 77 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1210.1', 'a', '194.50.85.2');											// set vlan 210 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1211.1', 'a', '194.50.85.2');											// set vlan 211 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1212.1', 'a', '194.50.85.2');											// set vlan 212 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1213.1', 'a', '194.50.85.2');											// set vlan 213 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1214.1', 'a', '194.50.85.2');											// set vlan 214 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1215.1', 'a', '194.50.85.2');											// set vlan 215 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1411.1', 'a', '194.50.85.2');											// set vlan 411 dhcp relay 1 ip address
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.2.1.3.1413.1', 'a', '194.50.85.2');											// set vlan 413 dhcp relay 1 ip address
*/
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.10.11.2.3.0', 'i', 1);													// dhcp relay restart
/*
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.19.6.4.1.2.10.0.0.2', 'i', 1);												// add remote syslog server
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.19.6.4.1.2.10.0.0.101', 'i', 2);												// del remote syslog server
*//*
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.23.1.1.0', 'i', 1);														// enable sntp
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.23.1.3.0', 'i', 16384);													// set sntp sync period
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.23.1.4.1.2.1', 'a', '10.0.0.2');												// set sntp sync server
*/
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.1.0', 'i', 4);														// set src tftp
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.2.0', 's', 'ES4612_1.0.6.3.bix');											// set src filename
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.3.0', 'i', 1);														// set dst file
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.4.0', 's', 'ES4612_1.0.6.3.bix');											// set dst filename
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.5.0', 'i', 1);														// set dst type opcode
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.6.0', 'a', '10.0.0.2');												// set src tftp address
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.8.0', 'i', 2);														// start copy
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.2.1.1.4.1.69.83.52.54.49.50.95.49.46.48.46.54.46.51.46.98.105.120', 'i', 1);						// set startup ES4612_1.0.6.3.bix
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.2.1.1.7.1.69.83.52.54.49.50.95.49.46.48.46.50.46.53.55.46.98.105.120', 'i', 2);						// delete ES4612_1.0.2.57.bix
/*
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.26.6.1.2.1', 'a', '194.50.85.2');												// set dns server
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.26.6.1.2.2', 'a', '0.0.0.0');												// set dns server
*//*
				if($modem['uplink']){
					$collisions = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::mib-2.16.1.1.1.13.".$modem['uplink'], $options['snmp-timeout'], $options['snmp-retries']);		// get collisions
				}
*//*
				$name = true;
				for($index = 9; $index <= 12; $index++){
					$type = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::enterprises.259.6.10.57.1.2.1.1.3.".$index, $options['snmp-timeout'], $options['snmp-retries']);		// get port type
					if($name && $type != 8){
						echo $modem['name']."\t".$index;
						$name = false;
					}elseif($type != 8){
						echo " ".$index;
					}
				}
				if(!$name){
					echo "\n";
				}
*/
				if(
					$success
//					&& $collisions
/*
					&& _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.1.0', 'i', 2)
					&& _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.3.0', 'i', 3)
					&& _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.4.0', 's', $modem['name'].'-confg')
					&& _snmpset('SNMPv2-SMI::enterprises.259.6.10.57.1.24.1.8.0', 'i', 2)
*/				){
					$logger->info("edge %s: ok", $modem['name']);
//					$logger->info("edge %s: uplink port %d collisions: %d", $modem['name'], $modem['uplink'], $collisions);
				}else{
					$logger->error("edge %s: failed", $modem['name']);
				}
			}
		}else{
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
}

$logger->info("END");

?>
