#!/usr/bin/php -q
<?
if(!isset($_SERVER['argv'][1])){
	die("specify set name\n");
}else{
	$name = $_SERVER['argv'][1];
}
$hash = readHash($name);

$lines = file('php://stdin');

if(count($lines) < 1) {
//	fwrite(STDERR, "probably missing data, aborting\n");
//	exit(1);
}

foreach($lines as $line){
	$ip = trim($line);
	if($ip){
		if(isset($hash[$ip])){
			unset($hash[$ip]);
		}else{
			cmd(sprintf("ipset -A %s %s", $name, $ip));
		}
	}
}
foreach($hash as $ip=>$x){
	cmd(sprintf("ipset -D %s %s", $name, $ip));
}

function cmd($cmd){
	//echo $cmd."\n";
	exec($cmd, $out, $err);
	if($err){
	    echo $cmd.": ".implode("\n", $out)."\n";
	}
	return $err;
}

function readHash($name){
	$cmd = sprintf("ipset -L %s", $name);
	exec($cmd, $out, $code);
	if($code > 0){
	    printf("cant read %s", $name);
	    exit(2);
	}
	$hash = array();
	$count = count($out);
	for($i=0; $i<$count; $i++){
		$line = $out[$i];
		if(count(explode('.', $line))==4){
			$hash[$line] = 1;
		}
	}
	return $hash;
}
?>