#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.fix.dhcp');

$logger->info("BEGIN");

$tftp_server = '194.50.85.2'; //ip2long(implode('.', array_reverse(explode('.', '194.50.85.1'))));

$celan_models = array(
	'.1.3.6.1.4.1.655.5.3'=>'2402Fi-EA',
	'.1.3.6.1.4.1.655.5.11'=>'8F00i-EA',
	'.1.3.6.1.4.1.655.5.15'=>'0800i-EA',
	'.1.3.6.1.4.1.655.5.16'=>'1601Fi-EA',
	'.1.3.6.1.4.1.655.5.21'=>'0701Fi-EA',
	'.1.3.6.1.4.1.655.9.3'=>'2402FGi-EA',
	'.1.3.6.1.4.1.655.9.8'=>'8F02Gi-EA',
);
$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
	'.1.3.6.1.4.1.259.10.1.27.101'=>'ES3510-28T',
	
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
	'http-timeout' => '10',
	'http-user' => 'security',
	'http-password' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

$ch = curl_init();

curl_setopt($ch, CURLOPT_TIMEOUT, $options['http-timeout']);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Basic ".base64_encode(sprintf("%s:%s", $options['http-user'], $options['http-password']))));

function _snmpset($oid, $type, $value){
	global $options, $modem;
	return snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
}

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();
while($modem = $it->next()){
	if($modem['model']=='ES3528M' || $modem['model']=='ES3552M'){
	//if($modem['ip']=='10.0.0.5'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
//   					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.46.1.1.0',  	// DHCP Snooping (1) enabled (2) disabled
//   					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.46.1.2.0',  	// DHCP Snooping verify MAC-address Integer (1) enabled (2) disabled
//   					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.46.2.1.1.2.x',  	// DHCP Snooping Vlan (x) Integer (1) enabled (2) disabled
//   					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.46.3.1.1.2.x',  	// DHCP Snooping Trusted port (x) Integer (1) trusted (2) untrusted

				$oid = array(
					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.46.1.1.0',
					'config_src'=>$model_oid.".1.24.1.1.0",
					'config_dst'=>$model_oid.".1.24.1.3.0",
					'config_dst_name'=>$model_oid.".1.24.1.4.0",
					'config_action'=>$model_oid.".1.24.1.8.0",
					'dhcp'=>'.1.3.6.1.4.1.259.6.10.94.1.46.3.1.1.2',
					'vlan'=>'.1.3.6.1.4.1.259.6.10.94.1.46.2.1.1.2',
				);
				$cfg_name = $modem['name'].'-confg';
				$success = true;

//   					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.46.2.1.1.2.x',  	// DHCP Snooping Vlan (x) Integer (1) enabled (2) disabled
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.46.2.1.1.2.2', 'i', 1);
				echo '+';
			}
		}else{
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
}
$logger->info("END");

curl_close($ch);
?>
