#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.set.ipfilter');

$logger->info("BEGIN");

$tftp_server = '194.50.85.2'; //ip2long(implode('.', array_reverse(explode('.', '194.50.85.1'))));

$celan_models = array(
	'.1.3.6.1.4.1.655.5.3'=>'2402Fi-EA',
	'.1.3.6.1.4.1.655.5.11'=>'8F00i-EA',
	'.1.3.6.1.4.1.655.5.15'=>'0800i-EA',
	'.1.3.6.1.4.1.655.5.16'=>'1601Fi-EA',
	'.1.3.6.1.4.1.655.5.21'=>'0701Fi-EA', //14
	'.1.3.6.1.4.1.655.9.3'=>'2402FGi-EA', //15
	'.1.3.6.1.4.1.655.9.8'=>'8F02Gi-EA',
);
$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
	'http-timeout' => '10',
	'http-user' => 'security',
	'http-password' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

$ch = curl_init();

curl_setopt($ch, CURLOPT_TIMEOUT, $options['http-timeout']);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Basic ".base64_encode(sprintf("%s:%s", $options['http-user'], $options['http-password']))));

function setSNMP($ip, $oid, $type, $val){
	global $options;
	printf("snmpset -v 1 -c %s %s %s %s %s\n", $options['snmp-writer'], $ip, $oid, $type, $val);
	return snmpset($ip, $options['snmp-writer'], $oid, $type, $val, $options['snmp-timeout'], $options['snmp-retries']);
}

//exit;
$dao = $beanFactory->getBean('modemsDAO');
$it = $dao->iterator();
while($modem = $it->next()){
	echo $modem['name'].":\n";
	$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
	if($model_oid){
/*		if(isset($celan_models[$model_oid])){
			$model = $celan_models[$model_oid];
			$oid = $model_oid . (strpos($model, 'G') > 0 ? '.1.15.1.1' : '.1.14.1.1' );
			$cmd = "snmpset -c ".$options['snmp-writer']." -v 1 ".$modem['ip']." ".
				$oid.'.2.1 i 1 '.
				$oid.'.2.2 i 1 '.
				$oid.'.3.1 a 194.50.85.0 '.
				$oid.'.3.2 a 10.0.0.0 '.
				$oid.'.4.1 a 255.255.255.0 '.
				$oid.'.4.2 a 255.255.255.0 '.
				$oid.'.5.1 i 2 '.
				$oid.'.5.2 i 2 '.
				$oid.'.6.1 i 1 '.
				$oid.'.6.2 i 1 '.
				$oid.'.7.1 i 1 '.
				$oid.'.7.2 i 1 '.
				$oid.'.8.1 i 1 '.
				$oid.'.8.2 i 1 ';
			echo $cmd."\n";
			$out = array();
			exec($cmd, $out, $exit);
			if(!$exit){
				$logger->info("celan %s: ok", $modem['name']);
			}else{
				print_r($out);
				$logger->info("celan %s: error", $modem['name']);
				//exit;
			}
		}
*/		if(isset($edgecore_models[$model_oid])){
			if($model_oid == '.1.3.6.1.4.1.259.8.1.6'){
				$model_oid = '.1.3.6.1.4.1.259.8.1.5';
			}
			$model_oid = '.1.3.6.1.4.1.259.6.10.94';
			$oid = $model_oid.'.1.17.9';
			$cmd = "snmpset -c ".$options['snmp-writer']." -v 1 ".$modem['ip']." ".
				$oid.'.1.1.3.10.0.0.1 i 1 '.
				$oid.'.1.1.2.10.0.0.1 a 10.0.0.254 '.
				$oid.'.1.1.3.10.101.0.1 i 2 '.
				$oid.'.1.1.2.10.101.0.1 a 10.101.255.254 '.
				$oid.'.1.1.3.194.50.85.1 i 1 '.
				$oid.'.1.1.2.194.50.85.1 a 194.50.85.254 '.
				
				$oid.'.2.1.3.10.0.0.1 i 1 '.
				$oid.'.2.1.2.10.0.0.1 a 10.0.0.254 '.
				$oid.'.2.1.3.10.101.0.1 i 2 '.
				$oid.'.2.1.2.10.101.0.1 a 10.101.255.254 '.
				$oid.'.2.1.3.194.50.85.1 i 1 '.
				$oid.'.2.1.2.194.50.85.1 a 194.50.85.254 '.
				
				$oid.'.3.1.3.10.0.0.1 i 1 '.
				$oid.'.3.1.2.10.0.0.1 a 10.0.0.254 '.
				$oid.'.3.1.3.10.101.0.1 i 2 '.
				$oid.'.3.1.2.10.101.0.1 a 10.101.255.254 '.
				$oid.'.3.1.3.194.50.85.1 i 1 '.
				$oid.'.3.1.2.194.50.85.1 a 194.50.85.254 ';
//			echo $cmd."\n";
			$out = array();
			exec($cmd, $out, $exit);
			if(!$exit){
				$logger->info("edgecore %s: ok", $modem['name']);
			}else{
				print_r($out);
				$logger->info("edgecore %s: error", $modem['name']);
				//exit;
			}
//			break;
		}
	}
}
$logger->info("END");

curl_close($ch);
?>