#!/usr/bin/php -q
<?php /* author: Ponomarev Denis <ponomarev@gmail.com> */

!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);
ini_set('include_path', DIRNAME(__FILE__). '/../');

include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/cli.php'),
	new ArrayBeanFactory('boot/caban/service.php'),
	new ArrayBeanFactory('boot/caban/service-2.php'),
));

$profileBuilder = $beanFactory->getBean('profileBuilder2');
$m = $_SERVER['argv'][1];
if(is_numeric($m)){
	exit($profileBuilder->buildModem($m));
}else{
	$modemsDAO = $beanFactory->getBean('modemsDAO');
	if($modem = $modemsDAO->getByIp($m)){
		exit($profileBuilder->buildModem($modem['id']));
	}
}
?>