<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:16 $
$Revision: 1.11 $
*/
include_once('includes/global.php');
include_once('functions/host.php');
include_once('classes/TvNodesNest.php');
include_once('classes/cells/CallbackCellRenderer.php');

loadStrings(BOOT.'tv_nodes/strings.txt');
loadStrings(BOOT.'exp_points/strings.txt');
loadStrings(BOOT.'hosts/strings.txt');

$doc->title .= ' :: '.getResource('tv.nodes.title');

required_access('tv_nodes');

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'profile': lookup('tv_node_profile');
	case 'point': lookup('exp_point', $_GET['city'] ? array('p.city='.addslashes($_GET['city'])) : array());
	case 'tv_node':
	case 'parent': lookup('tv_node', $_GET['city'] ? array('n.city='.addslashes($_GET['city'])) : array());
	case 'message': lookup('ivr_message', $_GET['city'] ? array('m.city="'.addslashes($_GET['city']).'"') : array());
}

if(isset($_GET['get_input_power'])){
	header("Content-Type: text/plain; charset=cp1251");
	if($arr = loadRecord("SELECT n.id, p.driver FROM tv_nodes n LEFT JOIN tv_node_profiles p ON p.id=n.profile WHERE n.id='".addslashes($_GET['get_input_power'])."'")){
		$reg = $beans->getBean('tvNodeDriverRegistry');
		if($driver = $reg->getDriver($arr['driver'])){
			$driver->setTargetNode($arr['id']);
			try{
				echo $driver->getInputPower();
			}catch(Exception $ex){
				echo $ex->getMessage();
			}
		}else{
			echo getResource('tv.nodes.audit.no.profile');
		}
	}else{
		echo getResource('tv.nodes.audit.no.node');
	}
	exit;
}

function laquo($val){
	return '<b>&laquo;</b>';
}

function getTvNodeModels(){
	return loadByQuery("SELECT id, name as value FROM tv_node_types ORDER BY name");
}

function check_node_circle($table){
	global $db;
	$path = array($table->old_record['id']);
	$pid = $table->new_record['parent'];
	while($parent = loadRecord('SELECT id, parent FROM tv_nodes WHERE id="'.addslashes($pid).'"')){
		if(in_array($parent['id'], $path)){
			$table->error(getResource('tv.nodes.error.circle'));
			return;
		}
		$path[] = $parent['id'];
		$pid = $parent['parent'];
	}
}

function recalc_tv_nodes_nest(){
	global $tv_nodes_nest;
	$tv_nodes_nest->recalc();
}

$input_deviation_cell = new CallbackCellRenderer(function($record, $attributes){
	if($record['audit'] && strlen($record['input_power']) > 0){
		if($record['input_power'] < 0 || !$record['available']){
			$attributes['class'] = 'red_lighted';
		}elseif(abs($record['input_deviation']) >= 2){
			$attributes['style'] = 'background-color: #acf';
		}else{
			$attributes['class'] = 'green_lighted';
		}
	}
	return $attributes;
});

$output_deviation_cell = new CallbackCellRenderer(function($record, $attributes){
	if($record['audit'] && strlen($record['output_power']) > 0){
		$d = $record['output_deviation'];
		if($d <= -2 || !$record['available']){
			$attributes['class'] = 'red_lighted';
		}elseif($d < 0){
			$attributes['style'] = 'background-color: #fcf';
		}else{
			$attributes['class'] = 'green_lighted';
		}
	}
	return $attributes;
});


//recalc_tv_clients();

$tv_nodes_nest = new TvNodesNest();

$tv_nodes = new PTable($db,BOOT.'tv_nodes/table.php');
$tv_nodes->readonly = !$oper->system_access['tv_nodes'];
addCityPolicy($tv_nodes, 'n.city');
$doc->page->contents['tv_nodes'] = new PMyAccess($tv_nodes, array(
	'title'=>getResource('tv.nodes.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/modems.gif',
	'grid_boot'=>forceCity(BOOT.'tv_nodes/grid.php'),
	'form_boot'=>forceCity(BOOT.'tv_nodes/form.php'),
));

if(!$doc->page->contents['tv_nodes']->brief){
	if(!$tv_nodes->readonly){
		$doc->page->contents['tv_nodes']->form->fields['ip']->comment = createIpCandidates('ip', $tv_nodes, 3);
	}

	ob_start();
?>
<script type="text/javascript" src="scripts/strict-input-tracker.js"></script>
<script>
	StrictInputTracker(document.forms['<?=$tv_nodes->nick?>'].elements['mac'], /.*/, /[\-;\.,]/g, ":");

	var f = $("form[name=<?=$tv_nodes->nick?>]");
	$("[name=city]", f).change(function(){
		lookup_point.src = '?lookup=point&target=lookup_point&city=' + this.value;
		lookup_point.loaded = false;
		lookup_point.loadFirst();
	}).change();
	
	var feedback_models = [<?=implode(",", array_map(function($a){return $a['id'];}, loadRecords("SELECT id FROM tv_node_types WHERE feedback=1")))?>];
	$("[name=type]", f).change(function(){
		var is_fb = $.inArray(parseInt(this.value), feedback_models)>=0;
		$("[name=power_in]", f).closest("tr").toggle(is_fb);
		$("[name=power_out]", f).closest("tr").toggle(is_fb);
		$("[name=ip]", f).closest("tr").toggle(is_fb);
		$("[name=mac]", f).closest("tr").toggle(is_fb);
		$("[name=profile]", f).closest("tr").toggle(is_fb);
		$("[name=audit]", f).closest("tr").toggle(is_fb).next().toggle(is_fb).next().toggle(is_fb);
	}).change();
	
	var pow_in = $("[name=power_in]", f);
	
	$('<a href="#"> &lt;- </a>').click(function(e){
		$.get("?get_input_power=<?=$tv_nodes->active_record['id']?>", function(data){
			var p;
			if((data.length > 0) && (p=parseInt(data))){
				pow_in.val(p/10);
			}else{
				alert("<?=getResource('tv.nodes.audit.error')?>" + "\n\n" + data);
			}
		})
	}).appendTo(pow_in.parent());
	
</script>
<?
	$doc->page->contents['mjs'] .= ob_get_clean();
}

if($tv_nodes->isOn() ){
	$node = $tv_nodes->active_record;
	$nest = loadRecord("SELECT left_key, right_key FROM tv_nodes_nest WHERE id='".$node['id']."'");
	$menu = new PNamedMenu($nil,BOOT.'tv_nodes/menu.php');
	$doc->page->contents['tv_nodes_menu'] = $menu;
	switch($menu->selected){
		case 'pe':
			$pedigree = new PTable($db,BOOT.'tv_nodes/pedigree/table.php');
			$pedigree->readonly = 1;
			$pedigree->filters['parents'] = "tnn.left_key < '".$nest['left_key']."' AND tnn.right_key > '".$nest['right_key']."'";
			$doc->page->contents['pedigree'] = new PMyAccess($pedigree, array(
				'title'=>getResource('tv.nodes.pedigree.title'),
				'icon'=>HREF.'images/modems.gif',
				'grid_boot'=>BOOT.'tv_nodes/pedigree/grid.php',
			));
			break;
		case 'ivr':
			loadStrings(BOOT.'ivr_autoreply_tv/strings.txt');
			$ivr_autoreply_tv = new PTable($db,BOOT.'ivr_autoreply_tv/table.php');
			$ivr_autoreply_tv->readonly = !$oper->system_access['ivr_autoreply_tv'];
			$ivr_autoreply_tv->filters['scope'] = "s.tv_node='".$node['id']."' OR (tnn.left_key < '".$nest['left_key']."' AND tnn.right_key > '".$nest['right_key']."' AND s.scope=1)";
			addCityPolicy($ivr_autoreply_tv, 's.city');
			$doc->page->contents['ivr_autoreply_tv'] = new PMyAccess($ivr_autoreply_tv, array(
				'title'=>getResource('ivr.autoreply.tv.title'),
				'help'=>HELP_PATH.'//IVR',
				'icon'=>HREF.'images/calls.gif',
				'grid_boot'=>BOOT.'ivr_autoreply_tv/grid.php',
				'form_boot'=>BOOT.'ivr_autoreply_tv/form.php',
			));
			break;
	}
}

echo $doc->Paint();
?>
