<?
include_once('includes/global.php');
include_once('classes/excel/Worksheet.php');
include_once('classes/excel/Workbook.php');

$id = $_POST['person'];
$date = $_POST['date']['year'] . "-" . sprintf('%02s', $_POST['date']['month']);

$wb = new Workbook("-");
$rsh = $wb->add_worksheet('');

$f = array(
	'head_num'=>  $wb->add_format()->set_size(10)->set_align('right')->set_color('white')->set_pattern()->set_fg_color('gray')->set_bold(),
	'head_name'=> $wb->add_format()->set_size(10)->set_align('left')->set_color('white')->set_pattern()->set_fg_color('gray')->set_bold(),
	'head_cost'=> $wb->add_format()->set_size(10)->set_align('right')->set_color('white')->set_pattern()->set_fg_color('gray')->set_bold(),
	'head_date'=> $wb->add_format()->set_size(10)->set_align('center')->set_color('white')->set_pattern()->set_fg_color('gray')->set_bold(),
	'job_num'=>   $wb->add_format()->set_align('right'),
	'job_name'=>  $wb->add_format()->set_align('left'),
	'job_cost'=>  $wb->add_format()->set_align('right'),
	'job_date'=>  $wb->add_format()->set_align('center'),
	'ex_name'=>   $wb->add_format()->set_size(8),
	'ex_cost'=>   $wb->add_format()->set_align('right'),
	'ex_date'=>   $wb->add_format()->set_align('center'),
	'foot_num'=>  $wb->add_format()->set_align('right')->set_bold()->set_top(1),
	'foot_name'=> $wb->add_format()->set_align('left')->set_bold()->set_top(1),
	'foot_cost'=> $wb->add_format()->set_align('right')->set_bold()->set_top(1),
	'foot_date'=> $wb->add_format()->set_align('center')->set_bold()->set_top(1),
);

$records = loadRecords("SELECT
	je.id, jet.name, je.amount, jet.worker_fee,
	je.job, je.amount * jet.worker_fee/100 as fee,
	jet.salary_group
	FROM jobs_extras je
	LEFT JOIN jobs_extra_types jet ON jet.id=je.type
	LEFT JOIN jobs j ON j.id=je.job
	WHERE j.worker = '$id' AND j.state=1 AND j.client_id IS NOT NULL AND jet.salary_group>''");
$extras = array();
foreach($records as $arr){
	$extras[$arr['job']]['items'][$arr['id']] = $arr;
	$extras[$arr['job']]['sum'] += $arr['fee'];
}

$ex_gorup = array();

$jobs =  loadRecords("SELECT
	j.id,
	sf.name as created_name,
	j.type, jt.name as type_name, j.date, str.name as street_name, h.house, j.entrance, j.floor, j.apartment, j.entrance_type,
	cl.last_name as client_name, j.cost/100 as cost,
	jt.fee_0, jt.fee_1
	FROM jobs j
	LEFT JOIN job_types jt ON jt.id=j.type
	LEFT JOIN houses h ON h.street=j.street AND h.house=j.house
	LEFT JOIN clients cl ON cl.id=j.client_id
	LEFT JOIN stamps s ON s.id=cl.stamp
	LEFT JOIN operators o ON o.id=s.created_by
	LEFT JOIN staff sf ON sf.id=o.person
	LEFT JOIN streets str ON str.id=j.street
	WHERE j.state=1 AND j.client_id IS NOT NULL AND j.worker = '$id' AND j.date LIKE '$date%'
	ORDER BY jt.number, jt.id, j.entrance_type DESC, j.date, j.id");

$count = 0;
$et = -1;
$jt = -1;
foreach($jobs as $j){
	$count++;
	if($j['type']!=$jt || $j['entrance_type']!=$et){
		$et = $j['entrance_type'];
		$jt = $j['type'];
		$title = $j['type_name'].' '.($j['entrance_type'] ? '()' : '()');
		$sh = $wb->add_worksheet($title);
		$sh->set_column(0,0,5.57);
		$sh->set_column(1,1,46.95);
		$sh->set_column(2,2,13.0);
		$sh->set_column(3,3,12.0);
		//$sh->set_column(4,4,20.0);
		$sh->set_row(3, 27);
		$sh->write_string(0, 1, " ");
		$sh->write_string(1, 1, " : $date");
		$sh->write_string(1, 2, ": " . $name_arr[0]);
		$sh->write_string(2, 1, $title);
		$sh->write_string(3, 0, "", $f['head_num']);
		$sh->write_string(3, 1, "    ", $f['head_name']);
		$sh->write_string(3, 2, "", $f['head_cost']);
		$sh->write_string(3, 3, "", $f['head_date']);
//		$sh->write_string(3, 4, " ", $f2);
		$sh->i = 4;
		$sh->c = 1;
		$sh->ex_sum = 0;
		$sh->pure_sum = 0;
		$sh->fee = $j['fee_'.$j['entrance_type']]/100;
	}
	$sh->write($sh->i, 0, $sh->c, $f['job_num']);
	$sh->write_string($sh->i, 1, $j['client_name'].' ('.$j['street_name'].' '.$j['house']. '  '.$j['apartment'].')', $f['job_name']);
	//$sh->write_string($sh->i, 2, array_shift(preg_split("|\s+|", $j['created_name'])));
	$sh->write_string($sh->i, 2, number_format($j['cost'], 2, '.', ''), $f['job_cost']);
	$sh->write_string($sh->i, 3, substr($j['date'], 0, 10), $f['job_date']);
	//$sh->write_string($sh->i, 4, $j['type_name'], $f);
	$sh->pure_sum += $j['cost'];
	$sh->i++;
	$sh->c++;
	if(isset($extras[$j['id']])){
		foreach($extras[$j['id']]['items'] as $ex){
			$sh->write_string($sh->i, 1, $ex['name'].($ex['amount'] > 1 ? (' x '.$ex['amount']) : ''), $f['ex_name']);
			$sh->write_string($sh->i, 2, number_format($ex['fee'], 2, '.', ''), $f['ex_cost']);
			$sh->write_string($sh->i, 3, substr($j['date'], 0, 10), $f['ex_date']);
			$ex_gorup[$ex['salary_group']]['fee'] += $ex['fee'];
			$ex_gorup[$ex['salary_group']]['amount'] += $ex['amount'];
			$ex_gorup[$ex['salary_group']]['worker_fee'] = $ex['worker_fee']/100;
			$sh->ex_sum += $ex['fee'];
			$sh->i++;
		}
	}
}

foreach($wb->worksheets as $sh){
	if($sh->pure_sum + $sh->ex_sum > 0){
		$sh->write_string($sh->i, 0, '', $f['foot_num']);
		$sh->write_string($sh->i, 1, '', $f['foot_name']);
		$sh->write_string($sh->i, 2, number_format($sh->pure_sum, 2, '.', ''), $f['foot_cost']);
		$sh->write_string($sh->i, 3, '', $f['foot_date']);
		$sh->i++;
		if($sh->ex_sum > 0){
			$sh->write_string($sh->i, 2, number_format($sh->ex_sum, 2, '.', ''), $f['foot_cost']);
		}
	}
}

$total = 0;
$sh = $rsh;
$sh->set_column(0, 0, 4);
$sh->set_column(1, 1, 50);
$sh->set_column(2, 2, 10);
$sh->set_column(3, 3, 12);
$sh->set_column(4, 4, 10);
$sh->set_row(2, 27);
$sh->write_string(0, 1, " ");
$sh->write_string(1, 1, " : $date");
$sh->write_string(1, 2, ": " . $name_arr[0]);
$sh->write_string(2, 1, "", $f['head_name']);
$sh->write_string(2, 2, "", $f['head_cost']);
$sh->write_string(2, 3, "", $f['head_cost']);
$sh->write_string(2, 4, "", $f['head_cost']);

$sh->i = 3;
foreach($wb->worksheets as $s){
	if($s->pure_sum > 0){
		$sh->write_string($sh->i, 1, $s->name, $f['job_name']);
		$sh->write_string($sh->i, 2, number_format($s->fee, 2, '.', ''), $f['job_cost']);
		$sh->write_string($sh->i, 3, $s->c - 1, $f['job_cost']);
		$sh->write_string($sh->i, 4, number_format($s->pure_sum, 2, '.', ''), $f['job_cost']);
		$total += $s->pure_sum;
		$sh->i++;
	}
}

foreach($ex_gorup as $group=>$ex){
	$sh->write_string($sh->i, 1, $group, $f['job_name']);
	$sh->write_string($sh->i, 2, number_format($ex['worker_fee'], 2, '.', ''), $f['job_cost']);
	$sh->write_string($sh->i, 3, $ex['amount'], $f['job_cost']);
	$sh->write_string($sh->i, 4, number_format($ex['fee'], 2, '.', ''), $f['job_cost']);
	$total += $ex['fee'];
	$sh->i++;
}

$sh->write_string($sh->i, 1, '', $f['job_name']);
$sh->write_string($sh->i, 2, number_format(4, 2, '.', ''), $f['job_cost']);
$sh->write_string($sh->i, 3, $count, $f['job_cost']);
$sh->write_string($sh->i, 4, number_format($count * 4, 2, '.', ''), $f['job_cost']);
$total += $count * 4;
$sh->i++;

$bonus_type = array(
	'1'=>array('', -1),
	'2'=>array('', 1),
	'3'=>array('', 1),
);
$bonus = loadRecords("SELECT type, sum(amount) amount FROM penalty_and_bonus WHERE oper = '$id' AND `date` LIKE '$date%' GROUP BY type");
foreach($bonus as $b){
	$type = $bonus_type[$b['type']];
	$sh->write_string($sh->i, 1, $type[0], $f['job_name']);
	$sh->write_string($sh->i, 4, number_format($b['amount'], 2, '.', ''), $f['job_cost']);
	$total += $b['amount'] * $type[1];
	$sh->i++;
}

$sh->write_string($sh->i, 1, '', $f['foot_name']);
$sh->write_string($sh->i, 2, '', $f['foot_name']);
$sh->write_string($sh->i, 3, '', $f['foot_name']);
$sh->write_string($sh->i, 4, number_format($total, 2, '.', ''), $f['foot_cost']);

foreach($wb->worksheets as $sh){
	$sh->set_margins_TB(0.4);
	$sh->set_margins_LR(0.2);
}

$person = loadRecord(sprintf("SELECT name FROM staff WHERE id='%s'", addslashes($id)));
$name_arr = preg_split("|\s|", $person['name']);
header("Content-type: application/vnd.ms-excel");
header("Content-Disposition: attachment; filename="."\"".$name_arr[0]." (" . $date . ").xls\"" );
header("Expires: 0");
header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
header("Pragma: public");

$wb->close();
?>